package de.mdelab.mlsdm.diagram.custom.edit.parts;

import org.eclipse.draw2d.PositionConstants;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.edit.EMFEditPlugin;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.gmf.runtime.draw2d.ui.figures.WrappingLabel;
import org.eclipse.gmf.runtime.notation.View;

import de.mdelab.mlcallactions.CallAction;
import de.mdelab.mlcallactions.CallActionExpression;
import de.mdelab.mlcallactions.CallActionParameter;
import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.mlexpressions.MLStringExpression;
import de.mdelab.mlsdm.diagram.edit.parts.MLStringExpression2EditPart;
import de.mdelab.mlstorypatterns.AttributeAssignment;
import de.mdelab.mlstorypatterns.diagram.custom.edit.parts.IMLExpressionEditPart;

public class CustomMLStringExpression3EditPart extends MLStringExpression2EditPart implements IMLExpressionEditPart {

	public CustomMLStringExpression3EditPart(View view)
	{
		super(view);
	}

	@Override
	protected void addNotationalListeners()
	{
		super.addNotationalListeners();
	}

	@Override
	protected void refreshVisuals()
	{
		super.refreshVisuals();
		updateFigure();
	}

	protected void updateFigure()
	{
		//JOptionPane.showInputDialog("huhu");
		EObject eO = ((View) getModel()).getElement();
		
		/*MLStringExpression expr = ((MLStringExpression) ((View) getModel()).getElement());//.getElement());

		String text = "[[ ]]";
		if (expr.getExpressionString()!=null){
			text ="[ " + expr.getExpressionString() + " ]";
		}
		setLabelText(text);*/
		
		((WrappingLabel) getFigure()).setTextWrap(true);
		((WrappingLabel) getFigure()).setTextJustification(PositionConstants.CENTER);


		//if (!((StoryPattern)eO).getConstraints().isEmpty())
		{
			StringBuilder labelBuilder = new StringBuilder();
			
			//for (MLExpression e : ((StoryPattern)eO).getConstraints())
			{
				labelBuilder.append("[ ");
				if (eO instanceof MLStringExpression)
					labelBuilder.append(((MLStringExpression)eO).getExpressionString());

				if (eO instanceof CallActionExpression){
					String text = "[ ]";
					try{
					ComposedAdapterFactory factory = new ComposedAdapterFactory(EMFEditPlugin.getComposedAdapterFactoryDescriptorRegistry());
					//JOptionPane.showInputDialog(((CallActionExpression)eO).getCallActions());
					if (((CallActionExpression)eO)!=null)
						text = ((IItemLabelProvider) factory.adapt(((CallActionExpression)eO), IItemLabelProvider.class)).getText(((CallActionExpression)eO));
					}
					catch(Exception e){
						e.printStackTrace();
					}
					labelBuilder.append(text);
				}

				labelBuilder.append(" ]");

				//labelBuilder.append(System.getProperty("line.separator"));
			}

			setLabelText(labelBuilder.toString());
		}
		//else
		{
			//setLabelText("");
		}
	}

	@Override
	protected void handleNotificationEvent(Notification event)
	{
		Object notifier = event.getNotifier();
		Object newValue = event.getNewValue();
		Object oldValue = event.getOldValue();
		int eventType = event.getEventType();

		if ((eventType == Notification.SET || eventType == Notification.ADD)
				&& (newValue instanceof CallAction || newValue instanceof MLExpression || newValue instanceof CallActionParameter))
		{
			this.addListenerFilter(newValue.getClass().getName(), this, (EObject) newValue);
			updateFigure();
		}
		else if (eventType == Notification.REMOVE
				&& (oldValue instanceof CallAction || oldValue instanceof MLExpression || oldValue instanceof CallActionParameter))
		{
			this.removeListenerFilter(oldValue.getClass().getName());
			updateFigure();
		}
		else if (notifier instanceof AttributeAssignment || notifier instanceof CallAction || notifier instanceof MLExpression
				|| notifier instanceof CallActionParameter)
		{
			updateFigure();
		}

		super.handleNotificationEvent(event);
	}

	@Override
	public MLExpression getMLExpression() {
		return (MLExpression) getAdapter( MLExpression.class );
	}
}

