package de.mdelab.mlsdm.diagram.custom.edit.parts;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.gmf.runtime.notation.View;

import de.mdelab.expressiondialogs.Utility;
import de.mdelab.mlsdm.diagram.edit.parts.WrappingLabel11EditPart;
import de.mdelab.mlstorypatterns.MapEntryLink;
import de.mdelab.mlstorypatterns.ModifierEnum;
import de.mdelab.mlstorypatterns.StoryPatternElement;
import de.mdelab.mlstorypatterns.StoryPatternObject;

public class CustomMapEntryLinkKeyLabelEditPart extends WrappingLabel11EditPart
{

	public CustomMapEntryLinkKeyLabelEditPart(View view)
	{
		super(view);
	}

	@Override
	protected void handleNotificationEvent(Notification notification)
	{
		if (notification.getEventType() != Notification.REMOVE
				&& (notification.getNotifier() instanceof MapEntryLink || notification.getNotifier() instanceof StoryPatternObject))
		{
			adaptColor();
		}

		super.handleNotificationEvent(notification);
	}

	@Override
	protected void refreshVisuals()
	{
		super.refreshVisuals();
		adaptColor();
	}

	protected void adaptColor()
	{
		ModifierEnum modifier = ((StoryPatternElement) ((View) this.getModel()).getElement()).getModifier();

		Utility.adaptColor(getFigure(), modifier);
	}
}
