package de.mdelab.mlsdm.diagram.custom.edit.parts;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.gmf.runtime.notation.Edge;
import org.eclipse.gmf.runtime.notation.View;

import de.mdelab.expressiondialogs.Utility;
import de.mdelab.mlsdm.diagram.edit.parts.WrappingLabel12EditPart;
import de.mdelab.mlstorypatterns.MapEntryLink;
import de.mdelab.mlstorypatterns.ModifierEnum;
import de.mdelab.mlstorypatterns.StoryPatternElement;
import de.mdelab.mlstorypatterns.StoryPatternObject;

public class CustomMapEntryLinkValueLinkLabelEditPart extends WrappingLabel12EditPart
{

	public CustomMapEntryLinkValueLinkLabelEditPart(View view)
	{
		super(view);
	}

	@Override
	protected void addNotationalListeners()
	{
		super.addNotationalListeners();

		MapEntryLink mapEntryStoryPatternLink = (MapEntryLink) ((Edge) ((View) getModel()).eContainer())
				.getSource().getElement();

		addListenerFilter("MapEntryStoryPatternLink", this, mapEntryStoryPatternLink);
	}

	@Override
	protected void handleNotificationEvent(Notification notification)
	{
		if (notification.getEventType() != Notification.REMOVE
				&& (notification.getNotifier() instanceof MapEntryLink || notification.getNotifier() instanceof StoryPatternObject))
		{
			adaptColor();
		}

		super.handleNotificationEvent(notification);
	}

	@Override
	protected void refreshVisuals()
	{
		super.refreshVisuals();
		adaptColor();
		/*((WrappingLabel) getFigure()).setTextWrap(true);
		((WrappingLabel) getFigure()).setTextJustification(PositionConstants.CENTER);

		//StringBuilder labelBuilder = new StringBuilder();
		String text = "";
		EObject e = ((MapEntryLink)((Edge)(EObject) ((View) getModel()).eContainer()).getSource().getElement()).getFeature();
		if (e!=null)
		{
			//EObject e = ((MapEntryLink) ((View) getModel()).getElement()).getFeature();
			try{
				//MLExpression expr = aParameter.getExpression();
				ComposedAdapterFactory factory = new ComposedAdapterFactory(EMFEditPlugin.getComposedAdapterFactoryDescriptorRegistry());
				text = ((IItemLabelProvider) factory.adapt(e, IItemLabelProvider.class)).getText(e);
			}
			catch (Exception ex){
				ex.printStackTrace();
			}
			setLabelText(text);
		}
		else
			setLabelText("###");
*/
	}

	protected void adaptColor()
	{
		if (((Edge) ((View) getModel()).eContainer()).getSource() != null)
		{
			ModifierEnum modifier = ((StoryPatternElement) ((Edge) ((View) getModel()).eContainer()).getSource()
					.getElement()).getModifier();

			Utility.adaptColor(getFigure(), modifier);
		}
	}
}
