package de.mdelab.mlsdm.diagram.custom.edit.parts;


import java.util.List;

import org.eclipse.draw2d.XYLayout;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.commands.CompoundCommand;
import org.eclipse.gmf.runtime.diagram.ui.commands.ICommandProxy;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.DragDropEditPolicy;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles;
import org.eclipse.gmf.runtime.diagram.ui.requests.CreateViewRequest;
import org.eclipse.gmf.runtime.diagram.ui.requests.CreateViewRequest.ViewDescriptor;
import org.eclipse.gmf.runtime.diagram.ui.requests.DropObjectsRequest;
import org.eclipse.gmf.runtime.emf.core.util.EObjectAdapter;
import org.eclipse.gmf.runtime.emf.type.core.IHintedType;
import org.eclipse.gmf.runtime.emf.type.core.commands.SetValueCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.SetRequest;
import org.eclipse.gmf.runtime.notation.Node;
import org.eclipse.gmf.runtime.notation.View;

import de.mdelab.mlcore.MlcorePackage;
import de.mdelab.mlsdm.diagram.edit.parts.StoryNodeStoryNodeElementsCompartmentEditPart;
import de.mdelab.mlstorypatterns.MlstorypatternsFactory;
import de.mdelab.mlstorypatterns.MlstorypatternsPackage;
import de.mdelab.mlstorypatterns.StoryPatternObject;
import de.mdelab.mlstorypatterns.diagram.providers.MlstorypatternsElementTypes;

public class CustomStoryNodeStoryNodeElementsCompartmentEditPart extends StoryNodeStoryNodeElementsCompartmentEditPart {

	public CustomStoryNodeStoryNodeElementsCompartmentEditPart(View view) {
		super(view);
	}

	@Override
	protected void createDefaultEditPolicies() {
		super.createDefaultEditPolicies();
		this.removeEditPolicy(EditPolicyRoles.DRAG_DROP_ROLE);
		
		// DB: there seems to be a problem with the default layout policy that is added 
		// as XY, which then causes a class cast exception because the container does not have a XY layout.
		if ( !( getFigure().getParent().getLayoutManager() instanceof XYLayout ) ) {
			removeEditPolicy(EditPolicy.LAYOUT_ROLE);
		}
		
		installEditPolicy(EditPolicyRoles.DRAG_DROP_ROLE, new MlsdmDiagramDnDEditPolicy());
		//TODO:???
		/*EditPolicyIterator e = this.getEditPolicyIterator();
		System.out.println("##############");
		while(e.hasNext()){
			EditPolicy ep = e.next();
			this.getEditPolicy(ep);
			if (ep instanceof XYLayoutEditPolicy){
				System.out.println(ep);
				this.removeEditPolicy(ep);
				this.installEditPolicy(EditPolicyRoles.OPEN_ROLE, new ConstrainedToolbarLayoutEditPolicy());
			}
		}*/
	}
	/*@Override
	protected void refreshVisuals()
	{
		super.refreshVisuals();
		updateFigure();
	}

	public void updateFigure()
	{
		EObject ep = ((View) getModel()).getElement();
		//JOptionPane.showInputDialog(((StoryNode)ep).getName()+": "+((StoryNode)ep).getStoryPattern().getConstraints().size());
		
		
		//this.getCompartmentFigure().setSize(100,100);
		//this.getFigure().getPrimaryShape().setMinimumSize(new Dimension(0, 0));

	}*/

	class MlsdmDiagramDnDEditPolicy extends DragDropEditPolicy
	{
		@Override
		public Command getDropObjectsCommand(DropObjectsRequest request)
		{
			List<?> objects = request.getObjects();
			if (objects.size() != 1)
			{
				return super.getDropObjectsCommand(request);
			}

			Object object = objects.get(0);
			if (object == null || !(object instanceof EClassifier))
			{
				return super.getDropObjectsCommand(request);
			}
			EClassifier eClassifier = (EClassifier) object;

			StoryPatternObject spo = MlstorypatternsFactory.eINSTANCE.createStoryPatternObject();
			CompoundCommand cc = new CompoundCommand();

			// zum SAN hinzu fügen
			EObject eObj = ((View) (getHost().getModel())).getElement();
			SetRequest sr = new SetRequest(eObj, MlstorypatternsPackage.eINSTANCE.getStoryPattern_StoryPatternObjects(), spo);
			TransactionalEditingDomain ted = sr.getEditingDomain();
			cc.add(new ICommandProxy(new SetValueCommand(sr)));

			// Classifier setzen
			sr = new SetRequest(ted, spo, MlstorypatternsPackage.eINSTANCE.getAbstractStoryPatternObject().eContainmentFeature(),eClassifier);//getAbstractStoryPatternObject_Classifier(), eClassifier);
			cc.add(new ICommandProxy(new SetValueCommand(sr)));

			// Namen setzen
			String name = eClassifier.getName();
			if (name.length() > 1)
			{
				name = name.substring(0, 1).toLowerCase() + name.substring(1);
			}
			else if (name.length() == 1)
			{
				name = name.toLowerCase();
			}

			sr = new SetRequest(ted, spo, MlcorePackage.eINSTANCE.getMLNamedElement_Name(), name);
			cc.add(new ICommandProxy(new SetValueCommand(sr)));

			// Node an entspr. Stelle anlegen
			ViewDescriptor vd = new ViewDescriptor(new EObjectAdapter(spo), Node.class,
					((IHintedType) MlstorypatternsElementTypes.StoryPatternObject_2003).getSemanticHint(),
					CustomStoryNodeStoryNodeElementsCompartmentEditPart.this.getDiagramPreferencesHint());
			CreateViewRequest cvr = new CreateViewRequest(vd);
			cvr.setLocation(request.getLocation());
			cc.add(CustomStoryNodeStoryNodeElementsCompartmentEditPart.this.getCommand(cvr));

			return cc.unwrap();
		}
	}
}
