package de.mdelab.mlsdm.diagram.custom.edit.parts;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.NullProgressMonitor;
import org.eclipse.core.runtime.Status;
import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.emf.transaction.util.TransactionUtil;
import org.eclipse.emf.workspace.AbstractEMFOperation;
import org.eclipse.gef.EditPart;
import org.eclipse.gmf.runtime.diagram.core.util.ViewUtil;
import org.eclipse.gmf.runtime.diagram.ui.actions.ActionIds;
import org.eclipse.gmf.runtime.diagram.ui.editparts.GraphicalEditPart;
import org.eclipse.gmf.runtime.diagram.ui.requests.ArrangeRequest;
import org.eclipse.gmf.runtime.notation.Node;
import org.eclipse.gmf.runtime.notation.NotationPackage;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;

import de.mdelab.expressiondialogs.actions.CustomAbstractActionDelegate;
import de.mdelab.mlsdm.diagram.edit.parts.ActivityEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternObjectEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternStoryPatternElementsCompartmentEditPart;
import de.mdelab.mlstorypatterns.diagram.custom.edit.parts.CustomStoryPatternObjectEditPart;

public class CustomStoryPatternReorderAction extends CustomAbstractActionDelegate
{
	ActivityEditPart	activityEditPart	= null;

	@Override
	public void selectionChanged(IAction act, ISelection selection)
	{
		if (selection instanceof IStructuredSelection)
		{
			activityEditPart = (ActivityEditPart) ((IStructuredSelection) selection).getFirstElement();
		}
	}
	@Override
	protected void doRun(IProgressMonitor progressMonitor){

		Object[] selection = activityEditPart.getChildren().toArray();
		
		for (Object iter:selection){
			if (iter instanceof CustomStoryNodeEditPart){
				Object[] selection2 = ((CustomStoryNodeEditPart)iter).getChildren().toArray();
				for (Object iter2:selection2){
					if (iter2 instanceof CustomStoryNodeStoryNodeElementsCompartmentEditPart){
						Object[] selection3 = ((CustomStoryNodeStoryNodeElementsCompartmentEditPart)iter2).getChildren().toArray();
						for (Object iter3:selection3){
							if (iter3 instanceof CustomStoryPatternEditPart){
								Object[] selection4 = ((CustomStoryPatternEditPart)iter3).getChildren().toArray();
								for (Object iter4:selection4){
									if (iter4 instanceof StoryPatternStoryPatternElementsCompartmentEditPart){
										Object[] selection5 = ((StoryPatternStoryPatternElementsCompartmentEditPart)iter4).getChildren().toArray();
										for (Object iter5:selection5){
											if (iter5 instanceof CustomStoryPatternObjectEditPart){
												EditPart ep = ((StoryPatternObjectEditPart)iter5).getParent();
												Object[] listEditPart = ((GraphicalEditPart) ep).getPrimaryView().getChildren().toArray();//this.getChildren().toArray();
												List<Object> listEditPart2 = new ArrayList<Object>();//((GraphicalEditPart) ep).getPrimaryView().getChildren();//this.getChildren().toArray();
												for (Object e:listEditPart){
													listEditPart2.add(e);
												}
												ArrangeRequest arrangeRequest = new ArrangeRequest(ActionIds.ACTION_ARRANGE_ALL);
												arrangeRequest.setPartsToArrange(listEditPart2);
												((GraphicalEditPart) ep).getDiagramEditDomain().getDiagramCommandStack().execute(((GraphicalEditPart) ep).getCommand(arrangeRequest));
																		
												{//start resize after reordering
													final Node parentNode, childNode;
													final int parentX, parentY/*, parentWidth, parentHeight*/;
													final int /*childX, childY,*/ childWidth, childHeight;
													final int resultX, resultY, resultWidth, resultHeight;
						
													View diag;
													EditPart compartment = ((GraphicalEditPart) ep.getParent());//.getParent();
													
													GraphicalEditPart storyNodeEditPart = ((GraphicalEditPart) ep);
													parentNode = (Node)storyNodeEditPart.getParent().getParent().getModel();
													childNode = (Node)storyNodeEditPart.getModel();
													parentX = (Integer) ViewUtil.getStructuralFeatureValue(parentNode, NotationPackage.eINSTANCE.getLocation_X());
													parentY = (Integer) ViewUtil.getStructuralFeatureValue(parentNode, NotationPackage.eINSTANCE.getLocation_Y());
													/*parentWidth = (Integer) ViewUtil.getStructuralFeatureValue(parentNode, NotationPackage.eINSTANCE.getSize_Width());
													parentHeight = (Integer) ViewUtil.getStructuralFeatureValue(parentNode, NotationPackage.eINSTANCE.getSize_Height());
													childX = (Integer) ViewUtil.getStructuralFeatureValue(childNode, NotationPackage.eINSTANCE.getLocation_X());
													childY = (Integer) ViewUtil.getStructuralFeatureValue(childNode, NotationPackage.eINSTANCE.getLocation_Y());
													*/childWidth = (Integer) ViewUtil.getStructuralFeatureValue(childNode, NotationPackage.eINSTANCE.getSize_Width());
													childHeight = (Integer) ViewUtil.getStructuralFeatureValue(childNode, NotationPackage.eINSTANCE.getSize_Height());
													resultX = parentX;
													resultY = parentY;
													resultWidth = childWidth;
													resultHeight = childHeight;
													
													diag = (View)compartment.getModel();
													TransactionalEditingDomain ted = TransactionUtil.getEditingDomain(diag);
													AbstractEMFOperation operation = new AbstractEMFOperation(ted, "Resizing", null)
													{
														protected IStatus doExecute(IProgressMonitor monitor, IAdaptable info) throws ExecutionException
														{
															ViewUtil.setStructuralFeatureValue(parentNode,
																	NotationPackage.eINSTANCE.getLocation_X(), resultX);
															ViewUtil.setStructuralFeatureValue(parentNode,
																	NotationPackage.eINSTANCE.getLocation_Y(), resultY);
															ViewUtil.setStructuralFeatureValue(parentNode,
																	NotationPackage.eINSTANCE.getSize_Width(), resultWidth);
															ViewUtil.setStructuralFeatureValue(parentNode,
																	NotationPackage.eINSTANCE.getSize_Height(), resultHeight);
					
															return Status.OK_STATUS;
														}
													};
													try
													{
														operation.execute(new NullProgressMonitor(), null);
													}
													catch (ExecutionException e)
													{
														e.printStackTrace();
													}
													//compartment.refresh();
													//Dimension s = new Dimension(resultWidth,resultHeight);
													//storyNodeEditPart.getFigure().setMinimumSize(s);
													//storyNodeEditPart.getFigure().repaint();						
												}//end resize
											}	
										}
									}
								}
							}
						}
					}
				}
			}
		}
		//arrange all at the end; but doesnt work 
		//for (Object o:activityEditPart.getChildren()){
			ArrangeRequest arrangeRequest = new ArrangeRequest(ActionIds.ACTION_ARRANGE_SELECTION);
			arrangeRequest.setPartsToArrange(activityEditPart.getChildren());
			((GraphicalEditPart) activityEditPart).getDiagramEditDomain().getDiagramCommandStack().execute(((GraphicalEditPart) activityEditPart).getCommand(arrangeRequest));
		//}
		//activityEditPart.refresh();
	}
}
