package de.mdelab.mlsdm.diagram.custom.edit.parts;

import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.NullProgressMonitor;
import org.eclipse.core.runtime.Status;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.emf.transaction.util.TransactionUtil;
import org.eclipse.emf.workspace.AbstractEMFOperation;
import org.eclipse.gef.EditPart;
import org.eclipse.gmf.runtime.diagram.core.util.ViewUtil;
import org.eclipse.gmf.runtime.notation.Node;
import org.eclipse.gmf.runtime.notation.NotationPackage;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;

import de.mdelab.expressiondialogs.actions.CustomAbstractActionDelegate;

public class CustomStoryPatternResizeAction extends CustomAbstractActionDelegate
{
	int sI=-1;
	int tI=-1;
	Node firstNode;
	Node secondNode;
	int firstX;
	int firstY;
	int secondX;
	int secondY;
	View diag;
	CustomStoryPatternEditPart	storyPatternEditPart	= null;

	@Override
	public void selectionChanged(IAction act, ISelection selection)
	{
		if (selection instanceof IStructuredSelection)
		{
			storyPatternEditPart = (CustomStoryPatternEditPart) ((IStructuredSelection) selection).getFirstElement();
		}
	}
	
	@Override
	protected void doRun(IProgressMonitor progressMonitor){

		EditPart compartment = (EditPart)this.storyPatternEditPart;//.getParent();
		firstNode = (Node)storyPatternEditPart.getModel();
		secondNode = (Node)storyPatternEditPart.getParent().getParent().getModel();
		firstX = (Integer) ViewUtil.getStructuralFeatureValue(secondNode,
		 NotationPackage.eINSTANCE.getLocation_X());
		//Bounds n = null;
		firstY = (Integer) ViewUtil.getStructuralFeatureValue(secondNode,
				 NotationPackage.eINSTANCE.getLocation_Y());
		secondX = (Integer) ViewUtil.getStructuralFeatureValue(secondNode,
				 NotationPackage.eINSTANCE.getSize_Width());
		secondY = (Integer) ViewUtil.getStructuralFeatureValue(secondNode,
				 NotationPackage.eINSTANCE.getSize_Height());
		
			diag = (View)compartment.getModel();
			TransactionalEditingDomain ted = TransactionUtil.getEditingDomain(diag);
			AbstractEMFOperation operation = new AbstractEMFOperation(ted, "Move Rule Up", null)
			{
				protected IStatus doExecute(IProgressMonitor monitor, IAdaptable info) throws ExecutionException
				{
					ViewUtil.setStructuralFeatureValue(firstNode,
							NotationPackage.eINSTANCE.getLocation_X(), firstX);
					ViewUtil.setStructuralFeatureValue(firstNode,
							NotationPackage.eINSTANCE.getLocation_Y(), firstY);
					ViewUtil.setStructuralFeatureValue(firstNode,
							NotationPackage.eINSTANCE.getSize_Width(), secondX);
					ViewUtil.setStructuralFeatureValue(firstNode,
							NotationPackage.eINSTANCE.getSize_Height(), secondY);
					
					/*
					ViewUtil.setStructuralFeatureValue(firstNode,
					NotationPackage.eINSTANCE.getLocation_X(), secondX);
					ViewUtil.setStructuralFeatureValue(firstNode, 
					NotationPackage.eINSTANCE.getLocation_Y(), secondY);
					ViewUtil.setStructuralFeatureValue(secondNode,
					NotationPackage.eINSTANCE.getLocation_X(), firstX);
					ViewUtil.setStructuralFeatureValue(secondNode,
					NotationPackage.eINSTANCE.getLocation_Y(), firstY);*/
							 
					//((TGGRule)((Node)tggRuleEditPart.getModel()).getElement()).getRuleGroup().getRules().move(sI, tI);

					return Status.OK_STATUS;
				}
			};
			//JOptionPane.showInputDialog(operation.canExecute()+" "+ViewUtil.getStructuralFeatureValue((Node)storyPatternEditPart.getModel(),
				//	 NotationPackage.eINSTANCE.getSize_Width()));
			try
			{
				operation.execute(new NullProgressMonitor(), null);
			}
			catch (ExecutionException e)
			{
				e.printStackTrace();
			}
			compartment.refresh();
			Dimension s = new Dimension(secondX,secondY);
			
			storyPatternEditPart.getFigure().setMinimumSize(s);
			//JOptionPane.showInputDialog(ViewUtil.getStructuralFeatureValue((Node)storyPatternEditPart.getModel(),
				//	 NotationPackage.eINSTANCE.getSize_Width()));
			storyPatternEditPart.getFigure().repaint();
	}	
}
/*public class CustomStoryPatternResizeAction implements IActionDelegate{
	int sI=-1;
	int tI=-1;
	Node firstNode;
	Node secondNode;
	int firstX;
	int firstY;
	int secondX;
	int secondY;
	View diag;
	CustomStoryPatternEditPart storyPatternEditPart	= null;

	@Override
	public void selectionChanged(IAction act, ISelection selection)
	{
		if (selection instanceof IStructuredSelection)
		{
			storyPatternEditPart = (CustomStoryPatternEditPart) ((IStructuredSelection) selection).getFirstElement();
		}
	}

	@Override
	public void run(IAction action) {
	
		EditPart compartment = (EditPart)this.storyPatternEditPart.getParent();
			firstNode = (Node)storyPatternEditPart.getModel();
			secondNode = (Node)storyPatternEditPart.getParent().getModel();
	
			firstX = (Integer) ViewUtil.getStructuralFeatureValue(secondNode,
			 NotationPackage.eINSTANCE.getLocation_X());
			//Bounds n = null;
			firstY = (Integer) ViewUtil.getStructuralFeatureValue(secondNode,
					 NotationPackage.eINSTANCE.getLocation_Y());
			secondX = (Integer) ViewUtil.getStructuralFeatureValue(secondNode,
					 NotationPackage.eINSTANCE.getSize_Width());
			secondY = (Integer) ViewUtil.getStructuralFeatureValue(secondNode,
					 NotationPackage.eINSTANCE.getSize_Height());
			
			diag = (View)compartment.getModel();
			TransactionalEditingDomain ted = TransactionUtil.getEditingDomain(diag);
			AbstractEMFOperation operation = new AbstractEMFOperation(ted, "Move Rule Up", null)
			{
			protected IStatus doExecute(IProgressMonitor monitor, IAdaptable info) throws ExecutionException
			{
				ViewUtil.setStructuralFeatureValue(firstNode,
						NotationPackage.eINSTANCE.getLocation_X(), firstX);
				ViewUtil.setStructuralFeatureValue(firstNode,
						NotationPackage.eINSTANCE.getLocation_Y(), firstY);
				ViewUtil.setStructuralFeatureValue(firstNode,
						NotationPackage.eINSTANCE.getSize_Width(), secondX);
				ViewUtil.setStructuralFeatureValue(firstNode,
						NotationPackage.eINSTANCE.getSize_Height(), secondY);
				//JOptionPane.showInputDialog("hjdsk");

				return Status.OK_STATUS;
			}
		};

		try
		{
			operation.execute(new NullProgressMonitor(), null);
		}
		catch (ExecutionException e)
		{
			e.printStackTrace();
		}
		storyPatternEditPart.refresh();
	}		
}
*/
