package de.mdelab.mlsdm.diagram.edit.commands;

import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.common.core.command.CommandResult;
import org.eclipse.gmf.runtime.emf.type.core.commands.EditElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientReferenceRelationshipRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientRelationshipRequest;

import de.mdelab.mlsdm.diagram.edit.policies.MlsdmBaseItemSemanticEditPolicy;
import de.mdelab.mlstorypatterns.AbstractStoryPatternObject;
import de.mdelab.mlstorypatterns.MapEntryLink;

/**
 * @generated
 */
public class MapEntryLinkValueTargetReorientCommand extends EditElementCommand
{

	/**
	 * @generated
	 */
	private final int		reorientDirection;

	/**
	 * @generated
	 */
	private final EObject	referenceOwner;

	/**
	 * @generated
	 */
	private final EObject	oldEnd;

	/**
	 * @generated
	 */
	private final EObject	newEnd;

	/**
	 * @generated
	 */
	public MapEntryLinkValueTargetReorientCommand(ReorientReferenceRelationshipRequest request)
	{
		super(request.getLabel(), null, request);
		reorientDirection = request.getDirection();
		referenceOwner = request.getReferenceOwner();
		oldEnd = request.getOldRelationshipEnd();
		newEnd = request.getNewRelationshipEnd();
	}

	/**
	 * @generated
	 */
	public boolean canExecute()
	{
		if (false == referenceOwner instanceof MapEntryLink)
		{
			return false;
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE)
		{
			return canReorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET)
		{
			return canReorientTarget();
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean canReorientSource()
	{
		if (!(oldEnd instanceof AbstractStoryPatternObject && newEnd instanceof MapEntryLink))
		{
			return false;
		}
		return MlsdmBaseItemSemanticEditPolicy.getLinkConstraints().canExistMapEntryLinkValueTarget_4007(getNewSource(), getOldTarget());
	}

	/**
	 * @generated
	 */
	protected boolean canReorientTarget()
	{
		if (!(oldEnd instanceof AbstractStoryPatternObject && newEnd instanceof AbstractStoryPatternObject))
		{
			return false;
		}
		return MlsdmBaseItemSemanticEditPolicy.getLinkConstraints().canExistMapEntryLinkValueTarget_4007(getOldSource(), getNewTarget());
	}

	/**
	 * @generated
	 */
	protected CommandResult doExecuteWithResult(IProgressMonitor monitor, IAdaptable info) throws ExecutionException
	{
		if (!canExecute())
		{
			throw new ExecutionException("Invalid arguments in reorient link command"); //$NON-NLS-1$
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE)
		{
			return reorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET)
		{
			return reorientTarget();
		}
		throw new IllegalStateException();
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientSource() throws ExecutionException
	{
		getOldSource().setValueTarget(null);
		getNewSource().setValueTarget(getOldTarget());
		return CommandResult.newOKCommandResult(referenceOwner);
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientTarget() throws ExecutionException
	{
		getOldSource().setValueTarget(getNewTarget());
		return CommandResult.newOKCommandResult(referenceOwner);
	}

	/**
	 * @generated
	 */
	protected MapEntryLink getOldSource()
	{
		return (MapEntryLink) referenceOwner;
	}

	/**
	 * @generated
	 */
	protected MapEntryLink getNewSource()
	{
		return (MapEntryLink) newEnd;
	}

	/**
	 * @generated
	 */
	protected AbstractStoryPatternObject getOldTarget()
	{
		return (AbstractStoryPatternObject) oldEnd;
	}

	/**
	 * @generated
	 */
	protected AbstractStoryPatternObject getNewTarget()
	{
		return (AbstractStoryPatternObject) newEnd;
	}
}
