package de.mdelab.mlsdm.diagram.edit.parts;

import java.util.ArrayList;
import java.util.Collections;
import java.util.LinkedList;
import java.util.List;

import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.Ellipse;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.PositionConstants;
import org.eclipse.draw2d.Shape;
import org.eclipse.draw2d.StackLayout;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.GraphicalEditPart;
import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.LayoutEditPolicy;
import org.eclipse.gef.editpolicies.NonResizableEditPolicy;
import org.eclipse.gef.handles.MoveHandle;
import org.eclipse.gef.requests.CreateRequest;
import org.eclipse.gmf.runtime.diagram.ui.editparts.AbstractBorderedShapeEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IBorderItemEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.BorderItemSelectionEditPolicy;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles;
import org.eclipse.gmf.runtime.diagram.ui.figures.BorderItemLocator;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.gef.ui.figures.DefaultSizeNodeFigure;
import org.eclipse.gmf.runtime.gef.ui.figures.NodeFigure;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.swt.graphics.Color;

import de.mdelab.mlsdm.diagram.edit.policies.InitialNode2ItemSemanticEditPolicy;
import de.mdelab.mlsdm.diagram.part.MlsdmVisualIDRegistry;
import de.mdelab.mlsdm.diagram.providers.MlsdmElementTypes;

/**
 * @generated
 */
public class InitialNode2EditPart extends AbstractBorderedShapeEditPart
{

	/**
	 * @generated
	 */
	public static final int	VISUAL_ID	= 3010;

	/**
	 * @generated
	 */
	protected IFigure		contentPane;

	/**
	 * @generated
	 */
	protected IFigure		primaryShape;

	/**
	 * @generated
	 */
	public InitialNode2EditPart(View view)
	{
		super(view);
	}

	/**
	 * @generated
	 */
	protected void createDefaultEditPolicies()
	{
		super.createDefaultEditPolicies();
		installEditPolicy(EditPolicyRoles.SEMANTIC_ROLE, new InitialNode2ItemSemanticEditPolicy());
		installEditPolicy(EditPolicy.LAYOUT_ROLE, createLayoutEditPolicy());
		// XXX need an SCR to runtime to have another abstract superclass that would let children add reasonable editpolicies
		// removeEditPolicy(org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles.CONNECTION_HANDLES_ROLE);
	}

	/**
	 * @generated
	 */
	protected LayoutEditPolicy createLayoutEditPolicy()
	{
		org.eclipse.gmf.runtime.diagram.ui.editpolicies.LayoutEditPolicy lep = new org.eclipse.gmf.runtime.diagram.ui.editpolicies.LayoutEditPolicy()
		{

			protected EditPolicy createChildEditPolicy(EditPart child)
			{
				View childView = (View) child.getModel();
				switch (MlsdmVisualIDRegistry.getVisualID(childView))
				{
					case WrappingLabel13EditPart.VISUAL_ID:
						return new BorderItemSelectionEditPolicy()
						{

							protected List<?> createSelectionHandles()
							{
								MoveHandle mh = new MoveHandle((GraphicalEditPart) getHost());
								mh.setBorder(null);
								return Collections.singletonList(mh);
							}
						};
				}
				EditPolicy result = child.getEditPolicy(EditPolicy.PRIMARY_DRAG_ROLE);
				if (result == null)
				{
					result = new NonResizableEditPolicy();
				}
				return result;
			}

			protected Command getMoveChildrenCommand(Request request)
			{
				return null;
			}

			protected Command getCreateCommand(CreateRequest request)
			{
				return null;
			}
		};
		return lep;
	}

	/**
	 * @generated
	 */
	protected IFigure createNodeShape()
	{
		return primaryShape = new InitialNodeFigureDescriptor();
	}

	/**
	 * @generated
	 */
	public InitialNodeFigureDescriptor getPrimaryShape()
	{
		return (InitialNodeFigureDescriptor) primaryShape;
	}

	/**
	 * @generated
	 */
	protected void addBorderItem(IFigure borderItemContainer, IBorderItemEditPart borderItemEditPart)
	{
		if (borderItemEditPart instanceof WrappingLabel13EditPart)
		{
			BorderItemLocator locator = new BorderItemLocator(getMainFigure(), PositionConstants.SOUTH);
			locator.setBorderItemOffset(new Dimension(-20, -20));
			borderItemContainer.add(borderItemEditPart.getFigure(), locator);
		}
		else
		{
			super.addBorderItem(borderItemContainer, borderItemEditPart);
		}
	}

	/**
	 * @generated
	 */
	protected NodeFigure createNodePlate()
	{
		DefaultSizeNodeFigure result = new DefaultSizeNodeFigure(15, 15);
		return result;
	}

	/**
	 * Creates figure for this edit part.
	 * 
	 * Body of this method does not depend on settings in generation model
	 * so you may safely remove <i>generated</i> tag and modify it.
	 * 
	 * @generated
	 */
	protected NodeFigure createMainFigure()
	{
		NodeFigure figure = createNodePlate();
		figure.setLayoutManager(new StackLayout());
		IFigure shape = createNodeShape();
		figure.add(shape);
		contentPane = setupContentPane(shape);
		return figure;
	}

	/**
	 * Default implementation treats passed figure as content pane.
	 * Respects layout one may have set for generated figure.
	 * @param nodeShape instance of generated figure class
	 * @generated
	 */
	protected IFigure setupContentPane(IFigure nodeShape)
	{
		return nodeShape; // use nodeShape itself as contentPane
	}

	/**
	 * @generated
	 */
	public IFigure getContentPane()
	{
		if (contentPane != null)
		{
			return contentPane;
		}
		return super.getContentPane();
	}

	/**
	 * @generated
	 */
	protected void setForegroundColor(Color color)
	{
		if (primaryShape != null)
		{
			primaryShape.setForegroundColor(color);
		}
	}

	/**
	 * @generated
	 */
	protected void setBackgroundColor(Color color)
	{
		if (primaryShape != null)
		{
			primaryShape.setBackgroundColor(color);
		}
	}

	/**
	 * @generated
	 */
	protected void setLineWidth(int width)
	{
		if (primaryShape instanceof Shape)
		{
			((Shape) primaryShape).setLineWidth(width);
		}
	}

	/**
	 * @generated
	 */
	protected void setLineType(int style)
	{
		if (primaryShape instanceof Shape)
		{
			((Shape) primaryShape).setLineStyle(style);
		}
	}

	/**
	 * @generated
	 */
	public EditPart getPrimaryChildEditPart()
	{
		return getChildBySemanticHint(MlsdmVisualIDRegistry.getType(WrappingLabel13EditPart.VISUAL_ID));
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnSource()
	{
		ArrayList<IElementType> types = new ArrayList<IElementType>(1);
		types.add(MlsdmElementTypes.ActivityEdge_4001);
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnSourceAndTarget(IGraphicalEditPart targetEditPart)
	{
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (targetEditPart instanceof ActivityFinalNodeEditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof DecisionMergeNodeEditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof ExpressionActivityNodeEditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof FlowFinalNodeEditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof ForkJoinNodeEditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof InitialNodeEditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof StoryNodeEditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof StructuredNodeEditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof DecisionMergeNode2EditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof ExpressionActivityNode2EditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof FlowFinalNode2EditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof ForkJoinNode2EditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof de.mdelab.mlsdm.diagram.edit.parts.InitialNode2EditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof StoryNode2EditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof StructuredNode2EditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof ActivityFinalNode2EditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMATypesForTarget(IElementType relationshipType)
	{
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (relationshipType == MlsdmElementTypes.ActivityEdge_4001)
		{
			types.add(MlsdmElementTypes.ActivityFinalNode_2002);
			types.add(MlsdmElementTypes.DecisionMergeNode_2006);
			types.add(MlsdmElementTypes.ExpressionActivityNode_2001);
			types.add(MlsdmElementTypes.FlowFinalNode_2007);
			types.add(MlsdmElementTypes.ForkJoinNode_2003);
			types.add(MlsdmElementTypes.InitialNode_2004);
			types.add(MlsdmElementTypes.StoryNode_2008);
			types.add(MlsdmElementTypes.StructuredNode_2009);
			types.add(MlsdmElementTypes.DecisionMergeNode_3006);
			types.add(MlsdmElementTypes.ExpressionActivityNode_3007);
			types.add(MlsdmElementTypes.FlowFinalNode_3008);
			types.add(MlsdmElementTypes.ForkJoinNode_3009);
			types.add(MlsdmElementTypes.InitialNode_3010);
			types.add(MlsdmElementTypes.StoryNode_3011);
			types.add(MlsdmElementTypes.StructuredNode_3018);
			types.add(MlsdmElementTypes.ActivityFinalNode_3019);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnTarget()
	{
		ArrayList<IElementType> types = new ArrayList<IElementType>(1);
		types.add(MlsdmElementTypes.ActivityEdge_4001);
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMATypesForSource(IElementType relationshipType)
	{
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (relationshipType == MlsdmElementTypes.ActivityEdge_4001)
		{
			types.add(MlsdmElementTypes.ActivityFinalNode_2002);
			types.add(MlsdmElementTypes.DecisionMergeNode_2006);
			types.add(MlsdmElementTypes.ExpressionActivityNode_2001);
			types.add(MlsdmElementTypes.FlowFinalNode_2007);
			types.add(MlsdmElementTypes.ForkJoinNode_2003);
			types.add(MlsdmElementTypes.InitialNode_2004);
			types.add(MlsdmElementTypes.StoryNode_2008);
			types.add(MlsdmElementTypes.StructuredNode_2009);
			types.add(MlsdmElementTypes.DecisionMergeNode_3006);
			types.add(MlsdmElementTypes.ExpressionActivityNode_3007);
			types.add(MlsdmElementTypes.FlowFinalNode_3008);
			types.add(MlsdmElementTypes.ForkJoinNode_3009);
			types.add(MlsdmElementTypes.InitialNode_3010);
			types.add(MlsdmElementTypes.StoryNode_3011);
			types.add(MlsdmElementTypes.StructuredNode_3018);
			types.add(MlsdmElementTypes.ActivityFinalNode_3019);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public class InitialNodeFigureDescriptor extends Ellipse
	{

		/**
		 * @generated
		 */
		public InitialNodeFigureDescriptor()
		{
			this.setForegroundColor(ColorConstants.black);
			this.setBackgroundColor(ColorConstants.black);
			this.setPreferredSize(new Dimension(getMapMode().DPtoLP(15), getMapMode().DPtoLP(15)));
			this.setMaximumSize(new Dimension(getMapMode().DPtoLP(15), getMapMode().DPtoLP(15)));
			this.setMinimumSize(new Dimension(getMapMode().DPtoLP(15), getMapMode().DPtoLP(15)));
		}

	}

}
