package de.mdelab.mlsdm.diagram.edit.parts;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

import org.eclipse.draw2d.BorderLayout;
import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.GridData;
import org.eclipse.draw2d.GridLayout;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.MarginBorder;
import org.eclipse.draw2d.RectangleFigure;
import org.eclipse.draw2d.RoundedRectangle;
import org.eclipse.draw2d.Shape;
import org.eclipse.draw2d.StackLayout;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.LayoutEditPolicy;
import org.eclipse.gef.editpolicies.NonResizableEditPolicy;
import org.eclipse.gef.requests.CreateRequest;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ShapeNodeEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles;
import org.eclipse.gmf.runtime.draw2d.ui.figures.ConstrainedToolbarLayout;
import org.eclipse.gmf.runtime.draw2d.ui.figures.WrappingLabel;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.gef.ui.figures.DefaultSizeNodeFigure;
import org.eclipse.gmf.runtime.gef.ui.figures.NodeFigure;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.widgets.Display;

import de.mdelab.mlsdm.diagram.edit.policies.StoryNode2ItemSemanticEditPolicy;
import de.mdelab.mlsdm.diagram.part.MlsdmVisualIDRegistry;
import de.mdelab.mlsdm.diagram.providers.MlsdmElementTypes;

/**
 * @generated
 */
public class StoryNode2EditPart extends ShapeNodeEditPart
{

	/**
	 * @generated
	 */
	public static final int	VISUAL_ID	= 3011;

	/**
	 * @generated
	 */
	protected IFigure		contentPane;

	/**
	 * @generated
	 */
	protected IFigure		primaryShape;

	/**
	 * @generated
	 */
	public StoryNode2EditPart(View view)
	{
		super(view);
	}

	/**
	 * @generated
	 */
	protected void createDefaultEditPolicies()
	{
		super.createDefaultEditPolicies();
		installEditPolicy(EditPolicyRoles.SEMANTIC_ROLE, new StoryNode2ItemSemanticEditPolicy());
		installEditPolicy(EditPolicy.LAYOUT_ROLE, createLayoutEditPolicy());
		// XXX need an SCR to runtime to have another abstract superclass that would let children add reasonable editpolicies
		// removeEditPolicy(org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles.CONNECTION_HANDLES_ROLE);
	}

	/**
	 * @generated
	 */
	protected LayoutEditPolicy createLayoutEditPolicy()
	{
		org.eclipse.gmf.runtime.diagram.ui.editpolicies.LayoutEditPolicy lep = new org.eclipse.gmf.runtime.diagram.ui.editpolicies.LayoutEditPolicy()
		{

			protected EditPolicy createChildEditPolicy(EditPart child)
			{
				EditPolicy result = child.getEditPolicy(EditPolicy.PRIMARY_DRAG_ROLE);
				if (result == null)
				{
					result = new NonResizableEditPolicy();
				}
				return result;
			}

			protected Command getMoveChildrenCommand(Request request)
			{
				return null;
			}

			protected Command getCreateCommand(CreateRequest request)
			{
				return null;
			}
		};
		return lep;
	}

	/**
	 * @generated
	 */
	protected IFigure createNodeShape()
	{
		return primaryShape = new StoryNodeFigureDescriptor();
	}

	/**
	 * @generated
	 */
	public StoryNodeFigureDescriptor getPrimaryShape()
	{
		return (StoryNodeFigureDescriptor) primaryShape;
	}

	/**
	 * @generated
	 */
	protected boolean addFixedChild(EditPart childEditPart)
	{
		if (childEditPart instanceof StoryNodeName2EditPart)
		{
			((StoryNodeName2EditPart) childEditPart).setLabel(getPrimaryShape().getFigureStoryNodeTitleLabel());
			return true;
		}
		if (childEditPart instanceof StoryNodeStoryNodeElementsCompartment2EditPart)
		{
			IFigure pane = getPrimaryShape().getFigureStoryNodeElementsRectangle();
			setupContentPane(pane); // FIXME each comparment should handle his content pane in his own way 
			pane.add(((StoryNodeStoryNodeElementsCompartment2EditPart) childEditPart).getFigure());
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean removeFixedChild(EditPart childEditPart)
	{
		if (childEditPart instanceof StoryNodeName2EditPart)
		{
			return true;
		}
		if (childEditPart instanceof StoryNodeStoryNodeElementsCompartment2EditPart)
		{
			IFigure pane = getPrimaryShape().getFigureStoryNodeElementsRectangle();
			pane.remove(((StoryNodeStoryNodeElementsCompartment2EditPart) childEditPart).getFigure());
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected void addChildVisual(EditPart childEditPart, int index)
	{
		if (addFixedChild(childEditPart))
		{
			return;
		}
		super.addChildVisual(childEditPart, -1);
	}

	/**
	 * @generated
	 */
	protected void removeChildVisual(EditPart childEditPart)
	{
		if (removeFixedChild(childEditPart))
		{
			return;
		}
		super.removeChildVisual(childEditPart);
	}

	/**
	 * @generated
	 */
	protected IFigure getContentPaneFor(IGraphicalEditPart editPart)
	{
		if (editPart instanceof StoryNodeStoryNodeElementsCompartment2EditPart)
		{
			return getPrimaryShape().getFigureStoryNodeElementsRectangle();
		}
		return getContentPane();
	}

	/**
	 * @generated
	 */
	protected NodeFigure createNodePlate()
	{
		DefaultSizeNodeFigure result = new DefaultSizeNodeFigure(40, 40);
		return result;
	}

	/**
	 * Creates figure for this edit part.
	 * 
	 * Body of this method does not depend on settings in generation model
	 * so you may safely remove <i>generated</i> tag and modify it.
	 * 
	 * @generated NOT
	 */
	protected NodeFigure createNodeFigure()
	{
		NodeFigure figure = createNodePlate();
		figure.setLayoutManager(new ResizableFlowLayout());
		IFigure shape = createNodeShape();
		figure.add(shape);
		contentPane = setupContentPane(shape);
		return figure;
	}

	/**
	 * Default implementation treats passed figure as content pane.
	 * Respects layout one may have set for generated figure.
	 * @param nodeShape instance of generated figure class
	 * @generated
	 */
	protected IFigure setupContentPane(IFigure nodeShape)
	{
		if (nodeShape.getLayoutManager() == null)
		{
			ConstrainedToolbarLayout layout = new ConstrainedToolbarLayout();
			layout.setSpacing(5);
			nodeShape.setLayoutManager(layout);
		}
		return nodeShape; // use nodeShape itself as contentPane
	}

	/**
	 * @generated
	 */
	public IFigure getContentPane()
	{
		if (contentPane != null)
		{
			return contentPane;
		}
		return super.getContentPane();
	}

	/**
	 * @generated
	 */
	protected void setForegroundColor(Color color)
	{
		if (primaryShape != null)
		{
			primaryShape.setForegroundColor(color);
		}
	}

	/**
	 * @generated
	 */
	protected void setBackgroundColor(Color color)
	{
		if (primaryShape != null)
		{
			primaryShape.setBackgroundColor(color);
		}
	}

	/**
	 * @generated
	 */
	protected void setLineWidth(int width)
	{
		if (primaryShape instanceof Shape)
		{
			((Shape) primaryShape).setLineWidth(width);
		}
	}

	/**
	 * @generated
	 */
	protected void setLineType(int style)
	{
		if (primaryShape instanceof Shape)
		{
			((Shape) primaryShape).setLineStyle(style);
		}
	}

	/**
	 * @generated
	 */
	public EditPart getPrimaryChildEditPart()
	{
		return getChildBySemanticHint(MlsdmVisualIDRegistry.getType(StoryNodeName2EditPart.VISUAL_ID));
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnSource()
	{
		ArrayList<IElementType> types = new ArrayList<IElementType>(1);
		types.add(MlsdmElementTypes.ActivityEdge_4001);
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnSourceAndTarget(IGraphicalEditPart targetEditPart)
	{
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (targetEditPart instanceof ActivityFinalNodeEditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof DecisionMergeNodeEditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof ExpressionActivityNodeEditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof FlowFinalNodeEditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof ForkJoinNodeEditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof InitialNodeEditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof StoryNodeEditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof StructuredNodeEditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof DecisionMergeNode2EditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof ExpressionActivityNode2EditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof FlowFinalNode2EditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof ForkJoinNode2EditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof InitialNode2EditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof de.mdelab.mlsdm.diagram.edit.parts.StoryNode2EditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof StructuredNode2EditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof ActivityFinalNode2EditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMATypesForTarget(IElementType relationshipType)
	{
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (relationshipType == MlsdmElementTypes.ActivityEdge_4001)
		{
			types.add(MlsdmElementTypes.ActivityFinalNode_2002);
			types.add(MlsdmElementTypes.DecisionMergeNode_2006);
			types.add(MlsdmElementTypes.ExpressionActivityNode_2001);
			types.add(MlsdmElementTypes.FlowFinalNode_2007);
			types.add(MlsdmElementTypes.ForkJoinNode_2003);
			types.add(MlsdmElementTypes.InitialNode_2004);
			types.add(MlsdmElementTypes.StoryNode_2008);
			types.add(MlsdmElementTypes.StructuredNode_2009);
			types.add(MlsdmElementTypes.DecisionMergeNode_3006);
			types.add(MlsdmElementTypes.ExpressionActivityNode_3007);
			types.add(MlsdmElementTypes.FlowFinalNode_3008);
			types.add(MlsdmElementTypes.ForkJoinNode_3009);
			types.add(MlsdmElementTypes.InitialNode_3010);
			types.add(MlsdmElementTypes.StoryNode_3011);
			types.add(MlsdmElementTypes.StructuredNode_3018);
			types.add(MlsdmElementTypes.ActivityFinalNode_3019);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnTarget()
	{
		ArrayList<IElementType> types = new ArrayList<IElementType>(1);
		types.add(MlsdmElementTypes.ActivityEdge_4001);
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMATypesForSource(IElementType relationshipType)
	{
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (relationshipType == MlsdmElementTypes.ActivityEdge_4001)
		{
			types.add(MlsdmElementTypes.ActivityFinalNode_2002);
			types.add(MlsdmElementTypes.DecisionMergeNode_2006);
			types.add(MlsdmElementTypes.ExpressionActivityNode_2001);
			types.add(MlsdmElementTypes.FlowFinalNode_2007);
			types.add(MlsdmElementTypes.ForkJoinNode_2003);
			types.add(MlsdmElementTypes.InitialNode_2004);
			types.add(MlsdmElementTypes.StoryNode_2008);
			types.add(MlsdmElementTypes.StructuredNode_2009);
			types.add(MlsdmElementTypes.DecisionMergeNode_3006);
			types.add(MlsdmElementTypes.ExpressionActivityNode_3007);
			types.add(MlsdmElementTypes.FlowFinalNode_3008);
			types.add(MlsdmElementTypes.ForkJoinNode_3009);
			types.add(MlsdmElementTypes.InitialNode_3010);
			types.add(MlsdmElementTypes.StoryNode_3011);
			types.add(MlsdmElementTypes.StructuredNode_3018);
			types.add(MlsdmElementTypes.ActivityFinalNode_3019);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public class StoryNodeFigureDescriptor extends RoundedRectangle
	{

		/**
		 * @generated
		 */
		private WrappingLabel		fFigureStoryNodeTitleLabel;
		/**
		 * @generated
		 */
		private RoundedRectangle	fFigureStoryNodeElementsRectangle;

		/**
		 * @generated
		 */
		public StoryNodeFigureDescriptor()
		{
			this.setLayoutManager(new StackLayout());
			this.setCornerDimensions(new Dimension(getMapMode().DPtoLP(16), getMapMode().DPtoLP(16)));
			this.setFill(false);
			this.setOutline(false);
			this.setMinimumSize(new Dimension(getMapMode().DPtoLP(100), getMapMode().DPtoLP(50)));
			createContents();
		}

		/**
		 * @generated
		 */
		private void createContents()
		{

			RectangleFigure storyNodeContainerBack0 = new RectangleFigure();

			storyNodeContainerBack0.setFill(false);
			storyNodeContainerBack0.setOutline(false);

			storyNodeContainerBack0.setBorder(new MarginBorder(getMapMode().DPtoLP(10), getMapMode().DPtoLP(10), getMapMode().DPtoLP(0),
					getMapMode().DPtoLP(0)));

			this.add(storyNodeContainerBack0);
			storyNodeContainerBack0.setLayoutManager(new StackLayout());

			RoundedRectangle storyNodeFigureBackRectangle1 = new RoundedRectangle();

			storyNodeFigureBackRectangle1.setCornerDimensions(new Dimension(getMapMode().DPtoLP(16), getMapMode().DPtoLP(16)));
			storyNodeFigureBackRectangle1.setForegroundColor(ColorConstants.black);
			storyNodeFigureBackRectangle1.setBackgroundColor(STORYNODEFIGUREBACKRECTANGLE1_BACK);

			storyNodeContainerBack0.add(storyNodeFigureBackRectangle1);

			RectangleFigure storyNodeContainerFront0 = new RectangleFigure();

			storyNodeContainerFront0.setFill(false);
			storyNodeContainerFront0.setOutline(false);

			storyNodeContainerFront0.setBorder(new MarginBorder(getMapMode().DPtoLP(0), getMapMode().DPtoLP(0), getMapMode().DPtoLP(10),
					getMapMode().DPtoLP(10)));

			this.add(storyNodeContainerFront0);
			storyNodeContainerFront0.setLayoutManager(new StackLayout());

			RoundedRectangle storyNodeFigureFrontRectangle1 = new RoundedRectangle();

			storyNodeFigureFrontRectangle1.setCornerDimensions(new Dimension(getMapMode().DPtoLP(16), getMapMode().DPtoLP(16)));
			storyNodeFigureFrontRectangle1.setForegroundColor(ColorConstants.black);
			storyNodeFigureFrontRectangle1.setBackgroundColor(STORYNODEFIGUREFRONTRECTANGLE1_BACK);

			storyNodeContainerFront0.add(storyNodeFigureFrontRectangle1);

			BorderLayout layoutStoryNodeFigureFrontRectangle1 = new BorderLayout();
			storyNodeFigureFrontRectangle1.setLayoutManager(layoutStoryNodeFigureFrontRectangle1);

			RoundedRectangle storyNodeFigureTitleRectangle2 = new RoundedRectangle();

			storyNodeFigureTitleRectangle2.setCornerDimensions(new Dimension(getMapMode().DPtoLP(16), getMapMode().DPtoLP(16)));
			storyNodeFigureTitleRectangle2.setFill(false);
			storyNodeFigureTitleRectangle2.setOutline(false);
			storyNodeFigureTitleRectangle2.setPreferredSize(new Dimension(getMapMode().DPtoLP(100), getMapMode().DPtoLP(30)));

			storyNodeFigureFrontRectangle1.add(storyNodeFigureTitleRectangle2, BorderLayout.TOP);

			GridLayout layoutStoryNodeFigureTitleRectangle2 = new GridLayout();
			layoutStoryNodeFigureTitleRectangle2.numColumns = 1;
			layoutStoryNodeFigureTitleRectangle2.makeColumnsEqualWidth = true;
			storyNodeFigureTitleRectangle2.setLayoutManager(layoutStoryNodeFigureTitleRectangle2);

			fFigureStoryNodeTitleLabel = new WrappingLabel();

			fFigureStoryNodeTitleLabel.setText("");

			fFigureStoryNodeTitleLabel.setFont(FFIGURESTORYNODETITLELABEL_FONT);

			GridData constraintFFigureStoryNodeTitleLabel = new GridData();
			constraintFFigureStoryNodeTitleLabel.verticalAlignment = GridData.CENTER;
			constraintFFigureStoryNodeTitleLabel.horizontalAlignment = GridData.CENTER;
			constraintFFigureStoryNodeTitleLabel.horizontalIndent = 0;
			constraintFFigureStoryNodeTitleLabel.horizontalSpan = 1;
			constraintFFigureStoryNodeTitleLabel.verticalSpan = 1;
			constraintFFigureStoryNodeTitleLabel.grabExcessHorizontalSpace = true;
			constraintFFigureStoryNodeTitleLabel.grabExcessVerticalSpace = false;
			storyNodeFigureTitleRectangle2.add(fFigureStoryNodeTitleLabel, constraintFFigureStoryNodeTitleLabel);

			RoundedRectangle storyNodeContentRectangle2 = new RoundedRectangle();

			storyNodeContentRectangle2.setCornerDimensions(new Dimension(getMapMode().DPtoLP(16), getMapMode().DPtoLP(16)));
			storyNodeContentRectangle2.setFill(false);
			storyNodeContentRectangle2.setOutline(false);

			storyNodeFigureFrontRectangle1.add(storyNodeContentRectangle2, BorderLayout.CENTER);

			BorderLayout layoutStoryNodeContentRectangle2 = new BorderLayout();
			storyNodeContentRectangle2.setLayoutManager(layoutStoryNodeContentRectangle2);

			fFigureStoryNodeElementsRectangle = new RoundedRectangle();

			fFigureStoryNodeElementsRectangle.setCornerDimensions(new Dimension(getMapMode().DPtoLP(16), getMapMode().DPtoLP(16)));
			fFigureStoryNodeElementsRectangle.setFill(false);
			fFigureStoryNodeElementsRectangle.setOutline(false);

			storyNodeContentRectangle2.add(fFigureStoryNodeElementsRectangle, BorderLayout.CENTER);
			fFigureStoryNodeElementsRectangle.setLayoutManager(new StackLayout());

		}

		/**
		 * @generated
		 */
		public WrappingLabel getFigureStoryNodeTitleLabel()
		{
			return fFigureStoryNodeTitleLabel;
		}

		/**
		 * @generated
		 */
		public RoundedRectangle getFigureStoryNodeElementsRectangle()
		{
			return fFigureStoryNodeElementsRectangle;
		}

	}

	/**
	 * @generated
	 */
	static final Color	STORYNODEFIGUREBACKRECTANGLE1_BACK	= new Color(null, 252, 254, 204);

	/**
	 * @generated
	 */
	static final Color	STORYNODEFIGUREFRONTRECTANGLE1_BACK	= new Color(null, 252, 254, 204);

	/**
	 * @generated
	 */
	static final Font	FFIGURESTORYNODETITLELABEL_FONT		= new Font(Display.getCurrent(), Display.getDefault().getSystemFont()
																	.getFontData()[0].getName(), 10, SWT.BOLD);

}
