/**
 */
package de.mdelab.mlsdm.impl;

import java.util.Collection;

import java.util.Map;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import org.eclipse.ocl.pivot.evaluation.Executor;
import org.eclipse.ocl.pivot.ids.EnumerationLiteralId;
import org.eclipse.ocl.pivot.ids.IdResolver;
import org.eclipse.ocl.pivot.ids.TypeId;
import org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal;
import org.eclipse.ocl.pivot.library.logical.BooleanNotOperation;
import org.eclipse.ocl.pivot.library.oclany.OclAnyOclAsTypeOperation;
import org.eclipse.ocl.pivot.library.oclany.OclAnyOclIsKindOfOperation;
import org.eclipse.ocl.pivot.library.oclany.OclAnyOclIsTypeOfOperation;
import org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation;
import org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation;
import org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation;
import org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation;
import org.eclipse.ocl.pivot.library.string.StringConcatOperation;
import org.eclipse.ocl.pivot.utilities.ClassUtil;
import org.eclipse.ocl.pivot.utilities.PivotUtil;
import org.eclipse.ocl.pivot.utilities.ValueUtil;
import org.eclipse.ocl.pivot.values.IntegerValue;
import org.eclipse.ocl.pivot.values.InvalidValueException;
import org.eclipse.ocl.pivot.values.TupleValue;
import de.mdelab.mlannotations.MLAnnotation;
import de.mdelab.mlannotations.MlannotationsPackage;
import de.mdelab.mlcore.MLAnnotatedElement;
import de.mdelab.mlcore.MlcorePackage;
import de.mdelab.mlcore.impl.MLElementWithUUIDImpl;
import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.mlsdm.AcquireEdge;
import de.mdelab.mlsdm.ActivityEdge;
import de.mdelab.mlsdm.ActivityEdgeGuardEnum;
import de.mdelab.mlsdm.ActivityNode;
import de.mdelab.mlsdm.ActivityNodeContainer;
import de.mdelab.mlsdm.MlsdmPackage;
import de.mdelab.mlsdm.MlsdmTables;
import de.mdelab.mlsdm.ReleaseEdge;
import de.mdelab.mlsdm.StoryNode;
import de.mdelab.mlsdm.StoryNodeSemanticsEnum;
import java.lang.reflect.InvocationTargetException;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Activity Edge</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link de.mdelab.mlsdm.impl.ActivityEdgeImpl#getAnnotations <em>Annotations</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.impl.ActivityEdgeImpl#getSource <em>Source</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.impl.ActivityEdgeImpl#getTarget <em>Target</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.impl.ActivityEdgeImpl#getActivityNodeContainer <em>Activity Node Container</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.impl.ActivityEdgeImpl#getGuardType <em>Guard Type</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.impl.ActivityEdgeImpl#getGuardExpression <em>Guard Expression</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.impl.ActivityEdgeImpl#getAcquireEdges <em>Acquire Edges</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.impl.ActivityEdgeImpl#getReleaseEdges <em>Release Edges</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.impl.ActivityEdgeImpl#getAssertionExpressions <em>Assertion Expressions</em>}</li>
 * </ul>
 *
 * @generated
 */
public class ActivityEdgeImpl extends MLElementWithUUIDImpl implements ActivityEdge {
	/**
	 * The cached value of the '{@link #getAnnotations() <em>Annotations</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getAnnotations()
	 * @generated
	 * @ordered
	 */
	protected EList<MLAnnotation> annotations;

	/**
	 * The cached value of the '{@link #getSource() <em>Source</em>}' reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getSource()
	 * @generated
	 * @ordered
	 */
	protected ActivityNode source;

	/**
	 * The cached value of the '{@link #getTarget() <em>Target</em>}' reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getTarget()
	 * @generated
	 * @ordered
	 */
	protected ActivityNode target;

	/**
	 * The default value of the '{@link #getGuardType() <em>Guard Type</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getGuardType()
	 * @generated
	 * @ordered
	 */
	protected static final ActivityEdgeGuardEnum GUARD_TYPE_EDEFAULT = ActivityEdgeGuardEnum.NONE;

	/**
	 * The cached value of the '{@link #getGuardType() <em>Guard Type</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getGuardType()
	 * @generated
	 * @ordered
	 */
	protected ActivityEdgeGuardEnum guardType = GUARD_TYPE_EDEFAULT;

	/**
	 * The cached value of the '{@link #getGuardExpression() <em>Guard Expression</em>}' containment reference.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @see #getGuardExpression()
	 * @generated
	 * @ordered
	 */
	protected MLExpression guardExpression;

	/**
	 * The cached value of the '{@link #getAcquireEdges() <em>Acquire Edges</em>}' reference list.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see #getAcquireEdges()
	 * @generated
	 * @ordered
	 */
	protected EList<AcquireEdge> acquireEdges;

	/**
	 * The cached value of the '{@link #getReleaseEdges() <em>Release Edges</em>}' reference list.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see #getReleaseEdges()
	 * @generated
	 * @ordered
	 */
	protected EList<ReleaseEdge> releaseEdges;

	/**
	 * The cached value of the '{@link #getAssertionExpressions()
	 * <em>Assertion Expressions</em>}' containment reference list. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getAssertionExpressions()
	 * @generated
	 * @ordered
	 */
	protected EList<MLExpression> assertionExpressions;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected ActivityEdgeImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MlsdmPackage.Literals.ACTIVITY_EDGE;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<MLAnnotation> getAnnotations() {
		if (annotations == null) {
			annotations = new EObjectContainmentWithInverseEList<MLAnnotation>(MLAnnotation.class, this,
					MlsdmPackage.ACTIVITY_EDGE__ANNOTATIONS, MlannotationsPackage.ML_ANNOTATION__ELEMENT);
		}
		return annotations;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ActivityNode getSource() {
		return source;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetSource(ActivityNode newSource, NotificationChain msgs) {
		ActivityNode oldSource = source;
		source = newSource;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET,
					MlsdmPackage.ACTIVITY_EDGE__SOURCE, oldSource, newSource);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setSource(ActivityNode newSource) {
		if (newSource != source) {
			NotificationChain msgs = null;
			if (source != null)
				msgs = ((InternalEObject) source).eInverseRemove(this, MlsdmPackage.ACTIVITY_NODE__OUTGOING_EDGES,
						ActivityNode.class, msgs);
			if (newSource != null)
				msgs = ((InternalEObject) newSource).eInverseAdd(this, MlsdmPackage.ACTIVITY_NODE__OUTGOING_EDGES,
						ActivityNode.class, msgs);
			msgs = basicSetSource(newSource, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MlsdmPackage.ACTIVITY_EDGE__SOURCE, newSource,
					newSource));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ActivityNode getTarget() {
		return target;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetTarget(ActivityNode newTarget, NotificationChain msgs) {
		ActivityNode oldTarget = target;
		target = newTarget;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET,
					MlsdmPackage.ACTIVITY_EDGE__TARGET, oldTarget, newTarget);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setTarget(ActivityNode newTarget) {
		if (newTarget != target) {
			NotificationChain msgs = null;
			if (target != null)
				msgs = ((InternalEObject) target).eInverseRemove(this, MlsdmPackage.ACTIVITY_NODE__INCOMING_EDGES,
						ActivityNode.class, msgs);
			if (newTarget != null)
				msgs = ((InternalEObject) newTarget).eInverseAdd(this, MlsdmPackage.ACTIVITY_NODE__INCOMING_EDGES,
						ActivityNode.class, msgs);
			msgs = basicSetTarget(newTarget, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MlsdmPackage.ACTIVITY_EDGE__TARGET, newTarget,
					newTarget));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ActivityNodeContainer getActivityNodeContainer() {
		if (eContainerFeatureID() != MlsdmPackage.ACTIVITY_EDGE__ACTIVITY_NODE_CONTAINER)
			return null;
		return (ActivityNodeContainer) eInternalContainer();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetActivityNodeContainer(ActivityNodeContainer newActivityNodeContainer,
			NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject) newActivityNodeContainer,
				MlsdmPackage.ACTIVITY_EDGE__ACTIVITY_NODE_CONTAINER, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setActivityNodeContainer(ActivityNodeContainer newActivityNodeContainer) {
		if (newActivityNodeContainer != eInternalContainer()
				|| (eContainerFeatureID() != MlsdmPackage.ACTIVITY_EDGE__ACTIVITY_NODE_CONTAINER
						&& newActivityNodeContainer != null)) {
			if (EcoreUtil.isAncestor(this, newActivityNodeContainer))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newActivityNodeContainer != null)
				msgs = ((InternalEObject) newActivityNodeContainer).eInverseAdd(this,
						MlsdmPackage.ACTIVITY_NODE_CONTAINER__EDGES, ActivityNodeContainer.class, msgs);
			msgs = basicSetActivityNodeContainer(newActivityNodeContainer, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MlsdmPackage.ACTIVITY_EDGE__ACTIVITY_NODE_CONTAINER,
					newActivityNodeContainer, newActivityNodeContainer));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ActivityEdgeGuardEnum getGuardType() {
		return guardType;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setGuardType(ActivityEdgeGuardEnum newGuardType) {
		ActivityEdgeGuardEnum oldGuardType = guardType;
		guardType = newGuardType == null ? GUARD_TYPE_EDEFAULT : newGuardType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MlsdmPackage.ACTIVITY_EDGE__GUARD_TYPE, oldGuardType,
					guardType));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public MLExpression getGuardExpression() {
		return guardExpression;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetGuardExpression(MLExpression newGuardExpression, NotificationChain msgs) {
		MLExpression oldGuardExpression = guardExpression;
		guardExpression = newGuardExpression;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET,
					MlsdmPackage.ACTIVITY_EDGE__GUARD_EXPRESSION, oldGuardExpression, newGuardExpression);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setGuardExpression(MLExpression newGuardExpression) {
		if (newGuardExpression != guardExpression) {
			NotificationChain msgs = null;
			if (guardExpression != null)
				msgs = ((InternalEObject) guardExpression).eInverseRemove(this,
						EOPPOSITE_FEATURE_BASE - MlsdmPackage.ACTIVITY_EDGE__GUARD_EXPRESSION, null, msgs);
			if (newGuardExpression != null)
				msgs = ((InternalEObject) newGuardExpression).eInverseAdd(this,
						EOPPOSITE_FEATURE_BASE - MlsdmPackage.ACTIVITY_EDGE__GUARD_EXPRESSION, null, msgs);
			msgs = basicSetGuardExpression(newGuardExpression, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MlsdmPackage.ACTIVITY_EDGE__GUARD_EXPRESSION,
					newGuardExpression, newGuardExpression));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<AcquireEdge> getAcquireEdges() {
		if (acquireEdges == null) {
			acquireEdges = new EObjectWithInverseEList<AcquireEdge>(AcquireEdge.class, this,
					MlsdmPackage.ACTIVITY_EDGE__ACQUIRE_EDGES, MlsdmPackage.ACQUIRE_EDGE__ACTIVITY_EDGE);
		}
		return acquireEdges;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<ReleaseEdge> getReleaseEdges() {
		if (releaseEdges == null) {
			releaseEdges = new EObjectWithInverseEList<ReleaseEdge>(ReleaseEdge.class, this,
					MlsdmPackage.ACTIVITY_EDGE__RELEASE_EDGES, MlsdmPackage.RELEASE_EDGE__ACTIVITY_EDGE);
		}
		return releaseEdges;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<MLExpression> getAssertionExpressions() {
		if (assertionExpressions == null) {
			assertionExpressions = new EObjectContainmentEList<MLExpression>(MLExpression.class, this,
					MlsdmPackage.ACTIVITY_EDGE__ASSERTION_EXPRESSIONS);
		}
		return assertionExpressions;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean ActivityEdgeBooleanGuard(final DiagnosticChain diagnostics, final Map<Object, Object> context) {
		final String constraintName = "ActivityEdge::ActivityEdgeBooleanGuard";
		try {
			/**
			 *
			 * inv ActivityEdgeBooleanGuard:
			 *   let severity : Integer[1] = constraintName.getSeverity()
			 *   in
			 *     if severity <= 0
			 *     then true
			 *     else
			 *       let
			 *         result : OclAny[1] = let
			 *           status : Boolean[?] = if self.guardType = ActivityEdgeGuardEnum::BOOLEAN and
			 *             self.source.oclIsKindOf(DecisionMergeNode) implies
			 *             self.source.oclIsTypeOf(DecisionMergeNode)
			 *           then true
			 *           else null
			 *           endif
			 *         in
			 *           if status = true
			 *           then true
			 *           else
			 *             Tuple{message = 'The BOOLEAN guard of activity edge ' +
			 *               self.toString() + ' is only valid for edges starting from a decision/merge node.', status = status
			 *             }
			 *           endif
			 *       in
			 *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
			 *     endif
			 */
			final /*@NonInvalid*/ Executor executor = PivotUtil.getExecutor(this, context);
			final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
			/*@Caught*/ Object CAUGHT_severity_0;
			try {
				final /*@Thrown*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE.evaluate(executor,
						MlsdmPackage.Literals.ACTIVITY_EDGE___ACTIVITY_EDGE_BOOLEAN_GUARD__DIAGNOSTICCHAIN_MAP);
				CAUGHT_severity_0 = severity_0;
			} catch (Exception e) {
				CAUGHT_severity_0 = ValueUtil.createInvalidValue(e);
			}
			if (CAUGHT_severity_0 instanceof InvalidValueException) {
				throw (InvalidValueException) CAUGHT_severity_0;
			}
			final /*@Thrown*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
					.evaluate(executor, CAUGHT_severity_0, MlsdmTables.INT_0).booleanValue();
			/*@NonInvalid*/ Object symbol_2;
			if (le) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ ActivityEdgeGuardEnum guardType = this.getGuardType();
				final /*@NonInvalid*/ EnumerationLiteralId BOXED_guardType = MlsdmTables.ENUMid_ActivityEdgeGuardEnum
						.getEnumerationLiteralId(ClassUtil.nonNullState(guardType.getName()));
				final /*@NonInvalid*/ boolean eq = BOXED_guardType == MlsdmTables.ELITid_BOOLEAN;
				/*@NonInvalid*/ boolean and;
				if (eq) {
					final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_mlsdm_c_c_DecisionMergeNode = idResolver
							.getClass(MlsdmTables.CLSSid_DecisionMergeNode, null);
					final /*@NonInvalid*/ ActivityNode source = this.getSource();
					final /*@NonInvalid*/ boolean oclIsKindOf = OclAnyOclIsKindOfOperation.INSTANCE
							.evaluate(executor, source, TYP_mlsdm_c_c_DecisionMergeNode).booleanValue();
					and = oclIsKindOf;
				} else {
					and = ValueUtil.FALSE_VALUE;
				}
				/*@NonInvalid*/ boolean implies;
				if (and) {
					final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_mlsdm_c_c_DecisionMergeNode_0 = idResolver
							.getClass(MlsdmTables.CLSSid_DecisionMergeNode, null);
					final /*@NonInvalid*/ ActivityNode source_0 = this.getSource();
					final /*@NonInvalid*/ boolean oclIsTypeOf = OclAnyOclIsTypeOfOperation.INSTANCE
							.evaluate(executor, source_0, TYP_mlsdm_c_c_DecisionMergeNode_0).booleanValue();
					implies = oclIsTypeOf;
				} else {
					implies = ValueUtil.TRUE_VALUE;
				}
				/*@NonInvalid*/ Boolean status;
				if (implies) {
					status = ValueUtil.TRUE_VALUE;
				} else {
					status = null;
				}
				final /*@NonInvalid*/ boolean eq_0 = status == Boolean.TRUE;
				/*@NonInvalid*/ Object symbol_1;
				if (eq_0) {
					symbol_1 = ValueUtil.TRUE_VALUE;
				} else {
					final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE.evaluate(this);
					final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
							.evaluate(MlsdmTables.STR_The_32_BOOLEAN_32_guard_32_of_32_activity_32_edge_32, toString);
					final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE.evaluate(sum,
							MlsdmTables.STR__32_is_32_only_32_valid_32_for_32_edges_32_starting_32_from_32_a_32_decision_s_merge_32_node);
					final /*@NonInvalid*/ TupleValue symbol_0 = ValueUtil.createTupleOfEach(MlsdmTables.TUPLid_, sum_0,
							status);
					symbol_1 = symbol_0;
				}
				final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
						.evaluate(executor, TypeId.BOOLEAN, constraintName, this, (Object) null, diagnostics, context,
								(Object) null, CAUGHT_severity_0, symbol_1, MlsdmTables.INT_0)
						.booleanValue();
				symbol_2 = logDiagnostic;
			}
			return Boolean.TRUE == symbol_2;
		} catch (Throwable e) {
			return ValueUtil.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean ActivityEdgeSuccessGuard(final DiagnosticChain diagnostics, final Map<Object, Object> context) {
		final String constraintName = "ActivityEdge::ActivityEdgeSuccessGuard";
		try {
			/**
			 *
			 * inv ActivityEdgeSuccessGuard:
			 *   let severity : Integer[1] = constraintName.getSeverity()
			 *   in
			 *     if severity <= 0
			 *     then true
			 *     else
			 *       let
			 *         result : OclAny[1] = let
			 *           status : Boolean[?] = if self.guardType = ActivityEdgeGuardEnum::SUCCESS and
			 *             self.source.oclIsKindOf(StoryNode) implies
			 *             self.source.oclAsType(StoryNode).semantics = StoryNodeSemanticsEnum::SINGLE_MATCH
			 *           then true
			 *           else null
			 *           endif
			 *         in
			 *           if status = true
			 *           then true
			 *           else
			 *             Tuple{message = 'The SUCCESS guard of activity edge ' +
			 *               self.toString() + ' is only valid for edges starting from a story node with SINGLE_MATCH semantics.', status = status
			 *             }
			 *           endif
			 *       in
			 *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
			 *     endif
			 */
			final /*@NonInvalid*/ Executor executor = PivotUtil.getExecutor(this, context);
			final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
			/*@Caught*/ Object CAUGHT_severity_0;
			try {
				final /*@Thrown*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE.evaluate(executor,
						MlsdmPackage.Literals.ACTIVITY_EDGE___ACTIVITY_EDGE_SUCCESS_GUARD__DIAGNOSTICCHAIN_MAP);
				CAUGHT_severity_0 = severity_0;
			} catch (Exception e) {
				CAUGHT_severity_0 = ValueUtil.createInvalidValue(e);
			}
			if (CAUGHT_severity_0 instanceof InvalidValueException) {
				throw (InvalidValueException) CAUGHT_severity_0;
			}
			final /*@Thrown*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
					.evaluate(executor, CAUGHT_severity_0, MlsdmTables.INT_0).booleanValue();
			/*@NonInvalid*/ Object symbol_2;
			if (le) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ ActivityEdgeGuardEnum guardType = this.getGuardType();
				final /*@NonInvalid*/ EnumerationLiteralId BOXED_guardType = MlsdmTables.ENUMid_ActivityEdgeGuardEnum
						.getEnumerationLiteralId(ClassUtil.nonNullState(guardType.getName()));
				final /*@NonInvalid*/ boolean eq = BOXED_guardType == MlsdmTables.ELITid_SUCCESS;
				/*@NonInvalid*/ boolean and;
				if (eq) {
					final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_mlsdm_c_c_StoryNode_0 = idResolver
							.getClass(MlsdmTables.CLSSid_StoryNode, null);
					final /*@NonInvalid*/ ActivityNode source = this.getSource();
					final /*@NonInvalid*/ boolean oclIsKindOf = OclAnyOclIsKindOfOperation.INSTANCE
							.evaluate(executor, source, TYP_mlsdm_c_c_StoryNode_0).booleanValue();
					and = oclIsKindOf;
				} else {
					and = ValueUtil.FALSE_VALUE;
				}
				/*@Thrown*/ boolean implies;
				if (and) {
					final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_mlsdm_c_c_StoryNode_1 = idResolver
							.getClass(MlsdmTables.CLSSid_StoryNode, null);
					final /*@NonInvalid*/ ActivityNode source_0 = this.getSource();
					final /*@Thrown*/ StoryNode oclAsType = (StoryNode) OclAnyOclAsTypeOperation.INSTANCE
							.evaluate(executor, source_0, TYP_mlsdm_c_c_StoryNode_1);
					final /*@Thrown*/ StoryNodeSemanticsEnum semantics = oclAsType.getSemantics();
					final /*@Thrown*/ EnumerationLiteralId BOXED_semantics = MlsdmTables.ENUMid_StoryNodeSemanticsEnum
							.getEnumerationLiteralId(ClassUtil.nonNullState(semantics.getName()));
					final /*@Thrown*/ boolean eq_0 = BOXED_semantics == MlsdmTables.ELITid_SINGLE_MATCH;
					implies = eq_0;
				} else {
					implies = ValueUtil.TRUE_VALUE;
				}
				/*@NonInvalid*/ Boolean status;
				if (implies) {
					status = ValueUtil.TRUE_VALUE;
				} else {
					status = null;
				}
				final /*@NonInvalid*/ boolean eq_1 = status == Boolean.TRUE;
				/*@NonInvalid*/ Object symbol_1;
				if (eq_1) {
					symbol_1 = ValueUtil.TRUE_VALUE;
				} else {
					final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE.evaluate(this);
					final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
							.evaluate(MlsdmTables.STR_The_32_SUCCESS_32_guard_32_of_32_activity_32_edge_32, toString);
					final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE.evaluate(sum,
							MlsdmTables.STR__32_is_32_only_32_valid_32_for_32_edges_32_starting_32_from_32_a_32_story_32_node_32_with_32_SINGLE_);
					final /*@NonInvalid*/ TupleValue symbol_0 = ValueUtil.createTupleOfEach(MlsdmTables.TUPLid_, sum_0,
							status);
					symbol_1 = symbol_0;
				}
				final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
						.evaluate(executor, TypeId.BOOLEAN, constraintName, this, (Object) null, diagnostics, context,
								(Object) null, CAUGHT_severity_0, symbol_1, MlsdmTables.INT_0)
						.booleanValue();
				symbol_2 = logDiagnostic;
			}
			return Boolean.TRUE == symbol_2;
		} catch (Throwable e) {
			return ValueUtil.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean ActivityEdgeGuardType(final DiagnosticChain diagnostics, final Map<Object, Object> context) {
		final String constraintName = "ActivityEdge::ActivityEdgeGuardType";
		try {
			/**
			 *
			 * inv ActivityEdgeGuardType:
			 *   let severity : Integer[1] = constraintName.getSeverity()
			 *   in
			 *     if severity <= 0
			 *     then true
			 *     else
			 *       let
			 *         result : OclAny[1] = let
			 *           status : Boolean[?] = if self.guardType <> null
			 *           then true
			 *           else null
			 *           endif
			 *         in
			 *           if status = true
			 *           then true
			 *           else
			 *             Tuple{message = 'Guard type of activity edge ' +
			 *               self.toString() + ' must be specified.', status = status
			 *             }
			 *           endif
			 *       in
			 *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
			 *     endif
			 */
			final /*@NonInvalid*/ Executor executor = PivotUtil.getExecutor(this, context);
			/*@Caught*/ Object CAUGHT_severity_0;
			try {
				final /*@Thrown*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE.evaluate(executor,
						MlsdmPackage.Literals.ACTIVITY_EDGE___ACTIVITY_EDGE_GUARD_TYPE__DIAGNOSTICCHAIN_MAP);
				CAUGHT_severity_0 = severity_0;
			} catch (Exception e) {
				CAUGHT_severity_0 = ValueUtil.createInvalidValue(e);
			}
			if (CAUGHT_severity_0 instanceof InvalidValueException) {
				throw (InvalidValueException) CAUGHT_severity_0;
			}
			final /*@Thrown*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
					.evaluate(executor, CAUGHT_severity_0, MlsdmTables.INT_0).booleanValue();
			/*@NonInvalid*/ Object symbol_0;
			if (le) {
				symbol_0 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
						.evaluate(executor, TypeId.BOOLEAN, constraintName, this, (Object) null, diagnostics, context,
								(Object) null, CAUGHT_severity_0, ValueUtil.TRUE_VALUE, MlsdmTables.INT_0)
						.booleanValue();
				symbol_0 = logDiagnostic;
			}
			return Boolean.TRUE == symbol_0;
		} catch (Throwable e) {
			return ValueUtil.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean ActivityEdgeForEachGuard(final DiagnosticChain diagnostics, final Map<Object, Object> context) {
		final String constraintName = "ActivityEdge::ActivityEdgeForEachGuard";
		try {
			/**
			 *
			 * inv ActivityEdgeForEachGuard:
			 *   let severity : Integer[1] = constraintName.getSeverity()
			 *   in
			 *     if severity <= 0
			 *     then true
			 *     else
			 *       let
			 *         result : OclAny[1] = let
			 *           status : Boolean[?] = if self.guardType = ActivityEdgeGuardEnum::FOR_EACH and
			 *             self.source.oclIsKindOf(StoryNode) implies
			 *             self.source.oclAsType(StoryNode).semantics = StoryNodeSemanticsEnum::FOR_EACH_FRESH_MATCH
			 *           then true
			 *           else null
			 *           endif
			 *         in
			 *           if status = true
			 *           then true
			 *           else
			 *             Tuple{message = 'The FOR_EACH guard of activity edge ' +
			 *               self.toString() + ' is only valid for edges starting from a story node with FOR_EACH semantics.', status = status
			 *             }
			 *           endif
			 *       in
			 *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
			 *     endif
			 */
			final /*@NonInvalid*/ Executor executor = PivotUtil.getExecutor(this, context);
			final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
			/*@Caught*/ Object CAUGHT_severity_0;
			try {
				final /*@Thrown*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE.evaluate(executor,
						MlsdmPackage.Literals.ACTIVITY_EDGE___ACTIVITY_EDGE_FOR_EACH_GUARD__DIAGNOSTICCHAIN_MAP);
				CAUGHT_severity_0 = severity_0;
			} catch (Exception e) {
				CAUGHT_severity_0 = ValueUtil.createInvalidValue(e);
			}
			if (CAUGHT_severity_0 instanceof InvalidValueException) {
				throw (InvalidValueException) CAUGHT_severity_0;
			}
			final /*@Thrown*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
					.evaluate(executor, CAUGHT_severity_0, MlsdmTables.INT_0).booleanValue();
			/*@NonInvalid*/ Object symbol_2;
			if (le) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ ActivityEdgeGuardEnum guardType = this.getGuardType();
				final /*@NonInvalid*/ EnumerationLiteralId BOXED_guardType = MlsdmTables.ENUMid_ActivityEdgeGuardEnum
						.getEnumerationLiteralId(ClassUtil.nonNullState(guardType.getName()));
				final /*@NonInvalid*/ boolean eq = BOXED_guardType == MlsdmTables.ELITid_FOR_EACH;
				/*@NonInvalid*/ boolean and;
				if (eq) {
					final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_mlsdm_c_c_StoryNode = idResolver
							.getClass(MlsdmTables.CLSSid_StoryNode, null);
					final /*@NonInvalid*/ ActivityNode source = this.getSource();
					final /*@NonInvalid*/ boolean oclIsKindOf = OclAnyOclIsKindOfOperation.INSTANCE
							.evaluate(executor, source, TYP_mlsdm_c_c_StoryNode).booleanValue();
					and = oclIsKindOf;
				} else {
					and = ValueUtil.FALSE_VALUE;
				}
				/*@Thrown*/ boolean implies;
				if (and) {
					final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_mlsdm_c_c_StoryNode_0 = idResolver
							.getClass(MlsdmTables.CLSSid_StoryNode, null);
					final /*@NonInvalid*/ ActivityNode source_0 = this.getSource();
					final /*@Thrown*/ StoryNode oclAsType = (StoryNode) OclAnyOclAsTypeOperation.INSTANCE
							.evaluate(executor, source_0, TYP_mlsdm_c_c_StoryNode_0);
					final /*@Thrown*/ StoryNodeSemanticsEnum semantics = oclAsType.getSemantics();
					final /*@Thrown*/ EnumerationLiteralId BOXED_semantics = MlsdmTables.ENUMid_StoryNodeSemanticsEnum
							.getEnumerationLiteralId(ClassUtil.nonNullState(semantics.getName()));
					final /*@Thrown*/ boolean eq_0 = BOXED_semantics == MlsdmTables.ELITid_FOR_EACH_FRESH_MATCH;
					implies = eq_0;
				} else {
					implies = ValueUtil.TRUE_VALUE;
				}
				/*@NonInvalid*/ Boolean status;
				if (implies) {
					status = ValueUtil.TRUE_VALUE;
				} else {
					status = null;
				}
				final /*@NonInvalid*/ boolean eq_1 = status == Boolean.TRUE;
				/*@NonInvalid*/ Object symbol_1;
				if (eq_1) {
					symbol_1 = ValueUtil.TRUE_VALUE;
				} else {
					final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE.evaluate(this);
					final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
							.evaluate(MlsdmTables.STR_The_32_FOR_EACH_32_guard_32_of_32_activity_32_edge_32, toString);
					final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE.evaluate(sum,
							MlsdmTables.STR__32_is_32_only_32_valid_32_for_32_edges_32_starting_32_from_32_a_32_story_32_node_32_with_32_FOR_EAC);
					final /*@NonInvalid*/ TupleValue symbol_0 = ValueUtil.createTupleOfEach(MlsdmTables.TUPLid_, sum_0,
							status);
					symbol_1 = symbol_0;
				}
				final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
						.evaluate(executor, TypeId.BOOLEAN, constraintName, this, (Object) null, diagnostics, context,
								(Object) null, CAUGHT_severity_0, symbol_1, MlsdmTables.INT_0)
						.booleanValue();
				symbol_2 = logDiagnostic;
			}
			return Boolean.TRUE == symbol_2;
		} catch (Throwable e) {
			return ValueUtil.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean ActivityEdgeSource(final DiagnosticChain diagnostics, final Map<Object, Object> context) {
		final String constraintName = "ActivityEdge::ActivityEdgeSource";
		try {
			/**
			 *
			 * inv ActivityEdgeSource:
			 *   let severity : Integer[1] = constraintName.getSeverity()
			 *   in
			 *     if severity <= 0
			 *     then true
			 *     else
			 *       let
			 *         result : OclAny[1] = let
			 *           status : Boolean[?] = if self.source <> null
			 *           then true
			 *           else null
			 *           endif
			 *         in
			 *           if status = true
			 *           then true
			 *           else
			 *             Tuple{message = 'Source of activity edge ' +
			 *               self.toString() + ' must be specified.', status = status
			 *             }
			 *           endif
			 *       in
			 *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
			 *     endif
			 */
			final /*@NonInvalid*/ Executor executor = PivotUtil.getExecutor(this, context);
			/*@Caught*/ Object CAUGHT_severity_0;
			try {
				final /*@Thrown*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE.evaluate(executor,
						MlsdmPackage.Literals.ACTIVITY_EDGE___ACTIVITY_EDGE_SOURCE__DIAGNOSTICCHAIN_MAP);
				CAUGHT_severity_0 = severity_0;
			} catch (Exception e) {
				CAUGHT_severity_0 = ValueUtil.createInvalidValue(e);
			}
			if (CAUGHT_severity_0 instanceof InvalidValueException) {
				throw (InvalidValueException) CAUGHT_severity_0;
			}
			final /*@Thrown*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
					.evaluate(executor, CAUGHT_severity_0, MlsdmTables.INT_0).booleanValue();
			/*@NonInvalid*/ Object symbol_0;
			if (le) {
				symbol_0 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
						.evaluate(executor, TypeId.BOOLEAN, constraintName, this, (Object) null, diagnostics, context,
								(Object) null, CAUGHT_severity_0, ValueUtil.TRUE_VALUE, MlsdmTables.INT_0)
						.booleanValue();
				symbol_0 = logDiagnostic;
			}
			return Boolean.TRUE == symbol_0;
		} catch (Throwable e) {
			return ValueUtil.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean ActivityEdgeElseGuard(final DiagnosticChain diagnostics, final Map<Object, Object> context) {
		final String constraintName = "ActivityEdge::ActivityEdgeElseGuard";
		try {
			/**
			 *
			 * inv ActivityEdgeElseGuard:
			 *   let severity : Integer[1] = constraintName.getSeverity()
			 *   in
			 *     if severity <= 0
			 *     then true
			 *     else
			 *       let
			 *         result : OclAny[1] = let
			 *           status : Boolean[?] = if self.guardType = ActivityEdgeGuardEnum::ELSE implies
			 *             self.source.oclIsTypeOf(DecisionMergeNode)
			 *           then true
			 *           else null
			 *           endif
			 *         in
			 *           if status = true
			 *           then true
			 *           else
			 *             Tuple{message = 'The ELSE guard of activity edge ' +
			 *               self.toString() + ' is only valid for edges starting from a decision/merge node.', status = status
			 *             }
			 *           endif
			 *       in
			 *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
			 *     endif
			 */
			final /*@NonInvalid*/ Executor executor = PivotUtil.getExecutor(this, context);
			final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
			/*@Caught*/ Object CAUGHT_severity_0;
			try {
				final /*@Thrown*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE.evaluate(executor,
						MlsdmPackage.Literals.ACTIVITY_EDGE___ACTIVITY_EDGE_ELSE_GUARD__DIAGNOSTICCHAIN_MAP);
				CAUGHT_severity_0 = severity_0;
			} catch (Exception e) {
				CAUGHT_severity_0 = ValueUtil.createInvalidValue(e);
			}
			if (CAUGHT_severity_0 instanceof InvalidValueException) {
				throw (InvalidValueException) CAUGHT_severity_0;
			}
			final /*@Thrown*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
					.evaluate(executor, CAUGHT_severity_0, MlsdmTables.INT_0).booleanValue();
			/*@NonInvalid*/ Object symbol_2;
			if (le) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ ActivityEdgeGuardEnum guardType = this.getGuardType();
				final /*@NonInvalid*/ EnumerationLiteralId BOXED_guardType = MlsdmTables.ENUMid_ActivityEdgeGuardEnum
						.getEnumerationLiteralId(ClassUtil.nonNullState(guardType.getName()));
				final /*@NonInvalid*/ boolean eq = BOXED_guardType == MlsdmTables.ELITid_ELSE;
				/*@NonInvalid*/ boolean implies;
				if (eq) {
					final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_mlsdm_c_c_DecisionMergeNode_0 = idResolver
							.getClass(MlsdmTables.CLSSid_DecisionMergeNode, null);
					final /*@NonInvalid*/ ActivityNode source = this.getSource();
					final /*@NonInvalid*/ boolean oclIsTypeOf = OclAnyOclIsTypeOfOperation.INSTANCE
							.evaluate(executor, source, TYP_mlsdm_c_c_DecisionMergeNode_0).booleanValue();
					implies = oclIsTypeOf;
				} else {
					implies = ValueUtil.TRUE_VALUE;
				}
				/*@NonInvalid*/ Boolean status;
				if (implies) {
					status = ValueUtil.TRUE_VALUE;
				} else {
					status = null;
				}
				final /*@NonInvalid*/ boolean eq_0 = status == Boolean.TRUE;
				/*@NonInvalid*/ Object symbol_1;
				if (eq_0) {
					symbol_1 = ValueUtil.TRUE_VALUE;
				} else {
					final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE.evaluate(this);
					final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
							.evaluate(MlsdmTables.STR_The_32_ELSE_32_guard_32_of_32_activity_32_edge_32, toString);
					final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE.evaluate(sum,
							MlsdmTables.STR__32_is_32_only_32_valid_32_for_32_edges_32_starting_32_from_32_a_32_decision_s_merge_32_node);
					final /*@NonInvalid*/ TupleValue symbol_0 = ValueUtil.createTupleOfEach(MlsdmTables.TUPLid_, sum_0,
							status);
					symbol_1 = symbol_0;
				}
				final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
						.evaluate(executor, TypeId.BOOLEAN, constraintName, this, (Object) null, diagnostics, context,
								(Object) null, CAUGHT_severity_0, symbol_1, MlsdmTables.INT_0)
						.booleanValue();
				symbol_2 = logDiagnostic;
			}
			return Boolean.TRUE == symbol_2;
		} catch (Throwable e) {
			return ValueUtil.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean ActivityEdgeTarget(final DiagnosticChain diagnostics, final Map<Object, Object> context) {
		final String constraintName = "ActivityEdge::ActivityEdgeTarget";
		try {
			/**
			 *
			 * inv ActivityEdgeTarget:
			 *   let severity : Integer[1] = constraintName.getSeverity()
			 *   in
			 *     if severity <= 0
			 *     then true
			 *     else
			 *       let
			 *         result : OclAny[1] = let
			 *           status : Boolean[?] = if self.target <> null
			 *           then true
			 *           else null
			 *           endif
			 *         in
			 *           if status = true
			 *           then true
			 *           else
			 *             Tuple{message = 'Target of activity edge ' +
			 *               self.toString() + ' must be specified.', status = status
			 *             }
			 *           endif
			 *       in
			 *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
			 *     endif
			 */
			final /*@NonInvalid*/ Executor executor = PivotUtil.getExecutor(this, context);
			/*@Caught*/ Object CAUGHT_severity_0;
			try {
				final /*@Thrown*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE.evaluate(executor,
						MlsdmPackage.Literals.ACTIVITY_EDGE___ACTIVITY_EDGE_TARGET__DIAGNOSTICCHAIN_MAP);
				CAUGHT_severity_0 = severity_0;
			} catch (Exception e) {
				CAUGHT_severity_0 = ValueUtil.createInvalidValue(e);
			}
			if (CAUGHT_severity_0 instanceof InvalidValueException) {
				throw (InvalidValueException) CAUGHT_severity_0;
			}
			final /*@Thrown*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
					.evaluate(executor, CAUGHT_severity_0, MlsdmTables.INT_0).booleanValue();
			/*@NonInvalid*/ Object symbol_0;
			if (le) {
				symbol_0 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
						.evaluate(executor, TypeId.BOOLEAN, constraintName, this, (Object) null, diagnostics, context,
								(Object) null, CAUGHT_severity_0, ValueUtil.TRUE_VALUE, MlsdmTables.INT_0)
						.booleanValue();
				symbol_0 = logDiagnostic;
			}
			return Boolean.TRUE == symbol_0;
		} catch (Throwable e) {
			return ValueUtil.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean ActivityEdgeFailureGuard(final DiagnosticChain diagnostics, final Map<Object, Object> context) {
		final String constraintName = "ActivityEdge::ActivityEdgeFailureGuard";
		try {
			/**
			 *
			 * inv ActivityEdgeFailureGuard:
			 *   let severity : Integer[1] = constraintName.getSeverity()
			 *   in
			 *     if severity <= 0
			 *     then true
			 *     else
			 *       let
			 *         result : OclAny[1] = let
			 *           status : Boolean[?] = if self.guardType = ActivityEdgeGuardEnum::FAILURE and
			 *             self.source.oclIsKindOf(StoryNode) implies
			 *             self.source.oclAsType(StoryNode).semantics = StoryNodeSemanticsEnum::SINGLE_MATCH
			 *           then true
			 *           else null
			 *           endif
			 *         in
			 *           if status = true
			 *           then true
			 *           else
			 *             Tuple{message = 'The FAILURE guard of activity edge ' +
			 *               self.toString() + ' is only valid for edges starting from a story node with SINGLE_MATCH semantics.', status = status
			 *             }
			 *           endif
			 *       in
			 *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
			 *     endif
			 */
			final /*@NonInvalid*/ Executor executor = PivotUtil.getExecutor(this, context);
			final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
			/*@Caught*/ Object CAUGHT_severity_0;
			try {
				final /*@Thrown*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE.evaluate(executor,
						MlsdmPackage.Literals.ACTIVITY_EDGE___ACTIVITY_EDGE_FAILURE_GUARD__DIAGNOSTICCHAIN_MAP);
				CAUGHT_severity_0 = severity_0;
			} catch (Exception e) {
				CAUGHT_severity_0 = ValueUtil.createInvalidValue(e);
			}
			if (CAUGHT_severity_0 instanceof InvalidValueException) {
				throw (InvalidValueException) CAUGHT_severity_0;
			}
			final /*@Thrown*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
					.evaluate(executor, CAUGHT_severity_0, MlsdmTables.INT_0).booleanValue();
			/*@NonInvalid*/ Object symbol_2;
			if (le) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ ActivityEdgeGuardEnum guardType = this.getGuardType();
				final /*@NonInvalid*/ EnumerationLiteralId BOXED_guardType = MlsdmTables.ENUMid_ActivityEdgeGuardEnum
						.getEnumerationLiteralId(ClassUtil.nonNullState(guardType.getName()));
				final /*@NonInvalid*/ boolean eq = BOXED_guardType == MlsdmTables.ELITid_FAILURE;
				/*@NonInvalid*/ boolean and;
				if (eq) {
					final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_mlsdm_c_c_StoryNode_0 = idResolver
							.getClass(MlsdmTables.CLSSid_StoryNode, null);
					final /*@NonInvalid*/ ActivityNode source = this.getSource();
					final /*@NonInvalid*/ boolean oclIsKindOf = OclAnyOclIsKindOfOperation.INSTANCE
							.evaluate(executor, source, TYP_mlsdm_c_c_StoryNode_0).booleanValue();
					and = oclIsKindOf;
				} else {
					and = ValueUtil.FALSE_VALUE;
				}
				/*@Thrown*/ boolean implies;
				if (and) {
					final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_mlsdm_c_c_StoryNode_1 = idResolver
							.getClass(MlsdmTables.CLSSid_StoryNode, null);
					final /*@NonInvalid*/ ActivityNode source_0 = this.getSource();
					final /*@Thrown*/ StoryNode oclAsType = (StoryNode) OclAnyOclAsTypeOperation.INSTANCE
							.evaluate(executor, source_0, TYP_mlsdm_c_c_StoryNode_1);
					final /*@Thrown*/ StoryNodeSemanticsEnum semantics = oclAsType.getSemantics();
					final /*@Thrown*/ EnumerationLiteralId BOXED_semantics = MlsdmTables.ENUMid_StoryNodeSemanticsEnum
							.getEnumerationLiteralId(ClassUtil.nonNullState(semantics.getName()));
					final /*@Thrown*/ boolean eq_0 = BOXED_semantics == MlsdmTables.ELITid_SINGLE_MATCH;
					implies = eq_0;
				} else {
					implies = ValueUtil.TRUE_VALUE;
				}
				/*@NonInvalid*/ Boolean status;
				if (implies) {
					status = ValueUtil.TRUE_VALUE;
				} else {
					status = null;
				}
				final /*@NonInvalid*/ boolean eq_1 = status == Boolean.TRUE;
				/*@NonInvalid*/ Object symbol_1;
				if (eq_1) {
					symbol_1 = ValueUtil.TRUE_VALUE;
				} else {
					final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE.evaluate(this);
					final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
							.evaluate(MlsdmTables.STR_The_32_FAILURE_32_guard_32_of_32_activity_32_edge_32, toString);
					final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE.evaluate(sum,
							MlsdmTables.STR__32_is_32_only_32_valid_32_for_32_edges_32_starting_32_from_32_a_32_story_32_node_32_with_32_SINGLE_);
					final /*@NonInvalid*/ TupleValue symbol_0 = ValueUtil.createTupleOfEach(MlsdmTables.TUPLid_, sum_0,
							status);
					symbol_1 = symbol_0;
				}
				final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
						.evaluate(executor, TypeId.BOOLEAN, constraintName, this, (Object) null, diagnostics, context,
								(Object) null, CAUGHT_severity_0, symbol_1, MlsdmTables.INT_0)
						.booleanValue();
				symbol_2 = logDiagnostic;
			}
			return Boolean.TRUE == symbol_2;
		} catch (Throwable e) {
			return ValueUtil.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean ActivityEdgeGuardExpression(final DiagnosticChain diagnostics, final Map<Object, Object> context) {
		final String constraintName = "ActivityEdge::ActivityEdgeGuardExpression";
		try {
			/**
			 *
			 * inv ActivityEdgeGuardExpression:
			 *   let severity : Integer[1] = constraintName.getSeverity()
			 *   in
			 *     if severity <= 0
			 *     then true
			 *     else
			 *       let
			 *         result : OclAny[1] = let
			 *           status : Boolean[?] = if self.guardType = ActivityEdgeGuardEnum::BOOLEAN implies self.guardExpression <> null
			 *           then true
			 *           else null
			 *           endif
			 *         in
			 *           if status = true
			 *           then true
			 *           else
			 *             Tuple{message = 'A guard expression for the boolean guard of activity edge ' +
			 *               self.toString() + ' must be specified.', status = status
			 *             }
			 *           endif
			 *       in
			 *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
			 *     endif
			 */
			final /*@NonInvalid*/ Executor executor = PivotUtil.getExecutor(this, context);
			/*@Caught*/ Object CAUGHT_severity_0;
			try {
				final /*@Thrown*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE.evaluate(executor,
						MlsdmPackage.Literals.ACTIVITY_EDGE___ACTIVITY_EDGE_GUARD_EXPRESSION__DIAGNOSTICCHAIN_MAP);
				CAUGHT_severity_0 = severity_0;
			} catch (Exception e) {
				CAUGHT_severity_0 = ValueUtil.createInvalidValue(e);
			}
			if (CAUGHT_severity_0 instanceof InvalidValueException) {
				throw (InvalidValueException) CAUGHT_severity_0;
			}
			final /*@Thrown*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
					.evaluate(executor, CAUGHT_severity_0, MlsdmTables.INT_0).booleanValue();
			/*@NonInvalid*/ Object symbol_2;
			if (le) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ ActivityEdgeGuardEnum guardType = this.getGuardType();
				final /*@NonInvalid*/ EnumerationLiteralId BOXED_guardType = MlsdmTables.ENUMid_ActivityEdgeGuardEnum
						.getEnumerationLiteralId(ClassUtil.nonNullState(guardType.getName()));
				final /*@NonInvalid*/ boolean eq = BOXED_guardType == MlsdmTables.ELITid_BOOLEAN;
				/*@NonInvalid*/ boolean implies;
				if (eq) {
					final /*@NonInvalid*/ MLExpression guardExpression = this.getGuardExpression();
					final /*@NonInvalid*/ boolean ne = guardExpression != null;
					implies = ne;
				} else {
					implies = ValueUtil.TRUE_VALUE;
				}
				/*@NonInvalid*/ Boolean status;
				if (implies) {
					status = ValueUtil.TRUE_VALUE;
				} else {
					status = null;
				}
				final /*@NonInvalid*/ boolean eq_0 = status == Boolean.TRUE;
				/*@NonInvalid*/ Object symbol_1;
				if (eq_0) {
					symbol_1 = ValueUtil.TRUE_VALUE;
				} else {
					final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE.evaluate(this);
					final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE.evaluate(
							MlsdmTables.STR_A_32_guard_32_expression_32_for_32_the_32_boolean_32_guard_32_of_32_activity_32_edge_32,
							toString);
					final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE.evaluate(sum,
							MlsdmTables.STR__32_must_32_be_32_specified);
					final /*@NonInvalid*/ TupleValue symbol_0 = ValueUtil.createTupleOfEach(MlsdmTables.TUPLid_, sum_0,
							status);
					symbol_1 = symbol_0;
				}
				final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
						.evaluate(executor, TypeId.BOOLEAN, constraintName, this, (Object) null, diagnostics, context,
								(Object) null, CAUGHT_severity_0, symbol_1, MlsdmTables.INT_0)
						.booleanValue();
				symbol_2 = logDiagnostic;
			}
			return Boolean.TRUE == symbol_2;
		} catch (Throwable e) {
			return ValueUtil.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean ActivityEdgeNoGuardExpression(final DiagnosticChain diagnostics, final Map<Object, Object> context) {
		final String constraintName = "ActivityEdge::ActivityEdgeNoGuardExpression";
		try {
			/**
			 *
			 * inv ActivityEdgeNoGuardExpression:
			 *   let severity : Integer[1] = constraintName.getSeverity()
			 *   in
			 *     if severity <= 0
			 *     then true
			 *     else
			 *       let
			 *         result : OclAny[1] = let
			 *           status : Boolean[?] = if self.guardExpression <> null implies self.guardType = ActivityEdgeGuardEnum::BOOLEAN
			 *           then true
			 *           else null
			 *           endif
			 *         in
			 *           if status = true
			 *           then true
			 *           else
			 *             Tuple{message = 'A guard expression may only be specified for boolean guards (activity edge ' +
			 *               self.toString() + ').', status = status
			 *             }
			 *           endif
			 *       in
			 *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
			 *     endif
			 */
			final /*@NonInvalid*/ Executor executor = PivotUtil.getExecutor(this, context);
			/*@Caught*/ Object CAUGHT_severity_0;
			try {
				final /*@Thrown*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE.evaluate(executor,
						MlsdmPackage.Literals.ACTIVITY_EDGE___ACTIVITY_EDGE_NO_GUARD_EXPRESSION__DIAGNOSTICCHAIN_MAP);
				CAUGHT_severity_0 = severity_0;
			} catch (Exception e) {
				CAUGHT_severity_0 = ValueUtil.createInvalidValue(e);
			}
			if (CAUGHT_severity_0 instanceof InvalidValueException) {
				throw (InvalidValueException) CAUGHT_severity_0;
			}
			final /*@Thrown*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
					.evaluate(executor, CAUGHT_severity_0, MlsdmTables.INT_0).booleanValue();
			/*@NonInvalid*/ Object symbol_2;
			if (le) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ MLExpression guardExpression = this.getGuardExpression();
				final /*@NonInvalid*/ boolean ne = guardExpression != null;
				/*@NonInvalid*/ boolean implies;
				if (ne) {
					final /*@NonInvalid*/ ActivityEdgeGuardEnum guardType = this.getGuardType();
					final /*@NonInvalid*/ EnumerationLiteralId BOXED_guardType = MlsdmTables.ENUMid_ActivityEdgeGuardEnum
							.getEnumerationLiteralId(ClassUtil.nonNullState(guardType.getName()));
					final /*@NonInvalid*/ boolean eq = BOXED_guardType == MlsdmTables.ELITid_BOOLEAN;
					implies = eq;
				} else {
					implies = ValueUtil.TRUE_VALUE;
				}
				/*@NonInvalid*/ Boolean status;
				if (implies) {
					status = ValueUtil.TRUE_VALUE;
				} else {
					status = null;
				}
				final /*@NonInvalid*/ boolean eq_0 = status == Boolean.TRUE;
				/*@NonInvalid*/ Object symbol_1;
				if (eq_0) {
					symbol_1 = ValueUtil.TRUE_VALUE;
				} else {
					final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE.evaluate(this);
					final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE.evaluate(
							MlsdmTables.STR_A_32_guard_32_expression_32_may_32_only_32_be_32_specified_32_for_32_boolean_32_guards_32_o_act,
							toString);
					final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE.evaluate(sum,
							MlsdmTables.STR__e_);
					final /*@NonInvalid*/ TupleValue symbol_0 = ValueUtil.createTupleOfEach(MlsdmTables.TUPLid_, sum_0,
							status);
					symbol_1 = symbol_0;
				}
				final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
						.evaluate(executor, TypeId.BOOLEAN, constraintName, this, (Object) null, diagnostics, context,
								(Object) null, CAUGHT_severity_0, symbol_1, MlsdmTables.INT_0)
						.booleanValue();
				symbol_2 = logDiagnostic;
			}
			return Boolean.TRUE == symbol_2;
		} catch (Throwable e) {
			return ValueUtil.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean ActivityEdgeEndGuard(final DiagnosticChain diagnostics, final Map<Object, Object> context) {
		final String constraintName = "ActivityEdge::ActivityEdgeEndGuard";
		try {
			/**
			 *
			 * inv ActivityEdgeEndGuard:
			 *   let severity : Integer[1] = constraintName.getSeverity()
			 *   in
			 *     if severity <= 0
			 *     then true
			 *     else
			 *       let
			 *         result : OclAny[1] = let
			 *           status : Boolean[?] = if self.guardType = ActivityEdgeGuardEnum::END and
			 *             self.source.oclIsKindOf(StoryNode) implies
			 *             self.source.oclAsType(StoryNode).semantics = StoryNodeSemanticsEnum::FOR_EACH_FRESH_MATCH
			 *           then true
			 *           else null
			 *           endif
			 *         in
			 *           if status = true
			 *           then true
			 *           else
			 *             Tuple{message = 'The END guard of activity edge ' +
			 *               self.toString() + ' is only valid for edges starting from a story node with FOR_EACH semantics.', status = status
			 *             }
			 *           endif
			 *       in
			 *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
			 *     endif
			 */
			final /*@NonInvalid*/ Executor executor = PivotUtil.getExecutor(this, context);
			final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
			/*@Caught*/ Object CAUGHT_severity_0;
			try {
				final /*@Thrown*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE.evaluate(executor,
						MlsdmPackage.Literals.ACTIVITY_EDGE___ACTIVITY_EDGE_END_GUARD__DIAGNOSTICCHAIN_MAP);
				CAUGHT_severity_0 = severity_0;
			} catch (Exception e) {
				CAUGHT_severity_0 = ValueUtil.createInvalidValue(e);
			}
			if (CAUGHT_severity_0 instanceof InvalidValueException) {
				throw (InvalidValueException) CAUGHT_severity_0;
			}
			final /*@Thrown*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
					.evaluate(executor, CAUGHT_severity_0, MlsdmTables.INT_0).booleanValue();
			/*@NonInvalid*/ Object symbol_2;
			if (le) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ ActivityEdgeGuardEnum guardType = this.getGuardType();
				final /*@NonInvalid*/ EnumerationLiteralId BOXED_guardType = MlsdmTables.ENUMid_ActivityEdgeGuardEnum
						.getEnumerationLiteralId(ClassUtil.nonNullState(guardType.getName()));
				final /*@NonInvalid*/ boolean eq = BOXED_guardType == MlsdmTables.ELITid_END;
				/*@NonInvalid*/ boolean and;
				if (eq) {
					final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_mlsdm_c_c_StoryNode_0 = idResolver
							.getClass(MlsdmTables.CLSSid_StoryNode, null);
					final /*@NonInvalid*/ ActivityNode source = this.getSource();
					final /*@NonInvalid*/ boolean oclIsKindOf = OclAnyOclIsKindOfOperation.INSTANCE
							.evaluate(executor, source, TYP_mlsdm_c_c_StoryNode_0).booleanValue();
					and = oclIsKindOf;
				} else {
					and = ValueUtil.FALSE_VALUE;
				}
				/*@Thrown*/ boolean implies;
				if (and) {
					final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_mlsdm_c_c_StoryNode_1 = idResolver
							.getClass(MlsdmTables.CLSSid_StoryNode, null);
					final /*@NonInvalid*/ ActivityNode source_0 = this.getSource();
					final /*@Thrown*/ StoryNode oclAsType = (StoryNode) OclAnyOclAsTypeOperation.INSTANCE
							.evaluate(executor, source_0, TYP_mlsdm_c_c_StoryNode_1);
					final /*@Thrown*/ StoryNodeSemanticsEnum semantics = oclAsType.getSemantics();
					final /*@Thrown*/ EnumerationLiteralId BOXED_semantics = MlsdmTables.ENUMid_StoryNodeSemanticsEnum
							.getEnumerationLiteralId(ClassUtil.nonNullState(semantics.getName()));
					final /*@Thrown*/ boolean eq_0 = BOXED_semantics == MlsdmTables.ELITid_FOR_EACH_FRESH_MATCH;
					implies = eq_0;
				} else {
					implies = ValueUtil.TRUE_VALUE;
				}
				/*@NonInvalid*/ Boolean status;
				if (implies) {
					status = ValueUtil.TRUE_VALUE;
				} else {
					status = null;
				}
				final /*@NonInvalid*/ boolean eq_1 = status == Boolean.TRUE;
				/*@NonInvalid*/ Object symbol_1;
				if (eq_1) {
					symbol_1 = ValueUtil.TRUE_VALUE;
				} else {
					final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE.evaluate(this);
					final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
							.evaluate(MlsdmTables.STR_The_32_END_32_guard_32_of_32_activity_32_edge_32, toString);
					final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE.evaluate(sum,
							MlsdmTables.STR__32_is_32_only_32_valid_32_for_32_edges_32_starting_32_from_32_a_32_story_32_node_32_with_32_FOR_EAC);
					final /*@NonInvalid*/ TupleValue symbol_0 = ValueUtil.createTupleOfEach(MlsdmTables.TUPLid_, sum_0,
							status);
					symbol_1 = symbol_0;
				}
				final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
						.evaluate(executor, TypeId.BOOLEAN, constraintName, this, (Object) null, diagnostics, context,
								(Object) null, CAUGHT_severity_0, symbol_1, MlsdmTables.INT_0)
						.booleanValue();
				symbol_2 = logDiagnostic;
			}
			return Boolean.TRUE == symbol_2;
		} catch (Throwable e) {
			return ValueUtil.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
		case MlsdmPackage.ACTIVITY_EDGE__ANNOTATIONS:
			return ((InternalEList<InternalEObject>) (InternalEList<?>) getAnnotations()).basicAdd(otherEnd, msgs);
		case MlsdmPackage.ACTIVITY_EDGE__SOURCE:
			if (source != null)
				msgs = ((InternalEObject) source).eInverseRemove(this, MlsdmPackage.ACTIVITY_NODE__OUTGOING_EDGES,
						ActivityNode.class, msgs);
			return basicSetSource((ActivityNode) otherEnd, msgs);
		case MlsdmPackage.ACTIVITY_EDGE__TARGET:
			if (target != null)
				msgs = ((InternalEObject) target).eInverseRemove(this, MlsdmPackage.ACTIVITY_NODE__INCOMING_EDGES,
						ActivityNode.class, msgs);
			return basicSetTarget((ActivityNode) otherEnd, msgs);
		case MlsdmPackage.ACTIVITY_EDGE__ACTIVITY_NODE_CONTAINER:
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			return basicSetActivityNodeContainer((ActivityNodeContainer) otherEnd, msgs);
		case MlsdmPackage.ACTIVITY_EDGE__ACQUIRE_EDGES:
			return ((InternalEList<InternalEObject>) (InternalEList<?>) getAcquireEdges()).basicAdd(otherEnd, msgs);
		case MlsdmPackage.ACTIVITY_EDGE__RELEASE_EDGES:
			return ((InternalEList<InternalEObject>) (InternalEList<?>) getReleaseEdges()).basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
		case MlsdmPackage.ACTIVITY_EDGE__ANNOTATIONS:
			return ((InternalEList<?>) getAnnotations()).basicRemove(otherEnd, msgs);
		case MlsdmPackage.ACTIVITY_EDGE__SOURCE:
			return basicSetSource(null, msgs);
		case MlsdmPackage.ACTIVITY_EDGE__TARGET:
			return basicSetTarget(null, msgs);
		case MlsdmPackage.ACTIVITY_EDGE__ACTIVITY_NODE_CONTAINER:
			return basicSetActivityNodeContainer(null, msgs);
		case MlsdmPackage.ACTIVITY_EDGE__GUARD_EXPRESSION:
			return basicSetGuardExpression(null, msgs);
		case MlsdmPackage.ACTIVITY_EDGE__ACQUIRE_EDGES:
			return ((InternalEList<?>) getAcquireEdges()).basicRemove(otherEnd, msgs);
		case MlsdmPackage.ACTIVITY_EDGE__RELEASE_EDGES:
			return ((InternalEList<?>) getReleaseEdges()).basicRemove(otherEnd, msgs);
		case MlsdmPackage.ACTIVITY_EDGE__ASSERTION_EXPRESSIONS:
			return ((InternalEList<?>) getAssertionExpressions()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
		switch (eContainerFeatureID()) {
		case MlsdmPackage.ACTIVITY_EDGE__ACTIVITY_NODE_CONTAINER:
			return eInternalContainer().eInverseRemove(this, MlsdmPackage.ACTIVITY_NODE_CONTAINER__EDGES,
					ActivityNodeContainer.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case MlsdmPackage.ACTIVITY_EDGE__ANNOTATIONS:
			return getAnnotations();
		case MlsdmPackage.ACTIVITY_EDGE__SOURCE:
			return getSource();
		case MlsdmPackage.ACTIVITY_EDGE__TARGET:
			return getTarget();
		case MlsdmPackage.ACTIVITY_EDGE__ACTIVITY_NODE_CONTAINER:
			return getActivityNodeContainer();
		case MlsdmPackage.ACTIVITY_EDGE__GUARD_TYPE:
			return getGuardType();
		case MlsdmPackage.ACTIVITY_EDGE__GUARD_EXPRESSION:
			return getGuardExpression();
		case MlsdmPackage.ACTIVITY_EDGE__ACQUIRE_EDGES:
			return getAcquireEdges();
		case MlsdmPackage.ACTIVITY_EDGE__RELEASE_EDGES:
			return getReleaseEdges();
		case MlsdmPackage.ACTIVITY_EDGE__ASSERTION_EXPRESSIONS:
			return getAssertionExpressions();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case MlsdmPackage.ACTIVITY_EDGE__ANNOTATIONS:
			getAnnotations().clear();
			getAnnotations().addAll((Collection<? extends MLAnnotation>) newValue);
			return;
		case MlsdmPackage.ACTIVITY_EDGE__SOURCE:
			setSource((ActivityNode) newValue);
			return;
		case MlsdmPackage.ACTIVITY_EDGE__TARGET:
			setTarget((ActivityNode) newValue);
			return;
		case MlsdmPackage.ACTIVITY_EDGE__ACTIVITY_NODE_CONTAINER:
			setActivityNodeContainer((ActivityNodeContainer) newValue);
			return;
		case MlsdmPackage.ACTIVITY_EDGE__GUARD_TYPE:
			setGuardType((ActivityEdgeGuardEnum) newValue);
			return;
		case MlsdmPackage.ACTIVITY_EDGE__GUARD_EXPRESSION:
			setGuardExpression((MLExpression) newValue);
			return;
		case MlsdmPackage.ACTIVITY_EDGE__ACQUIRE_EDGES:
			getAcquireEdges().clear();
			getAcquireEdges().addAll((Collection<? extends AcquireEdge>) newValue);
			return;
		case MlsdmPackage.ACTIVITY_EDGE__RELEASE_EDGES:
			getReleaseEdges().clear();
			getReleaseEdges().addAll((Collection<? extends ReleaseEdge>) newValue);
			return;
		case MlsdmPackage.ACTIVITY_EDGE__ASSERTION_EXPRESSIONS:
			getAssertionExpressions().clear();
			getAssertionExpressions().addAll((Collection<? extends MLExpression>) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case MlsdmPackage.ACTIVITY_EDGE__ANNOTATIONS:
			getAnnotations().clear();
			return;
		case MlsdmPackage.ACTIVITY_EDGE__SOURCE:
			setSource((ActivityNode) null);
			return;
		case MlsdmPackage.ACTIVITY_EDGE__TARGET:
			setTarget((ActivityNode) null);
			return;
		case MlsdmPackage.ACTIVITY_EDGE__ACTIVITY_NODE_CONTAINER:
			setActivityNodeContainer((ActivityNodeContainer) null);
			return;
		case MlsdmPackage.ACTIVITY_EDGE__GUARD_TYPE:
			setGuardType(GUARD_TYPE_EDEFAULT);
			return;
		case MlsdmPackage.ACTIVITY_EDGE__GUARD_EXPRESSION:
			setGuardExpression((MLExpression) null);
			return;
		case MlsdmPackage.ACTIVITY_EDGE__ACQUIRE_EDGES:
			getAcquireEdges().clear();
			return;
		case MlsdmPackage.ACTIVITY_EDGE__RELEASE_EDGES:
			getReleaseEdges().clear();
			return;
		case MlsdmPackage.ACTIVITY_EDGE__ASSERTION_EXPRESSIONS:
			getAssertionExpressions().clear();
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case MlsdmPackage.ACTIVITY_EDGE__ANNOTATIONS:
			return annotations != null && !annotations.isEmpty();
		case MlsdmPackage.ACTIVITY_EDGE__SOURCE:
			return source != null;
		case MlsdmPackage.ACTIVITY_EDGE__TARGET:
			return target != null;
		case MlsdmPackage.ACTIVITY_EDGE__ACTIVITY_NODE_CONTAINER:
			return getActivityNodeContainer() != null;
		case MlsdmPackage.ACTIVITY_EDGE__GUARD_TYPE:
			return guardType != GUARD_TYPE_EDEFAULT;
		case MlsdmPackage.ACTIVITY_EDGE__GUARD_EXPRESSION:
			return guardExpression != null;
		case MlsdmPackage.ACTIVITY_EDGE__ACQUIRE_EDGES:
			return acquireEdges != null && !acquireEdges.isEmpty();
		case MlsdmPackage.ACTIVITY_EDGE__RELEASE_EDGES:
			return releaseEdges != null && !releaseEdges.isEmpty();
		case MlsdmPackage.ACTIVITY_EDGE__ASSERTION_EXPRESSIONS:
			return assertionExpressions != null && !assertionExpressions.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
		if (baseClass == MLAnnotatedElement.class) {
			switch (derivedFeatureID) {
			case MlsdmPackage.ACTIVITY_EDGE__ANNOTATIONS:
				return MlcorePackage.ML_ANNOTATED_ELEMENT__ANNOTATIONS;
			default:
				return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
		if (baseClass == MLAnnotatedElement.class) {
			switch (baseFeatureID) {
			case MlcorePackage.ML_ANNOTATED_ELEMENT__ANNOTATIONS:
				return MlsdmPackage.ACTIVITY_EDGE__ANNOTATIONS;
			default:
				return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	@SuppressWarnings("unchecked")
	public Object eInvoke(int operationID, EList<?> arguments) throws InvocationTargetException {
		switch (operationID) {
		case MlsdmPackage.ACTIVITY_EDGE___ACTIVITY_EDGE_BOOLEAN_GUARD__DIAGNOSTICCHAIN_MAP:
			return ActivityEdgeBooleanGuard((DiagnosticChain) arguments.get(0), (Map<Object, Object>) arguments.get(1));
		case MlsdmPackage.ACTIVITY_EDGE___ACTIVITY_EDGE_SUCCESS_GUARD__DIAGNOSTICCHAIN_MAP:
			return ActivityEdgeSuccessGuard((DiagnosticChain) arguments.get(0), (Map<Object, Object>) arguments.get(1));
		case MlsdmPackage.ACTIVITY_EDGE___ACTIVITY_EDGE_GUARD_TYPE__DIAGNOSTICCHAIN_MAP:
			return ActivityEdgeGuardType((DiagnosticChain) arguments.get(0), (Map<Object, Object>) arguments.get(1));
		case MlsdmPackage.ACTIVITY_EDGE___ACTIVITY_EDGE_FOR_EACH_GUARD__DIAGNOSTICCHAIN_MAP:
			return ActivityEdgeForEachGuard((DiagnosticChain) arguments.get(0), (Map<Object, Object>) arguments.get(1));
		case MlsdmPackage.ACTIVITY_EDGE___ACTIVITY_EDGE_SOURCE__DIAGNOSTICCHAIN_MAP:
			return ActivityEdgeSource((DiagnosticChain) arguments.get(0), (Map<Object, Object>) arguments.get(1));
		case MlsdmPackage.ACTIVITY_EDGE___ACTIVITY_EDGE_ELSE_GUARD__DIAGNOSTICCHAIN_MAP:
			return ActivityEdgeElseGuard((DiagnosticChain) arguments.get(0), (Map<Object, Object>) arguments.get(1));
		case MlsdmPackage.ACTIVITY_EDGE___ACTIVITY_EDGE_TARGET__DIAGNOSTICCHAIN_MAP:
			return ActivityEdgeTarget((DiagnosticChain) arguments.get(0), (Map<Object, Object>) arguments.get(1));
		case MlsdmPackage.ACTIVITY_EDGE___ACTIVITY_EDGE_FAILURE_GUARD__DIAGNOSTICCHAIN_MAP:
			return ActivityEdgeFailureGuard((DiagnosticChain) arguments.get(0), (Map<Object, Object>) arguments.get(1));
		case MlsdmPackage.ACTIVITY_EDGE___ACTIVITY_EDGE_GUARD_EXPRESSION__DIAGNOSTICCHAIN_MAP:
			return ActivityEdgeGuardExpression((DiagnosticChain) arguments.get(0),
					(Map<Object, Object>) arguments.get(1));
		case MlsdmPackage.ACTIVITY_EDGE___ACTIVITY_EDGE_NO_GUARD_EXPRESSION__DIAGNOSTICCHAIN_MAP:
			return ActivityEdgeNoGuardExpression((DiagnosticChain) arguments.get(0),
					(Map<Object, Object>) arguments.get(1));
		case MlsdmPackage.ACTIVITY_EDGE___ACTIVITY_EDGE_END_GUARD__DIAGNOSTICCHAIN_MAP:
			return ActivityEdgeEndGuard((DiagnosticChain) arguments.get(0), (Map<Object, Object>) arguments.get(1));
		}
		return super.eInvoke(operationID, arguments);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuilder result = new StringBuilder(super.toString());
		result.append(" (guardType: ");
		result.append(guardType);
		result.append(')');
		return result.toString();
	}

} // ActivityEdgeImpl
