/**
 */
package de.mdelab.mlsdm.impl;

import java.util.Collection;

import java.util.Iterator;
import java.util.List;
import java.util.Map;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.eclipse.ocl.pivot.evaluation.Executor;
import org.eclipse.ocl.pivot.ids.IdResolver;
import org.eclipse.ocl.pivot.ids.TypeId;
import org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal;
import org.eclipse.ocl.pivot.library.collection.CollectionSizeOperation;
import org.eclipse.ocl.pivot.library.oclany.OclAnyOclIsTypeOfOperation;
import org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation;
import org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation;
import org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation;
import org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation;
import org.eclipse.ocl.pivot.library.string.StringConcatOperation;
import org.eclipse.ocl.pivot.messages.PivotMessages;
import org.eclipse.ocl.pivot.utilities.PivotUtil;
import org.eclipse.ocl.pivot.utilities.ValueUtil;
import org.eclipse.ocl.pivot.values.IntegerValue;
import org.eclipse.ocl.pivot.values.InvalidValueException;
import org.eclipse.ocl.pivot.values.SetValue;
import org.eclipse.ocl.pivot.values.SetValue.Accumulator;
import org.eclipse.ocl.pivot.values.TupleValue;
import de.mdelab.mlannotations.MLAnnotation;
import de.mdelab.mlannotations.MlannotationsPackage;
import de.mdelab.mlcore.MLAnnotatedElement;
import de.mdelab.mlcore.MLNamedElement;
import de.mdelab.mlcore.MlcorePackage;
import de.mdelab.mlcore.impl.MLElementWithUUIDImpl;
import de.mdelab.mlsdm.Activity;
import de.mdelab.mlsdm.ActivityEdge;
import de.mdelab.mlsdm.ActivityNode;
import de.mdelab.mlsdm.ActivityNodeContainer;
import de.mdelab.mlsdm.ActivityParameter;
import de.mdelab.mlsdm.MlsdmPackage;
import de.mdelab.mlsdm.MlsdmTables;
import de.mdelab.mlsdm.Semaphore;
import de.mdelab.mlsdm.SynchronizationEdge;
import java.lang.reflect.InvocationTargetException;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Activity</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link de.mdelab.mlsdm.impl.ActivityImpl#getAnnotations <em>Annotations</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.impl.ActivityImpl#getName <em>Name</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.impl.ActivityImpl#getEdges <em>Edges</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.impl.ActivityImpl#getNodes <em>Nodes</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.impl.ActivityImpl#getSemaphores <em>Semaphores</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.impl.ActivityImpl#getSynchronizationEdges <em>Synchronization Edges</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.impl.ActivityImpl#getParameters <em>Parameters</em>}</li>
 * </ul>
 *
 * @generated
 */
public class ActivityImpl extends MLElementWithUUIDImpl implements Activity {
	/**
	 * The cached value of the '{@link #getAnnotations() <em>Annotations</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getAnnotations()
	 * @generated
	 * @ordered
	 */
	protected EList<MLAnnotation> annotations;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The cached value of the '{@link #getEdges() <em>Edges</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getEdges()
	 * @generated
	 * @ordered
	 */
	protected EList<ActivityEdge> edges;

	/**
	 * The cached value of the '{@link #getNodes() <em>Nodes</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getNodes()
	 * @generated
	 * @ordered
	 */
	protected EList<ActivityNode> nodes;

	/**
	 * The cached value of the '{@link #getSemaphores() <em>Semaphores</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getSemaphores()
	 * @generated
	 * @ordered
	 */
	protected EList<Semaphore> semaphores;

	/**
	 * The cached value of the '{@link #getSynchronizationEdges()
	 * <em>Synchronization Edges</em>}' containment reference list. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getSynchronizationEdges()
	 * @generated
	 * @ordered
	 */
	protected EList<SynchronizationEdge> synchronizationEdges;

	/**
	 * The cached value of the '{@link #getParameters() <em>Parameters</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getParameters()
	 * @generated
	 * @ordered
	 */
	protected EList<ActivityParameter> parameters;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected ActivityImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MlsdmPackage.Literals.ACTIVITY;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<MLAnnotation> getAnnotations() {
		if (annotations == null) {
			annotations = new EObjectContainmentWithInverseEList<MLAnnotation>(MLAnnotation.class, this,
					MlsdmPackage.ACTIVITY__ANNOTATIONS, MlannotationsPackage.ML_ANNOTATION__ELEMENT);
		}
		return annotations;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MlsdmPackage.ACTIVITY__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<ActivityEdge> getEdges() {
		if (edges == null) {
			edges = new EObjectContainmentWithInverseEList<ActivityEdge>(ActivityEdge.class, this,
					MlsdmPackage.ACTIVITY__EDGES, MlsdmPackage.ACTIVITY_EDGE__ACTIVITY_NODE_CONTAINER);
		}
		return edges;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<ActivityNode> getNodes() {
		if (nodes == null) {
			nodes = new EObjectContainmentWithInverseEList<ActivityNode>(ActivityNode.class, this,
					MlsdmPackage.ACTIVITY__NODES, MlsdmPackage.ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER);
		}
		return nodes;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<Semaphore> getSemaphores() {
		if (semaphores == null) {
			semaphores = new EObjectContainmentWithInverseEList<Semaphore>(Semaphore.class, this,
					MlsdmPackage.ACTIVITY__SEMAPHORES, MlsdmPackage.SEMAPHORE__ACTIVITY_NODE_CONTAINER);
		}
		return semaphores;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<SynchronizationEdge> getSynchronizationEdges() {
		if (synchronizationEdges == null) {
			synchronizationEdges = new EObjectContainmentWithInverseEList<SynchronizationEdge>(
					SynchronizationEdge.class, this, MlsdmPackage.ACTIVITY__SYNCHRONIZATION_EDGES,
					MlsdmPackage.SYNCHRONIZATION_EDGE__ACTIVITY_NODE_CONTAINER);
		}
		return synchronizationEdges;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<ActivityParameter> getParameters() {
		if (parameters == null) {
			parameters = new EObjectContainmentWithInverseEList<ActivityParameter>(ActivityParameter.class, this,
					MlsdmPackage.ACTIVITY__PARAMETERS, MlsdmPackage.ACTIVITY_PARAMETER__ACTIVITY);
		}
		return parameters;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean ParameterDistinctNames(final DiagnosticChain diagnostics, final Map<Object, Object> context) {
		final String constraintName = "Activity::ParameterDistinctNames";
		try {
			/**
			 *
			 * inv ParameterDistinctNames:
			 *   let severity : Integer[1] = constraintName.getSeverity()
			 *   in
			 *     if severity <= 0
			 *     then true
			 *     else
			 *       let
			 *         result : OclAny[1] = let
			 *           status : Boolean[?] = if
			 *             self.parameters->forAll(e |
			 *               self.parameters->select(e2 | e.name = e2.name)
			 *               ->size() = 1)
			 *           then true
			 *           else null
			 *           endif
			 *         in
			 *           if status = true
			 *           then true
			 *           else
			 *             Tuple{message = 'Parameters of activity ' +
			 *               self.toString() + ' must have distinct names.', status = status
			 *             }
			 *           endif
			 *       in
			 *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
			 *     endif
			 */
			final /*@NonInvalid*/ Executor executor = PivotUtil.getExecutor(this, context);
			final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
			/*@Caught*/ Object CAUGHT_severity_0;
			try {
				final /*@Thrown*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE.evaluate(executor,
						MlsdmPackage.Literals.ACTIVITY___PARAMETER_DISTINCT_NAMES__DIAGNOSTICCHAIN_MAP);
				CAUGHT_severity_0 = severity_0;
			} catch (Exception e) {
				CAUGHT_severity_0 = ValueUtil.createInvalidValue(e);
			}
			if (CAUGHT_severity_0 instanceof InvalidValueException) {
				throw (InvalidValueException) CAUGHT_severity_0;
			}
			final /*@Thrown*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
					.evaluate(executor, CAUGHT_severity_0, MlsdmTables.INT_0).booleanValue();
			/*@NonInvalid*/ Object symbol_2;
			if (le) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ List<ActivityParameter> parameters = this.getParameters();
				final /*@NonInvalid*/ SetValue BOXED_parameters = idResolver
						.createSetOfAll(MlsdmTables.SET_CLSSid_ActivityParameter, parameters);
				/*@Thrown*/ Object accumulator = ValueUtil.TRUE_VALUE;
				Iterator<Object> ITERATOR_e_0 = BOXED_parameters.iterator();
				/*@NonInvalid*/ Boolean forAll;
				while (true) {
					if (!ITERATOR_e_0.hasNext()) {
						if (accumulator == ValueUtil.TRUE_VALUE) {
							forAll = ValueUtil.TRUE_VALUE;
						} else {
							throw (InvalidValueException) accumulator;
						}
						break;
					}
					/*@NonInvalid*/ ActivityParameter e_0 = (ActivityParameter) ITERATOR_e_0.next();
					/**
					 * self.parameters->select(e2 | e.name = e2.name)->size() = 1
					 */
					/*@Thrown*/ Accumulator accumulator_0 = ValueUtil
							.createSetAccumulatorValue(MlsdmTables.SET_CLSSid_ActivityParameter);
					Iterator<Object> ITERATOR_e2 = BOXED_parameters.iterator();
					/*@NonInvalid*/ SetValue select;
					while (true) {
						if (!ITERATOR_e2.hasNext()) {
							select = accumulator_0;
							break;
						}
						/*@NonInvalid*/ ActivityParameter e2 = (ActivityParameter) ITERATOR_e2.next();
						/**
						 * e.name = e2.name
						 */
						final /*@NonInvalid*/ String name = e_0.getName();
						final /*@NonInvalid*/ String name_0 = e2.getName();
						final /*@NonInvalid*/ boolean eq = (name != null) ? name.equals(name_0) : (name_0 == null);
						//
						if (eq == ValueUtil.TRUE_VALUE) {
							accumulator_0.add(e2);
						}
					}
					final /*@NonInvalid*/ IntegerValue size = CollectionSizeOperation.INSTANCE.evaluate(select);
					final /*@NonInvalid*/ boolean eq_0 = size.equals(MlsdmTables.INT_1);
					//
					if (eq_0 == ValueUtil.FALSE_VALUE) { // Normal unsuccessful body evaluation result
						forAll = ValueUtil.FALSE_VALUE;
						break; // Stop immediately
					} else if (eq_0 == ValueUtil.TRUE_VALUE) { // Normal successful body evaluation result
						; // Carry on
					} else { // Impossible badly typed result
						accumulator = new InvalidValueException(PivotMessages.NonBooleanBody, "forAll");
					}
				}
				if (forAll == null) {
					throw new InvalidValueException("Null if condition");
				}
				/*@NonInvalid*/ Boolean status;
				if (forAll) {
					status = ValueUtil.TRUE_VALUE;
				} else {
					status = null;
				}
				final /*@NonInvalid*/ boolean eq_1 = status == Boolean.TRUE;
				/*@NonInvalid*/ Object symbol_1;
				if (eq_1) {
					symbol_1 = ValueUtil.TRUE_VALUE;
				} else {
					final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE.evaluate(this);
					final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
							.evaluate(MlsdmTables.STR_Parameters_32_of_32_activity_32, toString);
					final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE.evaluate(sum,
							MlsdmTables.STR__32_must_32_have_32_distinct_32_names);
					final /*@NonInvalid*/ TupleValue symbol_0 = ValueUtil.createTupleOfEach(MlsdmTables.TUPLid_, sum_0,
							status);
					symbol_1 = symbol_0;
				}
				final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
						.evaluate(executor, TypeId.BOOLEAN, constraintName, this, (Object) null, diagnostics, context,
								(Object) null, CAUGHT_severity_0, symbol_1, MlsdmTables.INT_0)
						.booleanValue();
				symbol_2 = logDiagnostic;
			}
			return Boolean.TRUE == symbol_2;
		} catch (Throwable e) {
			return ValueUtil.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean AtLeastOneFinalNode(final DiagnosticChain diagnostics, final Map<Object, Object> context) {
		final String constraintName = "Activity::AtLeastOneFinalNode";
		try {
			/**
			 *
			 * inv AtLeastOneFinalNode:
			 *   let severity : Integer[1] = constraintName.getSeverity()
			 *   in
			 *     if severity <= 0
			 *     then true
			 *     else
			 *       let
			 *         result : OclAny[1] = let
			 *           status : Boolean[?] = if
			 *             self.nodes->exists(e |
			 *               e.oclIsTypeOf(ActivityFinalNode))
			 *           then true
			 *           else null
			 *           endif
			 *         in
			 *           if status = true
			 *           then true
			 *           else
			 *             Tuple{message = 'Activity ' +
			 *               self.toString() + ' must contain at least one activity final node.', status = status
			 *             }
			 *           endif
			 *       in
			 *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
			 *     endif
			 */
			final /*@NonInvalid*/ Executor executor = PivotUtil.getExecutor(this, context);
			final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
			/*@Caught*/ Object CAUGHT_severity_0;
			try {
				final /*@Thrown*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE.evaluate(executor,
						MlsdmPackage.Literals.ACTIVITY___AT_LEAST_ONE_FINAL_NODE__DIAGNOSTICCHAIN_MAP);
				CAUGHT_severity_0 = severity_0;
			} catch (Exception e) {
				CAUGHT_severity_0 = ValueUtil.createInvalidValue(e);
			}
			if (CAUGHT_severity_0 instanceof InvalidValueException) {
				throw (InvalidValueException) CAUGHT_severity_0;
			}
			final /*@Thrown*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
					.evaluate(executor, CAUGHT_severity_0, MlsdmTables.INT_0).booleanValue();
			/*@NonInvalid*/ Object symbol_2;
			if (le) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ List<ActivityNode> nodes = this.getNodes();
				final /*@NonInvalid*/ SetValue BOXED_nodes = idResolver
						.createSetOfAll(MlsdmTables.SET_CLSSid_ActivityNode, nodes);
				/*@Thrown*/ Object accumulator = ValueUtil.FALSE_VALUE;
				Iterator<Object> ITERATOR_e_0 = BOXED_nodes.iterator();
				/*@NonInvalid*/ Boolean exists;
				while (true) {
					if (!ITERATOR_e_0.hasNext()) {
						if (accumulator == ValueUtil.FALSE_VALUE) {
							exists = ValueUtil.FALSE_VALUE;
						} else {
							throw (InvalidValueException) accumulator;
						}
						break;
					}
					/*@NonInvalid*/ ActivityNode e_0 = (ActivityNode) ITERATOR_e_0.next();
					/**
					 * e.oclIsTypeOf(ActivityFinalNode)
					 */
					final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_mlsdm_c_c_ActivityFinalNode = idResolver
							.getClass(MlsdmTables.CLSSid_ActivityFinalNode, null);
					final /*@NonInvalid*/ boolean oclIsTypeOf = OclAnyOclIsTypeOfOperation.INSTANCE
							.evaluate(executor, e_0, TYP_mlsdm_c_c_ActivityFinalNode).booleanValue();
					//
					if (oclIsTypeOf == ValueUtil.TRUE_VALUE) { // Normal successful body evaluation result
						exists = ValueUtil.TRUE_VALUE;
						break; // Stop immediately
					} else if (oclIsTypeOf == ValueUtil.FALSE_VALUE) { // Normal unsuccessful body evaluation result
						; // Carry on
					} else { // Impossible badly typed result
						accumulator = new InvalidValueException(PivotMessages.NonBooleanBody, "exists");
					}
				}
				if (exists == null) {
					throw new InvalidValueException("Null if condition");
				}
				/*@NonInvalid*/ Boolean status;
				if (exists) {
					status = ValueUtil.TRUE_VALUE;
				} else {
					status = null;
				}
				final /*@NonInvalid*/ boolean eq = status == Boolean.TRUE;
				/*@NonInvalid*/ Object symbol_1;
				if (eq) {
					symbol_1 = ValueUtil.TRUE_VALUE;
				} else {
					final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE.evaluate(this);
					final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
							.evaluate(MlsdmTables.STR_Activity_32, toString);
					final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE.evaluate(sum,
							MlsdmTables.STR__32_must_32_contain_32_at_32_least_32_one_32_activity_32_final_32_node);
					final /*@NonInvalid*/ TupleValue symbol_0 = ValueUtil.createTupleOfEach(MlsdmTables.TUPLid_, sum_0,
							status);
					symbol_1 = symbol_0;
				}
				final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
						.evaluate(executor, TypeId.BOOLEAN, constraintName, this, (Object) null, diagnostics, context,
								(Object) null, CAUGHT_severity_0, symbol_1, MlsdmTables.INT_0)
						.booleanValue();
				symbol_2 = logDiagnostic;
			}
			return Boolean.TRUE == symbol_2;
		} catch (Throwable e) {
			return ValueUtil.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean ActivityName(final DiagnosticChain diagnostics, final Map<Object, Object> context) {
		final String constraintName = "Activity::ActivityName";
		try {
			/**
			 *
			 * inv ActivityName:
			 *   let severity : Integer[1] = constraintName.getSeverity()
			 *   in
			 *     if severity <= 0
			 *     then true
			 *     else
			 *       let
			 *         result : OclAny[1] = let
			 *           status : Boolean[?] = if self.name <> null and self.name <> ''
			 *           then true
			 *           else null
			 *           endif
			 *         in
			 *           if status = true
			 *           then true
			 *           else Tuple{message = 'Activity ' +
			 *               self.toString() + ' must have a name.', status = status}
			 *           endif
			 *       in
			 *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
			 *     endif
			 */
			final /*@NonInvalid*/ Executor executor = PivotUtil.getExecutor(this, context);
			/*@Caught*/ Object CAUGHT_severity_0;
			try {
				final /*@Thrown*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE.evaluate(executor,
						MlsdmPackage.Literals.ACTIVITY___ACTIVITY_NAME__DIAGNOSTICCHAIN_MAP);
				CAUGHT_severity_0 = severity_0;
			} catch (Exception e) {
				CAUGHT_severity_0 = ValueUtil.createInvalidValue(e);
			}
			if (CAUGHT_severity_0 instanceof InvalidValueException) {
				throw (InvalidValueException) CAUGHT_severity_0;
			}
			final /*@Thrown*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
					.evaluate(executor, CAUGHT_severity_0, MlsdmTables.INT_0).booleanValue();
			/*@NonInvalid*/ Object symbol_2;
			if (le) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ String name_0 = this.getName();
				final /*@NonInvalid*/ boolean ne = name_0 != null;
				/*@NonInvalid*/ boolean and;
				if (ne) {
					final /*@NonInvalid*/ boolean ne_0 = !MlsdmTables.STR_.equals(name_0);
					and = ne_0;
				} else {
					and = ValueUtil.FALSE_VALUE;
				}
				/*@NonInvalid*/ Boolean status;
				if (and) {
					status = ValueUtil.TRUE_VALUE;
				} else {
					status = null;
				}
				final /*@NonInvalid*/ boolean eq = status == Boolean.TRUE;
				/*@NonInvalid*/ Object symbol_1;
				if (eq) {
					symbol_1 = ValueUtil.TRUE_VALUE;
				} else {
					final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE.evaluate(this);
					final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
							.evaluate(MlsdmTables.STR_Activity_32, toString);
					final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE.evaluate(sum,
							MlsdmTables.STR__32_must_32_have_32_a_32_name);
					final /*@NonInvalid*/ TupleValue symbol_0 = ValueUtil.createTupleOfEach(MlsdmTables.TUPLid_, sum_0,
							status);
					symbol_1 = symbol_0;
				}
				final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
						.evaluate(executor, TypeId.BOOLEAN, constraintName, this, (Object) null, diagnostics, context,
								(Object) null, CAUGHT_severity_0, symbol_1, MlsdmTables.INT_0)
						.booleanValue();
				symbol_2 = logDiagnostic;
			}
			return Boolean.TRUE == symbol_2;
		} catch (Throwable e) {
			return ValueUtil.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean OneInitialNode(final DiagnosticChain diagnostics, final Map<Object, Object> context) {
		final String constraintName = "Activity::OneInitialNode";
		try {
			/**
			 *
			 * inv OneInitialNode:
			 *   let severity : Integer[1] = constraintName.getSeverity()
			 *   in
			 *     if severity <= 0
			 *     then true
			 *     else
			 *       let
			 *         result : OclAny[1] = let
			 *           status : Boolean[?] = if
			 *             self.nodes->select(e | e.oclIsTypeOf(InitialNode))
			 *             ->size() = 1
			 *           then true
			 *           else null
			 *           endif
			 *         in
			 *           if status = true
			 *           then true
			 *           else
			 *             Tuple{message = 'Activity ' +
			 *               self.toString() + 'must contain exactly one initial node.', status = status
			 *             }
			 *           endif
			 *       in
			 *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
			 *     endif
			 */
			final /*@NonInvalid*/ Executor executor = PivotUtil.getExecutor(this, context);
			final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
			/*@Caught*/ Object CAUGHT_severity_0;
			try {
				final /*@Thrown*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE.evaluate(executor,
						MlsdmPackage.Literals.ACTIVITY___ONE_INITIAL_NODE__DIAGNOSTICCHAIN_MAP);
				CAUGHT_severity_0 = severity_0;
			} catch (Exception e) {
				CAUGHT_severity_0 = ValueUtil.createInvalidValue(e);
			}
			if (CAUGHT_severity_0 instanceof InvalidValueException) {
				throw (InvalidValueException) CAUGHT_severity_0;
			}
			final /*@Thrown*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
					.evaluate(executor, CAUGHT_severity_0, MlsdmTables.INT_0).booleanValue();
			/*@NonInvalid*/ Object symbol_2;
			if (le) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ List<ActivityNode> nodes = this.getNodes();
				final /*@NonInvalid*/ SetValue BOXED_nodes = idResolver
						.createSetOfAll(MlsdmTables.SET_CLSSid_ActivityNode, nodes);
				/*@Thrown*/ Accumulator accumulator = ValueUtil
						.createSetAccumulatorValue(MlsdmTables.SET_CLSSid_ActivityNode);
				Iterator<Object> ITERATOR_e_0 = BOXED_nodes.iterator();
				/*@NonInvalid*/ SetValue select;
				while (true) {
					if (!ITERATOR_e_0.hasNext()) {
						select = accumulator;
						break;
					}
					/*@NonInvalid*/ ActivityNode e_0 = (ActivityNode) ITERATOR_e_0.next();
					/**
					 * e.oclIsTypeOf(InitialNode)
					 */
					final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_mlsdm_c_c_InitialNode = idResolver
							.getClass(MlsdmTables.CLSSid_InitialNode, null);
					final /*@NonInvalid*/ boolean oclIsTypeOf = OclAnyOclIsTypeOfOperation.INSTANCE
							.evaluate(executor, e_0, TYP_mlsdm_c_c_InitialNode).booleanValue();
					//
					if (oclIsTypeOf == ValueUtil.TRUE_VALUE) {
						accumulator.add(e_0);
					}
				}
				final /*@NonInvalid*/ IntegerValue size = CollectionSizeOperation.INSTANCE.evaluate(select);
				final /*@NonInvalid*/ boolean eq = size.equals(MlsdmTables.INT_1);
				/*@NonInvalid*/ Boolean status;
				if (eq) {
					status = ValueUtil.TRUE_VALUE;
				} else {
					status = null;
				}
				final /*@NonInvalid*/ boolean eq_0 = status == Boolean.TRUE;
				/*@NonInvalid*/ Object symbol_1;
				if (eq_0) {
					symbol_1 = ValueUtil.TRUE_VALUE;
				} else {
					final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE.evaluate(this);
					final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
							.evaluate(MlsdmTables.STR_Activity_32, toString);
					final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE.evaluate(sum,
							MlsdmTables.STR_must_32_contain_32_exactly_32_one_32_initial_32_node);
					final /*@NonInvalid*/ TupleValue symbol_0 = ValueUtil.createTupleOfEach(MlsdmTables.TUPLid_, sum_0,
							status);
					symbol_1 = symbol_0;
				}
				final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
						.evaluate(executor, TypeId.BOOLEAN, constraintName, this, (Object) null, diagnostics, context,
								(Object) null, CAUGHT_severity_0, symbol_1, MlsdmTables.INT_0)
						.booleanValue();
				symbol_2 = logDiagnostic;
			}
			return Boolean.TRUE == symbol_2;
		} catch (Throwable e) {
			return ValueUtil.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
		case MlsdmPackage.ACTIVITY__ANNOTATIONS:
			return ((InternalEList<InternalEObject>) (InternalEList<?>) getAnnotations()).basicAdd(otherEnd, msgs);
		case MlsdmPackage.ACTIVITY__EDGES:
			return ((InternalEList<InternalEObject>) (InternalEList<?>) getEdges()).basicAdd(otherEnd, msgs);
		case MlsdmPackage.ACTIVITY__NODES:
			return ((InternalEList<InternalEObject>) (InternalEList<?>) getNodes()).basicAdd(otherEnd, msgs);
		case MlsdmPackage.ACTIVITY__SEMAPHORES:
			return ((InternalEList<InternalEObject>) (InternalEList<?>) getSemaphores()).basicAdd(otherEnd, msgs);
		case MlsdmPackage.ACTIVITY__SYNCHRONIZATION_EDGES:
			return ((InternalEList<InternalEObject>) (InternalEList<?>) getSynchronizationEdges()).basicAdd(otherEnd,
					msgs);
		case MlsdmPackage.ACTIVITY__PARAMETERS:
			return ((InternalEList<InternalEObject>) (InternalEList<?>) getParameters()).basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
		case MlsdmPackage.ACTIVITY__ANNOTATIONS:
			return ((InternalEList<?>) getAnnotations()).basicRemove(otherEnd, msgs);
		case MlsdmPackage.ACTIVITY__EDGES:
			return ((InternalEList<?>) getEdges()).basicRemove(otherEnd, msgs);
		case MlsdmPackage.ACTIVITY__NODES:
			return ((InternalEList<?>) getNodes()).basicRemove(otherEnd, msgs);
		case MlsdmPackage.ACTIVITY__SEMAPHORES:
			return ((InternalEList<?>) getSemaphores()).basicRemove(otherEnd, msgs);
		case MlsdmPackage.ACTIVITY__SYNCHRONIZATION_EDGES:
			return ((InternalEList<?>) getSynchronizationEdges()).basicRemove(otherEnd, msgs);
		case MlsdmPackage.ACTIVITY__PARAMETERS:
			return ((InternalEList<?>) getParameters()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case MlsdmPackage.ACTIVITY__ANNOTATIONS:
			return getAnnotations();
		case MlsdmPackage.ACTIVITY__NAME:
			return getName();
		case MlsdmPackage.ACTIVITY__EDGES:
			return getEdges();
		case MlsdmPackage.ACTIVITY__NODES:
			return getNodes();
		case MlsdmPackage.ACTIVITY__SEMAPHORES:
			return getSemaphores();
		case MlsdmPackage.ACTIVITY__SYNCHRONIZATION_EDGES:
			return getSynchronizationEdges();
		case MlsdmPackage.ACTIVITY__PARAMETERS:
			return getParameters();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case MlsdmPackage.ACTIVITY__ANNOTATIONS:
			getAnnotations().clear();
			getAnnotations().addAll((Collection<? extends MLAnnotation>) newValue);
			return;
		case MlsdmPackage.ACTIVITY__NAME:
			setName((String) newValue);
			return;
		case MlsdmPackage.ACTIVITY__EDGES:
			getEdges().clear();
			getEdges().addAll((Collection<? extends ActivityEdge>) newValue);
			return;
		case MlsdmPackage.ACTIVITY__NODES:
			getNodes().clear();
			getNodes().addAll((Collection<? extends ActivityNode>) newValue);
			return;
		case MlsdmPackage.ACTIVITY__SEMAPHORES:
			getSemaphores().clear();
			getSemaphores().addAll((Collection<? extends Semaphore>) newValue);
			return;
		case MlsdmPackage.ACTIVITY__SYNCHRONIZATION_EDGES:
			getSynchronizationEdges().clear();
			getSynchronizationEdges().addAll((Collection<? extends SynchronizationEdge>) newValue);
			return;
		case MlsdmPackage.ACTIVITY__PARAMETERS:
			getParameters().clear();
			getParameters().addAll((Collection<? extends ActivityParameter>) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case MlsdmPackage.ACTIVITY__ANNOTATIONS:
			getAnnotations().clear();
			return;
		case MlsdmPackage.ACTIVITY__NAME:
			setName(NAME_EDEFAULT);
			return;
		case MlsdmPackage.ACTIVITY__EDGES:
			getEdges().clear();
			return;
		case MlsdmPackage.ACTIVITY__NODES:
			getNodes().clear();
			return;
		case MlsdmPackage.ACTIVITY__SEMAPHORES:
			getSemaphores().clear();
			return;
		case MlsdmPackage.ACTIVITY__SYNCHRONIZATION_EDGES:
			getSynchronizationEdges().clear();
			return;
		case MlsdmPackage.ACTIVITY__PARAMETERS:
			getParameters().clear();
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case MlsdmPackage.ACTIVITY__ANNOTATIONS:
			return annotations != null && !annotations.isEmpty();
		case MlsdmPackage.ACTIVITY__NAME:
			return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
		case MlsdmPackage.ACTIVITY__EDGES:
			return edges != null && !edges.isEmpty();
		case MlsdmPackage.ACTIVITY__NODES:
			return nodes != null && !nodes.isEmpty();
		case MlsdmPackage.ACTIVITY__SEMAPHORES:
			return semaphores != null && !semaphores.isEmpty();
		case MlsdmPackage.ACTIVITY__SYNCHRONIZATION_EDGES:
			return synchronizationEdges != null && !synchronizationEdges.isEmpty();
		case MlsdmPackage.ACTIVITY__PARAMETERS:
			return parameters != null && !parameters.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
		if (baseClass == MLAnnotatedElement.class) {
			switch (derivedFeatureID) {
			case MlsdmPackage.ACTIVITY__ANNOTATIONS:
				return MlcorePackage.ML_ANNOTATED_ELEMENT__ANNOTATIONS;
			default:
				return -1;
			}
		}
		if (baseClass == MLNamedElement.class) {
			switch (derivedFeatureID) {
			case MlsdmPackage.ACTIVITY__NAME:
				return MlcorePackage.ML_NAMED_ELEMENT__NAME;
			default:
				return -1;
			}
		}
		if (baseClass == ActivityNodeContainer.class) {
			switch (derivedFeatureID) {
			case MlsdmPackage.ACTIVITY__EDGES:
				return MlsdmPackage.ACTIVITY_NODE_CONTAINER__EDGES;
			case MlsdmPackage.ACTIVITY__NODES:
				return MlsdmPackage.ACTIVITY_NODE_CONTAINER__NODES;
			case MlsdmPackage.ACTIVITY__SEMAPHORES:
				return MlsdmPackage.ACTIVITY_NODE_CONTAINER__SEMAPHORES;
			case MlsdmPackage.ACTIVITY__SYNCHRONIZATION_EDGES:
				return MlsdmPackage.ACTIVITY_NODE_CONTAINER__SYNCHRONIZATION_EDGES;
			default:
				return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
		if (baseClass == MLAnnotatedElement.class) {
			switch (baseFeatureID) {
			case MlcorePackage.ML_ANNOTATED_ELEMENT__ANNOTATIONS:
				return MlsdmPackage.ACTIVITY__ANNOTATIONS;
			default:
				return -1;
			}
		}
		if (baseClass == MLNamedElement.class) {
			switch (baseFeatureID) {
			case MlcorePackage.ML_NAMED_ELEMENT__NAME:
				return MlsdmPackage.ACTIVITY__NAME;
			default:
				return -1;
			}
		}
		if (baseClass == ActivityNodeContainer.class) {
			switch (baseFeatureID) {
			case MlsdmPackage.ACTIVITY_NODE_CONTAINER__EDGES:
				return MlsdmPackage.ACTIVITY__EDGES;
			case MlsdmPackage.ACTIVITY_NODE_CONTAINER__NODES:
				return MlsdmPackage.ACTIVITY__NODES;
			case MlsdmPackage.ACTIVITY_NODE_CONTAINER__SEMAPHORES:
				return MlsdmPackage.ACTIVITY__SEMAPHORES;
			case MlsdmPackage.ACTIVITY_NODE_CONTAINER__SYNCHRONIZATION_EDGES:
				return MlsdmPackage.ACTIVITY__SYNCHRONIZATION_EDGES;
			default:
				return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	@SuppressWarnings("unchecked")
	public Object eInvoke(int operationID, EList<?> arguments) throws InvocationTargetException {
		switch (operationID) {
		case MlsdmPackage.ACTIVITY___PARAMETER_DISTINCT_NAMES__DIAGNOSTICCHAIN_MAP:
			return ParameterDistinctNames((DiagnosticChain) arguments.get(0), (Map<Object, Object>) arguments.get(1));
		case MlsdmPackage.ACTIVITY___AT_LEAST_ONE_FINAL_NODE__DIAGNOSTICCHAIN_MAP:
			return AtLeastOneFinalNode((DiagnosticChain) arguments.get(0), (Map<Object, Object>) arguments.get(1));
		case MlsdmPackage.ACTIVITY___ACTIVITY_NAME__DIAGNOSTICCHAIN_MAP:
			return ActivityName((DiagnosticChain) arguments.get(0), (Map<Object, Object>) arguments.get(1));
		case MlsdmPackage.ACTIVITY___ONE_INITIAL_NODE__DIAGNOSTICCHAIN_MAP:
			return OneInitialNode((DiagnosticChain) arguments.get(0), (Map<Object, Object>) arguments.get(1));
		}
		return super.eInvoke(operationID, arguments);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuilder result = new StringBuilder(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(')');
		return result.toString();
	}

} // ActivityImpl
