/**
 */
package de.mdelab.mlsdm.impl;

import de.mdelab.mlsdm.ActivityEdge;
import de.mdelab.mlsdm.ActivityEdgeGuardEnum;
import org.eclipse.emf.ecore.EClass;

import org.eclipse.ocl.pivot.evaluation.Executor;
import org.eclipse.ocl.pivot.ids.EnumerationLiteralId;
import org.eclipse.ocl.pivot.ids.IdResolver;
import org.eclipse.ocl.pivot.ids.TypeId;
import org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal;
import org.eclipse.ocl.pivot.library.collection.CollectionIsEmptyOperation;
import org.eclipse.ocl.pivot.library.collection.CollectionSizeOperation;
import org.eclipse.ocl.pivot.library.logical.BooleanNotOperation;
import org.eclipse.ocl.pivot.library.numeric.NumericMinusOperation;
import org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation;
import org.eclipse.ocl.pivot.library.oclany.OclComparableGreaterThanOperation;
import org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation;
import org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation;
import org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation;
import org.eclipse.ocl.pivot.library.string.StringConcatOperation;
import org.eclipse.ocl.pivot.messages.PivotMessages;
import org.eclipse.ocl.pivot.utilities.ClassUtil;
import org.eclipse.ocl.pivot.utilities.PivotUtil;
import org.eclipse.ocl.pivot.utilities.ValueUtil;
import org.eclipse.ocl.pivot.values.IntegerValue;
import org.eclipse.ocl.pivot.values.InvalidValueException;
import org.eclipse.ocl.pivot.values.SetValue;
import org.eclipse.ocl.pivot.values.SetValue.Accumulator;
import org.eclipse.ocl.pivot.values.TupleValue;
import de.mdelab.mlsdm.DecisionMergeNode;
import de.mdelab.mlsdm.MlsdmPackage;
import de.mdelab.mlsdm.MlsdmTables;
import java.lang.reflect.InvocationTargetException;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Decision Merge Node</b></em>'. <!-- end-user-doc -->
 *
 * @generated
 */
public class DecisionMergeNodeImpl extends ActivityNodeImpl implements DecisionMergeNode {
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected DecisionMergeNodeImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MlsdmPackage.Literals.DECISION_MERGE_NODE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean IncomingEdge(final DiagnosticChain diagnostics, final Map<Object, Object> context) {
		final String constraintName = "DecisionMergeNode::IncomingEdge";
		try {
			/**
			 *
			 * inv IncomingEdge:
			 *   let severity : Integer[1] = constraintName.getSeverity()
			 *   in
			 *     if severity <= 0
			 *     then true
			 *     else
			 *       let
			 *         result : OclAny[1] = let
			 *           status : Boolean[?] = if not self.incomingEdges->isEmpty()
			 *           then true
			 *           else null
			 *           endif
			 *         in
			 *           if status = true
			 *           then true
			 *           else
			 *             Tuple{message = 'Decision merge node ' +
			 *               self.toString() + ' must have at least one incoming edge.', status = status
			 *             }
			 *           endif
			 *       in
			 *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
			 *     endif
			 */
			final /*@NonInvalid*/ Executor executor = PivotUtil.getExecutor(this, context);
			final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
			/*@Caught*/ Object CAUGHT_severity_0;
			try {
				final /*@Thrown*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE.evaluate(executor,
						MlsdmPackage.Literals.DECISION_MERGE_NODE___INCOMING_EDGE__DIAGNOSTICCHAIN_MAP);
				CAUGHT_severity_0 = severity_0;
			} catch (Exception e) {
				CAUGHT_severity_0 = ValueUtil.createInvalidValue(e);
			}
			if (CAUGHT_severity_0 instanceof InvalidValueException) {
				throw (InvalidValueException) CAUGHT_severity_0;
			}
			final /*@Thrown*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
					.evaluate(executor, CAUGHT_severity_0, MlsdmTables.INT_0).booleanValue();
			/*@NonInvalid*/ Object symbol_2;
			if (le) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ List<ActivityEdge> incomingEdges = this.getIncomingEdges();
				final /*@NonInvalid*/ SetValue BOXED_incomingEdges = idResolver
						.createSetOfAll(MlsdmTables.SET_CLSSid_ActivityEdge, incomingEdges);
				final /*@NonInvalid*/ boolean isEmpty = CollectionIsEmptyOperation.INSTANCE
						.evaluate(BOXED_incomingEdges).booleanValue();
				final /*@NonInvalid*/ Boolean not = BooleanNotOperation.INSTANCE.evaluate(isEmpty);
				if (not == null) {
					throw new InvalidValueException("Null if condition");
				}
				/*@NonInvalid*/ Boolean status;
				if (not) {
					status = ValueUtil.TRUE_VALUE;
				} else {
					status = null;
				}
				final /*@NonInvalid*/ boolean eq = status == Boolean.TRUE;
				/*@NonInvalid*/ Object symbol_1;
				if (eq) {
					symbol_1 = ValueUtil.TRUE_VALUE;
				} else {
					final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE.evaluate(this);
					final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
							.evaluate(MlsdmTables.STR_Decision_32_merge_32_node_32, toString);
					final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE.evaluate(sum,
							MlsdmTables.STR__32_must_32_have_32_at_32_least_32_one_32_incoming_32_edge_0);
					final /*@NonInvalid*/ TupleValue symbol_0 = ValueUtil.createTupleOfEach(MlsdmTables.TUPLid_, sum_0,
							status);
					symbol_1 = symbol_0;
				}
				final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
						.evaluate(executor, TypeId.BOOLEAN, constraintName, this, (Object) null, diagnostics, context,
								(Object) null, CAUGHT_severity_0, symbol_1, MlsdmTables.INT_0)
						.booleanValue();
				symbol_2 = logDiagnostic;
			}
			return Boolean.TRUE == symbol_2;
		} catch (Throwable e) {
			return ValueUtil.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean MultipleEdgeGuards(final DiagnosticChain diagnostics, final Map<Object, Object> context) {
		final String constraintName = "DecisionMergeNode::MultipleEdgeGuards";
		try {
			/**
			 *
			 * inv MultipleEdgeGuards:
			 *   let severity : Integer[1] = constraintName.getSeverity()
			 *   in
			 *     if severity <= 0
			 *     then true
			 *     else
			 *       let
			 *         result : OclAny[1] = let
			 *           status : Boolean[?] = if
			 *             self.outgoingEdges->size() > 1 implies
			 *             self.outgoingEdges->select(e | e.guardType = ActivityEdgeGuardEnum::ELSE)
			 *             ->size() = 1 and
			 *             self.outgoingEdges->select(e | e.guardType = ActivityEdgeGuardEnum::BOOLEAN)
			 *             ->size() =
			 *             self.outgoingEdges->size() - 1
			 *           then true
			 *           else null
			 *           endif
			 *         in
			 *           if status = true
			 *           then true
			 *           else
			 *             Tuple{message = 'One of the outgoing edges of decision merge node ' +
			 *               self.toString() + ' must have the ELSE guard, the other edges must have the BOOLEAN guard.', status = status
			 *             }
			 *           endif
			 *       in
			 *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
			 *     endif
			 */
			final /*@NonInvalid*/ Executor executor = PivotUtil.getExecutor(this, context);
			final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
			/*@Caught*/ Object CAUGHT_severity_0;
			try {
				final /*@Thrown*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE.evaluate(executor,
						MlsdmPackage.Literals.DECISION_MERGE_NODE___MULTIPLE_EDGE_GUARDS__DIAGNOSTICCHAIN_MAP);
				CAUGHT_severity_0 = severity_0;
			} catch (Exception e) {
				CAUGHT_severity_0 = ValueUtil.createInvalidValue(e);
			}
			if (CAUGHT_severity_0 instanceof InvalidValueException) {
				throw (InvalidValueException) CAUGHT_severity_0;
			}
			final /*@Thrown*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
					.evaluate(executor, CAUGHT_severity_0, MlsdmTables.INT_0).booleanValue();
			/*@NonInvalid*/ Object symbol_2;
			if (le) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ List<ActivityEdge> outgoingEdges = this.getOutgoingEdges();
				final /*@NonInvalid*/ SetValue BOXED_outgoingEdges = idResolver
						.createSetOfAll(MlsdmTables.SET_CLSSid_ActivityEdge, outgoingEdges);
				final /*@NonInvalid*/ IntegerValue size = CollectionSizeOperation.INSTANCE
						.evaluate(BOXED_outgoingEdges);
				final /*@NonInvalid*/ boolean gt = OclComparableGreaterThanOperation.INSTANCE
						.evaluate(executor, size, MlsdmTables.INT_1).booleanValue();
				/*@NonInvalid*/ boolean implies;
				if (gt) {
					/*@Thrown*/ Accumulator accumulator = ValueUtil
							.createSetAccumulatorValue(MlsdmTables.SET_CLSSid_ActivityEdge);
					Iterator<Object> ITERATOR_e_0 = BOXED_outgoingEdges.iterator();
					/*@NonInvalid*/ SetValue select;
					while (true) {
						if (!ITERATOR_e_0.hasNext()) {
							select = accumulator;
							break;
						}
						/*@NonInvalid*/ ActivityEdge e_0 = (ActivityEdge) ITERATOR_e_0.next();
						/**
						 * e.guardType = ActivityEdgeGuardEnum::ELSE
						 */
						final /*@NonInvalid*/ ActivityEdgeGuardEnum guardType = e_0.getGuardType();
						final /*@NonInvalid*/ EnumerationLiteralId BOXED_guardType = MlsdmTables.ENUMid_ActivityEdgeGuardEnum
								.getEnumerationLiteralId(ClassUtil.nonNullState(guardType.getName()));
						final /*@NonInvalid*/ boolean eq = BOXED_guardType == MlsdmTables.ELITid_ELSE;
						//
						if (eq == ValueUtil.TRUE_VALUE) {
							accumulator.add(e_0);
						}
					}
					final /*@NonInvalid*/ IntegerValue size_0 = CollectionSizeOperation.INSTANCE.evaluate(select);
					final /*@NonInvalid*/ boolean eq_0 = size_0.equals(MlsdmTables.INT_1);
					/*@NonInvalid*/ boolean and;
					if (eq_0) {
						/*@Thrown*/ Accumulator accumulator_0 = ValueUtil
								.createSetAccumulatorValue(MlsdmTables.SET_CLSSid_ActivityEdge);
						Iterator<Object> ITERATOR_e_1 = BOXED_outgoingEdges.iterator();
						/*@NonInvalid*/ SetValue select_0;
						while (true) {
							if (!ITERATOR_e_1.hasNext()) {
								select_0 = accumulator_0;
								break;
							}
							/*@NonInvalid*/ ActivityEdge e_1 = (ActivityEdge) ITERATOR_e_1.next();
							/**
							 * e.guardType = ActivityEdgeGuardEnum::BOOLEAN
							 */
							final /*@NonInvalid*/ ActivityEdgeGuardEnum guardType_0 = e_1.getGuardType();
							final /*@NonInvalid*/ EnumerationLiteralId BOXED_guardType_0 = MlsdmTables.ENUMid_ActivityEdgeGuardEnum
									.getEnumerationLiteralId(ClassUtil.nonNullState(guardType_0.getName()));
							final /*@NonInvalid*/ boolean eq_1 = BOXED_guardType_0 == MlsdmTables.ELITid_BOOLEAN;
							//
							if (eq_1 == ValueUtil.TRUE_VALUE) {
								accumulator_0.add(e_1);
							}
						}
						final /*@NonInvalid*/ IntegerValue size_1 = CollectionSizeOperation.INSTANCE.evaluate(select_0);
						final /*@NonInvalid*/ IntegerValue diff = (IntegerValue) NumericMinusOperation.INSTANCE
								.evaluate(size, MlsdmTables.INT_1);
						final /*@NonInvalid*/ boolean eq_2 = size_1.equals(diff);
						and = eq_2;
					} else {
						and = ValueUtil.FALSE_VALUE;
					}
					implies = and;
				} else {
					implies = ValueUtil.TRUE_VALUE;
				}
				/*@NonInvalid*/ Boolean status;
				if (implies) {
					status = ValueUtil.TRUE_VALUE;
				} else {
					status = null;
				}
				final /*@NonInvalid*/ boolean eq_3 = status == Boolean.TRUE;
				/*@NonInvalid*/ Object symbol_1;
				if (eq_3) {
					symbol_1 = ValueUtil.TRUE_VALUE;
				} else {
					final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE.evaluate(this);
					final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE.evaluate(
							MlsdmTables.STR_One_32_of_32_the_32_outgoing_32_edges_32_of_32_decision_32_merge_32_node_32,
							toString);
					final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE.evaluate(sum,
							MlsdmTables.STR__32_must_32_have_32_the_32_ELSE_32_guard_44_32_the_32_other_32_edges_32_must_32_have_32_the_32_BOOLEAN);
					final /*@NonInvalid*/ TupleValue symbol_0 = ValueUtil.createTupleOfEach(MlsdmTables.TUPLid_, sum_0,
							status);
					symbol_1 = symbol_0;
				}
				final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
						.evaluate(executor, TypeId.BOOLEAN, constraintName, this, (Object) null, diagnostics, context,
								(Object) null, CAUGHT_severity_0, symbol_1, MlsdmTables.INT_0)
						.booleanValue();
				symbol_2 = logDiagnostic;
			}
			return Boolean.TRUE == symbol_2;
		} catch (Throwable e) {
			return ValueUtil.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean SingleEdgeGuard(final DiagnosticChain diagnostics, final Map<Object, Object> context) {
		final String constraintName = "DecisionMergeNode::SingleEdgeGuard";
		try {
			/**
			 *
			 * inv SingleEdgeGuard:
			 *   let severity : Integer[1] = constraintName.getSeverity()
			 *   in
			 *     if severity <= 0
			 *     then true
			 *     else
			 *       let
			 *         result : OclAny[1] = let
			 *           status : Boolean[?] = if
			 *             self.outgoingEdges->size() = 1 implies
			 *             self.outgoingEdges->forAll(e | e.guardType = ActivityEdgeGuardEnum::NONE)
			 *           then true
			 *           else null
			 *           endif
			 *         in
			 *           if status = true
			 *           then true
			 *           else
			 *             Tuple{message = 'Single outgoing edge from decision merge node ' +
			 *               self.toString() + ' may not have a guard.', status = status
			 *             }
			 *           endif
			 *       in
			 *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
			 *     endif
			 */
			final /*@NonInvalid*/ Executor executor = PivotUtil.getExecutor(this, context);
			final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
			/*@Caught*/ Object CAUGHT_severity_0;
			try {
				final /*@Thrown*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE.evaluate(executor,
						MlsdmPackage.Literals.DECISION_MERGE_NODE___SINGLE_EDGE_GUARD__DIAGNOSTICCHAIN_MAP);
				CAUGHT_severity_0 = severity_0;
			} catch (Exception e) {
				CAUGHT_severity_0 = ValueUtil.createInvalidValue(e);
			}
			if (CAUGHT_severity_0 instanceof InvalidValueException) {
				throw (InvalidValueException) CAUGHT_severity_0;
			}
			final /*@Thrown*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
					.evaluate(executor, CAUGHT_severity_0, MlsdmTables.INT_0).booleanValue();
			/*@NonInvalid*/ Object symbol_2;
			if (le) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ List<ActivityEdge> outgoingEdges_0 = this.getOutgoingEdges();
				final /*@NonInvalid*/ SetValue BOXED_outgoingEdges_0 = idResolver
						.createSetOfAll(MlsdmTables.SET_CLSSid_ActivityEdge, outgoingEdges_0);
				final /*@NonInvalid*/ IntegerValue size = CollectionSizeOperation.INSTANCE
						.evaluate(BOXED_outgoingEdges_0);
				final /*@NonInvalid*/ boolean eq = size.equals(MlsdmTables.INT_1);
				/*@NonInvalid*/ Boolean implies;
				if (eq) {
					/*@Thrown*/ Object accumulator = ValueUtil.TRUE_VALUE;
					Iterator<Object> ITERATOR_e_0 = BOXED_outgoingEdges_0.iterator();
					/*@NonInvalid*/ Boolean forAll;
					while (true) {
						if (!ITERATOR_e_0.hasNext()) {
							if (accumulator == ValueUtil.TRUE_VALUE) {
								forAll = ValueUtil.TRUE_VALUE;
							} else {
								throw (InvalidValueException) accumulator;
							}
							break;
						}
						/*@NonInvalid*/ ActivityEdge e_0 = (ActivityEdge) ITERATOR_e_0.next();
						/**
						 * e.guardType = ActivityEdgeGuardEnum::NONE
						 */
						final /*@NonInvalid*/ ActivityEdgeGuardEnum guardType = e_0.getGuardType();
						final /*@NonInvalid*/ EnumerationLiteralId BOXED_guardType = MlsdmTables.ENUMid_ActivityEdgeGuardEnum
								.getEnumerationLiteralId(ClassUtil.nonNullState(guardType.getName()));
						final /*@NonInvalid*/ boolean eq_0 = BOXED_guardType == MlsdmTables.ELITid_NONE;
						//
						if (eq_0 == ValueUtil.FALSE_VALUE) { // Normal unsuccessful body evaluation result
							forAll = ValueUtil.FALSE_VALUE;
							break; // Stop immediately
						} else if (eq_0 == ValueUtil.TRUE_VALUE) { // Normal successful body evaluation result
							; // Carry on
						} else { // Impossible badly typed result
							accumulator = new InvalidValueException(PivotMessages.NonBooleanBody, "forAll");
						}
					}
					implies = forAll;
				} else {
					implies = ValueUtil.TRUE_VALUE;
				}
				if (implies == null) {
					throw new InvalidValueException("Null if condition");
				}
				/*@NonInvalid*/ Boolean status;
				if (implies) {
					status = ValueUtil.TRUE_VALUE;
				} else {
					status = null;
				}
				final /*@NonInvalid*/ boolean eq_1 = status == Boolean.TRUE;
				/*@NonInvalid*/ Object symbol_1;
				if (eq_1) {
					symbol_1 = ValueUtil.TRUE_VALUE;
				} else {
					final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE.evaluate(this);
					final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE.evaluate(
							MlsdmTables.STR_Single_32_outgoing_32_edge_32_from_32_decision_32_merge_32_node_32,
							toString);
					final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE.evaluate(sum,
							MlsdmTables.STR__32_may_32_not_32_have_32_a_32_guard);
					final /*@NonInvalid*/ TupleValue symbol_0 = ValueUtil.createTupleOfEach(MlsdmTables.TUPLid_, sum_0,
							status);
					symbol_1 = symbol_0;
				}
				final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
						.evaluate(executor, TypeId.BOOLEAN, constraintName, this, (Object) null, diagnostics, context,
								(Object) null, CAUGHT_severity_0, symbol_1, MlsdmTables.INT_0)
						.booleanValue();
				symbol_2 = logDiagnostic;
			}
			return Boolean.TRUE == symbol_2;
		} catch (Throwable e) {
			return ValueUtil.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean OutgoingEdge(final DiagnosticChain diagnostics, final Map<Object, Object> context) {
		final String constraintName = "DecisionMergeNode::OutgoingEdge";
		try {
			/**
			 *
			 * inv OutgoingEdge:
			 *   let severity : Integer[1] = constraintName.getSeverity()
			 *   in
			 *     if severity <= 0
			 *     then true
			 *     else
			 *       let
			 *         result : OclAny[1] = let
			 *           status : Boolean[?] = if not self.outgoingEdges->isEmpty()
			 *           then true
			 *           else null
			 *           endif
			 *         in
			 *           if status = true
			 *           then true
			 *           else
			 *             Tuple{message = 'Decision merge node ' +
			 *               self.toString() + ' must have at least one outgoing edge.', status = status
			 *             }
			 *           endif
			 *       in
			 *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
			 *     endif
			 */
			final /*@NonInvalid*/ Executor executor = PivotUtil.getExecutor(this, context);
			final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
			/*@Caught*/ Object CAUGHT_severity_0;
			try {
				final /*@Thrown*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE.evaluate(executor,
						MlsdmPackage.Literals.DECISION_MERGE_NODE___OUTGOING_EDGE__DIAGNOSTICCHAIN_MAP);
				CAUGHT_severity_0 = severity_0;
			} catch (Exception e) {
				CAUGHT_severity_0 = ValueUtil.createInvalidValue(e);
			}
			if (CAUGHT_severity_0 instanceof InvalidValueException) {
				throw (InvalidValueException) CAUGHT_severity_0;
			}
			final /*@Thrown*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
					.evaluate(executor, CAUGHT_severity_0, MlsdmTables.INT_0).booleanValue();
			/*@NonInvalid*/ Object symbol_2;
			if (le) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ List<ActivityEdge> outgoingEdges = this.getOutgoingEdges();
				final /*@NonInvalid*/ SetValue BOXED_outgoingEdges = idResolver
						.createSetOfAll(MlsdmTables.SET_CLSSid_ActivityEdge, outgoingEdges);
				final /*@NonInvalid*/ boolean isEmpty = CollectionIsEmptyOperation.INSTANCE
						.evaluate(BOXED_outgoingEdges).booleanValue();
				final /*@NonInvalid*/ Boolean not = BooleanNotOperation.INSTANCE.evaluate(isEmpty);
				if (not == null) {
					throw new InvalidValueException("Null if condition");
				}
				/*@NonInvalid*/ Boolean status;
				if (not) {
					status = ValueUtil.TRUE_VALUE;
				} else {
					status = null;
				}
				final /*@NonInvalid*/ boolean eq = status == Boolean.TRUE;
				/*@NonInvalid*/ Object symbol_1;
				if (eq) {
					symbol_1 = ValueUtil.TRUE_VALUE;
				} else {
					final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE.evaluate(this);
					final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
							.evaluate(MlsdmTables.STR_Decision_32_merge_32_node_32, toString);
					final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE.evaluate(sum,
							MlsdmTables.STR__32_must_32_have_32_at_32_least_32_one_32_outgoing_32_edge);
					final /*@NonInvalid*/ TupleValue symbol_0 = ValueUtil.createTupleOfEach(MlsdmTables.TUPLid_, sum_0,
							status);
					symbol_1 = symbol_0;
				}
				final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
						.evaluate(executor, TypeId.BOOLEAN, constraintName, this, (Object) null, diagnostics, context,
								(Object) null, CAUGHT_severity_0, symbol_1, MlsdmTables.INT_0)
						.booleanValue();
				symbol_2 = logDiagnostic;
			}
			return Boolean.TRUE == symbol_2;
		} catch (Throwable e) {
			return ValueUtil.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	@SuppressWarnings("unchecked")
	public Object eInvoke(int operationID, EList<?> arguments) throws InvocationTargetException {
		switch (operationID) {
		case MlsdmPackage.DECISION_MERGE_NODE___INCOMING_EDGE__DIAGNOSTICCHAIN_MAP:
			return IncomingEdge((DiagnosticChain) arguments.get(0), (Map<Object, Object>) arguments.get(1));
		case MlsdmPackage.DECISION_MERGE_NODE___MULTIPLE_EDGE_GUARDS__DIAGNOSTICCHAIN_MAP:
			return MultipleEdgeGuards((DiagnosticChain) arguments.get(0), (Map<Object, Object>) arguments.get(1));
		case MlsdmPackage.DECISION_MERGE_NODE___SINGLE_EDGE_GUARD__DIAGNOSTICCHAIN_MAP:
			return SingleEdgeGuard((DiagnosticChain) arguments.get(0), (Map<Object, Object>) arguments.get(1));
		case MlsdmPackage.DECISION_MERGE_NODE___OUTGOING_EDGE__DIAGNOSTICCHAIN_MAP:
			return OutgoingEdge((DiagnosticChain) arguments.get(0), (Map<Object, Object>) arguments.get(1));
		}
		return super.eInvoke(operationID, arguments);
	}

} // DecisionMergeNodeImpl
