/**
 */
package de.mdelab.mlsdm.impl;

import java.util.Collection;

import java.util.Iterator;
import java.util.List;
import java.util.Map;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.eclipse.ocl.pivot.evaluation.Executor;
import org.eclipse.ocl.pivot.ids.IdResolver;
import org.eclipse.ocl.pivot.ids.TypeId;
import org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal;
import org.eclipse.ocl.pivot.library.oclany.OclAnyOclIsKindOfOperation;
import org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation;
import org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation;
import org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation;
import org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation;
import org.eclipse.ocl.pivot.library.string.StringConcatOperation;
import org.eclipse.ocl.pivot.messages.PivotMessages;
import org.eclipse.ocl.pivot.utilities.PivotUtil;
import org.eclipse.ocl.pivot.utilities.ValueUtil;
import org.eclipse.ocl.pivot.values.IntegerValue;
import org.eclipse.ocl.pivot.values.InvalidValueException;
import org.eclipse.ocl.pivot.values.SetValue;
import org.eclipse.ocl.pivot.values.TupleValue;
import de.mdelab.mlsdm.ActivityEdge;
import de.mdelab.mlsdm.ActivityNode;
import de.mdelab.mlsdm.ActivityNodeContainer;
import de.mdelab.mlsdm.MlsdmPackage;
import de.mdelab.mlsdm.MlsdmTables;
import de.mdelab.mlsdm.Semaphore;
import de.mdelab.mlsdm.StructuredNode;
import de.mdelab.mlsdm.SynchronizationEdge;
import java.lang.reflect.InvocationTargetException;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Structured Node</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link de.mdelab.mlsdm.impl.StructuredNodeImpl#getEdges <em>Edges</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.impl.StructuredNodeImpl#getNodes <em>Nodes</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.impl.StructuredNodeImpl#getSemaphores <em>Semaphores</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.impl.StructuredNodeImpl#getSynchronizationEdges <em>Synchronization Edges</em>}</li>
 * </ul>
 *
 * @generated
 */
public class StructuredNodeImpl extends ActivityNodeImpl implements StructuredNode {
	/**
	 * The cached value of the '{@link #getEdges() <em>Edges</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getEdges()
	 * @generated
	 * @ordered
	 */
	protected EList<ActivityEdge> edges;

	/**
	 * The cached value of the '{@link #getNodes() <em>Nodes</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getNodes()
	 * @generated
	 * @ordered
	 */
	protected EList<ActivityNode> nodes;

	/**
	 * The cached value of the '{@link #getSemaphores() <em>Semaphores</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getSemaphores()
	 * @generated
	 * @ordered
	 */
	protected EList<Semaphore> semaphores;

	/**
	 * The cached value of the '{@link #getSynchronizationEdges()
	 * <em>Synchronization Edges</em>}' containment reference list. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getSynchronizationEdges()
	 * @generated
	 * @ordered
	 */
	protected EList<SynchronizationEdge> synchronizationEdges;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected StructuredNodeImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MlsdmPackage.Literals.STRUCTURED_NODE;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<ActivityEdge> getEdges() {
		if (edges == null) {
			edges = new EObjectContainmentWithInverseEList<ActivityEdge>(ActivityEdge.class, this,
					MlsdmPackage.STRUCTURED_NODE__EDGES, MlsdmPackage.ACTIVITY_EDGE__ACTIVITY_NODE_CONTAINER);
		}
		return edges;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<ActivityNode> getNodes() {
		if (nodes == null) {
			nodes = new EObjectContainmentWithInverseEList<ActivityNode>(ActivityNode.class, this,
					MlsdmPackage.STRUCTURED_NODE__NODES, MlsdmPackage.ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER);
		}
		return nodes;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<Semaphore> getSemaphores() {
		if (semaphores == null) {
			semaphores = new EObjectContainmentWithInverseEList<Semaphore>(Semaphore.class, this,
					MlsdmPackage.STRUCTURED_NODE__SEMAPHORES, MlsdmPackage.SEMAPHORE__ACTIVITY_NODE_CONTAINER);
		}
		return semaphores;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<SynchronizationEdge> getSynchronizationEdges() {
		if (synchronizationEdges == null) {
			synchronizationEdges = new EObjectContainmentWithInverseEList<SynchronizationEdge>(
					SynchronizationEdge.class, this, MlsdmPackage.STRUCTURED_NODE__SYNCHRONIZATION_EDGES,
					MlsdmPackage.SYNCHRONIZATION_EDGE__ACTIVITY_NODE_CONTAINER);
		}
		return synchronizationEdges;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean InitialNodeContained(final DiagnosticChain diagnostics, final Map<Object, Object> context) {
		final String constraintName = "StructuredNode::InitialNodeContained";
		try {
			/**
			 *
			 * inv InitialNodeContained:
			 *   let severity : Integer[1] = constraintName.getSeverity()
			 *   in
			 *     if severity <= 0
			 *     then true
			 *     else
			 *       let
			 *         result : OclAny[1] = let
			 *           status : Boolean[?] = if
			 *             self.nodes->exists(e | e.oclIsKindOf(InitialNode))
			 *           then true
			 *           else null
			 *           endif
			 *         in
			 *           if status = true
			 *           then true
			 *           else
			 *             Tuple{message = 'Structured node ' +
			 *               self.toString() + ' must contain an initial node.', status = status
			 *             }
			 *           endif
			 *       in
			 *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
			 *     endif
			 */
			final /*@NonInvalid*/ Executor executor = PivotUtil.getExecutor(this, context);
			final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
			/*@Caught*/ Object CAUGHT_severity_0;
			try {
				final /*@Thrown*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE.evaluate(executor,
						MlsdmPackage.Literals.STRUCTURED_NODE___INITIAL_NODE_CONTAINED__DIAGNOSTICCHAIN_MAP);
				CAUGHT_severity_0 = severity_0;
			} catch (Exception e) {
				CAUGHT_severity_0 = ValueUtil.createInvalidValue(e);
			}
			if (CAUGHT_severity_0 instanceof InvalidValueException) {
				throw (InvalidValueException) CAUGHT_severity_0;
			}
			final /*@Thrown*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
					.evaluate(executor, CAUGHT_severity_0, MlsdmTables.INT_0).booleanValue();
			/*@NonInvalid*/ Object symbol_2;
			if (le) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ List<ActivityNode> nodes = this.getNodes();
				final /*@NonInvalid*/ SetValue BOXED_nodes = idResolver
						.createSetOfAll(MlsdmTables.SET_CLSSid_ActivityNode, nodes);
				/*@Thrown*/ Object accumulator = ValueUtil.FALSE_VALUE;
				Iterator<Object> ITERATOR_e_0 = BOXED_nodes.iterator();
				/*@NonInvalid*/ Boolean exists;
				while (true) {
					if (!ITERATOR_e_0.hasNext()) {
						if (accumulator == ValueUtil.FALSE_VALUE) {
							exists = ValueUtil.FALSE_VALUE;
						} else {
							throw (InvalidValueException) accumulator;
						}
						break;
					}
					/*@NonInvalid*/ ActivityNode e_0 = (ActivityNode) ITERATOR_e_0.next();
					/**
					 * e.oclIsKindOf(InitialNode)
					 */
					final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_mlsdm_c_c_InitialNode_0 = idResolver
							.getClass(MlsdmTables.CLSSid_InitialNode, null);
					final /*@NonInvalid*/ boolean oclIsKindOf = OclAnyOclIsKindOfOperation.INSTANCE
							.evaluate(executor, e_0, TYP_mlsdm_c_c_InitialNode_0).booleanValue();
					//
					if (oclIsKindOf == ValueUtil.TRUE_VALUE) { // Normal successful body evaluation result
						exists = ValueUtil.TRUE_VALUE;
						break; // Stop immediately
					} else if (oclIsKindOf == ValueUtil.FALSE_VALUE) { // Normal unsuccessful body evaluation result
						; // Carry on
					} else { // Impossible badly typed result
						accumulator = new InvalidValueException(PivotMessages.NonBooleanBody, "exists");
					}
				}
				if (exists == null) {
					throw new InvalidValueException("Null if condition");
				}
				/*@NonInvalid*/ Boolean status;
				if (exists) {
					status = ValueUtil.TRUE_VALUE;
				} else {
					status = null;
				}
				final /*@NonInvalid*/ boolean eq = status == Boolean.TRUE;
				/*@NonInvalid*/ Object symbol_1;
				if (eq) {
					symbol_1 = ValueUtil.TRUE_VALUE;
				} else {
					final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE.evaluate(this);
					final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
							.evaluate(MlsdmTables.STR_Structured_32_node_32, toString);
					final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE.evaluate(sum,
							MlsdmTables.STR__32_must_32_contain_32_an_32_initial_32_node);
					final /*@NonInvalid*/ TupleValue symbol_0 = ValueUtil.createTupleOfEach(MlsdmTables.TUPLid_, sum_0,
							status);
					symbol_1 = symbol_0;
				}
				final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
						.evaluate(executor, TypeId.BOOLEAN, constraintName, this, (Object) null, diagnostics, context,
								(Object) null, CAUGHT_severity_0, symbol_1, MlsdmTables.INT_0)
						.booleanValue();
				symbol_2 = logDiagnostic;
			}
			return Boolean.TRUE == symbol_2;
		} catch (Throwable e) {
			return ValueUtil.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean FinalNodeContained(final DiagnosticChain diagnostics, final Map<Object, Object> context) {
		final String constraintName = "StructuredNode::FinalNodeContained";
		try {
			/**
			 *
			 * inv FinalNodeContained:
			 *   let severity : Integer[1] = constraintName.getSeverity()
			 *   in
			 *     if severity <= 0
			 *     then true
			 *     else
			 *       let
			 *         result : OclAny[1] = let
			 *           status : Boolean[?] = if
			 *             self.nodes->exists(e |
			 *               e.oclIsKindOf(FlowFinalNode) or
			 *               e.oclIsKindOf(ActivityFinalNode))
			 *           then true
			 *           else null
			 *           endif
			 *         in
			 *           if status = true
			 *           then true
			 *           else
			 *             Tuple{message = 'Structured node ' +
			 *               self.toString() + ' must contain an flow final node or an activity final node.', status = status
			 *             }
			 *           endif
			 *       in
			 *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
			 *     endif
			 */
			final /*@NonInvalid*/ Executor executor = PivotUtil.getExecutor(this, context);
			final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
			/*@Caught*/ Object CAUGHT_severity_0;
			try {
				final /*@Thrown*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE.evaluate(executor,
						MlsdmPackage.Literals.STRUCTURED_NODE___FINAL_NODE_CONTAINED__DIAGNOSTICCHAIN_MAP);
				CAUGHT_severity_0 = severity_0;
			} catch (Exception e) {
				CAUGHT_severity_0 = ValueUtil.createInvalidValue(e);
			}
			if (CAUGHT_severity_0 instanceof InvalidValueException) {
				throw (InvalidValueException) CAUGHT_severity_0;
			}
			final /*@Thrown*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
					.evaluate(executor, CAUGHT_severity_0, MlsdmTables.INT_0).booleanValue();
			/*@NonInvalid*/ Object symbol_2;
			if (le) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ List<ActivityNode> nodes = this.getNodes();
				final /*@NonInvalid*/ SetValue BOXED_nodes = idResolver
						.createSetOfAll(MlsdmTables.SET_CLSSid_ActivityNode, nodes);
				/*@Thrown*/ Object accumulator = ValueUtil.FALSE_VALUE;
				Iterator<Object> ITERATOR_e_0 = BOXED_nodes.iterator();
				/*@NonInvalid*/ Boolean exists;
				while (true) {
					if (!ITERATOR_e_0.hasNext()) {
						if (accumulator == ValueUtil.FALSE_VALUE) {
							exists = ValueUtil.FALSE_VALUE;
						} else {
							throw (InvalidValueException) accumulator;
						}
						break;
					}
					/*@NonInvalid*/ ActivityNode e_0 = (ActivityNode) ITERATOR_e_0.next();
					/**
					 *
					 * e.oclIsKindOf(FlowFinalNode) or
					 * e.oclIsKindOf(ActivityFinalNode)
					 */
					final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_mlsdm_c_c_FlowFinalNode = idResolver
							.getClass(MlsdmTables.CLSSid_FlowFinalNode, null);
					final /*@NonInvalid*/ boolean oclIsKindOf = OclAnyOclIsKindOfOperation.INSTANCE
							.evaluate(executor, e_0, TYP_mlsdm_c_c_FlowFinalNode).booleanValue();
					/*@NonInvalid*/ boolean or;
					if (oclIsKindOf) {
						or = ValueUtil.TRUE_VALUE;
					} else {
						final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_mlsdm_c_c_ActivityFinalNode_0 = idResolver
								.getClass(MlsdmTables.CLSSid_ActivityFinalNode, null);
						final /*@NonInvalid*/ boolean oclIsKindOf_0 = OclAnyOclIsKindOfOperation.INSTANCE
								.evaluate(executor, e_0, TYP_mlsdm_c_c_ActivityFinalNode_0).booleanValue();
						or = oclIsKindOf_0;
					}
					//
					if (or == ValueUtil.TRUE_VALUE) { // Normal successful body evaluation result
						exists = ValueUtil.TRUE_VALUE;
						break; // Stop immediately
					} else if (or == ValueUtil.FALSE_VALUE) { // Normal unsuccessful body evaluation result
						; // Carry on
					} else { // Impossible badly typed result
						accumulator = new InvalidValueException(PivotMessages.NonBooleanBody, "exists");
					}
				}
				if (exists == null) {
					throw new InvalidValueException("Null if condition");
				}
				/*@NonInvalid*/ Boolean status;
				if (exists) {
					status = ValueUtil.TRUE_VALUE;
				} else {
					status = null;
				}
				final /*@NonInvalid*/ boolean eq = status == Boolean.TRUE;
				/*@NonInvalid*/ Object symbol_1;
				if (eq) {
					symbol_1 = ValueUtil.TRUE_VALUE;
				} else {
					final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE.evaluate(this);
					final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
							.evaluate(MlsdmTables.STR_Structured_32_node_32, toString);
					final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE.evaluate(sum,
							MlsdmTables.STR__32_must_32_contain_32_an_32_flow_32_final_32_node_32_or_32_an_32_activity_32_final_32_node);
					final /*@NonInvalid*/ TupleValue symbol_0 = ValueUtil.createTupleOfEach(MlsdmTables.TUPLid_, sum_0,
							status);
					symbol_1 = symbol_0;
				}
				final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
						.evaluate(executor, TypeId.BOOLEAN, constraintName, this, (Object) null, diagnostics, context,
								(Object) null, CAUGHT_severity_0, symbol_1, MlsdmTables.INT_0)
						.booleanValue();
				symbol_2 = logDiagnostic;
			}
			return Boolean.TRUE == symbol_2;
		} catch (Throwable e) {
			return ValueUtil.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
		case MlsdmPackage.STRUCTURED_NODE__EDGES:
			return ((InternalEList<InternalEObject>) (InternalEList<?>) getEdges()).basicAdd(otherEnd, msgs);
		case MlsdmPackage.STRUCTURED_NODE__NODES:
			return ((InternalEList<InternalEObject>) (InternalEList<?>) getNodes()).basicAdd(otherEnd, msgs);
		case MlsdmPackage.STRUCTURED_NODE__SEMAPHORES:
			return ((InternalEList<InternalEObject>) (InternalEList<?>) getSemaphores()).basicAdd(otherEnd, msgs);
		case MlsdmPackage.STRUCTURED_NODE__SYNCHRONIZATION_EDGES:
			return ((InternalEList<InternalEObject>) (InternalEList<?>) getSynchronizationEdges()).basicAdd(otherEnd,
					msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
		case MlsdmPackage.STRUCTURED_NODE__EDGES:
			return ((InternalEList<?>) getEdges()).basicRemove(otherEnd, msgs);
		case MlsdmPackage.STRUCTURED_NODE__NODES:
			return ((InternalEList<?>) getNodes()).basicRemove(otherEnd, msgs);
		case MlsdmPackage.STRUCTURED_NODE__SEMAPHORES:
			return ((InternalEList<?>) getSemaphores()).basicRemove(otherEnd, msgs);
		case MlsdmPackage.STRUCTURED_NODE__SYNCHRONIZATION_EDGES:
			return ((InternalEList<?>) getSynchronizationEdges()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case MlsdmPackage.STRUCTURED_NODE__EDGES:
			return getEdges();
		case MlsdmPackage.STRUCTURED_NODE__NODES:
			return getNodes();
		case MlsdmPackage.STRUCTURED_NODE__SEMAPHORES:
			return getSemaphores();
		case MlsdmPackage.STRUCTURED_NODE__SYNCHRONIZATION_EDGES:
			return getSynchronizationEdges();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case MlsdmPackage.STRUCTURED_NODE__EDGES:
			getEdges().clear();
			getEdges().addAll((Collection<? extends ActivityEdge>) newValue);
			return;
		case MlsdmPackage.STRUCTURED_NODE__NODES:
			getNodes().clear();
			getNodes().addAll((Collection<? extends ActivityNode>) newValue);
			return;
		case MlsdmPackage.STRUCTURED_NODE__SEMAPHORES:
			getSemaphores().clear();
			getSemaphores().addAll((Collection<? extends Semaphore>) newValue);
			return;
		case MlsdmPackage.STRUCTURED_NODE__SYNCHRONIZATION_EDGES:
			getSynchronizationEdges().clear();
			getSynchronizationEdges().addAll((Collection<? extends SynchronizationEdge>) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case MlsdmPackage.STRUCTURED_NODE__EDGES:
			getEdges().clear();
			return;
		case MlsdmPackage.STRUCTURED_NODE__NODES:
			getNodes().clear();
			return;
		case MlsdmPackage.STRUCTURED_NODE__SEMAPHORES:
			getSemaphores().clear();
			return;
		case MlsdmPackage.STRUCTURED_NODE__SYNCHRONIZATION_EDGES:
			getSynchronizationEdges().clear();
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case MlsdmPackage.STRUCTURED_NODE__EDGES:
			return edges != null && !edges.isEmpty();
		case MlsdmPackage.STRUCTURED_NODE__NODES:
			return nodes != null && !nodes.isEmpty();
		case MlsdmPackage.STRUCTURED_NODE__SEMAPHORES:
			return semaphores != null && !semaphores.isEmpty();
		case MlsdmPackage.STRUCTURED_NODE__SYNCHRONIZATION_EDGES:
			return synchronizationEdges != null && !synchronizationEdges.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
		if (baseClass == ActivityNodeContainer.class) {
			switch (derivedFeatureID) {
			case MlsdmPackage.STRUCTURED_NODE__EDGES:
				return MlsdmPackage.ACTIVITY_NODE_CONTAINER__EDGES;
			case MlsdmPackage.STRUCTURED_NODE__NODES:
				return MlsdmPackage.ACTIVITY_NODE_CONTAINER__NODES;
			case MlsdmPackage.STRUCTURED_NODE__SEMAPHORES:
				return MlsdmPackage.ACTIVITY_NODE_CONTAINER__SEMAPHORES;
			case MlsdmPackage.STRUCTURED_NODE__SYNCHRONIZATION_EDGES:
				return MlsdmPackage.ACTIVITY_NODE_CONTAINER__SYNCHRONIZATION_EDGES;
			default:
				return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
		if (baseClass == ActivityNodeContainer.class) {
			switch (baseFeatureID) {
			case MlsdmPackage.ACTIVITY_NODE_CONTAINER__EDGES:
				return MlsdmPackage.STRUCTURED_NODE__EDGES;
			case MlsdmPackage.ACTIVITY_NODE_CONTAINER__NODES:
				return MlsdmPackage.STRUCTURED_NODE__NODES;
			case MlsdmPackage.ACTIVITY_NODE_CONTAINER__SEMAPHORES:
				return MlsdmPackage.STRUCTURED_NODE__SEMAPHORES;
			case MlsdmPackage.ACTIVITY_NODE_CONTAINER__SYNCHRONIZATION_EDGES:
				return MlsdmPackage.STRUCTURED_NODE__SYNCHRONIZATION_EDGES;
			default:
				return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	@SuppressWarnings("unchecked")
	public Object eInvoke(int operationID, EList<?> arguments) throws InvocationTargetException {
		switch (operationID) {
		case MlsdmPackage.STRUCTURED_NODE___INITIAL_NODE_CONTAINED__DIAGNOSTICCHAIN_MAP:
			return InitialNodeContained((DiagnosticChain) arguments.get(0), (Map<Object, Object>) arguments.get(1));
		case MlsdmPackage.STRUCTURED_NODE___FINAL_NODE_CONTAINED__DIAGNOSTICCHAIN_MAP:
			return FinalNodeContained((DiagnosticChain) arguments.get(0), (Map<Object, Object>) arguments.get(1));
		}
		return super.eInvoke(operationID, arguments);
	}

} // StructuredNodeImpl
