/**
 */
package de.mdelab.mlsdm.util;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.util.Switch;

import de.mdelab.mlcore.MLAnnotatedElement;
import de.mdelab.mlcore.MLElementWithUUID;
import de.mdelab.mlcore.MLNamedElement;
import de.mdelab.mlcore.MLTypedElement;
import de.mdelab.mlsdm.*;
import de.mdelab.mlsdm.AcquireEdge;
import de.mdelab.mlsdm.Activity;
import de.mdelab.mlsdm.ActivityEdge;
import de.mdelab.mlsdm.ActivityFinalNode;
import de.mdelab.mlsdm.ActivityNode;
import de.mdelab.mlsdm.ActivityNodeContainer;
import de.mdelab.mlsdm.ActivityParameter;
import de.mdelab.mlsdm.DecisionMergeNode;
import de.mdelab.mlsdm.ExpressionActivityNode;
import de.mdelab.mlsdm.FlowFinalNode;
import de.mdelab.mlsdm.ForkJoinNode;
import de.mdelab.mlsdm.InitialNode;
import de.mdelab.mlsdm.MlsdmPackage;
import de.mdelab.mlsdm.OutputParameterValue;
import de.mdelab.mlsdm.ReleaseEdge;
import de.mdelab.mlsdm.Semaphore;
import de.mdelab.mlsdm.StoryNode;
import de.mdelab.mlsdm.StructuredNode;
import de.mdelab.mlsdm.SynchronizationEdge;

/**
 * <!-- begin-user-doc --> The <b>Switch</b> for the model's inheritance
 * hierarchy. It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object and proceeding up the
 * inheritance hierarchy until a non-null result is returned, which is the
 * result of the switch. <!-- end-user-doc -->
 * @see de.mdelab.mlsdm.MlsdmPackage
 * @generated
 */
public class MlsdmSwitch<T> extends Switch<T> {
	/**
	 * The cached model package
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected static MlsdmPackage modelPackage;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	public MlsdmSwitch() {
		if (modelPackage == null) {
			modelPackage = MlsdmPackage.eINSTANCE;
		}
	}

	/**
	 * Checks whether this is a switch for the given package. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @parameter ePackage the package in question.
	 * @return whether this is a switch for the given package.
	 * @generated
	 */
	@Override
	protected boolean isSwitchFor(EPackage ePackage) {
		return ePackage == modelPackage;
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	@Override
	protected T doSwitch(int classifierID, EObject theEObject) {
		switch (classifierID) {
		case MlsdmPackage.ACTIVITY_NODE_CONTAINER: {
			ActivityNodeContainer activityNodeContainer = (ActivityNodeContainer) theEObject;
			T result = caseActivityNodeContainer(activityNodeContainer);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case MlsdmPackage.ACTIVITY: {
			Activity activity = (Activity) theEObject;
			T result = caseActivity(activity);
			if (result == null)
				result = caseMLElementWithUUID(activity);
			if (result == null)
				result = caseMLAnnotatedElement(activity);
			if (result == null)
				result = caseMLNamedElement(activity);
			if (result == null)
				result = caseActivityNodeContainer(activity);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case MlsdmPackage.ACTIVITY_NODE: {
			ActivityNode activityNode = (ActivityNode) theEObject;
			T result = caseActivityNode(activityNode);
			if (result == null)
				result = caseMLElementWithUUID(activityNode);
			if (result == null)
				result = caseMLAnnotatedElement(activityNode);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case MlsdmPackage.ACTIVITY_EDGE: {
			ActivityEdge activityEdge = (ActivityEdge) theEObject;
			T result = caseActivityEdge(activityEdge);
			if (result == null)
				result = caseMLElementWithUUID(activityEdge);
			if (result == null)
				result = caseMLAnnotatedElement(activityEdge);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case MlsdmPackage.INITIAL_NODE: {
			InitialNode initialNode = (InitialNode) theEObject;
			T result = caseInitialNode(initialNode);
			if (result == null)
				result = caseActivityNode(initialNode);
			if (result == null)
				result = caseMLElementWithUUID(initialNode);
			if (result == null)
				result = caseMLAnnotatedElement(initialNode);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case MlsdmPackage.FLOW_FINAL_NODE: {
			FlowFinalNode flowFinalNode = (FlowFinalNode) theEObject;
			T result = caseFlowFinalNode(flowFinalNode);
			if (result == null)
				result = caseActivityNode(flowFinalNode);
			if (result == null)
				result = caseMLElementWithUUID(flowFinalNode);
			if (result == null)
				result = caseMLAnnotatedElement(flowFinalNode);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case MlsdmPackage.ACTIVITY_FINAL_NODE: {
			ActivityFinalNode activityFinalNode = (ActivityFinalNode) theEObject;
			T result = caseActivityFinalNode(activityFinalNode);
			if (result == null)
				result = caseActivityNode(activityFinalNode);
			if (result == null)
				result = caseMLElementWithUUID(activityFinalNode);
			if (result == null)
				result = caseMLAnnotatedElement(activityFinalNode);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case MlsdmPackage.EXPRESSION_ACTIVITY_NODE: {
			ExpressionActivityNode expressionActivityNode = (ExpressionActivityNode) theEObject;
			T result = caseExpressionActivityNode(expressionActivityNode);
			if (result == null)
				result = caseActivityNode(expressionActivityNode);
			if (result == null)
				result = caseMLNamedElement(expressionActivityNode);
			if (result == null)
				result = caseMLElementWithUUID(expressionActivityNode);
			if (result == null)
				result = caseMLAnnotatedElement(expressionActivityNode);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case MlsdmPackage.DECISION_MERGE_NODE: {
			DecisionMergeNode decisionMergeNode = (DecisionMergeNode) theEObject;
			T result = caseDecisionMergeNode(decisionMergeNode);
			if (result == null)
				result = caseActivityNode(decisionMergeNode);
			if (result == null)
				result = caseMLElementWithUUID(decisionMergeNode);
			if (result == null)
				result = caseMLAnnotatedElement(decisionMergeNode);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case MlsdmPackage.FORK_JOIN_NODE: {
			ForkJoinNode forkJoinNode = (ForkJoinNode) theEObject;
			T result = caseForkJoinNode(forkJoinNode);
			if (result == null)
				result = caseActivityNode(forkJoinNode);
			if (result == null)
				result = caseMLElementWithUUID(forkJoinNode);
			if (result == null)
				result = caseMLAnnotatedElement(forkJoinNode);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case MlsdmPackage.STORY_NODE: {
			StoryNode storyNode = (StoryNode) theEObject;
			T result = caseStoryNode(storyNode);
			if (result == null)
				result = caseActivityNode(storyNode);
			if (result == null)
				result = caseMLNamedElement(storyNode);
			if (result == null)
				result = caseMLElementWithUUID(storyNode);
			if (result == null)
				result = caseMLAnnotatedElement(storyNode);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case MlsdmPackage.STRUCTURED_NODE: {
			StructuredNode structuredNode = (StructuredNode) theEObject;
			T result = caseStructuredNode(structuredNode);
			if (result == null)
				result = caseActivityNode(structuredNode);
			if (result == null)
				result = caseActivityNodeContainer(structuredNode);
			if (result == null)
				result = caseMLElementWithUUID(structuredNode);
			if (result == null)
				result = caseMLAnnotatedElement(structuredNode);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case MlsdmPackage.SEMAPHORE: {
			Semaphore semaphore = (Semaphore) theEObject;
			T result = caseSemaphore(semaphore);
			if (result == null)
				result = caseMLElementWithUUID(semaphore);
			if (result == null)
				result = caseMLAnnotatedElement(semaphore);
			if (result == null)
				result = caseMLNamedElement(semaphore);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case MlsdmPackage.SYNCHRONIZATION_EDGE: {
			SynchronizationEdge synchronizationEdge = (SynchronizationEdge) theEObject;
			T result = caseSynchronizationEdge(synchronizationEdge);
			if (result == null)
				result = caseMLElementWithUUID(synchronizationEdge);
			if (result == null)
				result = caseMLAnnotatedElement(synchronizationEdge);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case MlsdmPackage.ACQUIRE_EDGE: {
			AcquireEdge acquireEdge = (AcquireEdge) theEObject;
			T result = caseAcquireEdge(acquireEdge);
			if (result == null)
				result = caseSynchronizationEdge(acquireEdge);
			if (result == null)
				result = caseMLElementWithUUID(acquireEdge);
			if (result == null)
				result = caseMLAnnotatedElement(acquireEdge);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case MlsdmPackage.RELEASE_EDGE: {
			ReleaseEdge releaseEdge = (ReleaseEdge) theEObject;
			T result = caseReleaseEdge(releaseEdge);
			if (result == null)
				result = caseSynchronizationEdge(releaseEdge);
			if (result == null)
				result = caseMLElementWithUUID(releaseEdge);
			if (result == null)
				result = caseMLAnnotatedElement(releaseEdge);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case MlsdmPackage.ACTIVITY_PARAMETER: {
			ActivityParameter activityParameter = (ActivityParameter) theEObject;
			T result = caseActivityParameter(activityParameter);
			if (result == null)
				result = caseMLElementWithUUID(activityParameter);
			if (result == null)
				result = caseMLAnnotatedElement(activityParameter);
			if (result == null)
				result = caseMLNamedElement(activityParameter);
			if (result == null)
				result = caseMLTypedElement(activityParameter);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case MlsdmPackage.OUTPUT_PARAMETER_VALUE: {
			OutputParameterValue outputParameterValue = (OutputParameterValue) theEObject;
			T result = caseOutputParameterValue(outputParameterValue);
			if (result == null)
				result = caseMLElementWithUUID(outputParameterValue);
			if (result == null)
				result = caseMLAnnotatedElement(outputParameterValue);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		default:
			return defaultCase(theEObject);
		}
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Activity Node Container</em>'.
	 * <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Activity Node Container</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseActivityNodeContainer(ActivityNodeContainer object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Activity</em>'.
	 * <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Activity</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseActivity(Activity object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Activity Node</em>'.
	 * <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Activity Node</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseActivityNode(ActivityNode object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Activity Edge</em>'.
	 * <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Activity Edge</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseActivityEdge(ActivityEdge object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Initial Node</em>'.
	 * <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Initial Node</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseInitialNode(InitialNode object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Flow Final Node</em>'.
	 * <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Flow Final Node</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseFlowFinalNode(FlowFinalNode object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Activity Final Node</em>'.
	 * <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Activity Final Node</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseActivityFinalNode(ActivityFinalNode object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Expression Activity Node</em>'.
	 * <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Expression Activity Node</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseExpressionActivityNode(ExpressionActivityNode object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Decision Merge Node</em>'.
	 * <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Decision Merge Node</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseDecisionMergeNode(DecisionMergeNode object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Fork Join Node</em>'.
	 * <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Fork Join Node</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseForkJoinNode(ForkJoinNode object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Story Node</em>'.
	 * <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Story Node</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseStoryNode(StoryNode object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Structured Node</em>'.
	 * <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Structured Node</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseStructuredNode(StructuredNode object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Semaphore</em>'.
	 * <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Semaphore</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSemaphore(Semaphore object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Synchronization Edge</em>'.
	 * <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Synchronization Edge</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSynchronizationEdge(SynchronizationEdge object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Acquire Edge</em>'.
	 * <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Acquire Edge</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseAcquireEdge(AcquireEdge object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Release Edge</em>'.
	 * <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Release Edge</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseReleaseEdge(ReleaseEdge object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Activity Parameter</em>'.
	 * <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Activity Parameter</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseActivityParameter(ActivityParameter object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Output Parameter Value</em>'.
	 * <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Output Parameter Value</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseOutputParameterValue(OutputParameterValue object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>ML Annotated Element</em>'.
	 * <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>ML Annotated Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMLAnnotatedElement(MLAnnotatedElement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>ML Element With UUID</em>'.
	 * <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>ML Element With UUID</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMLElementWithUUID(MLElementWithUUID object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>ML Named Element</em>'.
	 * <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>ML Named Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMLNamedElement(MLNamedElement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>ML Typed Element</em>'.
	 * <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>ML Typed Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMLTypedElement(MLTypedElement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch, but this is
	 * the last case anyway. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	@Override
	public T defaultCase(EObject object) {
		return null;
	}

} // MlsdmSwitch
