/**
 */
package de.mdelab.mlsdm.impl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EGenericType;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.EValidator;
import org.eclipse.emf.ecore.EcorePackage;
import org.eclipse.emf.ecore.impl.EPackageImpl;

import de.mdelab.mlcore.MlcorePackage;
import de.mdelab.mlexpressions.MlexpressionsPackage;
import de.mdelab.mlsdm.AcquireEdge;
import de.mdelab.mlsdm.Activity;
import de.mdelab.mlsdm.ActivityEdge;
import de.mdelab.mlsdm.ActivityEdgeGuardEnum;
import de.mdelab.mlsdm.ActivityFinalNode;
import de.mdelab.mlsdm.ActivityNode;
import de.mdelab.mlsdm.ActivityNodeContainer;
import de.mdelab.mlsdm.ActivityParameter;
import de.mdelab.mlsdm.ActivityParameterDirectionEnum;
import de.mdelab.mlsdm.DecisionMergeNode;
import de.mdelab.mlsdm.ExpressionActivityNode;
import de.mdelab.mlsdm.FlowFinalNode;
import de.mdelab.mlsdm.ForkJoinNode;
import de.mdelab.mlsdm.InitialNode;
import de.mdelab.mlsdm.MlsdmFactory;
import de.mdelab.mlsdm.MlsdmPackage;
import de.mdelab.mlsdm.OutputParameterValue;
import de.mdelab.mlsdm.ReleaseEdge;
import de.mdelab.mlsdm.Semaphore;
import de.mdelab.mlsdm.StoryNode;
import de.mdelab.mlsdm.StoryNodeSemanticsEnum;
import de.mdelab.mlsdm.StructuredNode;
import de.mdelab.mlsdm.SynchronizationEdge;
import de.mdelab.mlsdm.util.MlsdmValidator;
import de.mdelab.mlstorypatterns.MlstorypatternsPackage;

/**
 * <!-- begin-user-doc --> An implementation of the model <b>Package</b>. <!--
 * end-user-doc -->
 * @generated
 */
public class MlsdmPackageImpl extends EPackageImpl implements MlsdmPackage {
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EClass activityNodeContainerEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EClass activityEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EClass activityNodeEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EClass activityEdgeEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EClass initialNodeEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EClass flowFinalNodeEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EClass activityFinalNodeEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EClass expressionActivityNodeEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EClass decisionMergeNodeEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EClass forkJoinNodeEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EClass storyNodeEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EClass structuredNodeEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EClass semaphoreEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EClass synchronizationEdgeEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EClass acquireEdgeEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EClass releaseEdgeEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EClass activityParameterEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EClass outputParameterValueEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum activityEdgeGuardEnumEEnum = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum storyNodeSemanticsEnumEEnum = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum activityParameterDirectionEnumEEnum = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the
	 * package package URI value.
	 * <p>
	 * Note: the correct way to create the package is via the static factory
	 * method {@link #init init()}, which also performs initialization of the
	 * package, or returns the registered package, if one already exists. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see de.mdelab.mlsdm.MlsdmPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private MlsdmPackageImpl() {
		super(eNS_URI, MlsdmFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this model,
	 * and for any others upon which it depends.
	 * 
	 * <p>
	 * This method is used to initialize {@link MlsdmPackage#eINSTANCE} when
	 * that field is accessed. Clients should not invoke it directly. Instead,
	 * they should simply access that field to obtain the package. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static MlsdmPackage init() {
		if (isInited)
			return (MlsdmPackage) EPackage.Registry.INSTANCE.getEPackage(MlsdmPackage.eNS_URI);

		// Obtain or create and register package
		Object registeredMlsdmPackage = EPackage.Registry.INSTANCE.get(eNS_URI);
		MlsdmPackageImpl theMlsdmPackage = registeredMlsdmPackage instanceof MlsdmPackageImpl
				? (MlsdmPackageImpl) registeredMlsdmPackage
				: new MlsdmPackageImpl();

		isInited = true;

		// Initialize simple dependencies
		EcorePackage.eINSTANCE.eClass();
		MlcorePackage.eINSTANCE.eClass();
		MlexpressionsPackage.eINSTANCE.eClass();
		MlstorypatternsPackage.eINSTANCE.eClass();

		// Create package meta-data objects
		theMlsdmPackage.createPackageContents();

		// Initialize created meta-data
		theMlsdmPackage.initializePackageContents();

		// Register package validator
		EValidator.Registry.INSTANCE.put(theMlsdmPackage, new EValidator.Descriptor() {
			@Override
			public EValidator getEValidator() {
				return MlsdmValidator.INSTANCE;
			}
		});

		// Mark meta-data to indicate it can't be changed
		theMlsdmPackage.freeze();

		// Update the registry and return the package
		EPackage.Registry.INSTANCE.put(MlsdmPackage.eNS_URI, theMlsdmPackage);
		return theMlsdmPackage;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getActivityNodeContainer() {
		return activityNodeContainerEClass;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getActivityNodeContainer_Edges() {
		return (EReference) activityNodeContainerEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getActivityNodeContainer_Nodes() {
		return (EReference) activityNodeContainerEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getActivityNodeContainer_Semaphores() {
		return (EReference) activityNodeContainerEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getActivityNodeContainer_SynchronizationEdges() {
		return (EReference) activityNodeContainerEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getActivity() {
		return activityEClass;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getActivity_Parameters() {
		return (EReference) activityEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getActivity__ParameterDistinctNames__DiagnosticChain_Map() {
		return activityEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getActivity__AtLeastOneFinalNode__DiagnosticChain_Map() {
		return activityEClass.getEOperations().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getActivity__ActivityName__DiagnosticChain_Map() {
		return activityEClass.getEOperations().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getActivity__OneInitialNode__DiagnosticChain_Map() {
		return activityEClass.getEOperations().get(3);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getActivityNode() {
		return activityNodeEClass;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getActivityNode_OutgoingEdges() {
		return (EReference) activityNodeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getActivityNode_IncomingEdges() {
		return (EReference) activityNodeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getActivityNode_ActivityNodeContainer() {
		return (EReference) activityNodeEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getActivityEdge() {
		return activityEdgeEClass;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getActivityEdge_Source() {
		return (EReference) activityEdgeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getActivityEdge_Target() {
		return (EReference) activityEdgeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getActivityEdge_ActivityNodeContainer() {
		return (EReference) activityEdgeEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getActivityEdge_GuardType() {
		return (EAttribute) activityEdgeEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getActivityEdge_GuardExpression() {
		return (EReference) activityEdgeEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getActivityEdge_AcquireEdges() {
		return (EReference) activityEdgeEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getActivityEdge_ReleaseEdges() {
		return (EReference) activityEdgeEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getActivityEdge_AssertionExpressions() {
		return (EReference) activityEdgeEClass.getEStructuralFeatures().get(7);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getActivityEdge__ActivityEdgeBooleanGuard__DiagnosticChain_Map() {
		return activityEdgeEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getActivityEdge__ActivityEdgeSuccessGuard__DiagnosticChain_Map() {
		return activityEdgeEClass.getEOperations().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getActivityEdge__ActivityEdgeGuardType__DiagnosticChain_Map() {
		return activityEdgeEClass.getEOperations().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getActivityEdge__ActivityEdgeForEachGuard__DiagnosticChain_Map() {
		return activityEdgeEClass.getEOperations().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getActivityEdge__ActivityEdgeSource__DiagnosticChain_Map() {
		return activityEdgeEClass.getEOperations().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getActivityEdge__ActivityEdgeElseGuard__DiagnosticChain_Map() {
		return activityEdgeEClass.getEOperations().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getActivityEdge__ActivityEdgeTarget__DiagnosticChain_Map() {
		return activityEdgeEClass.getEOperations().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getActivityEdge__ActivityEdgeFailureGuard__DiagnosticChain_Map() {
		return activityEdgeEClass.getEOperations().get(7);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getActivityEdge__ActivityEdgeGuardExpression__DiagnosticChain_Map() {
		return activityEdgeEClass.getEOperations().get(8);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getActivityEdge__ActivityEdgeNoGuardExpression__DiagnosticChain_Map() {
		return activityEdgeEClass.getEOperations().get(9);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getActivityEdge__ActivityEdgeEndGuard__DiagnosticChain_Map() {
		return activityEdgeEClass.getEOperations().get(10);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getInitialNode() {
		return initialNodeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getInitialNode__InitialNodeIncomingEdge__DiagnosticChain_Map() {
		return initialNodeEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getInitialNode__InitialNodeOutgoingEdge__DiagnosticChain_Map() {
		return initialNodeEClass.getEOperations().get(1);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getFlowFinalNode() {
		return flowFinalNodeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getFlowFinalNode__FlowFinalNodeIncomingEdge__DiagnosticChain_Map() {
		return flowFinalNodeEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getFlowFinalNode__FlowFinalNodeOutgoingEdge__DiagnosticChain_Map() {
		return flowFinalNodeEClass.getEOperations().get(1);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getActivityFinalNode() {
		return activityFinalNodeEClass;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getActivityFinalNode_OutputParameterValues() {
		return (EReference) activityFinalNodeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getActivityFinalNode_Activity() {
		return (EReference) activityFinalNodeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getActivityFinalNode__IncomingEdge__DiagnosticChain_Map() {
		return activityFinalNodeEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getActivityFinalNode__NoOutputParameterValue__DiagnosticChain_Map() {
		return activityFinalNodeEClass.getEOperations().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getActivityFinalNode__OutgoingEdge__DiagnosticChain_Map() {
		return activityFinalNodeEClass.getEOperations().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getActivityFinalNode__OneOutputParameterValue__DiagnosticChain_Map() {
		return activityFinalNodeEClass.getEOperations().get(3);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getExpressionActivityNode() {
		return expressionActivityNodeEClass;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getExpressionActivityNode_Expressions() {
		return (EReference) expressionActivityNodeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getExpressionActivityNode__OneOutgoingEdge__DiagnosticChain_Map() {
		return expressionActivityNodeEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getExpressionActivityNode__OneIncomingEdge__DiagnosticChain_Map() {
		return expressionActivityNodeEClass.getEOperations().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getExpressionActivityNode__ExpressionSpecified__DiagnosticChain_Map() {
		return expressionActivityNodeEClass.getEOperations().get(2);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getDecisionMergeNode() {
		return decisionMergeNodeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getDecisionMergeNode__IncomingEdge__DiagnosticChain_Map() {
		return decisionMergeNodeEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getDecisionMergeNode__MultipleEdgeGuards__DiagnosticChain_Map() {
		return decisionMergeNodeEClass.getEOperations().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getDecisionMergeNode__SingleEdgeGuard__DiagnosticChain_Map() {
		return decisionMergeNodeEClass.getEOperations().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getDecisionMergeNode__OutgoingEdge__DiagnosticChain_Map() {
		return decisionMergeNodeEClass.getEOperations().get(3);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getForkJoinNode() {
		return forkJoinNodeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getForkJoinNode__IncomingEdge__DiagnosticChain_Map() {
		return forkJoinNodeEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getForkJoinNode__OutgoingEdge__DiagnosticChain_Map() {
		return forkJoinNodeEClass.getEOperations().get(1);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getStoryNode() {
		return storyNodeEClass;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getStoryNode_StoryPattern() {
		return (EReference) storyNodeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getStoryNode_Semantics() {
		return (EAttribute) storyNodeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getStoryNode__IncomingEdge__DiagnosticChain_Map() {
		return storyNodeEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getStoryNode__ForEachLoopBody__DiagnosticChain_Map() {
		return storyNodeEClass.getEOperations().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getStoryNode__StoryPatternSpecified__DiagnosticChain_Map() {
		return storyNodeEClass.getEOperations().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getStoryNode__SemanticsSpecified__DiagnosticChain_Map() {
		return storyNodeEClass.getEOperations().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getStoryNode__ForEachMatchOutgoingEdges__DiagnosticChain_Map() {
		return storyNodeEClass.getEOperations().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getStoryNode__SingleMatchOutgoingEdges__DiagnosticChain_Map() {
		return storyNodeEClass.getEOperations().get(5);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getStructuredNode() {
		return structuredNodeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getStructuredNode__InitialNodeContained__DiagnosticChain_Map() {
		return structuredNodeEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getStructuredNode__FinalNodeContained__DiagnosticChain_Map() {
		return structuredNodeEClass.getEOperations().get(1);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getSemaphore() {
		return semaphoreEClass;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getSemaphore_ActivityNodeContainer() {
		return (EReference) semaphoreEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getSemaphore_TokenCount() {
		return (EAttribute) semaphoreEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getSemaphore_AcquireEdges() {
		return (EReference) semaphoreEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getSemaphore_ReleaseEdges() {
		return (EReference) semaphoreEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getSemaphore__TokenCountNotNegative__DiagnosticChain_Map() {
		return semaphoreEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getSemaphore__ReleaseEdge__DiagnosticChain_Map() {
		return semaphoreEClass.getEOperations().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getSemaphore__AcquireEdge__DiagnosticChain_Map() {
		return semaphoreEClass.getEOperations().get(2);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getSynchronizationEdge() {
		return synchronizationEdgeEClass;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getSynchronizationEdge_ActivityNodeContainer() {
		return (EReference) synchronizationEdgeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getSynchronizationEdge_Weight() {
		return (EAttribute) synchronizationEdgeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getSynchronizationEdge__WeightPositive__DiagnosticChain_Map() {
		return synchronizationEdgeEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getAcquireEdge() {
		return acquireEdgeEClass;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getAcquireEdge_ActivityEdge() {
		return (EReference) acquireEdgeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getAcquireEdge_Semaphore() {
		return (EReference) acquireEdgeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getAcquireEdge__ActivityEdgeSpecified__DiagnosticChain_Map() {
		return acquireEdgeEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getReleaseEdge() {
		return releaseEdgeEClass;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getReleaseEdge_ActivityEdge() {
		return (EReference) releaseEdgeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getReleaseEdge_Semaphore() {
		return (EReference) releaseEdgeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getReleaseEdge__ActivityEdgeSpecified__DiagnosticChain_Map() {
		return releaseEdgeEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getActivityParameter() {
		return activityParameterEClass;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getActivityParameter_Direction() {
		return (EAttribute) activityParameterEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getActivityParameter_Activity() {
		return (EReference) activityParameterEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getActivityParameter__DirectionSpecified__DiagnosticChain_Map() {
		return activityParameterEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getActivityParameter__TypeSpecified__DiagnosticChain_Map() {
		return activityParameterEClass.getEOperations().get(1);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getOutputParameterValue() {
		return outputParameterValueEClass;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getOutputParameterValue_Parameter() {
		return (EReference) outputParameterValueEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getOutputParameterValue_Expression() {
		return (EReference) outputParameterValueEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getOutputParameterValue_ActivityFinalNode() {
		return (EReference) outputParameterValueEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getOutputParameterValue__ExpressionSpecfied__DiagnosticChain_Map() {
		return outputParameterValueEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getOutputParameterValue__ParameterSpecfied__DiagnosticChain_Map() {
		return outputParameterValueEClass.getEOperations().get(1);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EEnum getActivityEdgeGuardEnum() {
		return activityEdgeGuardEnumEEnum;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EEnum getStoryNodeSemanticsEnum() {
		return storyNodeSemanticsEnumEEnum;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EEnum getActivityParameterDirectionEnum() {
		return activityParameterDirectionEnumEEnum;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public MlsdmFactory getMlsdmFactory() {
		return (MlsdmFactory) getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated)
			return;
		isCreated = true;

		// Create classes and their features
		activityNodeContainerEClass = createEClass(ACTIVITY_NODE_CONTAINER);
		createEReference(activityNodeContainerEClass, ACTIVITY_NODE_CONTAINER__EDGES);
		createEReference(activityNodeContainerEClass, ACTIVITY_NODE_CONTAINER__NODES);
		createEReference(activityNodeContainerEClass, ACTIVITY_NODE_CONTAINER__SEMAPHORES);
		createEReference(activityNodeContainerEClass, ACTIVITY_NODE_CONTAINER__SYNCHRONIZATION_EDGES);

		activityEClass = createEClass(ACTIVITY);
		createEReference(activityEClass, ACTIVITY__PARAMETERS);
		createEOperation(activityEClass, ACTIVITY___PARAMETER_DISTINCT_NAMES__DIAGNOSTICCHAIN_MAP);
		createEOperation(activityEClass, ACTIVITY___AT_LEAST_ONE_FINAL_NODE__DIAGNOSTICCHAIN_MAP);
		createEOperation(activityEClass, ACTIVITY___ACTIVITY_NAME__DIAGNOSTICCHAIN_MAP);
		createEOperation(activityEClass, ACTIVITY___ONE_INITIAL_NODE__DIAGNOSTICCHAIN_MAP);

		activityNodeEClass = createEClass(ACTIVITY_NODE);
		createEReference(activityNodeEClass, ACTIVITY_NODE__OUTGOING_EDGES);
		createEReference(activityNodeEClass, ACTIVITY_NODE__INCOMING_EDGES);
		createEReference(activityNodeEClass, ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER);

		activityEdgeEClass = createEClass(ACTIVITY_EDGE);
		createEReference(activityEdgeEClass, ACTIVITY_EDGE__SOURCE);
		createEReference(activityEdgeEClass, ACTIVITY_EDGE__TARGET);
		createEReference(activityEdgeEClass, ACTIVITY_EDGE__ACTIVITY_NODE_CONTAINER);
		createEAttribute(activityEdgeEClass, ACTIVITY_EDGE__GUARD_TYPE);
		createEReference(activityEdgeEClass, ACTIVITY_EDGE__GUARD_EXPRESSION);
		createEReference(activityEdgeEClass, ACTIVITY_EDGE__ACQUIRE_EDGES);
		createEReference(activityEdgeEClass, ACTIVITY_EDGE__RELEASE_EDGES);
		createEReference(activityEdgeEClass, ACTIVITY_EDGE__ASSERTION_EXPRESSIONS);
		createEOperation(activityEdgeEClass, ACTIVITY_EDGE___ACTIVITY_EDGE_BOOLEAN_GUARD__DIAGNOSTICCHAIN_MAP);
		createEOperation(activityEdgeEClass, ACTIVITY_EDGE___ACTIVITY_EDGE_SUCCESS_GUARD__DIAGNOSTICCHAIN_MAP);
		createEOperation(activityEdgeEClass, ACTIVITY_EDGE___ACTIVITY_EDGE_GUARD_TYPE__DIAGNOSTICCHAIN_MAP);
		createEOperation(activityEdgeEClass, ACTIVITY_EDGE___ACTIVITY_EDGE_FOR_EACH_GUARD__DIAGNOSTICCHAIN_MAP);
		createEOperation(activityEdgeEClass, ACTIVITY_EDGE___ACTIVITY_EDGE_SOURCE__DIAGNOSTICCHAIN_MAP);
		createEOperation(activityEdgeEClass, ACTIVITY_EDGE___ACTIVITY_EDGE_ELSE_GUARD__DIAGNOSTICCHAIN_MAP);
		createEOperation(activityEdgeEClass, ACTIVITY_EDGE___ACTIVITY_EDGE_TARGET__DIAGNOSTICCHAIN_MAP);
		createEOperation(activityEdgeEClass, ACTIVITY_EDGE___ACTIVITY_EDGE_FAILURE_GUARD__DIAGNOSTICCHAIN_MAP);
		createEOperation(activityEdgeEClass, ACTIVITY_EDGE___ACTIVITY_EDGE_GUARD_EXPRESSION__DIAGNOSTICCHAIN_MAP);
		createEOperation(activityEdgeEClass, ACTIVITY_EDGE___ACTIVITY_EDGE_NO_GUARD_EXPRESSION__DIAGNOSTICCHAIN_MAP);
		createEOperation(activityEdgeEClass, ACTIVITY_EDGE___ACTIVITY_EDGE_END_GUARD__DIAGNOSTICCHAIN_MAP);

		initialNodeEClass = createEClass(INITIAL_NODE);
		createEOperation(initialNodeEClass, INITIAL_NODE___INITIAL_NODE_INCOMING_EDGE__DIAGNOSTICCHAIN_MAP);
		createEOperation(initialNodeEClass, INITIAL_NODE___INITIAL_NODE_OUTGOING_EDGE__DIAGNOSTICCHAIN_MAP);

		flowFinalNodeEClass = createEClass(FLOW_FINAL_NODE);
		createEOperation(flowFinalNodeEClass, FLOW_FINAL_NODE___FLOW_FINAL_NODE_INCOMING_EDGE__DIAGNOSTICCHAIN_MAP);
		createEOperation(flowFinalNodeEClass, FLOW_FINAL_NODE___FLOW_FINAL_NODE_OUTGOING_EDGE__DIAGNOSTICCHAIN_MAP);

		activityFinalNodeEClass = createEClass(ACTIVITY_FINAL_NODE);
		createEReference(activityFinalNodeEClass, ACTIVITY_FINAL_NODE__OUTPUT_PARAMETER_VALUES);
		createEReference(activityFinalNodeEClass, ACTIVITY_FINAL_NODE__ACTIVITY);
		createEOperation(activityFinalNodeEClass, ACTIVITY_FINAL_NODE___INCOMING_EDGE__DIAGNOSTICCHAIN_MAP);
		createEOperation(activityFinalNodeEClass, ACTIVITY_FINAL_NODE___NO_OUTPUT_PARAMETER_VALUE__DIAGNOSTICCHAIN_MAP);
		createEOperation(activityFinalNodeEClass, ACTIVITY_FINAL_NODE___OUTGOING_EDGE__DIAGNOSTICCHAIN_MAP);
		createEOperation(activityFinalNodeEClass,
				ACTIVITY_FINAL_NODE___ONE_OUTPUT_PARAMETER_VALUE__DIAGNOSTICCHAIN_MAP);

		expressionActivityNodeEClass = createEClass(EXPRESSION_ACTIVITY_NODE);
		createEReference(expressionActivityNodeEClass, EXPRESSION_ACTIVITY_NODE__EXPRESSIONS);
		createEOperation(expressionActivityNodeEClass,
				EXPRESSION_ACTIVITY_NODE___ONE_OUTGOING_EDGE__DIAGNOSTICCHAIN_MAP);
		createEOperation(expressionActivityNodeEClass,
				EXPRESSION_ACTIVITY_NODE___ONE_INCOMING_EDGE__DIAGNOSTICCHAIN_MAP);
		createEOperation(expressionActivityNodeEClass,
				EXPRESSION_ACTIVITY_NODE___EXPRESSION_SPECIFIED__DIAGNOSTICCHAIN_MAP);

		decisionMergeNodeEClass = createEClass(DECISION_MERGE_NODE);
		createEOperation(decisionMergeNodeEClass, DECISION_MERGE_NODE___INCOMING_EDGE__DIAGNOSTICCHAIN_MAP);
		createEOperation(decisionMergeNodeEClass, DECISION_MERGE_NODE___MULTIPLE_EDGE_GUARDS__DIAGNOSTICCHAIN_MAP);
		createEOperation(decisionMergeNodeEClass, DECISION_MERGE_NODE___SINGLE_EDGE_GUARD__DIAGNOSTICCHAIN_MAP);
		createEOperation(decisionMergeNodeEClass, DECISION_MERGE_NODE___OUTGOING_EDGE__DIAGNOSTICCHAIN_MAP);

		forkJoinNodeEClass = createEClass(FORK_JOIN_NODE);
		createEOperation(forkJoinNodeEClass, FORK_JOIN_NODE___INCOMING_EDGE__DIAGNOSTICCHAIN_MAP);
		createEOperation(forkJoinNodeEClass, FORK_JOIN_NODE___OUTGOING_EDGE__DIAGNOSTICCHAIN_MAP);

		storyNodeEClass = createEClass(STORY_NODE);
		createEReference(storyNodeEClass, STORY_NODE__STORY_PATTERN);
		createEAttribute(storyNodeEClass, STORY_NODE__SEMANTICS);
		createEOperation(storyNodeEClass, STORY_NODE___INCOMING_EDGE__DIAGNOSTICCHAIN_MAP);
		createEOperation(storyNodeEClass, STORY_NODE___FOR_EACH_LOOP_BODY__DIAGNOSTICCHAIN_MAP);
		createEOperation(storyNodeEClass, STORY_NODE___STORY_PATTERN_SPECIFIED__DIAGNOSTICCHAIN_MAP);
		createEOperation(storyNodeEClass, STORY_NODE___SEMANTICS_SPECIFIED__DIAGNOSTICCHAIN_MAP);
		createEOperation(storyNodeEClass, STORY_NODE___FOR_EACH_MATCH_OUTGOING_EDGES__DIAGNOSTICCHAIN_MAP);
		createEOperation(storyNodeEClass, STORY_NODE___SINGLE_MATCH_OUTGOING_EDGES__DIAGNOSTICCHAIN_MAP);

		structuredNodeEClass = createEClass(STRUCTURED_NODE);
		createEOperation(structuredNodeEClass, STRUCTURED_NODE___INITIAL_NODE_CONTAINED__DIAGNOSTICCHAIN_MAP);
		createEOperation(structuredNodeEClass, STRUCTURED_NODE___FINAL_NODE_CONTAINED__DIAGNOSTICCHAIN_MAP);

		semaphoreEClass = createEClass(SEMAPHORE);
		createEReference(semaphoreEClass, SEMAPHORE__ACTIVITY_NODE_CONTAINER);
		createEAttribute(semaphoreEClass, SEMAPHORE__TOKEN_COUNT);
		createEReference(semaphoreEClass, SEMAPHORE__ACQUIRE_EDGES);
		createEReference(semaphoreEClass, SEMAPHORE__RELEASE_EDGES);
		createEOperation(semaphoreEClass, SEMAPHORE___TOKEN_COUNT_NOT_NEGATIVE__DIAGNOSTICCHAIN_MAP);
		createEOperation(semaphoreEClass, SEMAPHORE___RELEASE_EDGE__DIAGNOSTICCHAIN_MAP);
		createEOperation(semaphoreEClass, SEMAPHORE___ACQUIRE_EDGE__DIAGNOSTICCHAIN_MAP);

		synchronizationEdgeEClass = createEClass(SYNCHRONIZATION_EDGE);
		createEReference(synchronizationEdgeEClass, SYNCHRONIZATION_EDGE__ACTIVITY_NODE_CONTAINER);
		createEAttribute(synchronizationEdgeEClass, SYNCHRONIZATION_EDGE__WEIGHT);
		createEOperation(synchronizationEdgeEClass, SYNCHRONIZATION_EDGE___WEIGHT_POSITIVE__DIAGNOSTICCHAIN_MAP);

		acquireEdgeEClass = createEClass(ACQUIRE_EDGE);
		createEReference(acquireEdgeEClass, ACQUIRE_EDGE__ACTIVITY_EDGE);
		createEReference(acquireEdgeEClass, ACQUIRE_EDGE__SEMAPHORE);
		createEOperation(acquireEdgeEClass, ACQUIRE_EDGE___ACTIVITY_EDGE_SPECIFIED__DIAGNOSTICCHAIN_MAP);

		releaseEdgeEClass = createEClass(RELEASE_EDGE);
		createEReference(releaseEdgeEClass, RELEASE_EDGE__ACTIVITY_EDGE);
		createEReference(releaseEdgeEClass, RELEASE_EDGE__SEMAPHORE);
		createEOperation(releaseEdgeEClass, RELEASE_EDGE___ACTIVITY_EDGE_SPECIFIED__DIAGNOSTICCHAIN_MAP);

		activityParameterEClass = createEClass(ACTIVITY_PARAMETER);
		createEAttribute(activityParameterEClass, ACTIVITY_PARAMETER__DIRECTION);
		createEReference(activityParameterEClass, ACTIVITY_PARAMETER__ACTIVITY);
		createEOperation(activityParameterEClass, ACTIVITY_PARAMETER___DIRECTION_SPECIFIED__DIAGNOSTICCHAIN_MAP);
		createEOperation(activityParameterEClass, ACTIVITY_PARAMETER___TYPE_SPECIFIED__DIAGNOSTICCHAIN_MAP);

		outputParameterValueEClass = createEClass(OUTPUT_PARAMETER_VALUE);
		createEReference(outputParameterValueEClass, OUTPUT_PARAMETER_VALUE__PARAMETER);
		createEReference(outputParameterValueEClass, OUTPUT_PARAMETER_VALUE__EXPRESSION);
		createEReference(outputParameterValueEClass, OUTPUT_PARAMETER_VALUE__ACTIVITY_FINAL_NODE);
		createEOperation(outputParameterValueEClass, OUTPUT_PARAMETER_VALUE___EXPRESSION_SPECFIED__DIAGNOSTICCHAIN_MAP);
		createEOperation(outputParameterValueEClass, OUTPUT_PARAMETER_VALUE___PARAMETER_SPECFIED__DIAGNOSTICCHAIN_MAP);

		// Create enums
		activityEdgeGuardEnumEEnum = createEEnum(ACTIVITY_EDGE_GUARD_ENUM);
		storyNodeSemanticsEnumEEnum = createEEnum(STORY_NODE_SEMANTICS_ENUM);
		activityParameterDirectionEnumEEnum = createEEnum(ACTIVITY_PARAMETER_DIRECTION_ENUM);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model. This
	 * method is guarded to have no affect on any invocation but its first. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized)
			return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Obtain other dependent packages
		MlcorePackage theMlcorePackage = (MlcorePackage) EPackage.Registry.INSTANCE.getEPackage(MlcorePackage.eNS_URI);
		MlexpressionsPackage theMlexpressionsPackage = (MlexpressionsPackage) EPackage.Registry.INSTANCE
				.getEPackage(MlexpressionsPackage.eNS_URI);
		MlstorypatternsPackage theMlstorypatternsPackage = (MlstorypatternsPackage) EPackage.Registry.INSTANCE
				.getEPackage(MlstorypatternsPackage.eNS_URI);

		// Create type parameters

		// Set bounds for type parameters

		// Add supertypes to classes
		activityEClass.getESuperTypes().add(theMlcorePackage.getMLElementWithUUID());
		activityEClass.getESuperTypes().add(theMlcorePackage.getMLAnnotatedElement());
		activityEClass.getESuperTypes().add(theMlcorePackage.getMLNamedElement());
		activityEClass.getESuperTypes().add(this.getActivityNodeContainer());
		activityNodeEClass.getESuperTypes().add(theMlcorePackage.getMLElementWithUUID());
		activityNodeEClass.getESuperTypes().add(theMlcorePackage.getMLAnnotatedElement());
		activityEdgeEClass.getESuperTypes().add(theMlcorePackage.getMLElementWithUUID());
		activityEdgeEClass.getESuperTypes().add(theMlcorePackage.getMLAnnotatedElement());
		initialNodeEClass.getESuperTypes().add(this.getActivityNode());
		flowFinalNodeEClass.getESuperTypes().add(this.getActivityNode());
		activityFinalNodeEClass.getESuperTypes().add(this.getActivityNode());
		expressionActivityNodeEClass.getESuperTypes().add(this.getActivityNode());
		expressionActivityNodeEClass.getESuperTypes().add(theMlcorePackage.getMLNamedElement());
		decisionMergeNodeEClass.getESuperTypes().add(this.getActivityNode());
		forkJoinNodeEClass.getESuperTypes().add(this.getActivityNode());
		storyNodeEClass.getESuperTypes().add(this.getActivityNode());
		storyNodeEClass.getESuperTypes().add(theMlcorePackage.getMLNamedElement());
		structuredNodeEClass.getESuperTypes().add(this.getActivityNode());
		structuredNodeEClass.getESuperTypes().add(this.getActivityNodeContainer());
		semaphoreEClass.getESuperTypes().add(theMlcorePackage.getMLElementWithUUID());
		semaphoreEClass.getESuperTypes().add(theMlcorePackage.getMLAnnotatedElement());
		semaphoreEClass.getESuperTypes().add(theMlcorePackage.getMLNamedElement());
		synchronizationEdgeEClass.getESuperTypes().add(theMlcorePackage.getMLElementWithUUID());
		synchronizationEdgeEClass.getESuperTypes().add(theMlcorePackage.getMLAnnotatedElement());
		acquireEdgeEClass.getESuperTypes().add(this.getSynchronizationEdge());
		releaseEdgeEClass.getESuperTypes().add(this.getSynchronizationEdge());
		activityParameterEClass.getESuperTypes().add(theMlcorePackage.getMLElementWithUUID());
		activityParameterEClass.getESuperTypes().add(theMlcorePackage.getMLAnnotatedElement());
		activityParameterEClass.getESuperTypes().add(theMlcorePackage.getMLNamedElement());
		activityParameterEClass.getESuperTypes().add(theMlcorePackage.getMLTypedElement());
		outputParameterValueEClass.getESuperTypes().add(theMlcorePackage.getMLElementWithUUID());
		outputParameterValueEClass.getESuperTypes().add(theMlcorePackage.getMLAnnotatedElement());

		// Initialize classes, features, and operations; add parameters
		initEClass(activityNodeContainerEClass, ActivityNodeContainer.class, "ActivityNodeContainer", IS_ABSTRACT,
				!IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getActivityNodeContainer_Edges(), this.getActivityEdge(),
				this.getActivityEdge_ActivityNodeContainer(), "edges", null, 0, -1, ActivityNodeContainer.class,
				!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
				IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getActivityNodeContainer_Nodes(), this.getActivityNode(),
				this.getActivityNode_ActivityNodeContainer(), "nodes", null, 1, -1, ActivityNodeContainer.class,
				!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
				IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getActivityNodeContainer_Semaphores(), this.getSemaphore(),
				this.getSemaphore_ActivityNodeContainer(), "semaphores", null, 0, -1, ActivityNodeContainer.class,
				!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
				IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getActivityNodeContainer_SynchronizationEdges(), this.getSynchronizationEdge(),
				this.getSynchronizationEdge_ActivityNodeContainer(), "synchronizationEdges", null, 0, -1,
				ActivityNodeContainer.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
				!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(activityEClass, Activity.class, "Activity", !IS_ABSTRACT, !IS_INTERFACE,
				IS_GENERATED_INSTANCE_CLASS);
		initEReference(getActivity_Parameters(), this.getActivityParameter(), this.getActivityParameter_Activity(),
				"parameters", null, 0, -1, Activity.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
				!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		EOperation op = initEOperation(getActivity__ParameterDistinctNames__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "ParameterDistinctNames", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		EGenericType g1 = createEGenericType(ecorePackage.getEMap());
		EGenericType g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getActivity__AtLeastOneFinalNode__DiagnosticChain_Map(), ecorePackage.getEBoolean(),
				"AtLeastOneFinalNode", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getActivity__ActivityName__DiagnosticChain_Map(), ecorePackage.getEBoolean(),
				"ActivityName", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getActivity__OneInitialNode__DiagnosticChain_Map(), ecorePackage.getEBoolean(),
				"OneInitialNode", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(activityNodeEClass, ActivityNode.class, "ActivityNode", IS_ABSTRACT, !IS_INTERFACE,
				IS_GENERATED_INSTANCE_CLASS);
		initEReference(getActivityNode_OutgoingEdges(), this.getActivityEdge(), this.getActivityEdge_Source(),
				"outgoingEdges", null, 0, -1, ActivityNode.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE,
				!IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getActivityNode_IncomingEdges(), this.getActivityEdge(), this.getActivityEdge_Target(),
				"incomingEdges", null, 0, -1, ActivityNode.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE,
				!IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getActivityNode_ActivityNodeContainer(), this.getActivityNodeContainer(),
				this.getActivityNodeContainer_Nodes(), "activityNodeContainer", null, 1, 1, ActivityNode.class,
				!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
				IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(activityEdgeEClass, ActivityEdge.class, "ActivityEdge", !IS_ABSTRACT, !IS_INTERFACE,
				IS_GENERATED_INSTANCE_CLASS);
		initEReference(getActivityEdge_Source(), this.getActivityNode(), this.getActivityNode_OutgoingEdges(), "source",
				null, 1, 1, ActivityEdge.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
				!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getActivityEdge_Target(), this.getActivityNode(), this.getActivityNode_IncomingEdges(), "target",
				null, 1, 1, ActivityEdge.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
				!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getActivityEdge_ActivityNodeContainer(), this.getActivityNodeContainer(),
				this.getActivityNodeContainer_Edges(), "activityNodeContainer", null, 1, 1, ActivityEdge.class,
				!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
				IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getActivityEdge_GuardType(), this.getActivityEdgeGuardEnum(), "guardType", null, 1, 1,
				ActivityEdge.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);
		initEReference(getActivityEdge_GuardExpression(), theMlexpressionsPackage.getMLExpression(), null,
				"guardExpression", null, 0, 1, ActivityEdge.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE,
				IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getActivityEdge_AcquireEdges(), this.getAcquireEdge(), this.getAcquireEdge_ActivityEdge(),
				"acquireEdges", null, 0, -1, ActivityEdge.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE,
				!IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getActivityEdge_ReleaseEdges(), this.getReleaseEdge(), this.getReleaseEdge_ActivityEdge(),
				"releaseEdges", null, 0, -1, ActivityEdge.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE,
				!IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getActivityEdge_AssertionExpressions(), theMlexpressionsPackage.getMLExpression(), null,
				"assertionExpressions", null, 0, -1, ActivityEdge.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE,
				IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		op = initEOperation(getActivityEdge__ActivityEdgeBooleanGuard__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "ActivityEdgeBooleanGuard", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getActivityEdge__ActivityEdgeSuccessGuard__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "ActivityEdgeSuccessGuard", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getActivityEdge__ActivityEdgeGuardType__DiagnosticChain_Map(), ecorePackage.getEBoolean(),
				"ActivityEdgeGuardType", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getActivityEdge__ActivityEdgeForEachGuard__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "ActivityEdgeForEachGuard", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getActivityEdge__ActivityEdgeSource__DiagnosticChain_Map(), ecorePackage.getEBoolean(),
				"ActivityEdgeSource", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getActivityEdge__ActivityEdgeElseGuard__DiagnosticChain_Map(), ecorePackage.getEBoolean(),
				"ActivityEdgeElseGuard", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getActivityEdge__ActivityEdgeTarget__DiagnosticChain_Map(), ecorePackage.getEBoolean(),
				"ActivityEdgeTarget", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getActivityEdge__ActivityEdgeFailureGuard__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "ActivityEdgeFailureGuard", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getActivityEdge__ActivityEdgeGuardExpression__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "ActivityEdgeGuardExpression", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getActivityEdge__ActivityEdgeNoGuardExpression__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "ActivityEdgeNoGuardExpression", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getActivityEdge__ActivityEdgeEndGuard__DiagnosticChain_Map(), ecorePackage.getEBoolean(),
				"ActivityEdgeEndGuard", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(initialNodeEClass, InitialNode.class, "InitialNode", !IS_ABSTRACT, !IS_INTERFACE,
				IS_GENERATED_INSTANCE_CLASS);

		op = initEOperation(getInitialNode__InitialNodeIncomingEdge__DiagnosticChain_Map(), ecorePackage.getEBoolean(),
				"InitialNodeIncomingEdge", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getInitialNode__InitialNodeOutgoingEdge__DiagnosticChain_Map(), ecorePackage.getEBoolean(),
				"InitialNodeOutgoingEdge", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(flowFinalNodeEClass, FlowFinalNode.class, "FlowFinalNode", !IS_ABSTRACT, !IS_INTERFACE,
				IS_GENERATED_INSTANCE_CLASS);

		op = initEOperation(getFlowFinalNode__FlowFinalNodeIncomingEdge__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "FlowFinalNodeIncomingEdge", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getFlowFinalNode__FlowFinalNodeOutgoingEdge__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "FlowFinalNodeOutgoingEdge", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(activityFinalNodeEClass, ActivityFinalNode.class, "ActivityFinalNode", !IS_ABSTRACT, !IS_INTERFACE,
				IS_GENERATED_INSTANCE_CLASS);
		initEReference(getActivityFinalNode_OutputParameterValues(), this.getOutputParameterValue(),
				this.getOutputParameterValue_ActivityFinalNode(), "outputParameterValues", null, 0, -1,
				ActivityFinalNode.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES,
				!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getActivityFinalNode_Activity(), this.getActivity(), null, "activity", null, 1, 1,
				ActivityFinalNode.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES,
				!IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);

		op = initEOperation(getActivityFinalNode__IncomingEdge__DiagnosticChain_Map(), ecorePackage.getEBoolean(),
				"IncomingEdge", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getActivityFinalNode__NoOutputParameterValue__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "NoOutputParameterValue", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getActivityFinalNode__OutgoingEdge__DiagnosticChain_Map(), ecorePackage.getEBoolean(),
				"OutgoingEdge", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getActivityFinalNode__OneOutputParameterValue__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "OneOutputParameterValue", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(expressionActivityNodeEClass, ExpressionActivityNode.class, "ExpressionActivityNode", !IS_ABSTRACT,
				!IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getExpressionActivityNode_Expressions(), theMlexpressionsPackage.getMLExpression(), null,
				"expressions", null, 1, -1, ExpressionActivityNode.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE,
				IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		op = initEOperation(getExpressionActivityNode__OneOutgoingEdge__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "OneOutgoingEdge", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getExpressionActivityNode__OneIncomingEdge__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "OneIncomingEdge", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getExpressionActivityNode__ExpressionSpecified__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "ExpressionSpecified", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(decisionMergeNodeEClass, DecisionMergeNode.class, "DecisionMergeNode", !IS_ABSTRACT, !IS_INTERFACE,
				IS_GENERATED_INSTANCE_CLASS);

		op = initEOperation(getDecisionMergeNode__IncomingEdge__DiagnosticChain_Map(), ecorePackage.getEBoolean(),
				"IncomingEdge", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getDecisionMergeNode__MultipleEdgeGuards__DiagnosticChain_Map(), ecorePackage.getEBoolean(),
				"MultipleEdgeGuards", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getDecisionMergeNode__SingleEdgeGuard__DiagnosticChain_Map(), ecorePackage.getEBoolean(),
				"SingleEdgeGuard", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getDecisionMergeNode__OutgoingEdge__DiagnosticChain_Map(), ecorePackage.getEBoolean(),
				"OutgoingEdge", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(forkJoinNodeEClass, ForkJoinNode.class, "ForkJoinNode", !IS_ABSTRACT, !IS_INTERFACE,
				IS_GENERATED_INSTANCE_CLASS);

		op = initEOperation(getForkJoinNode__IncomingEdge__DiagnosticChain_Map(), ecorePackage.getEBoolean(),
				"IncomingEdge", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getForkJoinNode__OutgoingEdge__DiagnosticChain_Map(), ecorePackage.getEBoolean(),
				"OutgoingEdge", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(storyNodeEClass, StoryNode.class, "StoryNode", !IS_ABSTRACT, !IS_INTERFACE,
				IS_GENERATED_INSTANCE_CLASS);
		initEReference(getStoryNode_StoryPattern(), theMlstorypatternsPackage.getStoryPattern(), null, "storyPattern",
				null, 1, 1, StoryNode.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
				!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getStoryNode_Semantics(), this.getStoryNodeSemanticsEnum(), "semantics", "SINGLE_MATCH", 1, 1,
				StoryNode.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);

		op = initEOperation(getStoryNode__IncomingEdge__DiagnosticChain_Map(), ecorePackage.getEBoolean(),
				"IncomingEdge", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getStoryNode__ForEachLoopBody__DiagnosticChain_Map(), ecorePackage.getEBoolean(),
				"ForEachLoopBody", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getStoryNode__StoryPatternSpecified__DiagnosticChain_Map(), ecorePackage.getEBoolean(),
				"StoryPatternSpecified", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getStoryNode__SemanticsSpecified__DiagnosticChain_Map(), ecorePackage.getEBoolean(),
				"SemanticsSpecified", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getStoryNode__ForEachMatchOutgoingEdges__DiagnosticChain_Map(), ecorePackage.getEBoolean(),
				"ForEachMatchOutgoingEdges", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getStoryNode__SingleMatchOutgoingEdges__DiagnosticChain_Map(), ecorePackage.getEBoolean(),
				"SingleMatchOutgoingEdges", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(structuredNodeEClass, StructuredNode.class, "StructuredNode", !IS_ABSTRACT, !IS_INTERFACE,
				IS_GENERATED_INSTANCE_CLASS);

		op = initEOperation(getStructuredNode__InitialNodeContained__DiagnosticChain_Map(), ecorePackage.getEBoolean(),
				"InitialNodeContained", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getStructuredNode__FinalNodeContained__DiagnosticChain_Map(), ecorePackage.getEBoolean(),
				"FinalNodeContained", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(semaphoreEClass, Semaphore.class, "Semaphore", !IS_ABSTRACT, !IS_INTERFACE,
				IS_GENERATED_INSTANCE_CLASS);
		initEReference(getSemaphore_ActivityNodeContainer(), this.getActivityNodeContainer(),
				this.getActivityNodeContainer_Semaphores(), "activityNodeContainer", null, 1, 1, Semaphore.class,
				!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
				IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getSemaphore_TokenCount(), ecorePackage.getEInt(), "tokenCount", "1", 1, 1, Semaphore.class,
				!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getSemaphore_AcquireEdges(), this.getAcquireEdge(), this.getAcquireEdge_Semaphore(),
				"acquireEdges", null, 1, -1, Semaphore.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
				!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getSemaphore_ReleaseEdges(), this.getReleaseEdge(), this.getReleaseEdge_Semaphore(),
				"releaseEdges", null, 1, -1, Semaphore.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
				!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		op = initEOperation(getSemaphore__TokenCountNotNegative__DiagnosticChain_Map(), ecorePackage.getEBoolean(),
				"TokenCountNotNegative", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getSemaphore__ReleaseEdge__DiagnosticChain_Map(), ecorePackage.getEBoolean(), "ReleaseEdge",
				0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getSemaphore__AcquireEdge__DiagnosticChain_Map(), ecorePackage.getEBoolean(), "AcquireEdge",
				0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(synchronizationEdgeEClass, SynchronizationEdge.class, "SynchronizationEdge", IS_ABSTRACT,
				!IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getSynchronizationEdge_ActivityNodeContainer(), this.getActivityNodeContainer(),
				this.getActivityNodeContainer_SynchronizationEdges(), "activityNodeContainer", null, 1, 1,
				SynchronizationEdge.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
				!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getSynchronizationEdge_Weight(), ecorePackage.getEInt(), "weight", "1", 1, 1,
				SynchronizationEdge.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID,
				IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		op = initEOperation(getSynchronizationEdge__WeightPositive__DiagnosticChain_Map(), ecorePackage.getEBoolean(),
				"WeightPositive", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(acquireEdgeEClass, AcquireEdge.class, "AcquireEdge", !IS_ABSTRACT, !IS_INTERFACE,
				IS_GENERATED_INSTANCE_CLASS);
		initEReference(getAcquireEdge_ActivityEdge(), this.getActivityEdge(), this.getActivityEdge_AcquireEdges(),
				"activityEdge", null, 1, 1, AcquireEdge.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE,
				!IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getAcquireEdge_Semaphore(), this.getSemaphore(), this.getSemaphore_AcquireEdges(), "semaphore",
				null, 1, 1, AcquireEdge.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
				!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		op = initEOperation(getAcquireEdge__ActivityEdgeSpecified__DiagnosticChain_Map(), ecorePackage.getEBoolean(),
				"ActivityEdgeSpecified", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(releaseEdgeEClass, ReleaseEdge.class, "ReleaseEdge", !IS_ABSTRACT, !IS_INTERFACE,
				IS_GENERATED_INSTANCE_CLASS);
		initEReference(getReleaseEdge_ActivityEdge(), this.getActivityEdge(), this.getActivityEdge_ReleaseEdges(),
				"activityEdge", null, 1, 1, ReleaseEdge.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE,
				!IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getReleaseEdge_Semaphore(), this.getSemaphore(), this.getSemaphore_ReleaseEdges(), "semaphore",
				null, 1, 1, ReleaseEdge.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
				!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		op = initEOperation(getReleaseEdge__ActivityEdgeSpecified__DiagnosticChain_Map(), ecorePackage.getEBoolean(),
				"ActivityEdgeSpecified", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(activityParameterEClass, ActivityParameter.class, "ActivityParameter", !IS_ABSTRACT, !IS_INTERFACE,
				IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getActivityParameter_Direction(), this.getActivityParameterDirectionEnum(), "direction", "IN", 1,
				1, ActivityParameter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID,
				IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getActivityParameter_Activity(), this.getActivity(), this.getActivity_Parameters(), "activity",
				null, 1, 1, ActivityParameter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
				!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		op = initEOperation(getActivityParameter__DirectionSpecified__DiagnosticChain_Map(), ecorePackage.getEBoolean(),
				"DirectionSpecified", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getActivityParameter__TypeSpecified__DiagnosticChain_Map(), ecorePackage.getEBoolean(),
				"TypeSpecified", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(outputParameterValueEClass, OutputParameterValue.class, "OutputParameterValue", !IS_ABSTRACT,
				!IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getOutputParameterValue_Parameter(), this.getActivityParameter(), null, "parameter", null, 1, 1,
				OutputParameterValue.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
				!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getOutputParameterValue_Expression(), theMlexpressionsPackage.getMLExpression(), null,
				"expression", null, 1, 1, OutputParameterValue.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE,
				IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getOutputParameterValue_ActivityFinalNode(), this.getActivityFinalNode(),
				this.getActivityFinalNode_OutputParameterValues(), "activityFinalNode", null, 1, 1,
				OutputParameterValue.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
				!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		op = initEOperation(getOutputParameterValue__ExpressionSpecfied__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "ExpressionSpecfied", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getOutputParameterValue__ParameterSpecfied__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "ParameterSpecfied", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		// Initialize enums and add enum literals
		initEEnum(activityEdgeGuardEnumEEnum, ActivityEdgeGuardEnum.class, "ActivityEdgeGuardEnum");
		addEEnumLiteral(activityEdgeGuardEnumEEnum, ActivityEdgeGuardEnum.NONE);
		addEEnumLiteral(activityEdgeGuardEnumEEnum, ActivityEdgeGuardEnum.FOR_EACH);
		addEEnumLiteral(activityEdgeGuardEnumEEnum, ActivityEdgeGuardEnum.END);
		addEEnumLiteral(activityEdgeGuardEnumEEnum, ActivityEdgeGuardEnum.SUCCESS);
		addEEnumLiteral(activityEdgeGuardEnumEEnum, ActivityEdgeGuardEnum.FAILURE);
		addEEnumLiteral(activityEdgeGuardEnumEEnum, ActivityEdgeGuardEnum.BOOLEAN);
		addEEnumLiteral(activityEdgeGuardEnumEEnum, ActivityEdgeGuardEnum.ELSE);

		initEEnum(storyNodeSemanticsEnumEEnum, StoryNodeSemanticsEnum.class, "StoryNodeSemanticsEnum");
		addEEnumLiteral(storyNodeSemanticsEnumEEnum, StoryNodeSemanticsEnum.SINGLE_MATCH);
		addEEnumLiteral(storyNodeSemanticsEnumEEnum, StoryNodeSemanticsEnum.FOR_EACH_FRESH_MATCH);
		addEEnumLiteral(storyNodeSemanticsEnumEEnum, StoryNodeSemanticsEnum.FOR_EACH_PRE_SELECT);

		initEEnum(activityParameterDirectionEnumEEnum, ActivityParameterDirectionEnum.class,
				"ActivityParameterDirectionEnum");
		addEEnumLiteral(activityParameterDirectionEnumEEnum, ActivityParameterDirectionEnum.IN);
		addEEnumLiteral(activityParameterDirectionEnumEEnum, ActivityParameterDirectionEnum.OUT);
		addEEnumLiteral(activityParameterDirectionEnumEEnum, ActivityParameterDirectionEnum.INOUT);

		// Create resource
		createResource(eNS_URI);

		// Create annotations
		// http://www.eclipse.org/emf/2002/Ecore
		createEcoreAnnotations();
		// http://www.eclipse.org/emf/2002/GenModel
		createGenModelAnnotations();
		// http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot
		createPivotAnnotations();
	}

	/**
	 * Initializes the annotations for <b>http://www.eclipse.org/emf/2002/Ecore</b>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void createEcoreAnnotations() {
		String source = "http://www.eclipse.org/emf/2002/Ecore";
		addAnnotation(this, source, new String[] {});
		addAnnotation(activityEClass, source, new String[] { "constraints", "OneInitialNode" });
		addAnnotation(activityEdgeEClass, source, new String[] { "constraints", "ActivityEdgeEndGuard" });
		addAnnotation(initialNodeEClass, source, new String[] { "constraints", "InitialNodeOutgoingEdge" });
		addAnnotation(flowFinalNodeEClass, source, new String[] { "constraints", "FlowFinalNodeOutgoingEdge" });
		addAnnotation(activityFinalNodeEClass, source, new String[] { "constraints", "OneOutputParameterValue" });
		addAnnotation(expressionActivityNodeEClass, source, new String[] { "constraints", "ExpressionSpecified" });
		addAnnotation(decisionMergeNodeEClass, source, new String[] { "constraints", "OutgoingEdge" });
		addAnnotation(forkJoinNodeEClass, source, new String[] { "constraints", "OutgoingEdge" });
		addAnnotation(storyNodeEClass, source, new String[] { "constraints", "SingleMatchOutgoingEdges" });
		addAnnotation(structuredNodeEClass, source, new String[] { "constraints", "FinalNodeContained" });
		addAnnotation(semaphoreEClass, source, new String[] { "constraints", "AcquireEdge" });
		addAnnotation(synchronizationEdgeEClass, source, new String[] { "constraints", "WeightPositive" });
		addAnnotation(acquireEdgeEClass, source, new String[] { "constraints", "ActivityEdgeSpecified" });
		addAnnotation(releaseEdgeEClass, source, new String[] { "constraints", "ActivityEdgeSpecified" });
		addAnnotation(activityParameterEClass, source, new String[] { "constraints", "TypeSpecified" });
		addAnnotation(outputParameterValueEClass, source, new String[] { "constraints", "ParameterSpecfied" });
	}

	/**
	 * Initializes the annotations for <b>http://www.eclipse.org/emf/2002/GenModel</b>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void createGenModelAnnotations() {
		String source = "http://www.eclipse.org/emf/2002/GenModel";
		addAnnotation(activityNodeContainerEClass, source,
				new String[] { "documentation", "Superclass of elements that contain activity nodes, edges, etc." });
		addAnnotation(getActivityNodeContainer_Edges(), source, new String[] { "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!ActivityNodeContainer!edges" });
		addAnnotation(getActivityNodeContainer_Nodes(), source, new String[] { "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!ActivityNodeContainer!nodes" });
		addAnnotation(getActivityNodeContainer_Semaphores(), source, new String[] { "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!ActivityNodeContainer!semaphores" });
		addAnnotation(getActivityNodeContainer_SynchronizationEdges(), source, new String[] { "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!ActivityNodeContainer!synchronizationEdges" });
		addAnnotation(activityEClass, source, new String[] { "documentation",
				"An Activity models behavior by a set of ActivityNodes that are connected by ActivityEdges. Semaphores can be added to model concurrently executed behavior. An Activity can have input and output parameters." });
		addAnnotation(getActivity__ParameterDistinctNames__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"Activity::ParameterDistinctNames\";\ntry {\n\t/**\n\t *\n\t * inv ParameterDistinctNames:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if\n\t *             self.parameters->forAll(e |\n\t *               self.parameters->select(e2 | e.name = e2.name)\n\t *               ->size() = 1)\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'Parameters of activity \' +\n\t *               self.toString() + \' must have distinct names.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.ACTIVITY___PARAMETER_DISTINCT_NAMES__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (le) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.util.List%><<%de.mdelab.mlsdm.ActivityParameter%>> parameters = this.getParameters();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.SetValue%> BOXED_parameters = idResolver.createSetOfAll(<%de.mdelab.mlsdm.MlsdmTables%>.SET_CLSSid_ActivityParameter, parameters);\n\t\t/*@Thrown*/ <%java.lang.Object%> accumulator = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t<%java.util.Iterator%><<%java.lang.Object%>> ITERATOR_e_0 = BOXED_parameters.iterator();\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> forAll;\n\t\twhile (true) {\n\t\t\tif (!ITERATOR_e_0.hasNext()) {\n\t\t\t\tif (accumulator == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE) {\n\t\t\t\t\tforAll = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t\t\t}\n\t\t\t\telse {\n\t\t\t\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)accumulator;\n\t\t\t\t}\n\t\t\t\tbreak;\n\t\t\t}\n\t\t\t/*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityParameter%> e_0 = (<%de.mdelab.mlsdm.ActivityParameter%>)ITERATOR_e_0.next();\n\t\t\t/**\n\t\t\t * self.parameters->select(e2 | e.name = e2.name)->size() = 1\n\t\t\t */\n\t\t\t/*@Thrown*/ <%org.eclipse.ocl.pivot.values.SetValue.Accumulator%> accumulator_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createSetAccumulatorValue(<%de.mdelab.mlsdm.MlsdmTables%>.SET_CLSSid_ActivityParameter);\n\t\t\t<%java.util.Iterator%><<%java.lang.Object%>> ITERATOR_e2 = BOXED_parameters.iterator();\n\t\t\t/*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.SetValue%> select;\n\t\t\twhile (true) {\n\t\t\t\tif (!ITERATOR_e2.hasNext()) {\n\t\t\t\t\tselect = accumulator_0;\n\t\t\t\t\tbreak;\n\t\t\t\t}\n\t\t\t\t/*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityParameter%> e2 = (<%de.mdelab.mlsdm.ActivityParameter%>)ITERATOR_e2.next();\n\t\t\t\t/**\n\t\t\t\t * e.name = e2.name\n\t\t\t\t */\n\t\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> name = e_0.getName();\n\t\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> name_0 = e2.getName();\n\t\t\t\tfinal /*@NonInvalid*/ boolean eq = (name != null) ? name.equals(name_0) : (name_0 == null);\n\t\t\t\t//\n\t\t\t\tif (eq == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE) {\n\t\t\t\t\taccumulator_0.add(e2);\n\t\t\t\t}\n\t\t\t}\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> size = <%org.eclipse.ocl.pivot.library.collection.CollectionSizeOperation%>.INSTANCE.evaluate(select);\n\t\t\tfinal /*@NonInvalid*/ boolean eq_0 = size.equals(<%de.mdelab.mlsdm.MlsdmTables%>.INT_1);\n\t\t\t//\n\t\t\tif (eq_0 == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE) {\t\t\t\t\t// Normal unsuccessful body evaluation result\n\t\t\t\tforAll = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t\t\tbreak;\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Stop immediately\n\t\t\t}\n\t\t\telse if (eq_0 == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE) {\t\t\t\t// Normal successful body evaluation result\n\t\t\t\t;\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Carry on\n\t\t\t}\n\t\t\telse {\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Impossible badly typed result\n\t\t\t\taccumulator = new <%org.eclipse.ocl.pivot.values.InvalidValueException%>(<%org.eclipse.ocl.pivot.messages.PivotMessages%>.NonBooleanBody, \"forAll\");\n\t\t\t}\n\t\t}\n\t\tif (forAll == null) {\n\t\t\tthrow new <%org.eclipse.ocl.pivot.values.InvalidValueException%>(\"Null if condition\");\n\t\t}\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\t\tif (forAll) {\n\t\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tstatus = null;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean eq_1 = status == Boolean.TRUE;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (eq_1) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlsdm.MlsdmTables%>.STR_Parameters_32_of_32_activity_32, toString);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlsdm.MlsdmTables%>.STR__32_must_32_have_32_distinct_32_names);\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlsdm.MlsdmTables%>.TUPLid_, sum_0, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, symbol_1, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getActivity__AtLeastOneFinalNode__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"Activity::AtLeastOneFinalNode\";\ntry {\n\t/**\n\t *\n\t * inv AtLeastOneFinalNode:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if\n\t *             self.nodes->exists(e |\n\t *               e.oclIsTypeOf(ActivityFinalNode))\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'Activity \' +\n\t *               self.toString() + \' must contain at least one activity final node.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.ACTIVITY___AT_LEAST_ONE_FINAL_NODE__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (le) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.util.List%><<%de.mdelab.mlsdm.ActivityNode%>> nodes = this.getNodes();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.SetValue%> BOXED_nodes = idResolver.createSetOfAll(<%de.mdelab.mlsdm.MlsdmTables%>.SET_CLSSid_ActivityNode, nodes);\n\t\t/*@Thrown*/ <%java.lang.Object%> accumulator = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t<%java.util.Iterator%><<%java.lang.Object%>> ITERATOR_e_0 = BOXED_nodes.iterator();\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> exists;\n\t\twhile (true) {\n\t\t\tif (!ITERATOR_e_0.hasNext()) {\n\t\t\t\tif (accumulator == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE) {\n\t\t\t\t\texists = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t\t\t}\n\t\t\t\telse {\n\t\t\t\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)accumulator;\n\t\t\t\t}\n\t\t\t\tbreak;\n\t\t\t}\n\t\t\t/*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityNode%> e_0 = (<%de.mdelab.mlsdm.ActivityNode%>)ITERATOR_e_0.next();\n\t\t\t/**\n\t\t\t * e.oclIsTypeOf(ActivityFinalNode)\n\t\t\t */\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.Class%> TYP_mlsdm_c_c_ActivityFinalNode = idResolver.getClass(<%de.mdelab.mlsdm.MlsdmTables%>.CLSSid_ActivityFinalNode, null);\n\t\t\tfinal /*@NonInvalid*/ boolean oclIsTypeOf = <%org.eclipse.ocl.pivot.library.oclany.OclAnyOclIsTypeOfOperation%>.INSTANCE.evaluate(executor, e_0, TYP_mlsdm_c_c_ActivityFinalNode).booleanValue();\n\t\t\t//\n\t\t\tif (oclIsTypeOf == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE) {\t\t\t\t\t// Normal successful body evaluation result\n\t\t\t\texists = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t\t\tbreak;\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Stop immediately\n\t\t\t}\n\t\t\telse if (oclIsTypeOf == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE) {\t\t\t\t// Normal unsuccessful body evaluation result\n\t\t\t\t;\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Carry on\n\t\t\t}\n\t\t\telse {\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Impossible badly typed result\n\t\t\t\taccumulator = new <%org.eclipse.ocl.pivot.values.InvalidValueException%>(<%org.eclipse.ocl.pivot.messages.PivotMessages%>.NonBooleanBody, \"exists\");\n\t\t\t}\n\t\t}\n\t\tif (exists == null) {\n\t\t\tthrow new <%org.eclipse.ocl.pivot.values.InvalidValueException%>(\"Null if condition\");\n\t\t}\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\t\tif (exists) {\n\t\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tstatus = null;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean eq = status == Boolean.TRUE;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (eq) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlsdm.MlsdmTables%>.STR_Activity_32, toString);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlsdm.MlsdmTables%>.STR__32_must_32_contain_32_at_32_least_32_one_32_activity_32_final_32_node);\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlsdm.MlsdmTables%>.TUPLid_, sum_0, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, symbol_1, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getActivity__ActivityName__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"Activity::ActivityName\";\ntry {\n\t/**\n\t *\n\t * inv ActivityName:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if self.name <> null and self.name <> \'\'\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else Tuple{message = \'Activity \' +\n\t *               self.toString() + \' must have a name.\', status = status}\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.ACTIVITY___ACTIVITY_NAME__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (le) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> name_0 = this.getName();\n\t\tfinal /*@NonInvalid*/ boolean ne = name_0 != null;\n\t\t/*@NonInvalid*/ boolean and;\n\t\tif (ne) {\n\t\t\tfinal /*@NonInvalid*/ boolean ne_0 = !<%de.mdelab.mlsdm.MlsdmTables%>.STR_.equals(name_0);\n\t\t\tand = ne_0;\n\t\t}\n\t\telse {\n\t\t\tand = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t}\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\t\tif (and) {\n\t\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tstatus = null;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean eq = status == Boolean.TRUE;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (eq) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlsdm.MlsdmTables%>.STR_Activity_32, toString);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlsdm.MlsdmTables%>.STR__32_must_32_have_32_a_32_name);\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlsdm.MlsdmTables%>.TUPLid_, sum_0, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, symbol_1, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getActivity__OneInitialNode__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"Activity::OneInitialNode\";\ntry {\n\t/**\n\t *\n\t * inv OneInitialNode:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if\n\t *             self.nodes->select(e | e.oclIsTypeOf(InitialNode))\n\t *             ->size() = 1\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'Activity \' +\n\t *               self.toString() + \'must contain exactly one initial node.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.ACTIVITY___ONE_INITIAL_NODE__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (le) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.util.List%><<%de.mdelab.mlsdm.ActivityNode%>> nodes = this.getNodes();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.SetValue%> BOXED_nodes = idResolver.createSetOfAll(<%de.mdelab.mlsdm.MlsdmTables%>.SET_CLSSid_ActivityNode, nodes);\n\t\t/*@Thrown*/ <%org.eclipse.ocl.pivot.values.SetValue.Accumulator%> accumulator = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createSetAccumulatorValue(<%de.mdelab.mlsdm.MlsdmTables%>.SET_CLSSid_ActivityNode);\n\t\t<%java.util.Iterator%><<%java.lang.Object%>> ITERATOR_e_0 = BOXED_nodes.iterator();\n\t\t/*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.SetValue%> select;\n\t\twhile (true) {\n\t\t\tif (!ITERATOR_e_0.hasNext()) {\n\t\t\t\tselect = accumulator;\n\t\t\t\tbreak;\n\t\t\t}\n\t\t\t/*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityNode%> e_0 = (<%de.mdelab.mlsdm.ActivityNode%>)ITERATOR_e_0.next();\n\t\t\t/**\n\t\t\t * e.oclIsTypeOf(InitialNode)\n\t\t\t */\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.Class%> TYP_mlsdm_c_c_InitialNode = idResolver.getClass(<%de.mdelab.mlsdm.MlsdmTables%>.CLSSid_InitialNode, null);\n\t\t\tfinal /*@NonInvalid*/ boolean oclIsTypeOf = <%org.eclipse.ocl.pivot.library.oclany.OclAnyOclIsTypeOfOperation%>.INSTANCE.evaluate(executor, e_0, TYP_mlsdm_c_c_InitialNode).booleanValue();\n\t\t\t//\n\t\t\tif (oclIsTypeOf == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE) {\n\t\t\t\taccumulator.add(e_0);\n\t\t\t}\n\t\t}\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> size = <%org.eclipse.ocl.pivot.library.collection.CollectionSizeOperation%>.INSTANCE.evaluate(select);\n\t\tfinal /*@NonInvalid*/ boolean eq = size.equals(<%de.mdelab.mlsdm.MlsdmTables%>.INT_1);\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\t\tif (eq) {\n\t\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tstatus = null;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean eq_0 = status == Boolean.TRUE;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (eq_0) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlsdm.MlsdmTables%>.STR_Activity_32, toString);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlsdm.MlsdmTables%>.STR_must_32_contain_32_exactly_32_one_32_initial_32_node);\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlsdm.MlsdmTables%>.TUPLid_, sum_0, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, symbol_1, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getActivity_Parameters(), source, new String[] { "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!Activity!parameters" });
		addAnnotation(activityNodeEClass, source,
				new String[] { "documentation", "Superclass of all nodes that can be contained in an Activity." });
		addAnnotation(getActivityNode_OutgoingEdges(), source, new String[] { "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!ActivityNode!outgoingEdges" });
		addAnnotation(getActivityNode_IncomingEdges(), source, new String[] { "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!ActivityNode!incomingEdges" });
		addAnnotation(getActivityNode_ActivityNodeContainer(), source, new String[] { "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!ActivityNode!activityNodeContainer" });
		addAnnotation(activityEdgeEClass, source, new String[] { "documentation",
				"Superclass of all edges that can be contained in an Activity. Edges can have a guard. However, depending on the source node only certain kinds of guards are valid. For the guard BOOLEAN, a guardExpression has to be provided." });
		addAnnotation(getActivityEdge__ActivityEdgeBooleanGuard__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"ActivityEdge::ActivityEdgeBooleanGuard\";\ntry {\n\t/**\n\t *\n\t * inv ActivityEdgeBooleanGuard:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if self.guardType = ActivityEdgeGuardEnum::BOOLEAN and\n\t *             self.source.oclIsKindOf(DecisionMergeNode) implies\n\t *             self.source.oclIsTypeOf(DecisionMergeNode)\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'The BOOLEAN guard of activity edge \' +\n\t *               self.toString() + \' is only valid for edges starting from a decision/merge node.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.ACTIVITY_EDGE___ACTIVITY_EDGE_BOOLEAN_GUARD__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (le) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityEdgeGuardEnum%> guardType = this.getGuardType();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_guardType = <%de.mdelab.mlsdm.MlsdmTables%>.ENUMid_ActivityEdgeGuardEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(guardType.getName()));\n\t\tfinal /*@NonInvalid*/ boolean eq = BOXED_guardType == <%de.mdelab.mlsdm.MlsdmTables%>.ELITid_BOOLEAN;\n\t\t/*@NonInvalid*/ boolean and;\n\t\tif (eq) {\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.Class%> TYP_mlsdm_c_c_DecisionMergeNode = idResolver.getClass(<%de.mdelab.mlsdm.MlsdmTables%>.CLSSid_DecisionMergeNode, null);\n\t\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityNode%> source = this.getSource();\n\t\t\tfinal /*@NonInvalid*/ boolean oclIsKindOf = <%org.eclipse.ocl.pivot.library.oclany.OclAnyOclIsKindOfOperation%>.INSTANCE.evaluate(executor, source, TYP_mlsdm_c_c_DecisionMergeNode).booleanValue();\n\t\t\tand = oclIsKindOf;\n\t\t}\n\t\telse {\n\t\t\tand = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t}\n\t\t/*@NonInvalid*/ boolean implies;\n\t\tif (and) {\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.Class%> TYP_mlsdm_c_c_DecisionMergeNode_0 = idResolver.getClass(<%de.mdelab.mlsdm.MlsdmTables%>.CLSSid_DecisionMergeNode, null);\n\t\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityNode%> source_0 = this.getSource();\n\t\t\tfinal /*@NonInvalid*/ boolean oclIsTypeOf = <%org.eclipse.ocl.pivot.library.oclany.OclAnyOclIsTypeOfOperation%>.INSTANCE.evaluate(executor, source_0, TYP_mlsdm_c_c_DecisionMergeNode_0).booleanValue();\n\t\t\timplies = oclIsTypeOf;\n\t\t}\n\t\telse {\n\t\t\timplies = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\t\tif (implies) {\n\t\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tstatus = null;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean eq_0 = status == Boolean.TRUE;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (eq_0) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlsdm.MlsdmTables%>.STR_The_32_BOOLEAN_32_guard_32_of_32_activity_32_edge_32, toString);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlsdm.MlsdmTables%>.STR__32_is_32_only_32_valid_32_for_32_edges_32_starting_32_from_32_a_32_decision_s_merge_32_node);\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlsdm.MlsdmTables%>.TUPLid_, sum_0, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, symbol_1, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getActivityEdge__ActivityEdgeSuccessGuard__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"ActivityEdge::ActivityEdgeSuccessGuard\";\ntry {\n\t/**\n\t *\n\t * inv ActivityEdgeSuccessGuard:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if self.guardType = ActivityEdgeGuardEnum::SUCCESS and\n\t *             self.source.oclIsKindOf(StoryNode) implies\n\t *             self.source.oclAsType(StoryNode).semantics = StoryNodeSemanticsEnum::SINGLE_MATCH\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'The SUCCESS guard of activity edge \' +\n\t *               self.toString() + \' is only valid for edges starting from a story node with SINGLE_MATCH semantics.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.ACTIVITY_EDGE___ACTIVITY_EDGE_SUCCESS_GUARD__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (le) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityEdgeGuardEnum%> guardType = this.getGuardType();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_guardType = <%de.mdelab.mlsdm.MlsdmTables%>.ENUMid_ActivityEdgeGuardEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(guardType.getName()));\n\t\tfinal /*@NonInvalid*/ boolean eq = BOXED_guardType == <%de.mdelab.mlsdm.MlsdmTables%>.ELITid_SUCCESS;\n\t\t/*@NonInvalid*/ boolean and;\n\t\tif (eq) {\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.Class%> TYP_mlsdm_c_c_StoryNode_0 = idResolver.getClass(<%de.mdelab.mlsdm.MlsdmTables%>.CLSSid_StoryNode, null);\n\t\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityNode%> source = this.getSource();\n\t\t\tfinal /*@NonInvalid*/ boolean oclIsKindOf = <%org.eclipse.ocl.pivot.library.oclany.OclAnyOclIsKindOfOperation%>.INSTANCE.evaluate(executor, source, TYP_mlsdm_c_c_StoryNode_0).booleanValue();\n\t\t\tand = oclIsKindOf;\n\t\t}\n\t\telse {\n\t\t\tand = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t}\n\t\t/*@Thrown*/ boolean implies;\n\t\tif (and) {\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.Class%> TYP_mlsdm_c_c_StoryNode_1 = idResolver.getClass(<%de.mdelab.mlsdm.MlsdmTables%>.CLSSid_StoryNode, null);\n\t\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityNode%> source_0 = this.getSource();\n\t\t\tfinal /*@Thrown*/ <%de.mdelab.mlsdm.StoryNode%> oclAsType = (<%de.mdelab.mlsdm.StoryNode%>)<%org.eclipse.ocl.pivot.library.oclany.OclAnyOclAsTypeOperation%>.INSTANCE.evaluate(executor, source_0, TYP_mlsdm_c_c_StoryNode_1);\n\t\t\tfinal /*@Thrown*/ <%de.mdelab.mlsdm.StoryNodeSemanticsEnum%> semantics = oclAsType.getSemantics();\n\t\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_semantics = <%de.mdelab.mlsdm.MlsdmTables%>.ENUMid_StoryNodeSemanticsEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(semantics.getName()));\n\t\t\tfinal /*@Thrown*/ boolean eq_0 = BOXED_semantics == <%de.mdelab.mlsdm.MlsdmTables%>.ELITid_SINGLE_MATCH;\n\t\t\timplies = eq_0;\n\t\t}\n\t\telse {\n\t\t\timplies = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\t\tif (implies) {\n\t\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tstatus = null;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean eq_1 = status == Boolean.TRUE;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (eq_1) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlsdm.MlsdmTables%>.STR_The_32_SUCCESS_32_guard_32_of_32_activity_32_edge_32, toString);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlsdm.MlsdmTables%>.STR__32_is_32_only_32_valid_32_for_32_edges_32_starting_32_from_32_a_32_story_32_node_32_with_32_SINGLE_);\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlsdm.MlsdmTables%>.TUPLid_, sum_0, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, symbol_1, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getActivityEdge__ActivityEdgeGuardType__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"ActivityEdge::ActivityEdgeGuardType\";\ntry {\n\t/**\n\t *\n\t * inv ActivityEdgeGuardType:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if self.guardType <> null\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'Guard type of activity edge \' +\n\t *               self.toString() + \' must be specified.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.ACTIVITY_EDGE___ACTIVITY_EDGE_GUARD_TYPE__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_0;\n\tif (le) {\n\t\tsymbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_0 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_0;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getActivityEdge__ActivityEdgeForEachGuard__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"ActivityEdge::ActivityEdgeForEachGuard\";\ntry {\n\t/**\n\t *\n\t * inv ActivityEdgeForEachGuard:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if self.guardType = ActivityEdgeGuardEnum::FOR_EACH and\n\t *             self.source.oclIsKindOf(StoryNode) implies\n\t *             self.source.oclAsType(StoryNode).semantics = StoryNodeSemanticsEnum::FOR_EACH_FRESH_MATCH\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'The FOR_EACH guard of activity edge \' +\n\t *               self.toString() + \' is only valid for edges starting from a story node with FOR_EACH semantics.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.ACTIVITY_EDGE___ACTIVITY_EDGE_FOR_EACH_GUARD__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (le) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityEdgeGuardEnum%> guardType = this.getGuardType();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_guardType = <%de.mdelab.mlsdm.MlsdmTables%>.ENUMid_ActivityEdgeGuardEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(guardType.getName()));\n\t\tfinal /*@NonInvalid*/ boolean eq = BOXED_guardType == <%de.mdelab.mlsdm.MlsdmTables%>.ELITid_FOR_EACH;\n\t\t/*@NonInvalid*/ boolean and;\n\t\tif (eq) {\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.Class%> TYP_mlsdm_c_c_StoryNode = idResolver.getClass(<%de.mdelab.mlsdm.MlsdmTables%>.CLSSid_StoryNode, null);\n\t\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityNode%> source = this.getSource();\n\t\t\tfinal /*@NonInvalid*/ boolean oclIsKindOf = <%org.eclipse.ocl.pivot.library.oclany.OclAnyOclIsKindOfOperation%>.INSTANCE.evaluate(executor, source, TYP_mlsdm_c_c_StoryNode).booleanValue();\n\t\t\tand = oclIsKindOf;\n\t\t}\n\t\telse {\n\t\t\tand = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t}\n\t\t/*@Thrown*/ boolean implies;\n\t\tif (and) {\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.Class%> TYP_mlsdm_c_c_StoryNode_0 = idResolver.getClass(<%de.mdelab.mlsdm.MlsdmTables%>.CLSSid_StoryNode, null);\n\t\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityNode%> source_0 = this.getSource();\n\t\t\tfinal /*@Thrown*/ <%de.mdelab.mlsdm.StoryNode%> oclAsType = (<%de.mdelab.mlsdm.StoryNode%>)<%org.eclipse.ocl.pivot.library.oclany.OclAnyOclAsTypeOperation%>.INSTANCE.evaluate(executor, source_0, TYP_mlsdm_c_c_StoryNode_0);\n\t\t\tfinal /*@Thrown*/ <%de.mdelab.mlsdm.StoryNodeSemanticsEnum%> semantics = oclAsType.getSemantics();\n\t\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_semantics = <%de.mdelab.mlsdm.MlsdmTables%>.ENUMid_StoryNodeSemanticsEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(semantics.getName()));\n\t\t\tfinal /*@Thrown*/ boolean eq_0 = BOXED_semantics == <%de.mdelab.mlsdm.MlsdmTables%>.ELITid_FOR_EACH_FRESH_MATCH;\n\t\t\timplies = eq_0;\n\t\t}\n\t\telse {\n\t\t\timplies = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\t\tif (implies) {\n\t\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tstatus = null;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean eq_1 = status == Boolean.TRUE;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (eq_1) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlsdm.MlsdmTables%>.STR_The_32_FOR_EACH_32_guard_32_of_32_activity_32_edge_32, toString);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlsdm.MlsdmTables%>.STR__32_is_32_only_32_valid_32_for_32_edges_32_starting_32_from_32_a_32_story_32_node_32_with_32_FOR_EAC);\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlsdm.MlsdmTables%>.TUPLid_, sum_0, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, symbol_1, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getActivityEdge__ActivityEdgeSource__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"ActivityEdge::ActivityEdgeSource\";\ntry {\n\t/**\n\t *\n\t * inv ActivityEdgeSource:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if self.source <> null\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'Source of activity edge \' +\n\t *               self.toString() + \' must be specified.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.ACTIVITY_EDGE___ACTIVITY_EDGE_SOURCE__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_0;\n\tif (le) {\n\t\tsymbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_0 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_0;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getActivityEdge__ActivityEdgeElseGuard__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"ActivityEdge::ActivityEdgeElseGuard\";\ntry {\n\t/**\n\t *\n\t * inv ActivityEdgeElseGuard:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if self.guardType = ActivityEdgeGuardEnum::ELSE implies\n\t *             self.source.oclIsTypeOf(DecisionMergeNode)\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'The ELSE guard of activity edge \' +\n\t *               self.toString() + \' is only valid for edges starting from a decision/merge node.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.ACTIVITY_EDGE___ACTIVITY_EDGE_ELSE_GUARD__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (le) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityEdgeGuardEnum%> guardType = this.getGuardType();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_guardType = <%de.mdelab.mlsdm.MlsdmTables%>.ENUMid_ActivityEdgeGuardEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(guardType.getName()));\n\t\tfinal /*@NonInvalid*/ boolean eq = BOXED_guardType == <%de.mdelab.mlsdm.MlsdmTables%>.ELITid_ELSE;\n\t\t/*@NonInvalid*/ boolean implies;\n\t\tif (eq) {\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.Class%> TYP_mlsdm_c_c_DecisionMergeNode_0 = idResolver.getClass(<%de.mdelab.mlsdm.MlsdmTables%>.CLSSid_DecisionMergeNode, null);\n\t\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityNode%> source = this.getSource();\n\t\t\tfinal /*@NonInvalid*/ boolean oclIsTypeOf = <%org.eclipse.ocl.pivot.library.oclany.OclAnyOclIsTypeOfOperation%>.INSTANCE.evaluate(executor, source, TYP_mlsdm_c_c_DecisionMergeNode_0).booleanValue();\n\t\t\timplies = oclIsTypeOf;\n\t\t}\n\t\telse {\n\t\t\timplies = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\t\tif (implies) {\n\t\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tstatus = null;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean eq_0 = status == Boolean.TRUE;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (eq_0) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlsdm.MlsdmTables%>.STR_The_32_ELSE_32_guard_32_of_32_activity_32_edge_32, toString);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlsdm.MlsdmTables%>.STR__32_is_32_only_32_valid_32_for_32_edges_32_starting_32_from_32_a_32_decision_s_merge_32_node);\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlsdm.MlsdmTables%>.TUPLid_, sum_0, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, symbol_1, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getActivityEdge__ActivityEdgeTarget__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"ActivityEdge::ActivityEdgeTarget\";\ntry {\n\t/**\n\t *\n\t * inv ActivityEdgeTarget:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if self.target <> null\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'Target of activity edge \' +\n\t *               self.toString() + \' must be specified.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.ACTIVITY_EDGE___ACTIVITY_EDGE_TARGET__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_0;\n\tif (le) {\n\t\tsymbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_0 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_0;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getActivityEdge__ActivityEdgeFailureGuard__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"ActivityEdge::ActivityEdgeFailureGuard\";\ntry {\n\t/**\n\t *\n\t * inv ActivityEdgeFailureGuard:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if self.guardType = ActivityEdgeGuardEnum::FAILURE and\n\t *             self.source.oclIsKindOf(StoryNode) implies\n\t *             self.source.oclAsType(StoryNode).semantics = StoryNodeSemanticsEnum::SINGLE_MATCH\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'The FAILURE guard of activity edge \' +\n\t *               self.toString() + \' is only valid for edges starting from a story node with SINGLE_MATCH semantics.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.ACTIVITY_EDGE___ACTIVITY_EDGE_FAILURE_GUARD__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (le) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityEdgeGuardEnum%> guardType = this.getGuardType();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_guardType = <%de.mdelab.mlsdm.MlsdmTables%>.ENUMid_ActivityEdgeGuardEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(guardType.getName()));\n\t\tfinal /*@NonInvalid*/ boolean eq = BOXED_guardType == <%de.mdelab.mlsdm.MlsdmTables%>.ELITid_FAILURE;\n\t\t/*@NonInvalid*/ boolean and;\n\t\tif (eq) {\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.Class%> TYP_mlsdm_c_c_StoryNode_0 = idResolver.getClass(<%de.mdelab.mlsdm.MlsdmTables%>.CLSSid_StoryNode, null);\n\t\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityNode%> source = this.getSource();\n\t\t\tfinal /*@NonInvalid*/ boolean oclIsKindOf = <%org.eclipse.ocl.pivot.library.oclany.OclAnyOclIsKindOfOperation%>.INSTANCE.evaluate(executor, source, TYP_mlsdm_c_c_StoryNode_0).booleanValue();\n\t\t\tand = oclIsKindOf;\n\t\t}\n\t\telse {\n\t\t\tand = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t}\n\t\t/*@Thrown*/ boolean implies;\n\t\tif (and) {\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.Class%> TYP_mlsdm_c_c_StoryNode_1 = idResolver.getClass(<%de.mdelab.mlsdm.MlsdmTables%>.CLSSid_StoryNode, null);\n\t\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityNode%> source_0 = this.getSource();\n\t\t\tfinal /*@Thrown*/ <%de.mdelab.mlsdm.StoryNode%> oclAsType = (<%de.mdelab.mlsdm.StoryNode%>)<%org.eclipse.ocl.pivot.library.oclany.OclAnyOclAsTypeOperation%>.INSTANCE.evaluate(executor, source_0, TYP_mlsdm_c_c_StoryNode_1);\n\t\t\tfinal /*@Thrown*/ <%de.mdelab.mlsdm.StoryNodeSemanticsEnum%> semantics = oclAsType.getSemantics();\n\t\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_semantics = <%de.mdelab.mlsdm.MlsdmTables%>.ENUMid_StoryNodeSemanticsEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(semantics.getName()));\n\t\t\tfinal /*@Thrown*/ boolean eq_0 = BOXED_semantics == <%de.mdelab.mlsdm.MlsdmTables%>.ELITid_SINGLE_MATCH;\n\t\t\timplies = eq_0;\n\t\t}\n\t\telse {\n\t\t\timplies = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\t\tif (implies) {\n\t\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tstatus = null;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean eq_1 = status == Boolean.TRUE;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (eq_1) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlsdm.MlsdmTables%>.STR_The_32_FAILURE_32_guard_32_of_32_activity_32_edge_32, toString);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlsdm.MlsdmTables%>.STR__32_is_32_only_32_valid_32_for_32_edges_32_starting_32_from_32_a_32_story_32_node_32_with_32_SINGLE_);\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlsdm.MlsdmTables%>.TUPLid_, sum_0, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, symbol_1, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getActivityEdge__ActivityEdgeGuardExpression__DiagnosticChain_Map(), source, new String[] {
				"body",
				"final <%java.lang.String%> constraintName = \"ActivityEdge::ActivityEdgeGuardExpression\";\ntry {\n\t/**\n\t *\n\t * inv ActivityEdgeGuardExpression:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if self.guardType = ActivityEdgeGuardEnum::BOOLEAN implies self.guardExpression <> null\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'A guard expression for the boolean guard of activity edge \' +\n\t *               self.toString() + \' must be specified.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.ACTIVITY_EDGE___ACTIVITY_EDGE_GUARD_EXPRESSION__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (le) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityEdgeGuardEnum%> guardType = this.getGuardType();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_guardType = <%de.mdelab.mlsdm.MlsdmTables%>.ENUMid_ActivityEdgeGuardEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(guardType.getName()));\n\t\tfinal /*@NonInvalid*/ boolean eq = BOXED_guardType == <%de.mdelab.mlsdm.MlsdmTables%>.ELITid_BOOLEAN;\n\t\t/*@NonInvalid*/ boolean implies;\n\t\tif (eq) {\n\t\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlexpressions.MLExpression%> guardExpression = this.getGuardExpression();\n\t\t\tfinal /*@NonInvalid*/ boolean ne = guardExpression != null;\n\t\t\timplies = ne;\n\t\t}\n\t\telse {\n\t\t\timplies = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\t\tif (implies) {\n\t\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tstatus = null;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean eq_0 = status == Boolean.TRUE;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (eq_0) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlsdm.MlsdmTables%>.STR_A_32_guard_32_expression_32_for_32_the_32_boolean_32_guard_32_of_32_activity_32_edge_32, toString);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlsdm.MlsdmTables%>.STR__32_must_32_be_32_specified);\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlsdm.MlsdmTables%>.TUPLid_, sum_0, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, symbol_1, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getActivityEdge__ActivityEdgeNoGuardExpression__DiagnosticChain_Map(), source, new String[] {
				"body",
				"final <%java.lang.String%> constraintName = \"ActivityEdge::ActivityEdgeNoGuardExpression\";\ntry {\n\t/**\n\t *\n\t * inv ActivityEdgeNoGuardExpression:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if self.guardExpression <> null implies self.guardType = ActivityEdgeGuardEnum::BOOLEAN\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'A guard expression may only be specified for boolean guards (activity edge \' +\n\t *               self.toString() + \').\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.ACTIVITY_EDGE___ACTIVITY_EDGE_NO_GUARD_EXPRESSION__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (le) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlexpressions.MLExpression%> guardExpression = this.getGuardExpression();\n\t\tfinal /*@NonInvalid*/ boolean ne = guardExpression != null;\n\t\t/*@NonInvalid*/ boolean implies;\n\t\tif (ne) {\n\t\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityEdgeGuardEnum%> guardType = this.getGuardType();\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_guardType = <%de.mdelab.mlsdm.MlsdmTables%>.ENUMid_ActivityEdgeGuardEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(guardType.getName()));\n\t\t\tfinal /*@NonInvalid*/ boolean eq = BOXED_guardType == <%de.mdelab.mlsdm.MlsdmTables%>.ELITid_BOOLEAN;\n\t\t\timplies = eq;\n\t\t}\n\t\telse {\n\t\t\timplies = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\t\tif (implies) {\n\t\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tstatus = null;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean eq_0 = status == Boolean.TRUE;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (eq_0) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlsdm.MlsdmTables%>.STR_A_32_guard_32_expression_32_may_32_only_32_be_32_specified_32_for_32_boolean_32_guards_32_o_act, toString);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlsdm.MlsdmTables%>.STR__e_);\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlsdm.MlsdmTables%>.TUPLid_, sum_0, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, symbol_1, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getActivityEdge__ActivityEdgeEndGuard__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"ActivityEdge::ActivityEdgeEndGuard\";\ntry {\n\t/**\n\t *\n\t * inv ActivityEdgeEndGuard:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if self.guardType = ActivityEdgeGuardEnum::END and\n\t *             self.source.oclIsKindOf(StoryNode) implies\n\t *             self.source.oclAsType(StoryNode).semantics = StoryNodeSemanticsEnum::FOR_EACH_FRESH_MATCH\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'The END guard of activity edge \' +\n\t *               self.toString() + \' is only valid for edges starting from a story node with FOR_EACH semantics.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.ACTIVITY_EDGE___ACTIVITY_EDGE_END_GUARD__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (le) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityEdgeGuardEnum%> guardType = this.getGuardType();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_guardType = <%de.mdelab.mlsdm.MlsdmTables%>.ENUMid_ActivityEdgeGuardEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(guardType.getName()));\n\t\tfinal /*@NonInvalid*/ boolean eq = BOXED_guardType == <%de.mdelab.mlsdm.MlsdmTables%>.ELITid_END;\n\t\t/*@NonInvalid*/ boolean and;\n\t\tif (eq) {\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.Class%> TYP_mlsdm_c_c_StoryNode_0 = idResolver.getClass(<%de.mdelab.mlsdm.MlsdmTables%>.CLSSid_StoryNode, null);\n\t\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityNode%> source = this.getSource();\n\t\t\tfinal /*@NonInvalid*/ boolean oclIsKindOf = <%org.eclipse.ocl.pivot.library.oclany.OclAnyOclIsKindOfOperation%>.INSTANCE.evaluate(executor, source, TYP_mlsdm_c_c_StoryNode_0).booleanValue();\n\t\t\tand = oclIsKindOf;\n\t\t}\n\t\telse {\n\t\t\tand = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t}\n\t\t/*@Thrown*/ boolean implies;\n\t\tif (and) {\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.Class%> TYP_mlsdm_c_c_StoryNode_1 = idResolver.getClass(<%de.mdelab.mlsdm.MlsdmTables%>.CLSSid_StoryNode, null);\n\t\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityNode%> source_0 = this.getSource();\n\t\t\tfinal /*@Thrown*/ <%de.mdelab.mlsdm.StoryNode%> oclAsType = (<%de.mdelab.mlsdm.StoryNode%>)<%org.eclipse.ocl.pivot.library.oclany.OclAnyOclAsTypeOperation%>.INSTANCE.evaluate(executor, source_0, TYP_mlsdm_c_c_StoryNode_1);\n\t\t\tfinal /*@Thrown*/ <%de.mdelab.mlsdm.StoryNodeSemanticsEnum%> semantics = oclAsType.getSemantics();\n\t\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_semantics = <%de.mdelab.mlsdm.MlsdmTables%>.ENUMid_StoryNodeSemanticsEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(semantics.getName()));\n\t\t\tfinal /*@Thrown*/ boolean eq_0 = BOXED_semantics == <%de.mdelab.mlsdm.MlsdmTables%>.ELITid_FOR_EACH_FRESH_MATCH;\n\t\t\timplies = eq_0;\n\t\t}\n\t\telse {\n\t\t\timplies = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\t\tif (implies) {\n\t\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tstatus = null;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean eq_1 = status == Boolean.TRUE;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (eq_1) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlsdm.MlsdmTables%>.STR_The_32_END_32_guard_32_of_32_activity_32_edge_32, toString);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlsdm.MlsdmTables%>.STR__32_is_32_only_32_valid_32_for_32_edges_32_starting_32_from_32_a_32_story_32_node_32_with_32_FOR_EAC);\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlsdm.MlsdmTables%>.TUPLid_, sum_0, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, symbol_1, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getActivityEdge_Source(), source, new String[] { "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!ActivityEdge!source" });
		addAnnotation(getActivityEdge_Target(), source, new String[] { "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!ActivityEdge!target" });
		addAnnotation(getActivityEdge_ActivityNodeContainer(), source, new String[] { "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!ActivityEdge!activityNodeContainer" });
		addAnnotation(getActivityEdge_GuardType(), source, new String[] { "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!ActivityEdge!guardType" });
		addAnnotation(getActivityEdge_GuardExpression(), source, new String[] { "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!ActivityEdge!guardExpression" });
		addAnnotation(getActivityEdge_AcquireEdges(), source, new String[] { "documentation",
				"Before this edge can be traversed, tokens have to be acquired from the semaphores connected by AcquireEdges.",
				"get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!ActivityEdge!acquireEdges" });
		addAnnotation(getActivityEdge_ReleaseEdges(), source, new String[] { "documentation",
				"When this edge is traversed, tokens are released to the semaphores connected by ReleaseEdges.", "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!ActivityEdge!releaseEdges" });
		addAnnotation(getActivityEdge_AssertionExpressions(), source, new String[] { "documentation",
				"A set of assertion expressions that are evaluated when the edge is traversed (and the interpreter is configured to evaluate assertions). If an expression is evaluated to false, an exception is thrown.",
				"get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!ActivityEdge!assertionExpressions" });
		addAnnotation(activityEdgeGuardEnumEEnum, source,
				new String[] { "documentation", "Enumeration of the guards that an ActivityEdge can have." });
		addAnnotation(activityEdgeGuardEnumEEnum.getELiterals().get(0), source,
				new String[] { "documentation", "No guard." });
		addAnnotation(activityEdgeGuardEnumEEnum.getELiterals().get(1), source, new String[] { "documentation",
				"Only valid for StoryNodes with FOR_EACH semantics. This edge is traversed for each match of the StoryNode\'s StoryPattern." });
		addAnnotation(activityEdgeGuardEnumEEnum.getELiterals().get(2), source, new String[] { "documentation",
				"Only valid for StoryNodes with FOR_EACH semantics. This edge is traversed when no more matches for the StoryNode\'s StoryPattern can be found." });
		addAnnotation(activityEdgeGuardEnumEEnum.getELiterals().get(3), source, new String[] { "documentation",
				"Only valid for StoryNodes with SINGLE_MATCH semantics. This edge is traversed when a match for the StoryNode\'s StoryPattern was found." });
		addAnnotation(activityEdgeGuardEnumEEnum.getELiterals().get(4), source, new String[] { "documentation",
				"Only valid for StoryNodes with SINGLE_MATCH semantics. This edge is traversed when no match for the StoryNode\'s StoryPattern was found." });
		addAnnotation(activityEdgeGuardEnumEEnum.getELiterals().get(5), source, new String[] { "documentation",
				"Only valid for DecisionMergeNodes. This edge is traversed when the edge\'s guardExpression is evaluated to true." });
		addAnnotation(activityEdgeGuardEnumEEnum.getELiterals().get(6), source, new String[] { "documentation",
				"Only valid for DecisionMergeNodes. This edge is traversed when the guardExpressions of all other edges of the DecisionMergeNode were evaluated to false. A DecisionMergeNode must have exactly one outgoing edge with guard ELSE." });
		addAnnotation(initialNodeEClass, source, new String[] { "documentation",
				"The InitialNode is the start of the Activity\'s behavior. An Activity must have exactly one InitialNode." });
		addAnnotation(getInitialNode__InitialNodeIncomingEdge__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"InitialNode::InitialNodeIncomingEdge\";\ntry {\n\t/**\n\t *\n\t * inv InitialNodeIncomingEdge:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if self.incomingEdges->isEmpty()\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'The initial node \' +\n\t *               self.toString() + \' must not have an incoming edge.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.INITIAL_NODE___INITIAL_NODE_INCOMING_EDGE__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (le) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.util.List%><<%de.mdelab.mlsdm.ActivityEdge%>> incomingEdges = this.getIncomingEdges();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.SetValue%> BOXED_incomingEdges = idResolver.createSetOfAll(<%de.mdelab.mlsdm.MlsdmTables%>.SET_CLSSid_ActivityEdge, incomingEdges);\n\t\tfinal /*@NonInvalid*/ boolean isEmpty = <%org.eclipse.ocl.pivot.library.collection.CollectionIsEmptyOperation%>.INSTANCE.evaluate(BOXED_incomingEdges).booleanValue();\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\t\tif (isEmpty) {\n\t\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tstatus = null;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean eq = status == Boolean.TRUE;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (eq) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlsdm.MlsdmTables%>.STR_The_32_initial_32_node_32, toString);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlsdm.MlsdmTables%>.STR__32_must_32_not_32_have_32_an_32_incoming_32_edge);\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlsdm.MlsdmTables%>.TUPLid_, sum_0, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, symbol_1, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getInitialNode__InitialNodeOutgoingEdge__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"InitialNode::InitialNodeOutgoingEdge\";\ntry {\n\t/**\n\t *\n\t * inv InitialNodeOutgoingEdge:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if self.outgoingEdges->size() = 1\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'The initial node \' +\n\t *               self.toString() + \' must have exactly one outgoing edge.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.INITIAL_NODE___INITIAL_NODE_OUTGOING_EDGE__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (le) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.util.List%><<%de.mdelab.mlsdm.ActivityEdge%>> outgoingEdges = this.getOutgoingEdges();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.SetValue%> BOXED_outgoingEdges = idResolver.createSetOfAll(<%de.mdelab.mlsdm.MlsdmTables%>.SET_CLSSid_ActivityEdge, outgoingEdges);\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> size = <%org.eclipse.ocl.pivot.library.collection.CollectionSizeOperation%>.INSTANCE.evaluate(BOXED_outgoingEdges);\n\t\tfinal /*@NonInvalid*/ boolean eq = size.equals(<%de.mdelab.mlsdm.MlsdmTables%>.INT_1);\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\t\tif (eq) {\n\t\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tstatus = null;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean eq_0 = status == Boolean.TRUE;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (eq_0) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlsdm.MlsdmTables%>.STR_The_32_initial_32_node_32, toString);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlsdm.MlsdmTables%>.STR__32_must_32_have_32_exactly_32_one_32_outgoing_32_edge);\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlsdm.MlsdmTables%>.TUPLid_, sum_0, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, symbol_1, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(flowFinalNodeEClass, source, new String[] { "documentation",
				"A FlowFinalNode terminates the execution of one concurrent execution flow." });
		addAnnotation(getFlowFinalNode__FlowFinalNodeIncomingEdge__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"FlowFinalNode::FlowFinalNodeIncomingEdge\";\ntry {\n\t/**\n\t *\n\t * inv FlowFinalNodeIncomingEdge:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if self.incomingEdges->notEmpty()\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'The flow final node \' +\n\t *               self.toString() + \' must have at least one incoming edge\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.FLOW_FINAL_NODE___FLOW_FINAL_NODE_INCOMING_EDGE__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (le) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.util.List%><<%de.mdelab.mlsdm.ActivityEdge%>> incomingEdges = this.getIncomingEdges();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.SetValue%> BOXED_incomingEdges = idResolver.createSetOfAll(<%de.mdelab.mlsdm.MlsdmTables%>.SET_CLSSid_ActivityEdge, incomingEdges);\n\t\tfinal /*@NonInvalid*/ boolean notEmpty = <%org.eclipse.ocl.pivot.library.collection.CollectionNotEmptyOperation%>.INSTANCE.evaluate(BOXED_incomingEdges).booleanValue();\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\t\tif (notEmpty) {\n\t\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tstatus = null;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean eq = status == Boolean.TRUE;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (eq) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlsdm.MlsdmTables%>.STR_The_32_flow_32_final_32_node_32, toString);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlsdm.MlsdmTables%>.STR__32_must_32_have_32_at_32_least_32_one_32_incoming_32_edge);\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlsdm.MlsdmTables%>.TUPLid_, sum_0, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, symbol_1, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getFlowFinalNode__FlowFinalNodeOutgoingEdge__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"FlowFinalNode::FlowFinalNodeOutgoingEdge\";\ntry {\n\t/**\n\t *\n\t * inv FlowFinalNodeOutgoingEdge:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if self.outgoingEdges->isEmpty()\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'The flow final node \' +\n\t *               self.toString() + \' must not have an outgoing edge\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.FLOW_FINAL_NODE___FLOW_FINAL_NODE_OUTGOING_EDGE__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (le) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.util.List%><<%de.mdelab.mlsdm.ActivityEdge%>> outgoingEdges = this.getOutgoingEdges();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.SetValue%> BOXED_outgoingEdges = idResolver.createSetOfAll(<%de.mdelab.mlsdm.MlsdmTables%>.SET_CLSSid_ActivityEdge, outgoingEdges);\n\t\tfinal /*@NonInvalid*/ boolean isEmpty = <%org.eclipse.ocl.pivot.library.collection.CollectionIsEmptyOperation%>.INSTANCE.evaluate(BOXED_outgoingEdges).booleanValue();\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\t\tif (isEmpty) {\n\t\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tstatus = null;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean eq = status == Boolean.TRUE;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (eq) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlsdm.MlsdmTables%>.STR_The_32_flow_32_final_32_node_32, toString);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlsdm.MlsdmTables%>.STR__32_must_32_not_32_have_32_an_32_outgoing_32_edge);\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlsdm.MlsdmTables%>.TUPLid_, sum_0, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, symbol_1, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(activityFinalNodeEClass, source, new String[] { "documentation",
				"An ActivityFinalNode terminates the execution of an activity and all its concurrent execution flows. The values of output parameters are calculated using the outputParameterValues." });
		addAnnotation(getActivityFinalNode__IncomingEdge__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"ActivityFinalNode::IncomingEdge\";\ntry {\n\t/**\n\t *\n\t * inv IncomingEdge:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if self.incomingEdges->notEmpty()\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'The activity final node \' +\n\t *               self.toString() + \' must have at least one incoming edge\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.ACTIVITY_FINAL_NODE___INCOMING_EDGE__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (le) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.util.List%><<%de.mdelab.mlsdm.ActivityEdge%>> incomingEdges = this.getIncomingEdges();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.SetValue%> BOXED_incomingEdges = idResolver.createSetOfAll(<%de.mdelab.mlsdm.MlsdmTables%>.SET_CLSSid_ActivityEdge, incomingEdges);\n\t\tfinal /*@NonInvalid*/ boolean notEmpty = <%org.eclipse.ocl.pivot.library.collection.CollectionNotEmptyOperation%>.INSTANCE.evaluate(BOXED_incomingEdges).booleanValue();\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\t\tif (notEmpty) {\n\t\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tstatus = null;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean eq = status == Boolean.TRUE;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (eq) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlsdm.MlsdmTables%>.STR_The_32_activity_32_final_32_node_32, toString);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlsdm.MlsdmTables%>.STR__32_must_32_have_32_at_32_least_32_one_32_incoming_32_edge);\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlsdm.MlsdmTables%>.TUPLid_, sum_0, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, symbol_1, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getActivityFinalNode__NoOutputParameterValue__DiagnosticChain_Map(), source, new String[] {
				"body",
				"final <%java.lang.String%> constraintName = \"ActivityFinalNode::NoOutputParameterValue\";\ntry {\n\t/**\n\t *\n\t * inv NoOutputParameterValue:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if\n\t *             self.activity.parameters->select(e | e.direction <> ActivityParameterDirectionEnum::IN)\n\t *             ->forAll(e |\n\t *               self.outputParameterValues->exists(e2 | e2.parameter = e))\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'An output parameter value is missing for parameters of activity final node \' +\n\t *               self.toString(), status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.ACTIVITY_FINAL_NODE___NO_OUTPUT_PARAMETER_VALUE__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (le) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlsdm.Activity%> activity = this.getActivity();\n\t\tfinal /*@NonInvalid*/ <%java.util.List%><<%de.mdelab.mlsdm.ActivityParameter%>> parameters = activity.getParameters();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.SetValue%> BOXED_parameters = idResolver.createSetOfAll(<%de.mdelab.mlsdm.MlsdmTables%>.SET_CLSSid_ActivityParameter, parameters);\n\t\t/*@Thrown*/ <%org.eclipse.ocl.pivot.values.SetValue.Accumulator%> accumulator = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createSetAccumulatorValue(<%de.mdelab.mlsdm.MlsdmTables%>.SET_CLSSid_ActivityParameter);\n\t\t<%java.util.Iterator%><<%java.lang.Object%>> ITERATOR_e_0 = BOXED_parameters.iterator();\n\t\t/*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.SetValue%> select;\n\t\twhile (true) {\n\t\t\tif (!ITERATOR_e_0.hasNext()) {\n\t\t\t\tselect = accumulator;\n\t\t\t\tbreak;\n\t\t\t}\n\t\t\t/*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityParameter%> e_0 = (<%de.mdelab.mlsdm.ActivityParameter%>)ITERATOR_e_0.next();\n\t\t\t/**\n\t\t\t * e.direction <> ActivityParameterDirectionEnum::IN\n\t\t\t */\n\t\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityParameterDirectionEnum%> direction = e_0.getDirection();\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_direction = <%de.mdelab.mlsdm.MlsdmTables%>.ENUMid_ActivityParameterDirectionEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(direction.getName()));\n\t\t\tfinal /*@NonInvalid*/ boolean ne = BOXED_direction != <%de.mdelab.mlsdm.MlsdmTables%>.ELITid_IN;\n\t\t\t//\n\t\t\tif (ne == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE) {\n\t\t\t\taccumulator.add(e_0);\n\t\t\t}\n\t\t}\n\t\t/*@Thrown*/ <%java.lang.Object%> accumulator_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t<%java.util.Iterator%><<%java.lang.Object%>> ITERATOR_e_1 = select.iterator();\n\t\t/*@Thrown*/ <%java.lang.Boolean%> forAll;\n\t\twhile (true) {\n\t\t\tif (!ITERATOR_e_1.hasNext()) {\n\t\t\t\tif (accumulator_0 == null) {\n\t\t\t\t\tforAll = null;\n\t\t\t\t}\n\t\t\t\telse if (accumulator_0 == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE) {\n\t\t\t\t\tforAll = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t\t\t}\n\t\t\t\telse {\n\t\t\t\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)accumulator_0;\n\t\t\t\t}\n\t\t\t\tbreak;\n\t\t\t}\n\t\t\t/*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityParameter%> e_1 = (<%de.mdelab.mlsdm.ActivityParameter%>)ITERATOR_e_1.next();\n\t\t\t/**\n\t\t\t *\n\t\t\t * self.outputParameterValues->exists(e2 | e2.parameter = e)\n\t\t\t */\n\t\t\tfinal /*@NonInvalid*/ <%java.util.List%><<%de.mdelab.mlsdm.OutputParameterValue%>> outputParameterValues = this.getOutputParameterValues();\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.SetValue%> BOXED_outputParameterValues = idResolver.createSetOfAll(<%de.mdelab.mlsdm.MlsdmTables%>.SET_CLSSid_OutputParameterValue, outputParameterValues);\n\t\t\t/*@Thrown*/ <%java.lang.Object%> accumulator_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t\t<%java.util.Iterator%><<%java.lang.Object%>> ITERATOR_e2 = BOXED_outputParameterValues.iterator();\n\t\t\t/*@NonInvalid*/ <%java.lang.Boolean%> exists;\n\t\t\twhile (true) {\n\t\t\t\tif (!ITERATOR_e2.hasNext()) {\n\t\t\t\t\tif (accumulator_1 == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE) {\n\t\t\t\t\t\texists = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t\t\t\t}\n\t\t\t\t\telse {\n\t\t\t\t\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)accumulator_1;\n\t\t\t\t\t}\n\t\t\t\t\tbreak;\n\t\t\t\t}\n\t\t\t\t/*@NonInvalid*/ <%de.mdelab.mlsdm.OutputParameterValue%> e2 = (<%de.mdelab.mlsdm.OutputParameterValue%>)ITERATOR_e2.next();\n\t\t\t\t/**\n\t\t\t\t * e2.parameter = e\n\t\t\t\t */\n\t\t\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityParameter%> parameter = e2.getParameter();\n\t\t\t\tfinal /*@NonInvalid*/ boolean eq = parameter.equals(e_1);\n\t\t\t\t//\n\t\t\t\tif (eq == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE) {\t\t\t\t\t// Normal successful body evaluation result\n\t\t\t\t\texists = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t\t\t\tbreak;\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Stop immediately\n\t\t\t\t}\n\t\t\t\telse if (eq == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE) {\t\t\t\t// Normal unsuccessful body evaluation result\n\t\t\t\t\t;\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Carry on\n\t\t\t\t}\n\t\t\t\telse {\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Impossible badly typed result\n\t\t\t\t\taccumulator_1 = new <%org.eclipse.ocl.pivot.values.InvalidValueException%>(<%org.eclipse.ocl.pivot.messages.PivotMessages%>.NonBooleanBody, \"exists\");\n\t\t\t\t}\n\t\t\t}\n\t\t\t//\n\t\t\tif (exists == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE) {\t\t\t\t\t// Normal unsuccessful body evaluation result\n\t\t\t\tforAll = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t\t\tbreak;\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Stop immediately\n\t\t\t}\n\t\t\telse if (exists == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE) {\t\t\t\t// Normal successful body evaluation result\n\t\t\t\t;\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Carry on\n\t\t\t}\n\t\t\telse if (exists == null) {\t\t\t\t\t\t\t\t// Abnormal null body evaluation result\n\t\t\t\tif (accumulator_0 == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE) {\n\t\t\t\t\taccumulator_0 = null;\t\t\t\t\t\t\t\t\t\t// Cache a null failure\n\t\t\t\t}\n\t\t\t}\n\t\t\telse {\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Impossible badly typed result\n\t\t\t\taccumulator_0 = new <%org.eclipse.ocl.pivot.values.InvalidValueException%>(<%org.eclipse.ocl.pivot.messages.PivotMessages%>.NonBooleanBody, \"forAll\");\n\t\t\t}\n\t\t}\n\t\tif (forAll == null) {\n\t\t\tthrow new <%org.eclipse.ocl.pivot.values.InvalidValueException%>(\"Null if condition\");\n\t\t}\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\t\tif (forAll) {\n\t\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tstatus = null;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean eq_0 = status == Boolean.TRUE;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (eq_0) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlsdm.MlsdmTables%>.STR_An_32_output_32_parameter_32_value_32_is_32_missing_32_for_32_parameters_32_of_32_activity_32, toString);\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlsdm.MlsdmTables%>.TUPLid_, sum, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, symbol_1, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getActivityFinalNode__OutgoingEdge__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"ActivityFinalNode::OutgoingEdge\";\ntry {\n\t/**\n\t *\n\t * inv OutgoingEdge:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if self.outgoingEdges->isEmpty()\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'The activity final node \' +\n\t *               self.toString() + \' must not have an outgoing edge\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.ACTIVITY_FINAL_NODE___OUTGOING_EDGE__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (le) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.util.List%><<%de.mdelab.mlsdm.ActivityEdge%>> outgoingEdges = this.getOutgoingEdges();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.SetValue%> BOXED_outgoingEdges = idResolver.createSetOfAll(<%de.mdelab.mlsdm.MlsdmTables%>.SET_CLSSid_ActivityEdge, outgoingEdges);\n\t\tfinal /*@NonInvalid*/ boolean isEmpty = <%org.eclipse.ocl.pivot.library.collection.CollectionIsEmptyOperation%>.INSTANCE.evaluate(BOXED_outgoingEdges).booleanValue();\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\t\tif (isEmpty) {\n\t\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tstatus = null;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean eq = status == Boolean.TRUE;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (eq) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlsdm.MlsdmTables%>.STR_The_32_activity_32_final_32_node_32, toString);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlsdm.MlsdmTables%>.STR__32_must_32_not_32_have_32_an_32_outgoing_32_edge);\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlsdm.MlsdmTables%>.TUPLid_, sum_0, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, symbol_1, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getActivityFinalNode__OneOutputParameterValue__DiagnosticChain_Map(), source, new String[] {
				"body",
				"final <%java.lang.String%> constraintName = \"ActivityFinalNode::OneOutputParameterValue\";\ntry {\n\t/**\n\t *\n\t * inv OneOutputParameterValue:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if\n\t *             self.outputParameterValues->forAll(e |\n\t *               self.outputParameterValues->select(e2 | e2.parameter = e.parameter)\n\t *               ->size() = 1)\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'There may only be one output parameter value for each parameter of activity final node \' +\n\t *               self.toString(), status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.ACTIVITY_FINAL_NODE___ONE_OUTPUT_PARAMETER_VALUE__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (le) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.util.List%><<%de.mdelab.mlsdm.OutputParameterValue%>> outputParameterValues = this.getOutputParameterValues();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.SetValue%> BOXED_outputParameterValues = idResolver.createSetOfAll(<%de.mdelab.mlsdm.MlsdmTables%>.SET_CLSSid_OutputParameterValue, outputParameterValues);\n\t\t/*@Thrown*/ <%java.lang.Object%> accumulator = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t<%java.util.Iterator%><<%java.lang.Object%>> ITERATOR_e_0 = BOXED_outputParameterValues.iterator();\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> forAll;\n\t\twhile (true) {\n\t\t\tif (!ITERATOR_e_0.hasNext()) {\n\t\t\t\tif (accumulator == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE) {\n\t\t\t\t\tforAll = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t\t\t}\n\t\t\t\telse {\n\t\t\t\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)accumulator;\n\t\t\t\t}\n\t\t\t\tbreak;\n\t\t\t}\n\t\t\t/*@NonInvalid*/ <%de.mdelab.mlsdm.OutputParameterValue%> e_0 = (<%de.mdelab.mlsdm.OutputParameterValue%>)ITERATOR_e_0.next();\n\t\t\t/**\n\t\t\t *\n\t\t\t * self.outputParameterValues->select(e2 | e2.parameter = e.parameter)\n\t\t\t * ->size() = 1\n\t\t\t */\n\t\t\t/*@Thrown*/ <%org.eclipse.ocl.pivot.values.SetValue.Accumulator%> accumulator_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createSetAccumulatorValue(<%de.mdelab.mlsdm.MlsdmTables%>.SET_CLSSid_OutputParameterValue);\n\t\t\t<%java.util.Iterator%><<%java.lang.Object%>> ITERATOR_e2 = BOXED_outputParameterValues.iterator();\n\t\t\t/*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.SetValue%> select;\n\t\t\twhile (true) {\n\t\t\t\tif (!ITERATOR_e2.hasNext()) {\n\t\t\t\t\tselect = accumulator_0;\n\t\t\t\t\tbreak;\n\t\t\t\t}\n\t\t\t\t/*@NonInvalid*/ <%de.mdelab.mlsdm.OutputParameterValue%> e2 = (<%de.mdelab.mlsdm.OutputParameterValue%>)ITERATOR_e2.next();\n\t\t\t\t/**\n\t\t\t\t * e2.parameter = e.parameter\n\t\t\t\t */\n\t\t\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityParameter%> parameter = e2.getParameter();\n\t\t\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityParameter%> parameter_0 = e_0.getParameter();\n\t\t\t\tfinal /*@NonInvalid*/ boolean eq = parameter.equals(parameter_0);\n\t\t\t\t//\n\t\t\t\tif (eq == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE) {\n\t\t\t\t\taccumulator_0.add(e2);\n\t\t\t\t}\n\t\t\t}\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> size = <%org.eclipse.ocl.pivot.library.collection.CollectionSizeOperation%>.INSTANCE.evaluate(select);\n\t\t\tfinal /*@NonInvalid*/ boolean eq_0 = size.equals(<%de.mdelab.mlsdm.MlsdmTables%>.INT_1);\n\t\t\t//\n\t\t\tif (eq_0 == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE) {\t\t\t\t\t// Normal unsuccessful body evaluation result\n\t\t\t\tforAll = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t\t\tbreak;\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Stop immediately\n\t\t\t}\n\t\t\telse if (eq_0 == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE) {\t\t\t\t// Normal successful body evaluation result\n\t\t\t\t;\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Carry on\n\t\t\t}\n\t\t\telse {\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Impossible badly typed result\n\t\t\t\taccumulator = new <%org.eclipse.ocl.pivot.values.InvalidValueException%>(<%org.eclipse.ocl.pivot.messages.PivotMessages%>.NonBooleanBody, \"forAll\");\n\t\t\t}\n\t\t}\n\t\tif (forAll == null) {\n\t\t\tthrow new <%org.eclipse.ocl.pivot.values.InvalidValueException%>(\"Null if condition\");\n\t\t}\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\t\tif (forAll) {\n\t\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tstatus = null;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean eq_1 = status == Boolean.TRUE;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (eq_1) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlsdm.MlsdmTables%>.STR_There_32_may_32_only_32_be_32_one_32_output_32_parameter_32_value_32_for_32_each_32_parameter_32, toString);\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlsdm.MlsdmTables%>.TUPLid_, sum, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, symbol_1, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getActivityFinalNode_OutputParameterValues(), source, new String[] { "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!ActivityFinalNode!outputParameterValues" });
		addAnnotation(getActivityFinalNode_Activity(), source, new String[] { "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!ActivityFinalNode!activity" });
		addAnnotation(expressionActivityNodeEClass, source, new String[] { "documentation",
				"An ExpressionActivityNode contains a number of expressions that are executed sequentially." });
		addAnnotation(getExpressionActivityNode__OneOutgoingEdge__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"ExpressionActivityNode::OneOutgoingEdge\";\ntry {\n\t/**\n\t *\n\t * inv OneOutgoingEdge:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if self.outgoingEdges->size() = 1\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'Expression activity node \' +\n\t *               self.toString() + \' must have one outgoing edge.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.EXPRESSION_ACTIVITY_NODE___ONE_OUTGOING_EDGE__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (le) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.util.List%><<%de.mdelab.mlsdm.ActivityEdge%>> outgoingEdges = this.getOutgoingEdges();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.SetValue%> BOXED_outgoingEdges = idResolver.createSetOfAll(<%de.mdelab.mlsdm.MlsdmTables%>.SET_CLSSid_ActivityEdge, outgoingEdges);\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> size = <%org.eclipse.ocl.pivot.library.collection.CollectionSizeOperation%>.INSTANCE.evaluate(BOXED_outgoingEdges);\n\t\tfinal /*@NonInvalid*/ boolean eq = size.equals(<%de.mdelab.mlsdm.MlsdmTables%>.INT_1);\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\t\tif (eq) {\n\t\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tstatus = null;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean eq_0 = status == Boolean.TRUE;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (eq_0) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlsdm.MlsdmTables%>.STR_Expression_32_activity_32_node_32, toString);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlsdm.MlsdmTables%>.STR__32_must_32_have_32_one_32_outgoing_32_edge);\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlsdm.MlsdmTables%>.TUPLid_, sum_0, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, symbol_1, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getExpressionActivityNode__OneIncomingEdge__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"ExpressionActivityNode::OneIncomingEdge\";\ntry {\n\t/**\n\t *\n\t * inv OneIncomingEdge:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if self.incomingEdges->size() = 1\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'Expression activity node \' +\n\t *               self.toString() + \' must have one incoming edge.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.EXPRESSION_ACTIVITY_NODE___ONE_INCOMING_EDGE__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (le) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.util.List%><<%de.mdelab.mlsdm.ActivityEdge%>> incomingEdges = this.getIncomingEdges();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.SetValue%> BOXED_incomingEdges = idResolver.createSetOfAll(<%de.mdelab.mlsdm.MlsdmTables%>.SET_CLSSid_ActivityEdge, incomingEdges);\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> size = <%org.eclipse.ocl.pivot.library.collection.CollectionSizeOperation%>.INSTANCE.evaluate(BOXED_incomingEdges);\n\t\tfinal /*@NonInvalid*/ boolean eq = size.equals(<%de.mdelab.mlsdm.MlsdmTables%>.INT_1);\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\t\tif (eq) {\n\t\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tstatus = null;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean eq_0 = status == Boolean.TRUE;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (eq_0) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlsdm.MlsdmTables%>.STR_Expression_32_activity_32_node_32, toString);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlsdm.MlsdmTables%>.STR__32_must_32_have_32_one_32_incoming_32_edge);\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlsdm.MlsdmTables%>.TUPLid_, sum_0, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, symbol_1, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getExpressionActivityNode__ExpressionSpecified__DiagnosticChain_Map(), source, new String[] {
				"body",
				"final <%java.lang.String%> constraintName = \"ExpressionActivityNode::ExpressionSpecified\";\ntry {\n\t/**\n\t *\n\t * inv ExpressionSpecified:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if not self.expressions->isEmpty()\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'Expression of expression activity node \' +\n\t *               self.toString() + \' must be specified.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.EXPRESSION_ACTIVITY_NODE___EXPRESSION_SPECIFIED__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (le) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.util.List%><<%de.mdelab.mlexpressions.MLExpression%>> expressions = this.getExpressions();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.OrderedSetValue%> BOXED_expressions = idResolver.createOrderedSetOfAll(<%de.mdelab.mlsdm.MlsdmTables%>.ORD_CLSSid_MLExpression, expressions);\n\t\tfinal /*@NonInvalid*/ boolean isEmpty = <%org.eclipse.ocl.pivot.library.collection.CollectionIsEmptyOperation%>.INSTANCE.evaluate(BOXED_expressions).booleanValue();\n\t\tfinal /*@NonInvalid*/ <%java.lang.Boolean%> not = <%org.eclipse.ocl.pivot.library.logical.BooleanNotOperation%>.INSTANCE.evaluate(isEmpty);\n\t\tif (not == null) {\n\t\t\tthrow new <%org.eclipse.ocl.pivot.values.InvalidValueException%>(\"Null if condition\");\n\t\t}\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\t\tif (not) {\n\t\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tstatus = null;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean eq = status == Boolean.TRUE;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (eq) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlsdm.MlsdmTables%>.STR_Expression_32_of_32_expression_32_activity_32_node_32, toString);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlsdm.MlsdmTables%>.STR__32_must_32_be_32_specified);\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlsdm.MlsdmTables%>.TUPLid_, sum_0, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, symbol_1, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getExpressionActivityNode_Expressions(), source, new String[] { "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!ExpressionActivityNode!expressions" });
		addAnnotation(decisionMergeNodeEClass, source, new String[] { "documentation",
				"DecisionMergeNodes branch or merge the control flow based on boolean conditions. If it is used for branching, one outgoing edge must have the ELSE guard, all other edges must have the BOOLEAN guard and guardExpressions. The guardExpressions should be disjunct but this is not checked." });
		addAnnotation(getDecisionMergeNode__IncomingEdge__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"DecisionMergeNode::IncomingEdge\";\ntry {\n\t/**\n\t *\n\t * inv IncomingEdge:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if not self.incomingEdges->isEmpty()\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'Decision merge node \' +\n\t *               self.toString() + \' must have at least one incoming edge.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.DECISION_MERGE_NODE___INCOMING_EDGE__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (le) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.util.List%><<%de.mdelab.mlsdm.ActivityEdge%>> incomingEdges = this.getIncomingEdges();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.SetValue%> BOXED_incomingEdges = idResolver.createSetOfAll(<%de.mdelab.mlsdm.MlsdmTables%>.SET_CLSSid_ActivityEdge, incomingEdges);\n\t\tfinal /*@NonInvalid*/ boolean isEmpty = <%org.eclipse.ocl.pivot.library.collection.CollectionIsEmptyOperation%>.INSTANCE.evaluate(BOXED_incomingEdges).booleanValue();\n\t\tfinal /*@NonInvalid*/ <%java.lang.Boolean%> not = <%org.eclipse.ocl.pivot.library.logical.BooleanNotOperation%>.INSTANCE.evaluate(isEmpty);\n\t\tif (not == null) {\n\t\t\tthrow new <%org.eclipse.ocl.pivot.values.InvalidValueException%>(\"Null if condition\");\n\t\t}\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\t\tif (not) {\n\t\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tstatus = null;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean eq = status == Boolean.TRUE;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (eq) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlsdm.MlsdmTables%>.STR_Decision_32_merge_32_node_32, toString);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlsdm.MlsdmTables%>.STR__32_must_32_have_32_at_32_least_32_one_32_incoming_32_edge_0);\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlsdm.MlsdmTables%>.TUPLid_, sum_0, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, symbol_1, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getDecisionMergeNode__MultipleEdgeGuards__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"DecisionMergeNode::MultipleEdgeGuards\";\ntry {\n\t/**\n\t *\n\t * inv MultipleEdgeGuards:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if\n\t *             self.outgoingEdges->size() > 1 implies\n\t *             self.outgoingEdges->select(e | e.guardType = ActivityEdgeGuardEnum::ELSE)\n\t *             ->size() = 1 and\n\t *             self.outgoingEdges->select(e | e.guardType = ActivityEdgeGuardEnum::BOOLEAN)\n\t *             ->size() =\n\t *             self.outgoingEdges->size() - 1\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'One of the outgoing edges of decision merge node \' +\n\t *               self.toString() + \' must have the ELSE guard, the other edges must have the BOOLEAN guard.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.DECISION_MERGE_NODE___MULTIPLE_EDGE_GUARDS__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (le) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.util.List%><<%de.mdelab.mlsdm.ActivityEdge%>> outgoingEdges = this.getOutgoingEdges();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.SetValue%> BOXED_outgoingEdges = idResolver.createSetOfAll(<%de.mdelab.mlsdm.MlsdmTables%>.SET_CLSSid_ActivityEdge, outgoingEdges);\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> size = <%org.eclipse.ocl.pivot.library.collection.CollectionSizeOperation%>.INSTANCE.evaluate(BOXED_outgoingEdges);\n\t\tfinal /*@NonInvalid*/ boolean gt = <%org.eclipse.ocl.pivot.library.oclany.OclComparableGreaterThanOperation%>.INSTANCE.evaluate(executor, size, <%de.mdelab.mlsdm.MlsdmTables%>.INT_1).booleanValue();\n\t\t/*@NonInvalid*/ boolean implies;\n\t\tif (gt) {\n\t\t\t/*@Thrown*/ <%org.eclipse.ocl.pivot.values.SetValue.Accumulator%> accumulator = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createSetAccumulatorValue(<%de.mdelab.mlsdm.MlsdmTables%>.SET_CLSSid_ActivityEdge);\n\t\t\t<%java.util.Iterator%><<%java.lang.Object%>> ITERATOR_e_0 = BOXED_outgoingEdges.iterator();\n\t\t\t/*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.SetValue%> select;\n\t\t\twhile (true) {\n\t\t\t\tif (!ITERATOR_e_0.hasNext()) {\n\t\t\t\t\tselect = accumulator;\n\t\t\t\t\tbreak;\n\t\t\t\t}\n\t\t\t\t/*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityEdge%> e_0 = (<%de.mdelab.mlsdm.ActivityEdge%>)ITERATOR_e_0.next();\n\t\t\t\t/**\n\t\t\t\t * e.guardType = ActivityEdgeGuardEnum::ELSE\n\t\t\t\t */\n\t\t\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityEdgeGuardEnum%> guardType = e_0.getGuardType();\n\t\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_guardType = <%de.mdelab.mlsdm.MlsdmTables%>.ENUMid_ActivityEdgeGuardEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(guardType.getName()));\n\t\t\t\tfinal /*@NonInvalid*/ boolean eq = BOXED_guardType == <%de.mdelab.mlsdm.MlsdmTables%>.ELITid_ELSE;\n\t\t\t\t//\n\t\t\t\tif (eq == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE) {\n\t\t\t\t\taccumulator.add(e_0);\n\t\t\t\t}\n\t\t\t}\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> size_0 = <%org.eclipse.ocl.pivot.library.collection.CollectionSizeOperation%>.INSTANCE.evaluate(select);\n\t\t\tfinal /*@NonInvalid*/ boolean eq_0 = size_0.equals(<%de.mdelab.mlsdm.MlsdmTables%>.INT_1);\n\t\t\t/*@NonInvalid*/ boolean and;\n\t\t\tif (eq_0) {\n\t\t\t\t/*@Thrown*/ <%org.eclipse.ocl.pivot.values.SetValue.Accumulator%> accumulator_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createSetAccumulatorValue(<%de.mdelab.mlsdm.MlsdmTables%>.SET_CLSSid_ActivityEdge);\n\t\t\t\t<%java.util.Iterator%><<%java.lang.Object%>> ITERATOR_e_1 = BOXED_outgoingEdges.iterator();\n\t\t\t\t/*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.SetValue%> select_0;\n\t\t\t\twhile (true) {\n\t\t\t\t\tif (!ITERATOR_e_1.hasNext()) {\n\t\t\t\t\t\tselect_0 = accumulator_0;\n\t\t\t\t\t\tbreak;\n\t\t\t\t\t}\n\t\t\t\t\t/*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityEdge%> e_1 = (<%de.mdelab.mlsdm.ActivityEdge%>)ITERATOR_e_1.next();\n\t\t\t\t\t/**\n\t\t\t\t\t * e.guardType = ActivityEdgeGuardEnum::BOOLEAN\n\t\t\t\t\t */\n\t\t\t\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityEdgeGuardEnum%> guardType_0 = e_1.getGuardType();\n\t\t\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_guardType_0 = <%de.mdelab.mlsdm.MlsdmTables%>.ENUMid_ActivityEdgeGuardEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(guardType_0.getName()));\n\t\t\t\t\tfinal /*@NonInvalid*/ boolean eq_1 = BOXED_guardType_0 == <%de.mdelab.mlsdm.MlsdmTables%>.ELITid_BOOLEAN;\n\t\t\t\t\t//\n\t\t\t\t\tif (eq_1 == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE) {\n\t\t\t\t\t\taccumulator_0.add(e_1);\n\t\t\t\t\t}\n\t\t\t\t}\n\t\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> size_1 = <%org.eclipse.ocl.pivot.library.collection.CollectionSizeOperation%>.INSTANCE.evaluate(select_0);\n\t\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> diff = (<%org.eclipse.ocl.pivot.values.IntegerValue%>)<%org.eclipse.ocl.pivot.library.numeric.NumericMinusOperation%>.INSTANCE.evaluate(size, <%de.mdelab.mlsdm.MlsdmTables%>.INT_1);\n\t\t\t\tfinal /*@NonInvalid*/ boolean eq_2 = size_1.equals(diff);\n\t\t\t\tand = eq_2;\n\t\t\t}\n\t\t\telse {\n\t\t\t\tand = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t\t}\n\t\t\timplies = and;\n\t\t}\n\t\telse {\n\t\t\timplies = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\t\tif (implies) {\n\t\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tstatus = null;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean eq_3 = status == Boolean.TRUE;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (eq_3) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlsdm.MlsdmTables%>.STR_One_32_of_32_the_32_outgoing_32_edges_32_of_32_decision_32_merge_32_node_32, toString);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlsdm.MlsdmTables%>.STR__32_must_32_have_32_the_32_ELSE_32_guard_44_32_the_32_other_32_edges_32_must_32_have_32_the_32_BOOLEAN);\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlsdm.MlsdmTables%>.TUPLid_, sum_0, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, symbol_1, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getDecisionMergeNode__SingleEdgeGuard__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"DecisionMergeNode::SingleEdgeGuard\";\ntry {\n\t/**\n\t *\n\t * inv SingleEdgeGuard:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if\n\t *             self.outgoingEdges->size() = 1 implies\n\t *             self.outgoingEdges->forAll(e | e.guardType = ActivityEdgeGuardEnum::NONE)\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'Single outgoing edge from decision merge node \' +\n\t *               self.toString() + \' may not have a guard.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.DECISION_MERGE_NODE___SINGLE_EDGE_GUARD__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (le) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.util.List%><<%de.mdelab.mlsdm.ActivityEdge%>> outgoingEdges_0 = this.getOutgoingEdges();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.SetValue%> BOXED_outgoingEdges_0 = idResolver.createSetOfAll(<%de.mdelab.mlsdm.MlsdmTables%>.SET_CLSSid_ActivityEdge, outgoingEdges_0);\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> size = <%org.eclipse.ocl.pivot.library.collection.CollectionSizeOperation%>.INSTANCE.evaluate(BOXED_outgoingEdges_0);\n\t\tfinal /*@NonInvalid*/ boolean eq = size.equals(<%de.mdelab.mlsdm.MlsdmTables%>.INT_1);\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> implies;\n\t\tif (eq) {\n\t\t\t/*@Thrown*/ <%java.lang.Object%> accumulator = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t\t<%java.util.Iterator%><<%java.lang.Object%>> ITERATOR_e_0 = BOXED_outgoingEdges_0.iterator();\n\t\t\t/*@NonInvalid*/ <%java.lang.Boolean%> forAll;\n\t\t\twhile (true) {\n\t\t\t\tif (!ITERATOR_e_0.hasNext()) {\n\t\t\t\t\tif (accumulator == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE) {\n\t\t\t\t\t\tforAll = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t\t\t\t}\n\t\t\t\t\telse {\n\t\t\t\t\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)accumulator;\n\t\t\t\t\t}\n\t\t\t\t\tbreak;\n\t\t\t\t}\n\t\t\t\t/*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityEdge%> e_0 = (<%de.mdelab.mlsdm.ActivityEdge%>)ITERATOR_e_0.next();\n\t\t\t\t/**\n\t\t\t\t * e.guardType = ActivityEdgeGuardEnum::NONE\n\t\t\t\t */\n\t\t\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityEdgeGuardEnum%> guardType = e_0.getGuardType();\n\t\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_guardType = <%de.mdelab.mlsdm.MlsdmTables%>.ENUMid_ActivityEdgeGuardEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(guardType.getName()));\n\t\t\t\tfinal /*@NonInvalid*/ boolean eq_0 = BOXED_guardType == <%de.mdelab.mlsdm.MlsdmTables%>.ELITid_NONE;\n\t\t\t\t//\n\t\t\t\tif (eq_0 == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE) {\t\t\t\t\t// Normal unsuccessful body evaluation result\n\t\t\t\t\tforAll = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t\t\t\tbreak;\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Stop immediately\n\t\t\t\t}\n\t\t\t\telse if (eq_0 == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE) {\t\t\t\t// Normal successful body evaluation result\n\t\t\t\t\t;\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Carry on\n\t\t\t\t}\n\t\t\t\telse {\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Impossible badly typed result\n\t\t\t\t\taccumulator = new <%org.eclipse.ocl.pivot.values.InvalidValueException%>(<%org.eclipse.ocl.pivot.messages.PivotMessages%>.NonBooleanBody, \"forAll\");\n\t\t\t\t}\n\t\t\t}\n\t\t\timplies = forAll;\n\t\t}\n\t\telse {\n\t\t\timplies = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\tif (implies == null) {\n\t\t\tthrow new <%org.eclipse.ocl.pivot.values.InvalidValueException%>(\"Null if condition\");\n\t\t}\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\t\tif (implies) {\n\t\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tstatus = null;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean eq_1 = status == Boolean.TRUE;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (eq_1) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlsdm.MlsdmTables%>.STR_Single_32_outgoing_32_edge_32_from_32_decision_32_merge_32_node_32, toString);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlsdm.MlsdmTables%>.STR__32_may_32_not_32_have_32_a_32_guard);\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlsdm.MlsdmTables%>.TUPLid_, sum_0, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, symbol_1, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getDecisionMergeNode__OutgoingEdge__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"DecisionMergeNode::OutgoingEdge\";\ntry {\n\t/**\n\t *\n\t * inv OutgoingEdge:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if not self.outgoingEdges->isEmpty()\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'Decision merge node \' +\n\t *               self.toString() + \' must have at least one outgoing edge.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.DECISION_MERGE_NODE___OUTGOING_EDGE__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (le) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.util.List%><<%de.mdelab.mlsdm.ActivityEdge%>> outgoingEdges = this.getOutgoingEdges();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.SetValue%> BOXED_outgoingEdges = idResolver.createSetOfAll(<%de.mdelab.mlsdm.MlsdmTables%>.SET_CLSSid_ActivityEdge, outgoingEdges);\n\t\tfinal /*@NonInvalid*/ boolean isEmpty = <%org.eclipse.ocl.pivot.library.collection.CollectionIsEmptyOperation%>.INSTANCE.evaluate(BOXED_outgoingEdges).booleanValue();\n\t\tfinal /*@NonInvalid*/ <%java.lang.Boolean%> not = <%org.eclipse.ocl.pivot.library.logical.BooleanNotOperation%>.INSTANCE.evaluate(isEmpty);\n\t\tif (not == null) {\n\t\t\tthrow new <%org.eclipse.ocl.pivot.values.InvalidValueException%>(\"Null if condition\");\n\t\t}\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\t\tif (not) {\n\t\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tstatus = null;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean eq = status == Boolean.TRUE;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (eq) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlsdm.MlsdmTables%>.STR_Decision_32_merge_32_node_32, toString);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlsdm.MlsdmTables%>.STR__32_must_32_have_32_at_32_least_32_one_32_outgoing_32_edge);\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlsdm.MlsdmTables%>.TUPLid_, sum_0, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, symbol_1, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(forkJoinNodeEClass, source, new String[] { "documentation",
				"ForkJoinNodes are used to fork and join concurrent execution flows." });
		addAnnotation(getForkJoinNode__IncomingEdge__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"ForkJoinNode::IncomingEdge\";\ntry {\n\t/**\n\t *\n\t * inv IncomingEdge:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if not self.incomingEdges->isEmpty()\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'Fork/join node \' +\n\t *               self.toString() + \' must have at least one incoming edge.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.FORK_JOIN_NODE___INCOMING_EDGE__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (le) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.util.List%><<%de.mdelab.mlsdm.ActivityEdge%>> incomingEdges = this.getIncomingEdges();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.SetValue%> BOXED_incomingEdges = idResolver.createSetOfAll(<%de.mdelab.mlsdm.MlsdmTables%>.SET_CLSSid_ActivityEdge, incomingEdges);\n\t\tfinal /*@NonInvalid*/ boolean isEmpty = <%org.eclipse.ocl.pivot.library.collection.CollectionIsEmptyOperation%>.INSTANCE.evaluate(BOXED_incomingEdges).booleanValue();\n\t\tfinal /*@NonInvalid*/ <%java.lang.Boolean%> not = <%org.eclipse.ocl.pivot.library.logical.BooleanNotOperation%>.INSTANCE.evaluate(isEmpty);\n\t\tif (not == null) {\n\t\t\tthrow new <%org.eclipse.ocl.pivot.values.InvalidValueException%>(\"Null if condition\");\n\t\t}\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\t\tif (not) {\n\t\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tstatus = null;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean eq = status == Boolean.TRUE;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (eq) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlsdm.MlsdmTables%>.STR_Fork_s_join_32_node_32, toString);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlsdm.MlsdmTables%>.STR__32_must_32_have_32_at_32_least_32_one_32_incoming_32_edge_0);\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlsdm.MlsdmTables%>.TUPLid_, sum_0, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, symbol_1, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getForkJoinNode__OutgoingEdge__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"ForkJoinNode::OutgoingEdge\";\ntry {\n\t/**\n\t *\n\t * inv OutgoingEdge:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if not self.outgoingEdges->isEmpty()\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'Fork/join node \' +\n\t *               self.toString() + \' must have at least one outgoing edge.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.FORK_JOIN_NODE___OUTGOING_EDGE__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (le) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.util.List%><<%de.mdelab.mlsdm.ActivityEdge%>> outgoingEdges = this.getOutgoingEdges();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.SetValue%> BOXED_outgoingEdges = idResolver.createSetOfAll(<%de.mdelab.mlsdm.MlsdmTables%>.SET_CLSSid_ActivityEdge, outgoingEdges);\n\t\tfinal /*@NonInvalid*/ boolean isEmpty = <%org.eclipse.ocl.pivot.library.collection.CollectionIsEmptyOperation%>.INSTANCE.evaluate(BOXED_outgoingEdges).booleanValue();\n\t\tfinal /*@NonInvalid*/ <%java.lang.Boolean%> not = <%org.eclipse.ocl.pivot.library.logical.BooleanNotOperation%>.INSTANCE.evaluate(isEmpty);\n\t\tif (not == null) {\n\t\t\tthrow new <%org.eclipse.ocl.pivot.values.InvalidValueException%>(\"Null if condition\");\n\t\t}\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\t\tif (not) {\n\t\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tstatus = null;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean eq = status == Boolean.TRUE;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (eq) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlsdm.MlsdmTables%>.STR_Fork_s_join_32_node_32, toString);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlsdm.MlsdmTables%>.STR__32_must_32_have_32_at_32_least_32_one_32_outgoing_32_edge);\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlsdm.MlsdmTables%>.TUPLid_, sum_0, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, symbol_1, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(storyNodeEClass, source, new String[] { "documentation",
				"A StoryNode contains a StoryPattern that is executed. It can have SINGLE_MATCH or FOR_EACH semantics, i.e. only one or all matches are sought. Depending on the semantics, the outgoing edges may have different guards: SUCCESS and FAILURE for SINGLE_MATCH semantics, FOR_EACH and END for FOR_EACH semantics." });
		addAnnotation(getStoryNode__IncomingEdge__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"StoryNode::IncomingEdge\";\ntry {\n\t/**\n\t *\n\t * inv IncomingEdge:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if self.incomingEdges->size() = 1\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else Tuple{message = \'Story node \' +\n\t *               self.toString() + \' must have one incoming edge.\', status = status}\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.STORY_NODE___INCOMING_EDGE__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (le) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.util.List%><<%de.mdelab.mlsdm.ActivityEdge%>> incomingEdges = this.getIncomingEdges();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.SetValue%> BOXED_incomingEdges = idResolver.createSetOfAll(<%de.mdelab.mlsdm.MlsdmTables%>.SET_CLSSid_ActivityEdge, incomingEdges);\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> size = <%org.eclipse.ocl.pivot.library.collection.CollectionSizeOperation%>.INSTANCE.evaluate(BOXED_incomingEdges);\n\t\tfinal /*@NonInvalid*/ boolean eq = size.equals(<%de.mdelab.mlsdm.MlsdmTables%>.INT_1);\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\t\tif (eq) {\n\t\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tstatus = null;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean eq_0 = status == Boolean.TRUE;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (eq_0) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlsdm.MlsdmTables%>.STR_Story_32_node_32, toString);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlsdm.MlsdmTables%>.STR__32_must_32_have_32_one_32_incoming_32_edge);\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlsdm.MlsdmTables%>.TUPLid_, sum_0, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, symbol_1, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getStoryNode__ForEachLoopBody__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"StoryNode::ForEachLoopBody\";\ntry {\n\t/**\n\t *\n\t * inv ForEachLoopBody:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if self.semantics = StoryNodeSemanticsEnum::FOR_EACH_FRESH_MATCH implies\n\t *             self.outgoingEdges->select(e | e.guardType = ActivityEdgeGuardEnum::FOR_EACH)\n\t *             ->forAll(e | e.target.oclIsKindOf(StructuredNode))\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'Loop body of story node \' +\n\t *               self.toString() + \' with FOR_EACH semantics must be contained in a structured node.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.STORY_NODE___FOR_EACH_LOOP_BODY__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (le) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlsdm.StoryNodeSemanticsEnum%> semantics = this.getSemantics();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_semantics = <%de.mdelab.mlsdm.MlsdmTables%>.ENUMid_StoryNodeSemanticsEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(semantics.getName()));\n\t\tfinal /*@NonInvalid*/ boolean eq = BOXED_semantics == <%de.mdelab.mlsdm.MlsdmTables%>.ELITid_FOR_EACH_FRESH_MATCH;\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> implies;\n\t\tif (eq) {\n\t\t\tfinal /*@NonInvalid*/ <%java.util.List%><<%de.mdelab.mlsdm.ActivityEdge%>> outgoingEdges = this.getOutgoingEdges();\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.SetValue%> BOXED_outgoingEdges = idResolver.createSetOfAll(<%de.mdelab.mlsdm.MlsdmTables%>.SET_CLSSid_ActivityEdge, outgoingEdges);\n\t\t\t/*@Thrown*/ <%org.eclipse.ocl.pivot.values.SetValue.Accumulator%> accumulator = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createSetAccumulatorValue(<%de.mdelab.mlsdm.MlsdmTables%>.SET_CLSSid_ActivityEdge);\n\t\t\t<%java.util.Iterator%><<%java.lang.Object%>> ITERATOR_e_0 = BOXED_outgoingEdges.iterator();\n\t\t\t/*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.SetValue%> select;\n\t\t\twhile (true) {\n\t\t\t\tif (!ITERATOR_e_0.hasNext()) {\n\t\t\t\t\tselect = accumulator;\n\t\t\t\t\tbreak;\n\t\t\t\t}\n\t\t\t\t/*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityEdge%> e_0 = (<%de.mdelab.mlsdm.ActivityEdge%>)ITERATOR_e_0.next();\n\t\t\t\t/**\n\t\t\t\t * e.guardType = ActivityEdgeGuardEnum::FOR_EACH\n\t\t\t\t */\n\t\t\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityEdgeGuardEnum%> guardType = e_0.getGuardType();\n\t\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_guardType = <%de.mdelab.mlsdm.MlsdmTables%>.ENUMid_ActivityEdgeGuardEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(guardType.getName()));\n\t\t\t\tfinal /*@NonInvalid*/ boolean eq_0 = BOXED_guardType == <%de.mdelab.mlsdm.MlsdmTables%>.ELITid_FOR_EACH;\n\t\t\t\t//\n\t\t\t\tif (eq_0 == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE) {\n\t\t\t\t\taccumulator.add(e_0);\n\t\t\t\t}\n\t\t\t}\n\t\t\t/*@Thrown*/ <%java.lang.Object%> accumulator_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t\t<%java.util.Iterator%><<%java.lang.Object%>> ITERATOR_e_1 = select.iterator();\n\t\t\t/*@NonInvalid*/ <%java.lang.Boolean%> forAll;\n\t\t\twhile (true) {\n\t\t\t\tif (!ITERATOR_e_1.hasNext()) {\n\t\t\t\t\tif (accumulator_0 == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE) {\n\t\t\t\t\t\tforAll = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t\t\t\t}\n\t\t\t\t\telse {\n\t\t\t\t\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)accumulator_0;\n\t\t\t\t\t}\n\t\t\t\t\tbreak;\n\t\t\t\t}\n\t\t\t\t/*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityEdge%> e_1 = (<%de.mdelab.mlsdm.ActivityEdge%>)ITERATOR_e_1.next();\n\t\t\t\t/**\n\t\t\t\t * e.target.oclIsKindOf(StructuredNode)\n\t\t\t\t */\n\t\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.Class%> TYP_mlsdm_c_c_StructuredNode = idResolver.getClass(<%de.mdelab.mlsdm.MlsdmTables%>.CLSSid_StructuredNode, null);\n\t\t\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityNode%> target = e_1.getTarget();\n\t\t\t\tfinal /*@NonInvalid*/ boolean oclIsKindOf = <%org.eclipse.ocl.pivot.library.oclany.OclAnyOclIsKindOfOperation%>.INSTANCE.evaluate(executor, target, TYP_mlsdm_c_c_StructuredNode).booleanValue();\n\t\t\t\t//\n\t\t\t\tif (oclIsKindOf == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE) {\t\t\t\t\t// Normal unsuccessful body evaluation result\n\t\t\t\t\tforAll = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t\t\t\tbreak;\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Stop immediately\n\t\t\t\t}\n\t\t\t\telse if (oclIsKindOf == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE) {\t\t\t\t// Normal successful body evaluation result\n\t\t\t\t\t;\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Carry on\n\t\t\t\t}\n\t\t\t\telse {\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Impossible badly typed result\n\t\t\t\t\taccumulator_0 = new <%org.eclipse.ocl.pivot.values.InvalidValueException%>(<%org.eclipse.ocl.pivot.messages.PivotMessages%>.NonBooleanBody, \"forAll\");\n\t\t\t\t}\n\t\t\t}\n\t\t\timplies = forAll;\n\t\t}\n\t\telse {\n\t\t\timplies = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\tif (implies == null) {\n\t\t\tthrow new <%org.eclipse.ocl.pivot.values.InvalidValueException%>(\"Null if condition\");\n\t\t}\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\t\tif (implies) {\n\t\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tstatus = null;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean eq_1 = status == Boolean.TRUE;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (eq_1) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlsdm.MlsdmTables%>.STR_Loop_32_body_32_of_32_story_32_node_32, toString);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlsdm.MlsdmTables%>.STR__32_with_32_FOR_EACH_32_semantics_32_must_32_be_32_contained_32_in_32_a_32_structured_32_node);\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlsdm.MlsdmTables%>.TUPLid_, sum_0, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, symbol_1, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getStoryNode__StoryPatternSpecified__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"StoryNode::StoryPatternSpecified\";\ntry {\n\t/**\n\t *\n\t * inv StoryPatternSpecified:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if self.storyPattern <> null\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else Tuple{message = \'Story node \' +\n\t *               self.toString() + \' must contain a story pattern.\', status = status}\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.STORY_NODE___STORY_PATTERN_SPECIFIED__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_0;\n\tif (le) {\n\t\tsymbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_0 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_0;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getStoryNode__SemanticsSpecified__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"StoryNode::SemanticsSpecified\";\ntry {\n\t/**\n\t *\n\t * inv SemanticsSpecified:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if self.semantics <> null\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'Semantics of story node \' +\n\t *               self.toString() + \' must be specified.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.STORY_NODE___SEMANTICS_SPECIFIED__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_0;\n\tif (le) {\n\t\tsymbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_0 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_0;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getStoryNode__ForEachMatchOutgoingEdges__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"StoryNode::ForEachMatchOutgoingEdges\";\ntry {\n\t/**\n\t *\n\t * inv ForEachMatchOutgoingEdges:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if self.semantics = StoryNodeSemanticsEnum::FOR_EACH_FRESH_MATCH implies\n\t *             self.outgoingEdges->size() = 1 and\n\t *             self.outgoingEdges->exists(e | e.guardType = ActivityEdgeGuardEnum::END) or\n\t *             self.outgoingEdges->size() = 2 and\n\t *             self.outgoingEdges->exists(e | e.guardType = ActivityEdgeGuardEnum::END) and\n\t *             self.outgoingEdges->exists(e | e.guardType = ActivityEdgeGuardEnum::FOR_EACH)\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'Story node \' +\n\t *               self.toString() + \' with FOR_EACH semantics must have one outgoing edge with the END guard. It may also have another outgoing edge with the FOR_EACH guard leading to a structured node, which contains the loop body.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.STORY_NODE___FOR_EACH_MATCH_OUTGOING_EDGES__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (le) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlsdm.StoryNodeSemanticsEnum%> semantics = this.getSemantics();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_semantics = <%de.mdelab.mlsdm.MlsdmTables%>.ENUMid_StoryNodeSemanticsEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(semantics.getName()));\n\t\tfinal /*@NonInvalid*/ boolean eq = BOXED_semantics == <%de.mdelab.mlsdm.MlsdmTables%>.ELITid_FOR_EACH_FRESH_MATCH;\n\t\t/*@Thrown*/ <%java.lang.Boolean%> implies;\n\t\tif (eq) {\n\t\t\tfinal /*@NonInvalid*/ <%java.util.List%><<%de.mdelab.mlsdm.ActivityEdge%>> outgoingEdges_0 = this.getOutgoingEdges();\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.SetValue%> BOXED_outgoingEdges_0 = idResolver.createSetOfAll(<%de.mdelab.mlsdm.MlsdmTables%>.SET_CLSSid_ActivityEdge, outgoingEdges_0);\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> size = <%org.eclipse.ocl.pivot.library.collection.CollectionSizeOperation%>.INSTANCE.evaluate(BOXED_outgoingEdges_0);\n\t\t\tfinal /*@NonInvalid*/ boolean eq_0 = size.equals(<%de.mdelab.mlsdm.MlsdmTables%>.INT_1);\n\t\t\t/*@NonInvalid*/ <%java.lang.Boolean%> and;\n\t\t\tif (eq_0) {\n\t\t\t\t/*@Thrown*/ <%java.lang.Object%> accumulator = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t\t\t<%java.util.Iterator%><<%java.lang.Object%>> ITERATOR_e_0 = BOXED_outgoingEdges_0.iterator();\n\t\t\t\t/*@NonInvalid*/ <%java.lang.Boolean%> exists;\n\t\t\t\twhile (true) {\n\t\t\t\t\tif (!ITERATOR_e_0.hasNext()) {\n\t\t\t\t\t\tif (accumulator == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE) {\n\t\t\t\t\t\t\texists = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t\t\t\t\t}\n\t\t\t\t\t\telse {\n\t\t\t\t\t\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)accumulator;\n\t\t\t\t\t\t}\n\t\t\t\t\t\tbreak;\n\t\t\t\t\t}\n\t\t\t\t\t/*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityEdge%> e_0 = (<%de.mdelab.mlsdm.ActivityEdge%>)ITERATOR_e_0.next();\n\t\t\t\t\t/**\n\t\t\t\t\t * e.guardType = ActivityEdgeGuardEnum::END\n\t\t\t\t\t */\n\t\t\t\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityEdgeGuardEnum%> guardType = e_0.getGuardType();\n\t\t\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_guardType = <%de.mdelab.mlsdm.MlsdmTables%>.ENUMid_ActivityEdgeGuardEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(guardType.getName()));\n\t\t\t\t\tfinal /*@NonInvalid*/ boolean eq_1 = BOXED_guardType == <%de.mdelab.mlsdm.MlsdmTables%>.ELITid_END;\n\t\t\t\t\t//\n\t\t\t\t\tif (eq_1 == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE) {\t\t\t\t\t// Normal successful body evaluation result\n\t\t\t\t\t\texists = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t\t\t\t\tbreak;\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Stop immediately\n\t\t\t\t\t}\n\t\t\t\t\telse if (eq_1 == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE) {\t\t\t\t// Normal unsuccessful body evaluation result\n\t\t\t\t\t\t;\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Carry on\n\t\t\t\t\t}\n\t\t\t\t\telse {\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Impossible badly typed result\n\t\t\t\t\t\taccumulator = new <%org.eclipse.ocl.pivot.values.InvalidValueException%>(<%org.eclipse.ocl.pivot.messages.PivotMessages%>.NonBooleanBody, \"exists\");\n\t\t\t\t\t}\n\t\t\t\t}\n\t\t\t\tand = exists;\n\t\t\t}\n\t\t\telse {\n\t\t\t\tand = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t\t}\n\t\t\t/*@Caught*/ <%java.lang.Object%> CAUGHT_and_1;\n\t\t\ttry {\n\t\t\t\tfinal /*@NonInvalid*/ boolean eq_2 = size.equals(<%de.mdelab.mlsdm.MlsdmTables%>.INT_2);\n\t\t\t\t/*@NonInvalid*/ <%java.lang.Boolean%> and_0;\n\t\t\t\tif (eq_2) {\n\t\t\t\t\t/*@Thrown*/ <%java.lang.Object%> accumulator_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t\t\t\t<%java.util.Iterator%><<%java.lang.Object%>> ITERATOR_e_1 = BOXED_outgoingEdges_0.iterator();\n\t\t\t\t\t/*@NonInvalid*/ <%java.lang.Boolean%> exists_0;\n\t\t\t\t\twhile (true) {\n\t\t\t\t\t\tif (!ITERATOR_e_1.hasNext()) {\n\t\t\t\t\t\t\tif (accumulator_0 == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE) {\n\t\t\t\t\t\t\t\texists_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\telse {\n\t\t\t\t\t\t\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)accumulator_0;\n\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\tbreak;\n\t\t\t\t\t\t}\n\t\t\t\t\t\t/*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityEdge%> e_1 = (<%de.mdelab.mlsdm.ActivityEdge%>)ITERATOR_e_1.next();\n\t\t\t\t\t\t/**\n\t\t\t\t\t\t * e.guardType = ActivityEdgeGuardEnum::END\n\t\t\t\t\t\t */\n\t\t\t\t\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityEdgeGuardEnum%> guardType_0 = e_1.getGuardType();\n\t\t\t\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_guardType_0 = <%de.mdelab.mlsdm.MlsdmTables%>.ENUMid_ActivityEdgeGuardEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(guardType_0.getName()));\n\t\t\t\t\t\tfinal /*@NonInvalid*/ boolean eq_3 = BOXED_guardType_0 == <%de.mdelab.mlsdm.MlsdmTables%>.ELITid_END;\n\t\t\t\t\t\t//\n\t\t\t\t\t\tif (eq_3 == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE) {\t\t\t\t\t// Normal successful body evaluation result\n\t\t\t\t\t\t\texists_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t\t\t\t\t\tbreak;\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Stop immediately\n\t\t\t\t\t\t}\n\t\t\t\t\t\telse if (eq_3 == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE) {\t\t\t\t// Normal unsuccessful body evaluation result\n\t\t\t\t\t\t\t;\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Carry on\n\t\t\t\t\t\t}\n\t\t\t\t\t\telse {\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Impossible badly typed result\n\t\t\t\t\t\t\taccumulator_0 = new <%org.eclipse.ocl.pivot.values.InvalidValueException%>(<%org.eclipse.ocl.pivot.messages.PivotMessages%>.NonBooleanBody, \"exists\");\n\t\t\t\t\t\t}\n\t\t\t\t\t}\n\t\t\t\t\tand_0 = exists_0;\n\t\t\t\t}\n\t\t\t\telse {\n\t\t\t\t\tand_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t\t\t}\n\t\t\t\t/*@Thrown*/ <%java.lang.Object%> accumulator_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t\t\t<%java.util.Iterator%><<%java.lang.Object%>> ITERATOR_e_2 = BOXED_outgoingEdges_0.iterator();\n\t\t\t\t/*@NonInvalid*/ <%java.lang.Boolean%> exists_1;\n\t\t\t\twhile (true) {\n\t\t\t\t\tif (!ITERATOR_e_2.hasNext()) {\n\t\t\t\t\t\tif (accumulator_1 == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE) {\n\t\t\t\t\t\t\texists_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t\t\t\t\t}\n\t\t\t\t\t\telse {\n\t\t\t\t\t\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)accumulator_1;\n\t\t\t\t\t\t}\n\t\t\t\t\t\tbreak;\n\t\t\t\t\t}\n\t\t\t\t\t/*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityEdge%> e_2 = (<%de.mdelab.mlsdm.ActivityEdge%>)ITERATOR_e_2.next();\n\t\t\t\t\t/**\n\t\t\t\t\t * e.guardType = ActivityEdgeGuardEnum::FOR_EACH\n\t\t\t\t\t */\n\t\t\t\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityEdgeGuardEnum%> guardType_1 = e_2.getGuardType();\n\t\t\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_guardType_1 = <%de.mdelab.mlsdm.MlsdmTables%>.ENUMid_ActivityEdgeGuardEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(guardType_1.getName()));\n\t\t\t\t\tfinal /*@NonInvalid*/ boolean eq_4 = BOXED_guardType_1 == <%de.mdelab.mlsdm.MlsdmTables%>.ELITid_FOR_EACH;\n\t\t\t\t\t//\n\t\t\t\t\tif (eq_4 == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE) {\t\t\t\t\t// Normal successful body evaluation result\n\t\t\t\t\t\texists_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t\t\t\t\tbreak;\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Stop immediately\n\t\t\t\t\t}\n\t\t\t\t\telse if (eq_4 == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE) {\t\t\t\t// Normal unsuccessful body evaluation result\n\t\t\t\t\t\t;\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Carry on\n\t\t\t\t\t}\n\t\t\t\t\telse {\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Impossible badly typed result\n\t\t\t\t\t\taccumulator_1 = new <%org.eclipse.ocl.pivot.values.InvalidValueException%>(<%org.eclipse.ocl.pivot.messages.PivotMessages%>.NonBooleanBody, \"exists\");\n\t\t\t\t\t}\n\t\t\t\t}\n\t\t\t\tfinal /*@Thrown*/ <%java.lang.Boolean%> and_1 = <%org.eclipse.ocl.pivot.library.logical.BooleanAndOperation%>.INSTANCE.evaluate(and_0, exists_1);\n\t\t\t\tCAUGHT_and_1 = and_1;\n\t\t\t}\n\t\t\tcatch (<%java.lang.Exception%> e) {\n\t\t\t\tCAUGHT_and_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t\t\t}\n\t\t\tfinal /*@Thrown*/ <%java.lang.Boolean%> or = <%org.eclipse.ocl.pivot.library.logical.BooleanOrOperation%>.INSTANCE.evaluate(and, CAUGHT_and_1);\n\t\t\timplies = or;\n\t\t}\n\t\telse {\n\t\t\timplies = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\tif (implies == null) {\n\t\t\tthrow new <%org.eclipse.ocl.pivot.values.InvalidValueException%>(\"Null if condition\");\n\t\t}\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\t\tif (implies) {\n\t\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tstatus = null;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean eq_5 = status == Boolean.TRUE;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (eq_5) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlsdm.MlsdmTables%>.STR_Story_32_node_32, toString);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlsdm.MlsdmTables%>.STR__32_with_32_FOR_EACH_32_semantics_32_must_32_have_32_one_32_outgoing_32_edge_32_with_32_the_32_EN);\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlsdm.MlsdmTables%>.TUPLid_, sum_0, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, symbol_1, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getStoryNode__SingleMatchOutgoingEdges__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"StoryNode::SingleMatchOutgoingEdges\";\ntry {\n\t/**\n\t *\n\t * inv SingleMatchOutgoingEdges:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if self.semantics = StoryNodeSemanticsEnum::SINGLE_MATCH implies\n\t *             self.outgoingEdges->size() = 1 and\n\t *             self.outgoingEdges->forAll(e | e.guardType = ActivityEdgeGuardEnum::NONE) or\n\t *             self.outgoingEdges->size() = 2 and\n\t *             self.outgoingEdges->exists(e | e.guardType = ActivityEdgeGuardEnum::SUCCESS) and\n\t *             self.outgoingEdges->exists(e | e.guardType = ActivityEdgeGuardEnum::FAILURE)\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'Story node \' +\n\t *               self.toString() + \' with SINGLE_MATCH semantics must have one outgoing edge with no guard or two outgoing edges with SUCCESS and FAILURE guards.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.STORY_NODE___SINGLE_MATCH_OUTGOING_EDGES__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (le) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlsdm.StoryNodeSemanticsEnum%> semantics = this.getSemantics();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_semantics = <%de.mdelab.mlsdm.MlsdmTables%>.ENUMid_StoryNodeSemanticsEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(semantics.getName()));\n\t\tfinal /*@NonInvalid*/ boolean eq = BOXED_semantics == <%de.mdelab.mlsdm.MlsdmTables%>.ELITid_SINGLE_MATCH;\n\t\t/*@Thrown*/ <%java.lang.Boolean%> implies;\n\t\tif (eq) {\n\t\t\tfinal /*@NonInvalid*/ <%java.util.List%><<%de.mdelab.mlsdm.ActivityEdge%>> outgoingEdges_0 = this.getOutgoingEdges();\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.SetValue%> BOXED_outgoingEdges_0 = idResolver.createSetOfAll(<%de.mdelab.mlsdm.MlsdmTables%>.SET_CLSSid_ActivityEdge, outgoingEdges_0);\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> size = <%org.eclipse.ocl.pivot.library.collection.CollectionSizeOperation%>.INSTANCE.evaluate(BOXED_outgoingEdges_0);\n\t\t\tfinal /*@NonInvalid*/ boolean eq_0 = size.equals(<%de.mdelab.mlsdm.MlsdmTables%>.INT_1);\n\t\t\t/*@NonInvalid*/ <%java.lang.Boolean%> and;\n\t\t\tif (eq_0) {\n\t\t\t\t/*@Thrown*/ <%java.lang.Object%> accumulator = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t\t\t<%java.util.Iterator%><<%java.lang.Object%>> ITERATOR_e_0 = BOXED_outgoingEdges_0.iterator();\n\t\t\t\t/*@NonInvalid*/ <%java.lang.Boolean%> forAll;\n\t\t\t\twhile (true) {\n\t\t\t\t\tif (!ITERATOR_e_0.hasNext()) {\n\t\t\t\t\t\tif (accumulator == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE) {\n\t\t\t\t\t\t\tforAll = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t\t\t\t\t}\n\t\t\t\t\t\telse {\n\t\t\t\t\t\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)accumulator;\n\t\t\t\t\t\t}\n\t\t\t\t\t\tbreak;\n\t\t\t\t\t}\n\t\t\t\t\t/*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityEdge%> e_0 = (<%de.mdelab.mlsdm.ActivityEdge%>)ITERATOR_e_0.next();\n\t\t\t\t\t/**\n\t\t\t\t\t * e.guardType = ActivityEdgeGuardEnum::NONE\n\t\t\t\t\t */\n\t\t\t\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityEdgeGuardEnum%> guardType = e_0.getGuardType();\n\t\t\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_guardType = <%de.mdelab.mlsdm.MlsdmTables%>.ENUMid_ActivityEdgeGuardEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(guardType.getName()));\n\t\t\t\t\tfinal /*@NonInvalid*/ boolean eq_1 = BOXED_guardType == <%de.mdelab.mlsdm.MlsdmTables%>.ELITid_NONE;\n\t\t\t\t\t//\n\t\t\t\t\tif (eq_1 == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE) {\t\t\t\t\t// Normal unsuccessful body evaluation result\n\t\t\t\t\t\tforAll = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t\t\t\t\tbreak;\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Stop immediately\n\t\t\t\t\t}\n\t\t\t\t\telse if (eq_1 == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE) {\t\t\t\t// Normal successful body evaluation result\n\t\t\t\t\t\t;\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Carry on\n\t\t\t\t\t}\n\t\t\t\t\telse {\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Impossible badly typed result\n\t\t\t\t\t\taccumulator = new <%org.eclipse.ocl.pivot.values.InvalidValueException%>(<%org.eclipse.ocl.pivot.messages.PivotMessages%>.NonBooleanBody, \"forAll\");\n\t\t\t\t\t}\n\t\t\t\t}\n\t\t\t\tand = forAll;\n\t\t\t}\n\t\t\telse {\n\t\t\t\tand = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t\t}\n\t\t\t/*@Caught*/ <%java.lang.Object%> CAUGHT_and_1;\n\t\t\ttry {\n\t\t\t\tfinal /*@NonInvalid*/ boolean eq_2 = size.equals(<%de.mdelab.mlsdm.MlsdmTables%>.INT_2);\n\t\t\t\t/*@NonInvalid*/ <%java.lang.Boolean%> and_0;\n\t\t\t\tif (eq_2) {\n\t\t\t\t\t/*@Thrown*/ <%java.lang.Object%> accumulator_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t\t\t\t<%java.util.Iterator%><<%java.lang.Object%>> ITERATOR_e_1 = BOXED_outgoingEdges_0.iterator();\n\t\t\t\t\t/*@NonInvalid*/ <%java.lang.Boolean%> exists;\n\t\t\t\t\twhile (true) {\n\t\t\t\t\t\tif (!ITERATOR_e_1.hasNext()) {\n\t\t\t\t\t\t\tif (accumulator_0 == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE) {\n\t\t\t\t\t\t\t\texists = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\telse {\n\t\t\t\t\t\t\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)accumulator_0;\n\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\tbreak;\n\t\t\t\t\t\t}\n\t\t\t\t\t\t/*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityEdge%> e_1 = (<%de.mdelab.mlsdm.ActivityEdge%>)ITERATOR_e_1.next();\n\t\t\t\t\t\t/**\n\t\t\t\t\t\t * e.guardType = ActivityEdgeGuardEnum::SUCCESS\n\t\t\t\t\t\t */\n\t\t\t\t\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityEdgeGuardEnum%> guardType_0 = e_1.getGuardType();\n\t\t\t\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_guardType_0 = <%de.mdelab.mlsdm.MlsdmTables%>.ENUMid_ActivityEdgeGuardEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(guardType_0.getName()));\n\t\t\t\t\t\tfinal /*@NonInvalid*/ boolean eq_3 = BOXED_guardType_0 == <%de.mdelab.mlsdm.MlsdmTables%>.ELITid_SUCCESS;\n\t\t\t\t\t\t//\n\t\t\t\t\t\tif (eq_3 == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE) {\t\t\t\t\t// Normal successful body evaluation result\n\t\t\t\t\t\t\texists = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t\t\t\t\t\tbreak;\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Stop immediately\n\t\t\t\t\t\t}\n\t\t\t\t\t\telse if (eq_3 == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE) {\t\t\t\t// Normal unsuccessful body evaluation result\n\t\t\t\t\t\t\t;\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Carry on\n\t\t\t\t\t\t}\n\t\t\t\t\t\telse {\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Impossible badly typed result\n\t\t\t\t\t\t\taccumulator_0 = new <%org.eclipse.ocl.pivot.values.InvalidValueException%>(<%org.eclipse.ocl.pivot.messages.PivotMessages%>.NonBooleanBody, \"exists\");\n\t\t\t\t\t\t}\n\t\t\t\t\t}\n\t\t\t\t\tand_0 = exists;\n\t\t\t\t}\n\t\t\t\telse {\n\t\t\t\t\tand_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t\t\t}\n\t\t\t\t/*@Thrown*/ <%java.lang.Object%> accumulator_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t\t\t<%java.util.Iterator%><<%java.lang.Object%>> ITERATOR_e_2 = BOXED_outgoingEdges_0.iterator();\n\t\t\t\t/*@NonInvalid*/ <%java.lang.Boolean%> exists_0;\n\t\t\t\twhile (true) {\n\t\t\t\t\tif (!ITERATOR_e_2.hasNext()) {\n\t\t\t\t\t\tif (accumulator_1 == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE) {\n\t\t\t\t\t\t\texists_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t\t\t\t\t}\n\t\t\t\t\t\telse {\n\t\t\t\t\t\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)accumulator_1;\n\t\t\t\t\t\t}\n\t\t\t\t\t\tbreak;\n\t\t\t\t\t}\n\t\t\t\t\t/*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityEdge%> e_2 = (<%de.mdelab.mlsdm.ActivityEdge%>)ITERATOR_e_2.next();\n\t\t\t\t\t/**\n\t\t\t\t\t * e.guardType = ActivityEdgeGuardEnum::FAILURE\n\t\t\t\t\t */\n\t\t\t\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityEdgeGuardEnum%> guardType_1 = e_2.getGuardType();\n\t\t\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.EnumerationLiteralId%> BOXED_guardType_1 = <%de.mdelab.mlsdm.MlsdmTables%>.ENUMid_ActivityEdgeGuardEnum.getEnumerationLiteralId(<%org.eclipse.ocl.pivot.utilities.ClassUtil%>.nonNullState(guardType_1.getName()));\n\t\t\t\t\tfinal /*@NonInvalid*/ boolean eq_4 = BOXED_guardType_1 == <%de.mdelab.mlsdm.MlsdmTables%>.ELITid_FAILURE;\n\t\t\t\t\t//\n\t\t\t\t\tif (eq_4 == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE) {\t\t\t\t\t// Normal successful body evaluation result\n\t\t\t\t\t\texists_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t\t\t\t\tbreak;\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Stop immediately\n\t\t\t\t\t}\n\t\t\t\t\telse if (eq_4 == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE) {\t\t\t\t// Normal unsuccessful body evaluation result\n\t\t\t\t\t\t;\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Carry on\n\t\t\t\t\t}\n\t\t\t\t\telse {\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Impossible badly typed result\n\t\t\t\t\t\taccumulator_1 = new <%org.eclipse.ocl.pivot.values.InvalidValueException%>(<%org.eclipse.ocl.pivot.messages.PivotMessages%>.NonBooleanBody, \"exists\");\n\t\t\t\t\t}\n\t\t\t\t}\n\t\t\t\tfinal /*@Thrown*/ <%java.lang.Boolean%> and_1 = <%org.eclipse.ocl.pivot.library.logical.BooleanAndOperation%>.INSTANCE.evaluate(and_0, exists_0);\n\t\t\t\tCAUGHT_and_1 = and_1;\n\t\t\t}\n\t\t\tcatch (<%java.lang.Exception%> e) {\n\t\t\t\tCAUGHT_and_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t\t\t}\n\t\t\tfinal /*@Thrown*/ <%java.lang.Boolean%> or = <%org.eclipse.ocl.pivot.library.logical.BooleanOrOperation%>.INSTANCE.evaluate(and, CAUGHT_and_1);\n\t\t\timplies = or;\n\t\t}\n\t\telse {\n\t\t\timplies = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\tif (implies == null) {\n\t\t\tthrow new <%org.eclipse.ocl.pivot.values.InvalidValueException%>(\"Null if condition\");\n\t\t}\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\t\tif (implies) {\n\t\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tstatus = null;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean eq_5 = status == Boolean.TRUE;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (eq_5) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlsdm.MlsdmTables%>.STR_Story_32_node_32, toString);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlsdm.MlsdmTables%>.STR__32_with_32_SINGLE_MATCH_32_semantics_32_must_32_have_32_one_32_outgoing_32_edge_32_with_32_no);\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlsdm.MlsdmTables%>.TUPLid_, sum_0, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, symbol_1, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getStoryNode_StoryPattern(), source, new String[] { "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!StoryNode!storyPattern" });
		addAnnotation(getStoryNode_Semantics(), source, new String[] { "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!StoryNode!semantics" });
		addAnnotation(structuredNodeEClass, source, new String[] { "documentation",
				"A StructuredNode contains other activity nodes. It should be used to group, e.g., nodes that belong to the body of a loop. This avoids modeling errors." });
		addAnnotation(getStructuredNode__InitialNodeContained__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"StructuredNode::InitialNodeContained\";\ntry {\n\t/**\n\t *\n\t * inv InitialNodeContained:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if\n\t *             self.nodes->exists(e | e.oclIsKindOf(InitialNode))\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'Structured node \' +\n\t *               self.toString() + \' must contain an initial node.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.STRUCTURED_NODE___INITIAL_NODE_CONTAINED__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (le) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.util.List%><<%de.mdelab.mlsdm.ActivityNode%>> nodes = this.getNodes();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.SetValue%> BOXED_nodes = idResolver.createSetOfAll(<%de.mdelab.mlsdm.MlsdmTables%>.SET_CLSSid_ActivityNode, nodes);\n\t\t/*@Thrown*/ <%java.lang.Object%> accumulator = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t<%java.util.Iterator%><<%java.lang.Object%>> ITERATOR_e_0 = BOXED_nodes.iterator();\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> exists;\n\t\twhile (true) {\n\t\t\tif (!ITERATOR_e_0.hasNext()) {\n\t\t\t\tif (accumulator == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE) {\n\t\t\t\t\texists = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t\t\t}\n\t\t\t\telse {\n\t\t\t\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)accumulator;\n\t\t\t\t}\n\t\t\t\tbreak;\n\t\t\t}\n\t\t\t/*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityNode%> e_0 = (<%de.mdelab.mlsdm.ActivityNode%>)ITERATOR_e_0.next();\n\t\t\t/**\n\t\t\t * e.oclIsKindOf(InitialNode)\n\t\t\t */\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.Class%> TYP_mlsdm_c_c_InitialNode_0 = idResolver.getClass(<%de.mdelab.mlsdm.MlsdmTables%>.CLSSid_InitialNode, null);\n\t\t\tfinal /*@NonInvalid*/ boolean oclIsKindOf = <%org.eclipse.ocl.pivot.library.oclany.OclAnyOclIsKindOfOperation%>.INSTANCE.evaluate(executor, e_0, TYP_mlsdm_c_c_InitialNode_0).booleanValue();\n\t\t\t//\n\t\t\tif (oclIsKindOf == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE) {\t\t\t\t\t// Normal successful body evaluation result\n\t\t\t\texists = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t\t\tbreak;\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Stop immediately\n\t\t\t}\n\t\t\telse if (oclIsKindOf == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE) {\t\t\t\t// Normal unsuccessful body evaluation result\n\t\t\t\t;\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Carry on\n\t\t\t}\n\t\t\telse {\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Impossible badly typed result\n\t\t\t\taccumulator = new <%org.eclipse.ocl.pivot.values.InvalidValueException%>(<%org.eclipse.ocl.pivot.messages.PivotMessages%>.NonBooleanBody, \"exists\");\n\t\t\t}\n\t\t}\n\t\tif (exists == null) {\n\t\t\tthrow new <%org.eclipse.ocl.pivot.values.InvalidValueException%>(\"Null if condition\");\n\t\t}\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\t\tif (exists) {\n\t\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tstatus = null;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean eq = status == Boolean.TRUE;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (eq) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlsdm.MlsdmTables%>.STR_Structured_32_node_32, toString);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlsdm.MlsdmTables%>.STR__32_must_32_contain_32_an_32_initial_32_node);\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlsdm.MlsdmTables%>.TUPLid_, sum_0, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, symbol_1, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getStructuredNode__FinalNodeContained__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"StructuredNode::FinalNodeContained\";\ntry {\n\t/**\n\t *\n\t * inv FinalNodeContained:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if\n\t *             self.nodes->exists(e |\n\t *               e.oclIsKindOf(FlowFinalNode) or\n\t *               e.oclIsKindOf(ActivityFinalNode))\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'Structured node \' +\n\t *               self.toString() + \' must contain an flow final node or an activity final node.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.STRUCTURED_NODE___FINAL_NODE_CONTAINED__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (le) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.util.List%><<%de.mdelab.mlsdm.ActivityNode%>> nodes = this.getNodes();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.SetValue%> BOXED_nodes = idResolver.createSetOfAll(<%de.mdelab.mlsdm.MlsdmTables%>.SET_CLSSid_ActivityNode, nodes);\n\t\t/*@Thrown*/ <%java.lang.Object%> accumulator = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t<%java.util.Iterator%><<%java.lang.Object%>> ITERATOR_e_0 = BOXED_nodes.iterator();\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> exists;\n\t\twhile (true) {\n\t\t\tif (!ITERATOR_e_0.hasNext()) {\n\t\t\t\tif (accumulator == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE) {\n\t\t\t\t\texists = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t\t\t}\n\t\t\t\telse {\n\t\t\t\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)accumulator;\n\t\t\t\t}\n\t\t\t\tbreak;\n\t\t\t}\n\t\t\t/*@NonInvalid*/ <%de.mdelab.mlsdm.ActivityNode%> e_0 = (<%de.mdelab.mlsdm.ActivityNode%>)ITERATOR_e_0.next();\n\t\t\t/**\n\t\t\t *\n\t\t\t * e.oclIsKindOf(FlowFinalNode) or\n\t\t\t * e.oclIsKindOf(ActivityFinalNode)\n\t\t\t */\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.Class%> TYP_mlsdm_c_c_FlowFinalNode = idResolver.getClass(<%de.mdelab.mlsdm.MlsdmTables%>.CLSSid_FlowFinalNode, null);\n\t\t\tfinal /*@NonInvalid*/ boolean oclIsKindOf = <%org.eclipse.ocl.pivot.library.oclany.OclAnyOclIsKindOfOperation%>.INSTANCE.evaluate(executor, e_0, TYP_mlsdm_c_c_FlowFinalNode).booleanValue();\n\t\t\t/*@NonInvalid*/ boolean or;\n\t\t\tif (oclIsKindOf) {\n\t\t\t\tor = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t\t}\n\t\t\telse {\n\t\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.Class%> TYP_mlsdm_c_c_ActivityFinalNode_0 = idResolver.getClass(<%de.mdelab.mlsdm.MlsdmTables%>.CLSSid_ActivityFinalNode, null);\n\t\t\t\tfinal /*@NonInvalid*/ boolean oclIsKindOf_0 = <%org.eclipse.ocl.pivot.library.oclany.OclAnyOclIsKindOfOperation%>.INSTANCE.evaluate(executor, e_0, TYP_mlsdm_c_c_ActivityFinalNode_0).booleanValue();\n\t\t\t\tor = oclIsKindOf_0;\n\t\t\t}\n\t\t\t//\n\t\t\tif (or == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE) {\t\t\t\t\t// Normal successful body evaluation result\n\t\t\t\texists = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t\t\tbreak;\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Stop immediately\n\t\t\t}\n\t\t\telse if (or == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE) {\t\t\t\t// Normal unsuccessful body evaluation result\n\t\t\t\t;\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Carry on\n\t\t\t}\n\t\t\telse {\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Impossible badly typed result\n\t\t\t\taccumulator = new <%org.eclipse.ocl.pivot.values.InvalidValueException%>(<%org.eclipse.ocl.pivot.messages.PivotMessages%>.NonBooleanBody, \"exists\");\n\t\t\t}\n\t\t}\n\t\tif (exists == null) {\n\t\t\tthrow new <%org.eclipse.ocl.pivot.values.InvalidValueException%>(\"Null if condition\");\n\t\t}\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\t\tif (exists) {\n\t\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tstatus = null;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean eq = status == Boolean.TRUE;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (eq) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlsdm.MlsdmTables%>.STR_Structured_32_node_32, toString);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlsdm.MlsdmTables%>.STR__32_must_32_contain_32_an_32_flow_32_final_32_node_32_or_32_an_32_activity_32_final_32_node);\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlsdm.MlsdmTables%>.TUPLid_, sum_0, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, symbol_1, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(semaphoreEClass, source, new String[] { "documentation",
				"A semaphore is used to control access to shared resources by concurrent threads. AcquireEdges take tokens from a Semaphore when the ActivityEdge of the AcquireEdge is executed. A ReleaseEdge does the opposite, i.e., when its ActivityEdge is executed, tokens are put back to the semaphore." });
		addAnnotation(getSemaphore__TokenCountNotNegative__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"Semaphore::TokenCountNotNegative\";\ntry {\n\t/**\n\t *\n\t * inv TokenCountNotNegative:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if self.tokenCount >= 0\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'Token count of semaphore \' +\n\t *               self.toString() + \' may not be negative.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.SEMAPHORE___TOKEN_COUNT_NOT_NEGATIVE__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (le) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ int tokenCount = this.getTokenCount();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> BOXED_tokenCount = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.integerValueOf(tokenCount);\n\t\tfinal /*@NonInvalid*/ boolean ge = <%org.eclipse.ocl.pivot.library.oclany.OclComparableGreaterThanEqualOperation%>.INSTANCE.evaluate(executor, BOXED_tokenCount, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\t\tif (ge) {\n\t\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tstatus = null;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean eq = status == Boolean.TRUE;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (eq) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlsdm.MlsdmTables%>.STR_Token_32_count_32_of_32_semaphore_32, toString);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlsdm.MlsdmTables%>.STR__32_may_32_not_32_be_32_negative);\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlsdm.MlsdmTables%>.TUPLid_, sum_0, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, symbol_1, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getSemaphore__ReleaseEdge__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"Semaphore::ReleaseEdge\";\ntry {\n\t/**\n\t *\n\t * inv ReleaseEdge:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if self.releaseEdges->size() > 0\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'Semaphore \' +\n\t *               self.toString() + \' must have at least one release edge.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.SEMAPHORE___RELEASE_EDGE__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (le) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.util.List%><<%de.mdelab.mlsdm.ReleaseEdge%>> releaseEdges = this.getReleaseEdges();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.SetValue%> BOXED_releaseEdges = idResolver.createSetOfAll(<%de.mdelab.mlsdm.MlsdmTables%>.SET_CLSSid_ReleaseEdge, releaseEdges);\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> size = <%org.eclipse.ocl.pivot.library.collection.CollectionSizeOperation%>.INSTANCE.evaluate(BOXED_releaseEdges);\n\t\tfinal /*@NonInvalid*/ boolean gt = <%org.eclipse.ocl.pivot.library.oclany.OclComparableGreaterThanOperation%>.INSTANCE.evaluate(executor, size, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\t\tif (gt) {\n\t\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tstatus = null;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean eq = status == Boolean.TRUE;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (eq) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlsdm.MlsdmTables%>.STR_Semaphore_32, toString);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlsdm.MlsdmTables%>.STR__32_must_32_have_32_at_32_least_32_one_32_release_32_edge);\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlsdm.MlsdmTables%>.TUPLid_, sum_0, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, symbol_1, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getSemaphore__AcquireEdge__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"Semaphore::AcquireEdge\";\ntry {\n\t/**\n\t *\n\t * inv AcquireEdge:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if self.acquireEdges->size() > 0\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'Semaphore \' +\n\t *               self.toString() + \' must have at least one acquire edge.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.SEMAPHORE___ACQUIRE_EDGE__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (le) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.util.List%><<%de.mdelab.mlsdm.AcquireEdge%>> acquireEdges = this.getAcquireEdges();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.SetValue%> BOXED_acquireEdges = idResolver.createSetOfAll(<%de.mdelab.mlsdm.MlsdmTables%>.SET_CLSSid_AcquireEdge, acquireEdges);\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> size = <%org.eclipse.ocl.pivot.library.collection.CollectionSizeOperation%>.INSTANCE.evaluate(BOXED_acquireEdges);\n\t\tfinal /*@NonInvalid*/ boolean gt = <%org.eclipse.ocl.pivot.library.oclany.OclComparableGreaterThanOperation%>.INSTANCE.evaluate(executor, size, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\t\tif (gt) {\n\t\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tstatus = null;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean eq = status == Boolean.TRUE;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (eq) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlsdm.MlsdmTables%>.STR_Semaphore_32, toString);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlsdm.MlsdmTables%>.STR__32_must_32_have_32_at_32_least_32_one_32_acquire_32_edge);\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlsdm.MlsdmTables%>.TUPLid_, sum_0, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, symbol_1, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getSemaphore_ActivityNodeContainer(), source, new String[] { "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!Semaphore!activityNodeContainer" });
		addAnnotation(getSemaphore_TokenCount(), source, new String[] { "documentation",
				"The number of tokens initially contained in this semaphore.", "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!Semaphore!tokenCount" });
		addAnnotation(getSemaphore_AcquireEdges(), source, new String[] { "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!Semaphore!acquireEdges" });
		addAnnotation(getSemaphore_ReleaseEdges(), source, new String[] { "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!Semaphore!releaseEdges" });
		addAnnotation(synchronizationEdgeEClass, source,
				new String[] { "documentation", "Superclass for edges between Semaphores and ActivityEdges." });
		addAnnotation(getSynchronizationEdge__WeightPositive__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"SynchronizationEdge::WeightPositive\";\ntry {\n\t/**\n\t *\n\t * inv WeightPositive:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if self.weight > 0\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'Weight of synchronization edge \' +\n\t *               self.toString() + \' must be greater than zero.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.SYNCHRONIZATION_EDGE___WEIGHT_POSITIVE__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (le) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ int weight = this.getWeight();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> BOXED_weight = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.integerValueOf(weight);\n\t\tfinal /*@NonInvalid*/ boolean gt = <%org.eclipse.ocl.pivot.library.oclany.OclComparableGreaterThanOperation%>.INSTANCE.evaluate(executor, BOXED_weight, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\t\tif (gt) {\n\t\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tstatus = null;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean eq = status == Boolean.TRUE;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (eq) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlsdm.MlsdmTables%>.STR_Weight_32_of_32_synchronization_32_edge_32, toString);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlsdm.MlsdmTables%>.STR__32_must_32_be_32_greater_32_than_32_zero);\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlsdm.MlsdmTables%>.TUPLid_, sum_0, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, symbol_1, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getSynchronizationEdge_ActivityNodeContainer(), source, new String[] { "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!SynchronizationEdge!activityNodeContainer" });
		addAnnotation(getSynchronizationEdge_Weight(), source, new String[] { "documentation",
				"The number of tokens acquired from/released to the token.", "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!SynchronizationEdge!weight" });
		addAnnotation(acquireEdgeEClass, source, new String[] { "documentation",
				"When the ActivityEdge is executed, a number of tokens is acquired from the Semaphore." });
		addAnnotation(getAcquireEdge__ActivityEdgeSpecified__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"AcquireEdge::ActivityEdgeSpecified\";\ntry {\n\t/**\n\t *\n\t * inv ActivityEdgeSpecified:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if self.activityEdge <> null\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'Activity edge of acquire edge \' +\n\t *               self.toString() + \' must be specified.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.ACQUIRE_EDGE___ACTIVITY_EDGE_SPECIFIED__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_0;\n\tif (le) {\n\t\tsymbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_0 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_0;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getAcquireEdge_ActivityEdge(), source, new String[] { "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!AcquireEdge!activityEdge" });
		addAnnotation(getAcquireEdge_Semaphore(), source, new String[] { "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!AcquireEdge!semaphore" });
		addAnnotation(releaseEdgeEClass, source, new String[] { "documentation",
				"When the ActivityEdge is executed, a number of tokens is released to the Semaphore." });
		addAnnotation(getReleaseEdge__ActivityEdgeSpecified__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"ReleaseEdge::ActivityEdgeSpecified\";\ntry {\n\t/**\n\t *\n\t * inv ActivityEdgeSpecified:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if self.activityEdge <> null\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'Activity edge of release edge \' +\n\t *               self.toString() + \' must be specified.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.RELEASE_EDGE___ACTIVITY_EDGE_SPECIFIED__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_0;\n\tif (le) {\n\t\tsymbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_0 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_0;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getReleaseEdge_ActivityEdge(), source, new String[] { "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!ReleaseEdge!activityEdge" });
		addAnnotation(getReleaseEdge_Semaphore(), source, new String[] { "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!ReleaseEdge!semaphore" });
		addAnnotation(activityParameterEClass, source, new String[] { "documentation",
				"Specifies a parameter of an Activity. In and inout parameters have to be provided before the exection of the Activity. Values for the out and inout parameters are calculated when the Activity terminates." });
		addAnnotation(getActivityParameter__DirectionSpecified__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"ActivityParameter::DirectionSpecified\";\ntry {\n\t/**\n\t *\n\t * inv DirectionSpecified:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if self.direction <> null\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'Direction of activity parameter \' +\n\t *               self.toString() + \' must be specified.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.ACTIVITY_PARAMETER___DIRECTION_SPECIFIED__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_0;\n\tif (le) {\n\t\tsymbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_0 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_0;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getActivityParameter__TypeSpecified__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"ActivityParameter::TypeSpecified\";\ntry {\n\t/**\n\t *\n\t * inv TypeSpecified:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if self.type <> null\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'Type of activity parameter \' +\n\t *               self.toString() + \' must be specified.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.ACTIVITY_PARAMETER___TYPE_SPECIFIED__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_2;\n\tif (le) {\n\t\tsymbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.emf.ecore.EClassifier%> type = this.getType();\n\t\tfinal /*@NonInvalid*/ boolean ne = type != null;\n\t\t/*@NonInvalid*/ <%java.lang.Boolean%> status;\n\t\tif (ne) {\n\t\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tstatus = null;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean eq = status == Boolean.TRUE;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (eq) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(this);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlsdm.MlsdmTables%>.STR_Type_32_of_32_activity_32_parameter_32, toString);\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> sum_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(sum, <%de.mdelab.mlsdm.MlsdmTables%>.STR__32_must_32_be_32_specified);\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlsdm.MlsdmTables%>.TUPLid_, sum_0, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, symbol_1, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getActivityParameter_Direction(), source, new String[] { "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!ActivityParameter!direction" });
		addAnnotation(getActivityParameter_Activity(), source, new String[] { "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!ActivityParameter!activity" });
		addAnnotation(outputParameterValueEClass, source, new String[] { "documentation",
				"Specifies the return value of an ActivityParameter using an expression." });
		addAnnotation(getOutputParameterValue__ExpressionSpecfied__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"OutputParameterValue::ExpressionSpecfied\";\ntry {\n\t/**\n\t *\n\t * inv ExpressionSpecfied:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if self.expression <> null\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'Expression of output parameter value assignment \' +\n\t *               self.toString() + \' must be specified.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.OUTPUT_PARAMETER_VALUE___EXPRESSION_SPECFIED__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_0;\n\tif (le) {\n\t\tsymbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_0 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_0;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getOutputParameterValue__ParameterSpecfied__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"OutputParameterValue::ParameterSpecfied\";\ntry {\n\t/**\n\t *\n\t * inv ParameterSpecfied:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if self.parameter <> null\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'Parameter of output parameter value assignment \' +\n\t *               self.toString() + \' must be specified.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\t/*@Caught*/ <%java.lang.Object%> CAUGHT_severity_0;\n\ttry {\n\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlsdm.MlsdmPackage%>.Literals.OUTPUT_PARAMETER_VALUE___PARAMETER_SPECFIED__DIAGNOSTICCHAIN_MAP);\n\t\tCAUGHT_severity_0 = severity_0;\n\t}\n\tcatch (<%java.lang.Exception%> e) {\n\t\tCAUGHT_severity_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t}\n\tif (CAUGHT_severity_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_severity_0;\n\t}\n\tfinal /*@Thrown*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, CAUGHT_severity_0, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ <%java.lang.Object%> symbol_0;\n\tif (le) {\n\t\tsymbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, CAUGHT_severity_0, <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE, <%de.mdelab.mlsdm.MlsdmTables%>.INT_0).booleanValue();\n\t\tsymbol_0 = logDiagnostic;\n\t}\n\treturn Boolean.TRUE == symbol_0;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getOutputParameterValue_Parameter(), source, new String[] { "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!OutputParameterValue!parameter" });
		addAnnotation(getOutputParameterValue_Expression(), source, new String[] { "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!OutputParameterValue!expression" });
		addAnnotation(getOutputParameterValue_ActivityFinalNode(), source, new String[] { "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!OutputParameterValue!activityFinalNode" });
	}

	/**
	 * Initializes the annotations for <b>http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot</b>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void createPivotAnnotations() {
		String source = "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot";
		addAnnotation(getActivity__ParameterDistinctNames__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'Parameters of activity \' + self.toString() + \' must have distinct names.\',\n\tstatus : Boolean = \n\t\tif self.parameters->forAll(e|self.parameters->select(e2|e.name = e2.name)->size() = 1) then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getActivity__AtLeastOneFinalNode__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'Activity \' + self.toString() + \' must contain at least one activity final node.\',\n\tstatus : Boolean = \n\t\tif self.nodes->exists(e|e.oclIsTypeOf(ActivityFinalNode)) then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getActivity__ActivityName__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'Activity \' + self.toString() + \' must have a name.\',\n\tstatus : Boolean = \n\t\tif self.name <> null and self.name <> \'\' then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getActivity__OneInitialNode__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'Activity \' + self.toString() + \'must contain exactly one initial node.\',\n\tstatus : Boolean = \n\t\tif self.nodes->select(e|e.oclIsTypeOf(InitialNode))->size() = 1 then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getActivityEdge__ActivityEdgeBooleanGuard__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'The BOOLEAN guard of activity edge \' + self.toString() + \' is only valid for edges starting from a decision/merge node.\',\n\tstatus : Boolean = \n\t\tif self.guardType = ActivityEdgeGuardEnum::BOOLEAN and self.source.oclIsKindOf(DecisionMergeNode) implies self.source.oclIsTypeOf(DecisionMergeNode) then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getActivityEdge__ActivityEdgeSuccessGuard__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'The SUCCESS guard of activity edge \' + self.toString() + \' is only valid for edges starting from a story node with SINGLE_MATCH semantics.\',\n\tstatus : Boolean = \n\t\tif self.guardType = ActivityEdgeGuardEnum::SUCCESS and self.source.oclIsKindOf(StoryNode) implies self.source.oclAsType(StoryNode).semantics = StoryNodeSemanticsEnum::SINGLE_MATCH then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getActivityEdge__ActivityEdgeGuardType__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'Guard type of activity edge \' + self.toString() + \' must be specified.\',\n\tstatus : Boolean = \n\t\tif self.guardType <> null then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getActivityEdge__ActivityEdgeForEachGuard__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'The FOR_EACH guard of activity edge \' + self.toString() + \' is only valid for edges starting from a story node with FOR_EACH semantics.\',\n\tstatus : Boolean = \n\t\tif self.guardType = ActivityEdgeGuardEnum::FOR_EACH and self.source.oclIsKindOf(StoryNode) implies self.source.oclAsType(StoryNode).semantics = StoryNodeSemanticsEnum::FOR_EACH_FRESH_MATCH then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getActivityEdge__ActivityEdgeSource__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'Source of activity edge \' + self.toString() + \' must be specified.\',\n\tstatus : Boolean = \n\t\tif self.source <> null then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getActivityEdge__ActivityEdgeElseGuard__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'The ELSE guard of activity edge \' + self.toString() + \' is only valid for edges starting from a decision/merge node.\',\n\tstatus : Boolean = \n\t\tif self.guardType = ActivityEdgeGuardEnum::ELSE implies self.source.oclIsTypeOf(DecisionMergeNode) then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getActivityEdge__ActivityEdgeTarget__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'Target of activity edge \' + self.toString() + \' must be specified.\',\n\tstatus : Boolean = \n\t\tif self.target <> null then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getActivityEdge__ActivityEdgeFailureGuard__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'The FAILURE guard of activity edge \' + self.toString() + \' is only valid for edges starting from a story node with SINGLE_MATCH semantics.\',\n\tstatus : Boolean = \n\t\tif self.guardType = ActivityEdgeGuardEnum::FAILURE and self.source.oclIsKindOf(StoryNode) implies self.source.oclAsType(StoryNode).semantics = StoryNodeSemanticsEnum::SINGLE_MATCH then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getActivityEdge__ActivityEdgeGuardExpression__DiagnosticChain_Map(), source, new String[] {
				"body",
				"Tuple {\n\tmessage : String = \'A guard expression for the boolean guard of activity edge \' + self.toString() + \' must be specified.\',\n\tstatus : Boolean = \n\t\tif self.guardType = ActivityEdgeGuardEnum::BOOLEAN implies self.guardExpression <> null then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getActivityEdge__ActivityEdgeNoGuardExpression__DiagnosticChain_Map(), source, new String[] {
				"body",
				"Tuple {\n\tmessage : String = \'A guard expression may only be specified for boolean guards (activity edge \' + self.toString() + \').\',\n\tstatus : Boolean = \n\t\tif self.guardExpression <> null implies self.guardType = ActivityEdgeGuardEnum::BOOLEAN then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getActivityEdge__ActivityEdgeEndGuard__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'The END guard of activity edge \' + self.toString() + \' is only valid for edges starting from a story node with FOR_EACH semantics.\',\n\tstatus : Boolean = \n\t\tif self.guardType = ActivityEdgeGuardEnum::END and self.source.oclIsKindOf(StoryNode) implies self.source.oclAsType(StoryNode).semantics = StoryNodeSemanticsEnum::FOR_EACH_FRESH_MATCH then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getInitialNode__InitialNodeIncomingEdge__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'The initial node \' + self.toString() + \' must not have an incoming edge.\',\n\tstatus : Boolean = \n\t\tif self.incomingEdges->isEmpty() then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getInitialNode__InitialNodeOutgoingEdge__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'The initial node \' + self.toString() + \' must have exactly one outgoing edge.\',\n\tstatus : Boolean = \n\t\tif self.outgoingEdges->size() = 1 then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getFlowFinalNode__FlowFinalNodeIncomingEdge__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'The flow final node \' + self.toString() + \' must have at least one incoming edge\',\n\tstatus : Boolean = \n\t\tif self.incomingEdges->notEmpty() then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getFlowFinalNode__FlowFinalNodeOutgoingEdge__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'The flow final node \' + self.toString() + \' must not have an outgoing edge\',\n\tstatus : Boolean = \n\t\tif self.outgoingEdges->isEmpty() then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getActivityFinalNode__IncomingEdge__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'The activity final node \' + self.toString() + \' must have at least one incoming edge\',\n\tstatus : Boolean = \n\t\tif self.incomingEdges->notEmpty() then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getActivityFinalNode__NoOutputParameterValue__DiagnosticChain_Map(), source, new String[] {
				"body",
				"Tuple {\n\tmessage : String = \'An output parameter value is missing for parameters of activity final node \' + self.toString(),\n\tstatus : Boolean = \n\t\tif self.activity.parameters->select(e|e.direction <> ActivityParameterDirectionEnum::IN)->forAll(e|self.outputParameterValues->exists(e2|e2.parameter = e)) then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getActivityFinalNode__OutgoingEdge__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'The activity final node \' + self.toString() + \' must not have an outgoing edge\',\n\tstatus : Boolean = \n\t\tif self.outgoingEdges->isEmpty() then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getActivityFinalNode__OneOutputParameterValue__DiagnosticChain_Map(), source, new String[] {
				"body",
				"Tuple {\n\tmessage : String = \'There may only be one output parameter value for each parameter of activity final node \' + self.toString(),\n\tstatus : Boolean = \n\t\tif self.outputParameterValues->forAll(e|self.outputParameterValues->select(e2|e2.parameter = e.parameter)->size() = 1) then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getExpressionActivityNode__OneOutgoingEdge__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'Expression activity node \' + self.toString() + \' must have one outgoing edge.\',\n\tstatus : Boolean = \n\t\tif self.outgoingEdges->size() = 1 then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getExpressionActivityNode__OneIncomingEdge__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'Expression activity node \' + self.toString() + \' must have one incoming edge.\',\n\tstatus : Boolean = \n\t\tif self.incomingEdges->size() = 1 then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getExpressionActivityNode__ExpressionSpecified__DiagnosticChain_Map(), source, new String[] {
				"body",
				"Tuple {\n\tmessage : String = \'Expression of expression activity node \' + self.toString() + \' must be specified.\',\n\tstatus : Boolean = \n\t\tif not self.expressions->isEmpty() then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getDecisionMergeNode__IncomingEdge__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'Decision merge node \' + self.toString() + \' must have at least one incoming edge.\',\n\tstatus : Boolean = \n\t\tif not self.incomingEdges->isEmpty() then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getDecisionMergeNode__MultipleEdgeGuards__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'One of the outgoing edges of decision merge node \' + self.toString() + \' must have the ELSE guard, the other edges must have the BOOLEAN guard.\',\n\tstatus : Boolean = \n\t\tif \t(self.outgoingEdges->size() >  1) implies\n\t\t\t(self.outgoingEdges->select(e|e.guardType = ActivityEdgeGuardEnum::ELSE)->size() = 1 and\n\t\t\t(self.outgoingEdges->select(e|e.guardType = ActivityEdgeGuardEnum::BOOLEAN)->size()) = self.outgoingEdges->size() - 1) then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getDecisionMergeNode__SingleEdgeGuard__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'Single outgoing edge from decision merge node \' + self.toString() + \' may not have a guard.\',\n\tstatus : Boolean = \n\t\tif (self.outgoingEdges->size() =  1) implies self.outgoingEdges->forAll(e|e.guardType = ActivityEdgeGuardEnum::NONE) then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getDecisionMergeNode__OutgoingEdge__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'Decision merge node \' + self.toString() + \' must have at least one outgoing edge.\',\n\tstatus : Boolean = \n\t\tif not self.outgoingEdges->isEmpty() then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getForkJoinNode__IncomingEdge__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'Fork/join node \' + self.toString() + \' must have at least one incoming edge.\',\n\tstatus : Boolean = \n\t\tif not self.incomingEdges->isEmpty() then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getForkJoinNode__OutgoingEdge__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'Fork/join node \' + self.toString() + \' must have at least one outgoing edge.\',\n\tstatus : Boolean = \n\t\tif not self.outgoingEdges->isEmpty() then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getStoryNode__IncomingEdge__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'Story node \' + self.toString() + \' must have one incoming edge.\',\n\tstatus : Boolean = \n\t\tif self.incomingEdges->size() = 1 then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getStoryNode__ForEachLoopBody__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'Loop body of story node \' + self.toString() + \' with FOR_EACH semantics must be contained in a structured node.\',\n\tstatus : Boolean = \n\t\tif \t(self.semantics = StoryNodeSemanticsEnum::FOR_EACH_FRESH_MATCH) implies\n\t\t\tself.outgoingEdges->select(e|e.guardType = ActivityEdgeGuardEnum::FOR_EACH)->forAll(e|e.target.oclIsKindOf(StructuredNode)) then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getStoryNode__StoryPatternSpecified__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'Story node \' + self.toString() + \' must contain a story pattern.\',\n\tstatus : Boolean = \n\t\tif \tself.storyPattern <> null then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getStoryNode__SemanticsSpecified__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'Semantics of story node \' + self.toString() + \' must be specified.\',\n\tstatus : Boolean = \n\t\tif self.semantics <> null then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getStoryNode__ForEachMatchOutgoingEdges__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'Story node \' + self.toString() + \' with FOR_EACH semantics must have one outgoing edge with the END guard. It may also have another outgoing edge with the FOR_EACH guard leading to a structured node, which contains the loop body.\',\n\tstatus : Boolean = \n\t\tif \t(self.semantics = StoryNodeSemanticsEnum::FOR_EACH_FRESH_MATCH) implies\n\t\t\t((self.outgoingEdges->size() = 1 and self.outgoingEdges->exists(e|e.guardType = ActivityEdgeGuardEnum::END)) or\n\t\t\t(self.outgoingEdges->size() = 2 and self.outgoingEdges->exists(e|e.guardType = ActivityEdgeGuardEnum::END) and self.outgoingEdges->exists(e|e.guardType = ActivityEdgeGuardEnum::FOR_EACH))) then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getStoryNode__SingleMatchOutgoingEdges__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'Story node \' + self.toString() + \' with SINGLE_MATCH semantics must have one outgoing edge with no guard or two outgoing edges with SUCCESS and FAILURE guards.\',\n\tstatus : Boolean = \n\t\tif \t(self.semantics = StoryNodeSemanticsEnum::SINGLE_MATCH) implies\n\t\t\t((self.outgoingEdges->size() = 1 and self.outgoingEdges->forAll(e|e.guardType = ActivityEdgeGuardEnum::NONE)) or\n\t\t\t(self.outgoingEdges->size() = 2 and self.outgoingEdges->exists(e|e.guardType = ActivityEdgeGuardEnum::SUCCESS) and self.outgoingEdges->exists(e|e.guardType = ActivityEdgeGuardEnum::FAILURE))) then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getStructuredNode__InitialNodeContained__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'Structured node \' + self.toString() + \' must contain an initial node.\',\n\tstatus : Boolean = \n\t\tif self.nodes->exists(e|e.oclIsKindOf(InitialNode)) then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getStructuredNode__FinalNodeContained__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'Structured node \' + self.toString() + \' must contain an flow final node or an activity final node.\',\n\tstatus : Boolean = \n\t\tif self.nodes->exists(e|e.oclIsKindOf(FlowFinalNode) or e.oclIsKindOf(ActivityFinalNode)) then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getSemaphore__TokenCountNotNegative__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'Token count of semaphore \' + self.toString() + \' may not be negative.\',\n\tstatus : Boolean = \n\t\tif \tself.tokenCount >= 0 then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getSemaphore__ReleaseEdge__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'Semaphore \' + self.toString() + \' must have at least one release edge.\',\n\tstatus : Boolean = \n\t\tif self.releaseEdges->size() > 0 then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getSemaphore__AcquireEdge__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'Semaphore \' + self.toString() + \' must have at least one acquire edge.\',\n\tstatus : Boolean = \n\t\tif self.acquireEdges->size() > 0 then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getSynchronizationEdge__WeightPositive__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'Weight of synchronization edge \' + self.toString() + \' must be greater than zero.\',\n\tstatus : Boolean = \n\t\tif self.weight > 0 then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getAcquireEdge__ActivityEdgeSpecified__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'Activity edge of acquire edge \' + self.toString() + \' must be specified.\',\n\tstatus : Boolean = \n\t\tif self.activityEdge <> null then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getReleaseEdge__ActivityEdgeSpecified__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'Activity edge of release edge \' + self.toString() + \' must be specified.\',\n\tstatus : Boolean = \n\t\tif self.activityEdge <> null then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getActivityParameter__DirectionSpecified__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'Direction of activity parameter \' + self.toString() + \' must be specified.\',\n\tstatus : Boolean = \n\t\tif self.direction <> null then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getActivityParameter__TypeSpecified__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'Type of activity parameter \' + self.toString() + \' must be specified.\',\n\tstatus : Boolean = \n\t\tif self.type <> null then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getOutputParameterValue__ExpressionSpecfied__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'Expression of output parameter value assignment \' + self.toString() + \' must be specified.\',\n\tstatus : Boolean = \n\t\tif self.expression <> null then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
		addAnnotation(getOutputParameterValue__ParameterSpecfied__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'Parameter of output parameter value assignment \' + self.toString() + \' must be specified.\',\n\tstatus : Boolean = \n\t\tif self.parameter <> null then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
	}

} // MlsdmPackageImpl
